#include <SeStretchUtils.h>
#define abs(x) ((x<0)?-(x):(x))

const unsigned long VO_ScaleRatio8[]=
{
	 0x3800,  0x4800,  0x5000,  0x5800,  0x6000,  0x6800,  0x7000,  0x7800,
	 0x8000,  0x8800,  0x9000,  0x9800,  0xa000,  0xa800,  0xb000,  0xb800,
	 0xc000,  0xc800,  0xd000,  0xd800,  0xe000,  0xe800,  0xf000,  0xf800,
	0x12000, 0x14000, 0x16000, 0x18000, 0x1a000, 0x1c000, 0x1e000, 0x20000
};

const short VO_coef_2t8p[8] =
{
  0x203, 0x2e8, 0x4a5, 0x6d6, 0x92a, 0xb5b, 0xd18, 0xdfd
};

const short VO_coef_4t8p_ratio8[][4][4] =
{
	// for all upscale ratio
	//4taps-- Vertical sampling
	{
	    {   -8,   256,    16,    -8 },
	    {  -24,   240,    48,    -8 },
	    {  -28,   212,    88,   -16 },
	    {  -28,   176,   132,   -24 },
	},
	//I=8, D=9, wp= 0.111, ws= 0.122, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {  -24,   241,     5,    34 },
	    {  -47,   249,    46,     8 },
	    {  -60,   237,    99,   -20 },
	    {  -59,   204,   155,   -44 },
	},
	//I=8, D=10, wp= 0.100, ws= 0.110, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   -1,   222,    28,     7 },
	    {  -26,   230,    67,   -15 },
	    {  -44,   223,   113,   -36 },
	    {  -53,   198,   160,   -49 },
	},
	//I=8, D=11, wp= 0.091, ws= 0.100, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   22,   208,    47,   -21 },
	    {   -4,   212,    82,   -34 },
	    {  -25,   204,   120,   -43 },
	    {  -40,   186,   156,   -46 },
	},
	//I=8, D=12, wp= 0.083, ws= 0.092, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   36,   198,    62,   -40 },
	    {   12,   197,    92,   -45 },
	    {   -9,   188,   122,   -45 },
	    {  -27,   172,   150,   -39 },
	},
	//I=8, D=13, wp= 0.077, ws= 0.085, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   47,   190,    72,   -53 },
	    {   24,   186,    97,   -51 },
	    {    2,   177,   121,   -44 },
	    {  -17,   163,   143,   -33 },
	},
	//I=8, D=14, wp= 0.071, ws= 0.079, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   55,   184,    78,   -61 },
	    {   32,   176,   100,   -52 },
	    {   10,   167,   120,   -41 },
	    {   -9,   154,   138,   -27 },
	},
	//I=8, D=15, wp= 0.067, ws= 0.073, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   61,   178,    82,   -65 },
	    {   38,   169,   101,   -52 },
	    {   16,   160,   118,   -38 },
	    {   -3,   146,   134,   -21 },
	},
	//I=8, D=16, wp= 0.063, ws= 0.069, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   65,   172,    85,   -66 },
	    {   42,   163,   101,   -50 },
	    {   21,   153,   116,   -34 },
	    {    1,   142,   130,   -17 },
	},
	//I=8, D=17, wp= 0.059, ws= 0.065, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   67,   167,    87,   -65 },
	    {   45,   158,   101,   -48 },
	    {   25,   147,   114,   -30 },
	    {    6,   137,   126,   -13 },
	},
	//I=8, D=18, wp= 0.056, ws= 0.061, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   69,   162,    88,   -63 },
	    {   48,   152,   100,   -44 },
	    {   28,   142,   112,   -26 },
	    {   10,   133,   122,    -9 },
	},
	//I=8, D=19, wp= 0.053, ws= 0.058, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   71,   156,    88,   -59 },
	    {   50,   147,    99,   -40 },
	    {   31,   137,   110,   -22 },
	    {   13,   129,   119,    -5 },
	},
	//I=8, D=20, wp= 0.050, ws= 0.055, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   72,   151,    88,   -55 },
	    {   52,   142,    98,   -36 },
	    {   34,   133,   107,   -18 },
	    {   16,   125,   116,    -1 },
	},
	//I=8, D=21, wp= 0.048, ws= 0.052, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   72,   147,    87,   -50 },
	    {   53,   138,    96,   -31 },
	    {   36,   128,   105,   -13 },
	    {   19,   121,   113,     3 },
	},
	//I=8, D=22, wp= 0.045, ws= 0.050, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   73,   140,    87,   -44 },
	    {   55,   132,    95,   -26 },
	    {   38,   125,   102,    -9 },
	    {   23,   116,   110,     7 },
	},
	//I=8, D=23, wp= 0.043, ws= 0.048, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   73,   135,    86,   -38 },
	    {   56,   127,    93,   -20 },
	    {   40,   120,   100,    -4 },
	    {   25,   113,   107,    11 },
	},
	//I=8, D=24, wp= 0.042, ws= 0.046, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   73,   129,    85,   -31 },
	    {   57,   123,    91,   -15 },
	    {   42,   117,    97,     0 },
	    {   28,   109,   104,    15 },
	},
	//I=8, D=25, wp= 0.040, ws= 0.044, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   72,   125,    83,   -24 },
	    {   58,   118,    89,    -9 },
	    {   44,   112,    95,     5 },
	    {   31,   106,   101,    18 },
	},
	//I=8, D=26, wp= 0.038, ws= 0.042, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   72,   120,    82,   -18 },
	    {   59,   114,    87,    -4 },
	    {   46,   108,    93,     9 },
	    {   34,   102,    98,    22 },
	},
	//I=8, D=27, wp= 0.037, ws= 0.041, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   72,   114,    81,   -11 },
	    {   59,   109,    86,     2 },
	    {   48,   104,    90,    14 },
	    {   36,   100,    95,    25 },
	},
	//I=8, D=28, wp= 0.036, ws= 0.039, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   71,   111,    79,    -5 },
	    {   60,   105,    84,     7 },
	    {   49,   101,    88,    18 },
	    {   39,    97,    92,    28 },
	},
	//I=8, D=29, wp= 0.034, ws= 0.038, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   71,   106,    78,     1 },
	    {   60,   102,    82,    12 },
	    {   51,    97,    86,    22 },
	    {   41,    94,    90,    31 },
	},
	//I=8, D=30, wp= 0.033, ws= 0.037, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   70,   103,    77,     6 },
	    {   61,    98,    81,    16 },
	    {   52,    95,    84,    25 },
	    {   43,    91,    88,    34 },
	},
	//I=8, D=31, wp= 0.032, ws= 0.035, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   70,    99,    76,    11 },
	    {   61,    96,    79,    20 },
	    {   53,    92,    82,    29 },
	    {   45,    88,    86,    37 },
	},
	//I=8, D=36, wp= 0.028, ws= 0.031, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   68,    86,    72,    30 },
	    {   62,    84,    74,    36 },
	    {   57,    82,    76,    41 },
	    {   52,    79,    78,    47 },
	},
	//I=8, D=40, wp= 0.025, ws= 0.028, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   67,    79,    70,    40 },
	    {   63,    78,    71,    44 },
	    {   59,    76,    73,    48 },
	    {   55,    76,    74,    51 },
	},
	//I=8, D=44, wp= 0.023, ws= 0.025, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   66,    76,    68,    46 },
	    {   63,    75,    69,    49 },
	    {   60,    74,    70,    52 },
	    {   57,    72,    72,    55 },
	},
	//I=8, D=48, wp= 0.021, ws= 0.023, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   66,    73,    67,    50 },
	    {   63,    73,    68,    52 },
	    {   61,    72,    69,    54 },
	    {   59,    70,    70,    57 },
	},
	//I=8, D=52, wp= 0.019, ws= 0.021, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   65,    71,    67,    53 },
	    {   64,    70,    67,    55 },
	    {   62,    70,    68,    56 },
	    {   60,    69,    69,    58 },
	},
	//I=8, D=56, wp= 0.018, ws= 0.020, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   65,    70,    66,    55 },
	    {   64,    69,    67,    56 },
	    {   62,    69,    67,    58 },
	    {   61,    68,    68,    59 },
	},
	//I=8, D=60, wp= 0.017, ws= 0.018, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   65,    69,    66,    56 },
	    {   64,    68,    66,    58 },
	    {   63,    67,    67,    59 },
	    {   61,    68,    67,    60 },
	},
	//I=8, D=64, wp= 0.016, ws= 0.017, alpha= 0.100
	//4taps-- Vertical sampling
	{
	    {   65,    67,    66,    58 },
	    {   64,    67,    66,    59 },
	    {   63,    67,    66,    60 },
	    {   62,    66,    67,    61 },
	},
};

const short VO_coef_4t16p_ratio[][8][4] =
{
	{
		{   -4,   256,     8,    -4 },
		{  -12,   252,    24,    -8 },
		{  -20,   244,    40,    -8 },
		{  -26,   234,    58,   -10 },
		{  -28,   220,    78,   -14 },
		{  -28,   202,   100,   -18 },
		{  -28,   184,   122,   -22 },
		{  -26,   164,   142,   -24 },
	},
	//I=16, D=17, wp= 0.059, ws= 0.065, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{  -30,   254,   -16,    48 },
		{  -42,   259,     1,    38 },
		{  -53,   261,    22,    26 },
		{  -60,   257,    46,    13 },
		{  -64,   249,    73,    -2 },
		{  -64,   233,   103,   -16 },
		{  -61,   215,   133,   -31 },
		{  -53,   189,   163,   -43 },
	},
	//I=16, D=18, wp= 0.056, ws= 0.061, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{  -17,   237,    -3,    39 },
		{  -31,   245,    14,    28 },
		{  -42,   248,    35,    15 },
		{  -52,   249,    58,     1 },
		{  -58,   242,    85,   -13 },
		{  -62,   231,   113,   -26 },
		{  -61,   215,   141,   -39 },
		{  -57,   193,   169,   -49 },
	},
	//I=16, D=19, wp= 0.053, ws= 0.058, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   -6,   226,     9,    27 },
		{  -19,   234,    26,    15 },
		{  -31,   238,    46,     3 },
		{  -42,   239,    69,   -10 },
		{  -50,   235,    94,   -23 },
		{  -55,   225,   120,   -34 },
		{  -58,   212,   146,   -44 },
		{  -56,   193,   171,   -52 },
	},
	//I=16, D=20, wp= 0.050, ws= 0.055, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{    6,   217,    20,    13 },
		{   -7,   224,    37,     2 },
		{  -20,   229,    57,   -10 },
		{  -31,   230,    78,   -21 },
		{  -40,   226,   101,   -31 },
		{  -47,   218,   125,   -40 },
		{  -52,   207,   148,   -47 },
		{  -53,   190,   170,   -51 },
	},
	//I=16, D=21, wp= 0.048, ws= 0.052, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   16,   212,    30,    -2 },
		{    3,   217,    47,   -11 },
		{   -9,   220,    66,   -21 },
		{  -20,   220,    86,   -30 },
		{  -30,   216,   107,   -37 },
		{  -38,   209,   128,   -43 },
		{  -44,   198,   149,   -47 },
		{  -48,   185,   168,   -49 },
	},
	//I=16, D=22, wp= 0.045, ws= 0.050, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   26,   205,    40,   -15 },
		{   13,   210,    56,   -23 },
		{    1,   213,    73,   -31 },
		{  -10,   211,    92,   -37 },
		{  -20,   208,   110,   -42 },
		{  -29,   201,   129,   -45 },
		{  -37,   192,   147,   -46 },
		{  -42,   179,   164,   -45 },
	},
	//I=16, D=23, wp= 0.043, ws= 0.048, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   34,   201,    48,   -27 },
		{   22,   204,    63,   -33 },
		{   10,   205,    79,   -38 },
		{   -1,   203,    96,   -42 },
		{  -12,   199,   113,   -44 },
		{  -21,   192,   130,   -45 },
		{  -30,   185,   145,   -44 },
		{  -36,   173,   160,   -41 },
	},
	//I=16, D=24, wp= 0.042, ws= 0.046, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   42,   197,    55,   -38 },
		{   30,   198,    69,   -41 },
		{   18,   198,    84,   -44 },
		{    6,   197,    99,   -46 },
		{   -4,   192,   114,   -46 },
		{  -14,   185,   129,   -44 },
		{  -23,   177,   143,   -41 },
		{  -31,   168,   156,   -37 },
	},
	//I=16, D=25, wp= 0.040, ws= 0.044, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   48,   193,    61,   -46 },
		{   36,   194,    74,   -48 },
		{   24,   193,    88,   -49 },
		{   13,   189,   102,   -48 },
		{    2,   185,   115,   -46 },
		{   -8,   179,   128,   -43 },
		{  -18,   172,   141,   -39 },
		{  -26,   163,   152,   -33 },
	},
	//I=16, D=26, wp= 0.038, ws= 0.042, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   53,   191,    65,   -53 },
		{   41,   190,    78,   -53 },
		{   29,   188,    91,   -52 },
		{   18,   184,   103,   -49 },
		{    7,   180,   115,   -46 },
		{   -3,   173,   127,   -41 },
		{  -13,   167,   138,   -36 },
		{  -21,   157,   149,   -29 },
	},
	//I=16, D=27, wp= 0.037, ws= 0.041, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   57,   188,    69,   -58 },
		{   45,   186,    81,   -56 },
		{   34,   183,    93,   -54 },
		{   22,   180,   104,   -50 },
		{   12,   174,   115,   -45 },
		{    1,   169,   126,   -40 },
		{   -8,   161,   136,   -33 },
		{  -17,   154,   145,   -26 },
	},
	//I=16, D=28, wp= 0.036, ws= 0.039, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   61,   184,    73,   -62 },
		{   49,   182,    84,   -59 },
		{   37,   180,    94,   -55 },
		{   26,   175,   105,   -50 },
		{   15,   170,   115,   -44 },
		{    5,   164,   125,   -38 },
		{   -5,   157,   134,   -30 },
		{  -14,   151,   142,   -23 },
	},
	//I=16, D=29, wp= 0.034, ws= 0.038, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   64,   182,    75,   -65 },
		{   52,   179,    86,   -61 },
		{   41,   174,    96,   -55 },
		{   29,   171,   105,   -49 },
		{   19,   166,   114,   -43 },
		{    8,   161,   123,   -36 },
		{   -2,   154,   132,   -28 },
		{  -11,   147,   140,   -20 },
	},
	//I=16, D=30, wp= 0.033, ws= 0.037, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   67,   178,    78,   -67 },
		{   55,   176,    87,   -62 },
		{   43,   172,    96,   -55 },
		{   32,   168,   105,   -49 },
		{   21,   162,   114,   -41 },
		{   11,   157,   122,   -34 },
		{    1,   151,   130,   -26 },
		{   -8,   144,   137,   -17 },
	},
	//I=16, D=31, wp= 0.032, ws= 0.035, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   69,   177,    79,   -69 },
		{   57,   173,    88,   -62 },
		{   46,   168,    97,   -55 },
		{   35,   164,   105,   -48 },
		{   24,   159,   113,   -40 },
		{   14,   153,   121,   -32 },
		{    4,   147,   128,   -23 },
		{   -6,   142,   135,   -15 },
	},
	//I=16, D=32, wp= 0.031, ws= 0.034, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   70,   174,    81,   -69 },
		{   59,   170,    89,   -62 },
		{   47,   166,    97,   -54 },
		{   37,   160,   105,   -46 },
		{   26,   156,   112,   -38 },
		{   16,   151,   119,   -30 },
		{    6,   145,   126,   -21 },
		{   -3,   138,   133,   -12 },
	},
	//I=16, D=33, wp= 0.030, ws= 0.033, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   72,   172,    82,   -70 },
		{   60,   167,    90,   -61 },
		{   49,   162,    98,   -53 },
		{   38,   158,   105,   -45 },
		{   28,   152,   112,   -36 },
		{   18,   148,   118,   -28 },
		{    8,   142,   125,   -19 },
		{   -1,   136,   131,   -10 },
	},
	//I=16, D=34, wp= 0.029, ws= 0.032, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   73,   169,    83,   -69 },
		{   62,   165,    90,   -61 },
		{   51,   159,    98,   -52 },
		{   40,   155,   104,   -43 },
		{   30,   150,   111,   -35 },
		{   20,   145,   117,   -26 },
		{   10,   140,   123,   -17 },
		{    1,   134,   129,    -8 },
	},
	//I=16, D=35, wp= 0.029, ws= 0.031, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   74,   167,    84,   -69 },
		{   63,   161,    91,   -59 },
		{   52,   157,    97,   -50 },
		{   42,   151,   104,   -41 },
		{   32,   147,   110,   -33 },
		{   22,   142,   116,   -24 },
		{   12,   138,   121,   -15 },
		{    3,   132,   127,    -6 },
	},
	//I=16, D=36, wp= 0.028, ws= 0.031, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   75,   164,    84,   -67 },
		{   64,   159,    91,   -58 },
		{   53,   155,    97,   -49 },
		{   43,   150,   103,   -40 },
		{   33,   145,   109,   -31 },
		{   23,   141,   114,   -22 },
		{   14,   135,   120,   -13 },
		{    5,   130,   125,    -4 },
	},
	//I=16, D=37, wp= 0.027, ws= 0.030, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   161,    85,   -66 },
		{   65,   156,    91,   -56 },
		{   54,   152,    97,   -47 },
		{   44,   147,   103,   -38 },
		{   34,   143,   108,   -29 },
		{   25,   138,   113,   -20 },
		{   16,   133,   118,   -11 },
		{    7,   128,   123,    -2 },
	},
	//I=16, D=38, wp= 0.026, ws= 0.029, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   159,    85,   -64 },
		{   65,   154,    91,   -54 },
		{   55,   149,    97,   -45 },
		{   45,   144,   102,   -35 },
		{   36,   139,   107,   -26 },
		{   27,   135,   112,   -18 },
		{   18,   130,   117,    -9 },
		{    9,   126,   121,     0 },
	},
	//I=16, D=39, wp= 0.026, ws= 0.028, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   156,    85,   -62 },
		{   66,   151,    91,   -52 },
		{   56,   147,    96,   -43 },
		{   46,   142,   101,   -33 },
		{   37,   137,   106,   -24 },
		{   28,   133,   111,   -16 },
		{   19,   129,   115,    -7 },
		{   10,   124,   120,     2 },
	},
	//I=16, D=40, wp= 0.025, ws= 0.028, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   154,    85,   -60 },
		{   67,   149,    90,   -50 },
		{   57,   144,    95,   -40 },
		{   47,   140,   100,   -31 },
		{   38,   135,   105,   -22 },
		{   29,   131,   109,   -13 },
		{   21,   126,   114,    -5 },
		{   12,   122,   118,     4 },
	},
	//I=16, D=41, wp= 0.024, ws= 0.027, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   151,    85,   -57 },
		{   67,   146,    90,   -47 },
		{   57,   142,    95,   -38 },
		{   48,   138,    99,   -29 },
		{   39,   133,   104,   -20 },
		{   31,   128,   108,   -11 },
		{   22,   125,   112,    -3 },
		{   14,   121,   116,     5 },
	},
	//I=16, D=42, wp= 0.024, ws= 0.026, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   149,    85,   -55 },
		{   67,   144,    90,   -45 },
		{   58,   139,    94,   -35 },
		{   49,   134,    99,   -26 },
		{   40,   131,   103,   -18 },
		{   32,   126,   107,    -9 },
		{   24,   122,   111,    -1 },
		{   15,   119,   115,     7 },
	},
	//I=16, D=43, wp= 0.023, ws= 0.026, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   146,    85,   -52 },
		{   68,   141,    89,   -42 },
		{   59,   136,    94,   -33 },
		{   50,   132,    98,   -24 },
		{   41,   128,   102,   -15 },
		{   33,   125,   105,    -7 },
		{   25,   121,   109,     1 },
		{   17,   117,   113,     9 },
	},
	//I=16, D=44, wp= 0.023, ws= 0.025, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   144,    84,   -49 },
		{   68,   138,    89,   -39 },
		{   59,   134,    93,   -30 },
		{   51,   129,    97,   -21 },
		{   42,   127,   100,   -13 },
		{   34,   123,   104,    -5 },
		{   26,   119,   108,     3 },
		{   19,   115,   111,    11 },
	},
	//I=16, D=45, wp= 0.022, ws= 0.024, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   140,    84,   -45 },
		{   68,   136,    88,   -36 },
		{   60,   131,    92,   -27 },
		{   51,   128,    96,   -19 },
		{   43,   124,    99,   -10 },
		{   36,   120,   103,    -3 },
		{   28,   117,   106,     5 },
		{   20,   113,   110,    13 },
	},
	//I=16, D=46, wp= 0.022, ws= 0.024, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   137,    84,   -42 },
		{   68,   133,    88,   -33 },
		{   60,   129,    91,   -24 },
		{   52,   125,    95,   -16 },
		{   44,   122,    98,    -8 },
		{   37,   117,   102,     0 },
		{   29,   115,   105,     7 },
		{   22,   111,   108,    15 },
	},
	//I=16, D=47, wp= 0.021, ws= 0.023, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   135,    83,   -39 },
		{   68,   131,    87,   -30 },
		{   60,   127,    90,   -21 },
		{   53,   122,    94,   -13 },
		{   45,   120,    97,    -6 },
		{   38,   116,   100,     2 },
		{   31,   113,   103,     9 },
		{   23,   110,   107,    16 },
	},
	//I=16, D=48, wp= 0.021, ws= 0.023, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   77,   131,    83,   -35 },
		{   69,   128,    86,   -27 },
		{   61,   123,    90,   -18 },
		{   53,   121,    93,   -11 },
		{   46,   117,    96,    -3 },
		{   39,   114,    99,     4 },
		{   32,   111,   102,    11 },
		{   25,   108,   105,    18 },
	},
	//I=16, D=49, wp= 0.020, ws= 0.022, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   130,    82,   -32 },
		{   69,   124,    86,   -23 },
		{   61,   122,    89,   -16 },
		{   54,   118,    92,    -8 },
		{   47,   115,    95,    -1 },
		{   40,   112,    98,     6 },
		{   33,   109,   101,    13 },
		{   26,   107,   103,    20 },
	},
	//I=16, D=50, wp= 0.020, ws= 0.022, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   126,    82,   -28 },
		{   69,   122,    85,   -20 },
		{   61,   120,    88,   -13 },
		{   54,   116,    91,    -5 },
		{   48,   112,    94,     2 },
		{   41,   111,    96,     8 },
		{   34,   108,    99,    15 },
		{   28,   104,   102,    22 },
	},
	//I=16, D=51, wp= 0.020, ws= 0.022, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   124,    81,   -25 },
		{   69,   120,    84,   -17 },
		{   62,   117,    87,   -10 },
		{   55,   114,    90,    -3 },
		{   48,   112,    92,     4 },
		{   42,   108,    95,    11 },
		{   36,   105,    98,    17 },
		{   29,   104,   100,    23 },
	},
	//I=16, D=52, wp= 0.019, ws= 0.021, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   76,   120,    81,   -21 },
		{   69,   118,    83,   -14 },
		{   62,   115,    86,    -7 },
		{   55,   112,    89,     0 },
		{   49,   110,    91,     6 },
		{   43,   106,    94,    13 },
		{   37,   104,    96,    19 },
		{   31,   101,    99,    25 },
	},
	//I=16, D=53, wp= 0.019, ws= 0.021, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   75,   119,    80,   -18 },
		{   68,   116,    83,   -11 },
		{   62,   113,    85,    -4 },
		{   56,   110,    88,     2 },
		{   50,   107,    90,     9 },
		{   44,   104,    93,    15 },
		{   38,   102,    95,    21 },
		{   32,   101,    97,    26 },
	},
	//I=16, D=54, wp= 0.019, ws= 0.020, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   75,   117,    79,   -15 },
		{   68,   114,    82,    -8 },
		{   62,   111,    84,    -1 },
		{   56,   108,    87,     5 },
		{   50,   106,    89,    11 },
		{   45,   103,    91,    17 },
		{   39,   101,    94,    22 },
		{   34,    98,    96,    28 },
	},
	//I=16, D=55, wp= 0.018, ws= 0.020, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   74,   114,    79,   -11 },
		{   68,   112,    81,    -5 },
		{   62,   109,    84,     1 },
		{   57,   106,    86,     7 },
		{   51,   104,    88,    13 },
		{   46,   101,    90,    19 },
		{   40,   100,    92,    24 },
		{   35,    96,    95,    30 },
	},
	//I=16, D=56, wp= 0.018, ws= 0.020, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   74,   112,    78,    -8 },
		{   68,   109,    81,    -2 },
		{   63,   106,    83,     4 },
		{   57,   104,    85,    10 },
		{   52,   102,    87,    15 },
		{   47,    99,    89,    21 },
		{   41,    98,    91,    26 },
		{   36,    96,    93,    31 },
	},
	//I=16, D=57, wp= 0.018, ws= 0.019, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   74,   109,    78,    -5 },
		{   68,   107,    80,     1 },
		{   63,   104,    82,     7 },
		{   57,   103,    84,    12 },
		{   52,   101,    86,    17 },
		{   47,    99,    88,    22 },
		{   42,    96,    90,    28 },
		{   37,    94,    92,    33 },
	},
	//I=16, D=58, wp= 0.017, ws= 0.019, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   73,   108,    77,    -2 },
		{   68,   105,    79,     4 },
		{   63,   103,    81,     9 },
		{   58,   101,    83,    14 },
		{   53,    99,    85,    19 },
		{   48,    97,    87,    24 },
		{   43,    95,    89,    29 },
		{   39,    92,    91,    34 },
	},
	//I=16, D=59, wp= 0.017, ws= 0.019, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   73,   105,    77,     1 },
		{   68,   103,    79,     6 },
		{   63,   100,    81,    12 },
		{   58,    99,    82,    17 },
		{   53,    98,    84,    21 },
		{   49,    95,    86,    26 },
		{   44,    93,    88,    31 },
		{   40,    91,    90,    35 },
	},
	//I=16, D=60, wp= 0.017, ws= 0.018, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   73,   103,    76,     4 },
		{   68,   101,    78,     9 },
		{   63,    99,    80,    14 },
		{   58,    97,    82,    19 },
		{   54,    96,    83,    23 },
		{   50,    93,    85,    28 },
		{   45,    92,    87,    32 },
		{   41,    90,    88,    37 },
	},
	//I=16, D=61, wp= 0.016, ws= 0.018, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   72,   101,    76,     7 },
		{   68,   100,    77,    11 },
		{   63,    98,    79,    16 },
		{   59,    95,    81,    21 },
		{   54,    95,    82,    25 },
		{   50,    93,    84,    29 },
		{   46,    90,    86,    34 },
		{   42,    89,    87,    38 },
	},
	//I=16, D=62, wp= 0.016, ws= 0.018, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   72,   100,    75,     9 },
		{   68,    97,    77,    14 },
		{   63,    97,    78,    18 },
		{   59,    94,    80,    23 },
		{   55,    92,    82,    27 },
		{   51,    91,    83,    31 },
		{   47,    89,    85,    35 },
		{   43,    88,    86,    39 },
	},
	//I=16, D=63, wp= 0.016, ws= 0.017, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   72,    97,    75,    12 },
		{   67,    97,    76,    16 },
		{   63,    95,    78,    20 },
		{   59,    94,    79,    24 },
		{   55,    92,    81,    28 },
		{   52,    90,    82,    32 },
		{   48,    88,    84,    36 },
		{   44,    87,    85,    40 },
	},
	//I=16, D=72, wp= 0.014, ws= 0.015, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   69,    87,    71,    29 },
		{   67,    85,    72,    32 },
		{   64,    84,    73,    35 },
		{   61,    84,    74,    37 },
		{   58,    83,    75,    40 },
		{   56,    81,    76,    43 },
		{   53,    81,    77,    45 },
		{   51,    79,    78,    48 },
	},
	//I=16, D=80, wp= 0.013, ws= 0.014, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   68,    80,    69,    39 },
		{   66,    79,    70,    41 },
		{   64,    78,    71,    43 },
		{   62,    77,    72,    45 },
		{   60,    77,    72,    47 },
		{   58,    77,    73,    48 },
		{   56,    76,    74,    50 },
		{   54,    76,    74,    52 },
	},
	//I=16, D=88, wp= 0.011, ws= 0.013, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   67,    76,    68,    45 },
		{   65,    76,    69,    46 },
		{   64,    75,    69,    48 },
		{   63,    74,    70,    49 },
		{   61,    74,    70,    51 },
		{   60,    73,    71,    52 },
		{   58,    73,    71,    54 },
		{   57,    72,    72,    55 },
	},
	//I=16, D=96, wp= 0.010, ws= 0.011, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   66,    74,    67,    49 },
		{   65,    73,    68,    50 },
		{   64,    72,    68,    52 },
		{   63,    72,    68,    53 },
		{   62,    71,    69,    54 },
		{   61,    71,    69,    55 },
		{   59,    71,    70,    56 },
		{   58,    71,    70,    57 },
	},
	//I=16, D=104, wp= 0.010, ws= 0.011, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   66,    71,    67,    52 },
		{   65,    71,    67,    53 },
		{   64,    71,    67,    54 },
		{   63,    70,    68,    55 },
		{   62,    70,    68,    56 },
		{   61,    70,    68,    57 },
		{   60,    70,    68,    58 },
		{   60,    68,    69,    59 },
	},
	//I=16, D=112, wp= 0.009, ws= 0.010, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   66,    70,    66,    54 },
		{   65,    70,    66,    55 },
		{   64,    69,    67,    56 },
		{   63,    69,    67,    57 },
		{   63,    69,    67,    57 },
		{   62,    69,    67,    58 },
		{   61,    68,    68,    59 },
		{   60,    68,    68,    60 },
	},
	//I=16, D=120, wp= 0.008, ws= 0.009, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   65,    69,    66,    56 },
		{   65,    68,    66,    57 },
		{   64,    69,    66,    57 },
		{   63,    69,    66,    58 },
		{   63,    67,    67,    59 },
		{   62,    68,    67,    59 },
		{   62,    67,    67,    60 },
		{   61,    68,    67,    60 },
	},
	//I=16, D=128, wp= 0.008, ws= 0.009, alpha= 0.100
	//4taps-- Vertical sampling
	{
		{   65,    69,    65,    57 },
		{   65,    67,    66,    58 },
		{   64,    68,    66,    58 },
		{   64,    67,    66,    59 },
		{   63,    68,    66,    59 },
		{   62,    68,    66,    60 },
		{   62,    67,    67,    60 },
		{   61,    67,    67,    61 },
	},
};

const short VO_coef_8t8p_ratio8[][4][8] =
{
	// for all upscale ratio
	//8taps-- Horizontal sampling
	{
	   {    0,     0,    -8,   256,    16,    -8,     0,     0 },
	   {    0,     0,   -24,   240,    48,    -8,     0,     0 },
	   {    0,     0,   -28,   212,    88,   -16,     0,     0 },
	   {    0,     0,   -28,   176,   132,   -24,     0,     0 },
	},
	//I=8, D=9, wp= 0.111, ws= 0.122, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -3,     3,    -8,   238,    22,   -12,     7,     9 },
	   {  -12,    17,   -32,   235,    61,   -28,    18,    -3 },
	   {  -18,    27,   -48,   219,   105,   -43,    27,   -13 },
	   {  -21,    32,   -55,   190,   150,   -53,    32,   -19 },
	},
	//I=8, D=10, wp= 0.100, ws= 0.110, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   19,   -20,    16,   222,    45,   -32,    25,   -19 },
	   {   11,    -7,    -9,   216,    79,   -42,    28,   -20 },
	   {    3,     6,   -30,   201,   114,   -48,    28,   -18 },
	   {   -6,    16,   -42,   178,   147,   -48,    24,   -13 },
	},
	//I=8, D=11, wp= 0.091, ws= 0.100, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   27,   -34,    33,   211,    61,   -42,    27,   -27 },
	   {   23,   -24,     8,   200,    89,   -45,    24,   -19 },
	   {   17,   -12,   -12,   183,   116,   -44,    18,   -10 },
	   {    9,    -1,   -28,   164,   141,   -38,     9,     0 },
	},
	//I=8, D=12, wp= 0.083, ws= 0.092, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   23,   -41,    47,   198,    72,   -44,    19,   -18 },
	   {   23,   -34,    23,   188,    94,   -42,    11,    -7 },
	   {   21,   -25,     2,   172,   116,   -36,     3,     3 },
	   {   17,   -16,   -14,   155,   136,   -27,    -6,    11 },
	},
	//I=8, D=13, wp= 0.077, ws= 0.085, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   11,   -40,    57,   182,    79,   -39,     5,     1 },
	   {   16,   -38,    35,   172,    98,   -33,    -3,     9 },
	   {   18,   -33,    16,   161,   116,   -25,   -11,    14 },
	   {   19,   -26,     0,   146,   132,   -14,   -19,    18 },
	},
	//I=8, D=14, wp= 0.071, ws= 0.079, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -1,   -35,    64,   167,    83,   -31,    -8,    17 },
	   {    6,   -37,    45,   162,   100,   -24,   -15,    19 },
	   {   12,   -35,    28,   152,   115,   -14,   -22,    20 },
	   {   16,   -32,    12,   142,   129,    -2,   -28,    19 },
	},
	//I=8, D=15, wp= 0.067, ws= 0.073, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -9,   -29,    69,   154,    85,   -23,   -16,    25 },
	   {   -2,   -33,    53,   152,   100,   -15,   -23,    24 },
	   {    4,   -35,    37,   147,   115,    -4,   -29,    21 },
	   {   11,   -34,    22,   138,   127,     8,   -32,    16 },
	},
	//I=8, D=16, wp= 0.063, ws= 0.069, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -16,   -23,    72,   146,    86,   -16,   -21,    28 },
	   {   -9,   -28,    58,   145,   100,    -7,   -27,    24 },
	   {   -2,   -32,    44,   142,   113,     4,   -31,    18 },
	   {    5,   -33,    30,   134,   125,    16,   -33,    12 },
	},
	//I=8, D=17, wp= 0.059, ws= 0.065, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -20,   -16,    74,   138,    86,    -8,   -24,    26 },
	   {  -14,   -23,    62,   138,   100,     1,   -28,    20 },
	   {   -8,   -28,    49,   137,   112,    11,   -31,    14 },
	   {   -1,   -31,    36,   132,   122,    23,   -32,     7 },
	},
	//I=8, D=18, wp= 0.056, ws= 0.061, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -22,   -10,    75,   133,    86,    -2,   -25,    21 },
	   {  -18,   -17,    65,   132,    99,     8,   -28,    15 },
	   {  -13,   -22,    54,   130,   110,    18,   -29,     8 },
	   {   -6,   -26,    42,   125,   119,    30,   -29,     1 },
	},
	//I=8, D=19, wp= 0.053, ws= 0.058, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -23,    -3,    76,   125,    86,     5,   -25,    15 },
	   {  -20,   -10,    67,   126,    97,    14,   -26,     8 },
	   {  -16,   -16,    57,   125,   107,    24,   -26,     1 },
	   {  -11,   -21,    46,   122,   115,    35,   -25,    -5 },
	},
	//I=8, D=20, wp= 0.050, ws= 0.055, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -23,     3,    77,   120,    85,    11,   -24,     7 },
	   {  -22,    -4,    69,   121,    95,    20,   -24,     1 },
	   {  -19,   -10,    60,   119,   104,    30,   -23,    -5 },
	   {  -15,   -16,    50,   117,   111,    40,   -20,   -11 },
	},
	//I=8, D=21, wp= 0.048, ws= 0.052, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -22,     9,    77,   115,    84,    16,   -22,    -1 },
	   {  -22,     2,    69,   116,    93,    25,   -21,    -6 },
	   {  -21,    -5,    61,   115,   101,    34,   -18,   -11 },
	   {  -19,   -10,    53,   112,   107,    43,   -15,   -15 },
	},
	//I=8, D=22, wp= 0.045, ws= 0.050, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -21,    14,    76,   111,    83,    21,   -20,    -8 },
	   {  -22,     7,    70,   110,    91,    29,   -17,   -12 },
	   {  -22,     1,    63,   109,    97,    38,   -14,   -16 },
	   {  -21,    -5,    55,   107,   103,    46,   -10,   -19 },
	},
	//I=8, D=23, wp= 0.043, ws= 0.048, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -19,    18,    76,   105,    82,    25,   -17,   -14 },
	   {  -21,    12,    70,   104,    89,    33,   -14,   -17 },
	   {  -22,     5,    63,   105,    94,    41,   -10,   -20 },
	   {  -22,    -1,    56,   103,    99,    48,    -6,   -21 },
	},
	//I=8, D=24, wp= 0.042, ws= 0.046, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -18,    22,    75,   102,    81,    28,   -15,   -19 },
	   {  -20,    15,    70,   101,    86,    36,   -11,   -21 },
	   {  -22,     9,    64,   100,    91,    43,    -7,   -22 },
	   {  -23,     3,    57,    99,    95,    50,    -2,   -23 },
	},
	//I=8, D=25, wp= 0.040, ws= 0.044, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -16,    24,    74,    99,    80,    31,   -13,   -23 },
	   {  -19,    18,    69,    99,    84,    38,    -9,   -24 },
	   {  -21,    12,    64,    97,    89,    44,    -4,   -25 },
	   {  -23,     6,    57,    96,    92,    51,     1,   -24 },
	},
	//I=8, D=26, wp= 0.038, ws= 0.042, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -14,    27,    74,    96,    78,    33,   -11,   -27 },
	   {  -18,    21,    69,    95,    83,    39,    -6,   -27 },
	   {  -21,    15,    63,    95,    86,    46,    -2,   -26 },
	   {  -23,     9,    58,    91,    90,    52,     4,   -25 },
	},
	//I=8, D=27, wp= 0.037, ws= 0.041, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -13,    29,    73,    93,    77,    35,    -9,   -29 },
	   {  -17,    23,    68,    92,    81,    41,    -4,   -28 },
	   {  -20,    17,    63,    92,    84,    46,     1,   -27 },
	   {  -23,    11,    58,    90,    87,    52,     6,   -25 },
	},
	//I=8, D=28, wp= 0.036, ws= 0.039, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -11,    30,    72,    91,    76,    36,    -7,   -31 },
	   {  -15,    24,    67,    91,    79,    41,    -2,   -29 },
	   {  -19,    19,    63,    88,    82,    47,     3,   -27 },
	   {  -22,    13,    58,    87,    85,    52,     8,   -25 },
	},
	//I=8, D=29, wp= 0.034, ws= 0.038, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {  -10,    31,    71,    90,    75,    37,    -6,   -32 },
	   {  -14,    26,    67,    88,    78,    42,    -1,   -30 },
	   {  -18,    20,    62,    87,    81,    47,     4,   -27 },
	   {  -22,    15,    57,    86,    83,    52,     9,   -24 },
	},
	//I=8, D=30, wp= 0.033, ws= 0.037, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -9,    32,    70,    88,    74,    38,    -4,   -33 },
	   {  -13,    27,    66,    85,    77,    43,     1,   -30 },
	   {  -17,    21,    62,    84,    79,    48,     6,   -27 },
	   {  -21,    16,    57,    84,    81,    52,    11,   -24 },
	},
	//I=8, D=31, wp= 0.032, ws= 0.035, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -8,    33,    70,    86,    73,    38,    -3,   -33 },
	   {  -12,    28,    65,    85,    75,    43,     2,   -30 },
	   {  -16,    22,    61,    83,    78,    48,     7,   -27 },
	   {  -20,    17,    57,    82,    80,    52,    12,   -24 },
	},
	//I=8, D=36, wp= 0.028, ws= 0.031, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   -2,    36,    66,    77,    68,    40,     3,   -32 },
	   {   -7,    31,    62,    77,    70,    44,     7,   -28 },
	   {  -11,    26,    58,    76,    71,    48,    12,   -24 },
	   {  -15,    21,    55,    74,    73,    51,    17,   -20 },
	},
	//I=8, D=40, wp= 0.025, ws= 0.028, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {    2,    36,    62,    73,    65,    40,     6,   -28 },
	   {   -3,    32,    59,    72,    66,    43,    11,   -24 },
	   {   -7,    28,    56,    70,    67,    47,    15,   -20 },
	   {  -11,    23,    53,    69,    68,    50,    19,   -15 },
	},
	//I=8, D=44, wp= 0.023, ws= 0.025, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {    6,    37,    59,    66,    61,    40,    10,   -23 },
	   {    2,    33,    56,    65,    62,    43,    14,   -19 },
	   {   -2,    29,    53,    65,    63,    45,    18,   -15 },
	   {   -6,    25,    51,    64,    64,    48,    21,   -11 },
	},
	//I=8, D=48, wp= 0.021, ws= 0.023, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {    9,    36,    55,    64,    57,    39,    13,   -17 },
	   {    6,    33,    53,    60,    58,    42,    17,   -13 },
	   {    2,    30,    51,    60,    58,    44,    20,    -9 },
	   {   -2,    26,    48,    61,    59,    46,    23,    -5 },
	},
	//I=8, D=52, wp= 0.019, ws= 0.021, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   13,    36,    52,    58,    53,    38,    16,   -10 },
	   {   10,    33,    50,    57,    54,    40,    19,    -7 },
	   {    6,    30,    48,    57,    54,    42,    22,    -3 },
	   {    3,    27,    46,    56,    55,    44,    25,     0 },
	},
	//I=8, D=56, wp= 0.018, ws= 0.020, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   16,    36,    49,    52,    50,    38,    19,    -4 },
	   {   13,    33,    47,    54,    50,    39,    21,    -1 },
	   {   10,    31,    45,    52,    51,    41,    24,     2 },
	   {    8,    28,    44,    52,    51,    42,    26,     5 },
	},
	//I=8, D=60, wp= 0.017, ws= 0.018, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   19,    35,    46,    49,    47,    37,    21,     2 },
	   {   16,    33,    44,    51,    47,    38,    23,     4 },
	   {   14,    31,    43,    49,    48,    39,    25,     7 },
	   {   12,    29,    42,    48,    48,    41,    27,     9 },
	},
	//I=8, D=64, wp= 0.016, ws= 0.017, alpha= 0.100
	//8taps-- Horizontal sampling
	{
	   {   21,    35,    43,    47,    44,    36,    23,     7 },
	   {   19,    33,    42,    46,    45,    37,    25,     9 },
	   {   17,    31,    41,    47,    45,    38,    26,    11 },
	   {   15,    30,    40,    46,    45,    39,    28,    13 },
	},
};

const short VO_coef_8t16p_ratio[][8][8] =
{
	// for all upscale ratio
	//8taps-- Horizontal sampling
	{
		{    0,     0,    -4,   256,     8,    -4,     0,     0 },
		{    0,     0,   -12,   252,    24,    -8,     0,     0 },
		{    0,     0,   -20,   244,    40,    -8,     0,     0 },
		{    0,     0,   -26,   234,    58,   -10,     0,     0 },
		{    0,     0,   -28,   220,    78,   -14,     0,     0 },
		{    0,     0,   -28,   202,   100,   -18,     0,     0 },
		{    0,     0,   -28,   184,   122,   -22,     0,     0 },
		{    0,     0,   -26,   164,   142,   -24,     0,     0 },
	},

	//I=16, D=17, wp= 0.059, ws= 0.065, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -13,    12,   -15,   252,     0,     5,    -8,    23 },
		{  -17,    19,   -28,   252,    18,    -3,    -3,    18 },
		{  -20,    25,   -39,   248,    38,   -12,     3,    13 },
		{  -23,    29,   -48,   243,    60,   -21,     9,     7 },
		{  -24,    32,   -54,   233,    84,   -30,    15,     0 },
		{  -24,    34,   -58,   220,   108,   -39,    20,    -5 },
		{  -22,    34,   -58,   200,   133,   -46,    26,   -11 },
		{  -19,    33,   -57,   180,   158,   -53,    30,   -16 },
	},
	//I=16, D=18, wp= 0.056, ws= 0.061, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{    0,     0,    -1,   234,    14,    -8,     5,    12 },
		{   -5,     7,   -15,   238,    31,   -16,    10,     6 },
		{  -10,    13,   -27,   239,    50,   -24,    15,     0 },
		{  -14,    20,   -37,   233,    71,   -32,    20,    -5 },
		{  -17,    25,   -45,   223,    94,   -39,    25,   -10 },
		{  -20,    29,   -51,   215,   116,   -46,    28,   -15 },
		{  -21,    31,   -54,   199,   139,   -51,    31,   -18 },
		{  -21,    33,   -55,   179,   161,   -54,    33,   -20 },
	},
	//I=16, D=19, wp= 0.053, ws= 0.058, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   12,   -12,    12,   225,    26,   -19,    16,    -4 },
		{    7,    -6,    -2,   228,    43,   -26,    20,    -8 },
		{    3,     1,   -14,   226,    61,   -33,    24,   -12 },
		{   -2,     8,   -25,   221,    81,   -39,    27,   -15 },
		{   -6,    14,   -34,   214,   100,   -44,    29,   -17 },
		{  -10,    19,   -42,   204,   121,   -48,    30,   -18 },
		{  -13,    23,   -47,   193,   140,   -51,    30,   -19 },
		{  -16,    27,   -50,   177,   159,   -52,    29,   -18 },
	},
	//I=16, D=20, wp= 0.050, ws= 0.055, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   21,   -23,    23,   222,    37,   -29,    23,   -18 },
		{   17,   -17,     9,   221,    53,   -34,    26,   -19 },
		{   13,   -10,    -3,   217,    70,   -39,    28,   -20 },
		{    9,    -4,   -15,   214,    87,   -43,    28,   -20 },
		{    5,     3,   -24,   204,   105,   -46,    28,   -19 },
		{    0,     8,   -33,   197,   122,   -48,    27,   -17 },
		{   -4,    14,   -39,   184,   139,   -48,    25,   -15 },
		{   -8,    19,   -44,   171,   155,   -47,    22,   -12 },
	},
	//I=16, D=21, wp= 0.048, ws= 0.052, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   26,   -31,    32,   218,    46,   -36,    27,   -26 },
		{   23,   -25,    18,   216,    61,   -40,    28,   -25 },
		{   20,   -19,     6,   210,    77,   -43,    28,   -23 },
		{   17,   -13,    -6,   204,    92,   -45,    27,   -20 },
		{   13,    -7,   -16,   197,   107,   -46,    25,   -17 },
		{    9,    -1,   -24,   186,   123,   -46,    22,   -13 },
		{    4,     5,   -32,   177,   137,   -45,    19,    -9 },
		{    0,    10,   -37,   164,   151,   -42,    15,    -5 },
	},
	//I=16, D=22, wp= 0.045, ws= 0.050, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   27,   -37,    40,   214,    54,   -41,    28,   -29 },
		{   26,   -32,    26,   209,    68,   -43,    27,   -25 },
		{   24,   -27,    14,   204,    82,   -45,    25,   -21 },
		{   22,   -21,     2,   198,    95,   -45,    22,   -17 },
		{   19,   -15,    -8,   189,   109,   -45,    19,   -12 },
		{   15,   -10,   -17,   180,   122,   -43,    16,    -7 },
		{   11,    -4,   -25,   171,   135,   -40,    11,    -3 },
		{    7,     2,   -31,   158,   147,   -36,     7,     2 },
	},
	//I=16, D=23, wp= 0.043, ws= 0.048, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   26,   -41,    47,   208,    61,   -43,    25,   -27 },
		{   26,   -37,    34,   203,    73,   -44,    23,   -22 },
		{   25,   -32,    21,   196,    86,   -44,    20,   -16 },
		{   24,   -27,    10,   189,    98,   -44,    17,   -11 },
		{   22,   -22,     0,   181,   110,   -42,    13,    -6 },
		{   19,   -17,   -10,   174,   122,   -39,     8,    -1 },
		{   16,   -11,   -18,   163,   133,   -35,     4,     4 },
		{   12,    -6,   -25,   154,   144,   -30,    -1,     8 },
	},
	//I=16, D=24, wp= 0.042, ws= 0.046, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   22,   -42,    54,   200,    66,   -44,    20,   -20 },
		{   23,   -39,    40,   196,    78,   -44,    17,   -15 },
		{   23,   -36,    28,   191,    89,   -43,    13,    -9 },
		{   23,   -32,    17,   184,   100,   -41,     9,    -4 },
		{   22,   -27,     7,   175,   111,   -38,     5,     1 },
		{   21,   -23,    -2,   167,   121,   -34,     1,     5 },
		{   19,   -18,   -11,   160,   131,   -30,    -4,     9 },
		{   16,   -13,   -18,   150,   141,   -24,    -9,    13 },
	},
	//I=16, D=25, wp= 0.040, ws= 0.044, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   16,   -42,    59,   193,    71,   -43,    13,   -11 },
		{   18,   -40,    46,   188,    81,   -41,    10,    -6 },
		{   20,   -38,    35,   182,    91,   -39,     6,    -1 },
		{   21,   -35,    24,   177,   101,   -37,     2,     3 },
		{   21,   -31,    14,   169,   111,   -33,    -2,     7 },
		{   21,   -28,     5,   163,   120,   -29,    -7,    11 },
		{   20,   -24,    -3,   153,   130,   -23,   -11,    14 },
		{   18,   -20,   -11,   148,   138,   -18,   -15,    16 },
	},
	//I=16, D=26, wp= 0.038, ws= 0.042, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   10,   -41,    63,   185,    74,   -40,     6,    -1 },
		{   13,   -40,    52,   179,    84,   -38,     3,     3 },
		{   15,   -38,    41,   174,    93,   -35,    -1,     7 },
		{   17,   -37,    30,   171,   102,   -32,    -5,    10 },
		{   18,   -34,    21,   164,   111,   -28,    -9,    13 },
		{   19,   -31,    12,   157,   120,   -23,   -13,    15 },
		{   19,   -28,     3,   151,   128,   -17,   -17,    17 },
		{   19,   -25,    -4,   144,   136,   -11,   -21,    18 },
	},
	//I=16, D=27, wp= 0.037, ws= 0.041, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{    3,   -38,    67,   174,    77,   -36,     0,     9 },
		{    7,   -38,    56,   172,    86,   -34,    -4,    11 },
		{   10,   -38,    46,   167,    95,   -30,    -8,    14 },
		{   12,   -37,    36,   165,   103,   -27,   -12,    16 },
		{   14,   -36,    27,   160,   111,   -22,   -15,    17 },
		{   16,   -34,    18,   155,   119,   -17,   -19,    18 },
		{   17,   -31,    10,   147,   127,   -11,   -22,    19 },
		{   18,   -29,     2,   143,   134,    -5,   -26,    19 },
	},
	//I=16, D=28, wp= 0.036, ws= 0.039, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -2,   -35,    69,   168,    79,   -33,    -6,    16 },
		{    1,   -36,    60,   165,    87,   -29,   -10,    18 },
		{    5,   -36,    50,   161,    96,   -26,   -13,    19 },
		{    8,   -36,    41,   158,   104,   -22,   -17,    20 },
		{   10,   -36,    32,   156,   111,   -17,   -20,    20 },
		{   13,   -35,    24,   149,   119,   -11,   -23,    20 },
		{   15,   -33,    16,   144,   126,    -5,   -26,    19 },
		{   17,   -31,     8,   139,   133,     1,   -29,    18 },
	},
	//I=16, D=29, wp= 0.034, ws= 0.038, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -7,   -31,    71,   161,    80,   -29,   -11,    22 },
		{   -4,   -33,    62,   160,    88,   -25,   -14,    22 },
		{    0,   -35,    54,   158,    96,   -21,   -18,    22 },
		{    3,   -35,    45,   155,   104,   -17,   -21,    22 },
		{    7,   -35,    37,   151,   111,   -12,   -24,    21 },
		{   10,   -35,    29,   147,   118,    -6,   -27,    20 },
		{   12,   -34,    21,   142,   125,     0,   -29,    19 },
		{   15,   -33,    14,   136,   131,     7,   -31,    17 },
	},
	//I=16, D=30, wp= 0.033, ws= 0.037, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -11,   -28,    73,   155,    81,   -25,   -15,    26 },
		{   -8,   -30,    65,   154,    89,   -21,   -18,    25 },
		{   -4,   -32,    57,   152,    97,   -17,   -21,    24 },
		{   -1,   -34,    49,   151,   104,   -12,   -24,    23 },
		{    3,   -34,    41,   147,   111,    -7,   -27,    22 },
		{    6,   -35,    33,   144,   118,    -1,   -29,    20 },
		{    9,   -34,    26,   140,   124,     5,   -31,    17 },
		{   12,   -34,    18,   137,   130,    11,   -33,    15 },
	},
	//I=16, D=31, wp= 0.032, ws= 0.035, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -14,   -24,    74,   149,    82,   -21,   -18,    28 },
		{  -11,   -27,    67,   149,    89,   -17,   -21,    27 },
		{   -8,   -30,    59,   150,    97,   -13,   -24,    25 },
		{   -4,   -32,    52,   147,   104,    -8,   -26,    23 },
		{   -1,   -33,    44,   145,   111,    -3,   -28,    21 },
		{    3,   -34,    37,   142,   117,     3,   -30,    18 },
		{    6,   -34,    30,   138,   123,     9,   -32,    16 },
		{   10,   -34,    23,   132,   129,    16,   -33,    13 },
	},
	//I=16, D=32, wp= 0.031, ws= 0.034, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -17,   -21,    75,   145,    82,   -17,   -20,    29 },
		{  -14,   -24,    68,   145,    90,   -13,   -23,    27 },
		{  -11,   -27,    62,   144,    97,    -9,   -25,    25 },
		{   -7,   -29,    54,   144,   104,    -4,   -28,    22 },
		{   -4,   -31,    47,   143,   110,     1,   -30,    20 },
		{    0,   -32,    40,   138,   117,     7,   -31,    17 },
		{    3,   -33,    33,   136,   122,    13,   -32,    14 },
		{    7,   -33,    26,   132,   127,    20,   -33,    10 },
	},
	//I=16, D=33, wp= 0.030, ws= 0.033, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -19,   -18,    76,   141,    83,   -14,   -22,    29 },
		{  -16,   -21,    70,   141,    90,   -10,   -24,    26 },
		{  -13,   -24,    63,   141,    97,    -5,   -27,    24 },
		{  -10,   -27,    57,   141,   103,     0,   -29,    21 },
		{   -7,   -29,    50,   139,   110,     5,   -30,    18 },
		{   -3,   -31,    43,   137,   116,    11,   -31,    14 },
		{    0,   -32,    36,   135,   121,    17,   -32,    11 },
		{    4,   -32,    30,   131,   126,    23,   -33,     7 },
	},
	//I=16, D=34, wp= 0.029, ws= 0.032, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -21,   -14,    77,   137,    83,   -10,   -23,    27 },
		{  -18,   -18,    71,   137,    90,    -6,   -25,    25 },
		{  -16,   -21,    65,   139,    96,    -2,   -27,    22 },
		{  -13,   -24,    59,   138,   103,     3,   -29,    19 },
		{  -10,   -26,    52,   137,   109,     9,   -30,    15 },
		{   -6,   -28,    46,   134,   115,    14,   -31,    12 },
		{   -3,   -30,    39,   134,   120,    20,   -32,     8 },
		{    1,   -31,    33,   127,   125,    27,   -31,     5 },
	},
	//I=16, D=35, wp= 0.029, ws= 0.031, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -22,   -11,    77,   134,    83,    -7,   -24,    26 },
		{  -20,   -15,    72,   135,    90,    -3,   -26,    23 },
		{  -18,   -18,    66,   137,    96,     2,   -28,    19 },
		{  -15,   -21,    61,   135,   102,     7,   -29,    16 },
		{  -12,   -24,    55,   134,   108,    12,   -30,    13 },
		{   -9,   -26,    48,   132,   114,    18,   -30,     9 },
		{   -5,   -28,    42,   129,   119,    24,   -30,     5 },
		{   -2,   -29,    36,   126,   123,    30,   -30,     2 },
	},
	//I=16, D=36, wp= 0.028, ws= 0.031, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -23,    -8,    78,   132,    83,    -4,   -25,    23 },
		{  -21,   -12,    73,   133,    89,     0,   -26,    20 },
		{  -19,   -15,    68,   132,    96,     5,   -28,    17 },
		{  -17,   -18,    62,   132,   102,    10,   -28,    13 },
		{  -14,   -21,    56,   132,   107,    15,   -29,    10 },
		{  -11,   -23,    51,   129,   112,    21,   -29,     6 },
		{   -8,   -25,    45,   127,   117,    27,   -29,     2 },
		{   -5,   -27,    39,   124,   121,    33,   -28,    -1 },
	},
	//I=16, D=37, wp= 0.027, ws= 0.030, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -23,    -4,    78,   127,    83,     0,   -25,    20 },
		{  -22,    -8,    73,   129,    89,     4,   -26,    17 },
		{  -20,   -12,    69,   130,    95,     8,   -27,    13 },
		{  -18,   -15,    63,   130,   101,    13,   -28,    10 },
		{  -16,   -18,    58,   129,   106,    19,   -28,     6 },
		{  -13,   -21,    53,   127,   111,    24,   -28,     3 },
		{  -10,   -23,    47,   125,   115,    30,   -27,    -1 },
		{   -7,   -25,    41,   123,   119,    35,   -26,    -4 },
	},
	//I=16, D=38, wp= 0.026, ws= 0.029, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -24,    -1,    78,   126,    83,     3,   -25,    16 },
		{  -23,    -5,    74,   127,    89,     7,   -26,    13 },
		{  -21,    -9,    69,   127,    94,    12,   -26,    10 },
		{  -19,   -12,    65,   126,   100,    17,   -27,     6 },
		{  -17,   -15,    60,   124,   105,    22,   -26,     3 },
		{  -15,   -18,    54,   125,   109,    27,   -26,     0 },
		{  -13,   -20,    49,   123,   114,    32,   -25,    -4 },
		{  -10,   -22,    43,   121,   117,    38,   -24,    -7 },
	},
	//I=16, D=39, wp= 0.026, ws= 0.028, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -24,     2,    78,   122,    83,     6,   -24,    13 },
		{  -23,    -2,    74,   125,    88,    10,   -25,     9 },
		{  -22,    -5,    70,   123,    94,    15,   -25,     6 },
		{  -20,    -9,    66,   123,    99,    19,   -25,     3 },
		{  -19,   -12,    61,   124,   103,    24,   -25,     0 },
		{  -17,   -15,    56,   122,   108,    30,   -24,    -4 },
		{  -15,   -17,    51,   120,   112,    35,   -23,    -7 },
		{  -12,   -20,    45,   118,   115,    40,   -21,    -9 },
	},
	//I=16, D=40, wp= 0.025, ws= 0.028, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -23,     5,    78,   120,    83,     9,   -24,     8 },
		{  -23,     1,    75,   121,    88,    13,   -24,     5 },
		{  -22,    -2,    71,   120,    93,    18,   -24,     2 },
		{  -21,    -6,    66,   122,    98,    22,   -24,    -1 },
		{  -20,    -9,    62,   121,   102,    27,   -23,    -4 },
		{  -18,   -12,    57,   120,   106,    32,   -22,    -7 },
		{  -16,   -14,    52,   117,   110,    37,   -21,    -9 },
		{  -14,   -17,    47,   116,   113,    42,   -19,   -12 },
	},
	//I=16, D=41, wp= 0.024, ws= 0.027, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -23,     8,    78,   118,    82,    12,   -23,     4 },
		{  -23,     4,    75,   118,    87,    16,   -23,     2 },
		{  -22,     1,    71,   118,    92,    20,   -23,    -1 },
		{  -22,    -3,    67,   119,    96,    25,   -22,    -4 },
		{  -21,    -6,    63,   118,   100,    30,   -21,    -7 },
		{  -19,    -9,    58,   117,   104,    34,   -20,    -9 },
		{  -18,   -12,    54,   115,   108,    39,   -18,   -12 },
		{  -16,   -14,    49,   112,   111,    44,   -16,   -14 },
	},
	//I=16, D=42, wp= 0.024, ws= 0.026, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -22,    11,    78,   115,    82,    14,   -22,     0 },
		{  -22,     7,    75,   114,    87,    19,   -22,    -2 },
		{  -22,     4,    71,   115,    91,    23,   -21,    -5 },
		{  -22,     0,    68,   115,    95,    27,   -20,    -7 },
		{  -21,    -3,    64,   114,    99,    32,   -19,   -10 },
		{  -20,    -6,    59,   115,   102,    36,   -18,   -12 },
		{  -19,    -9,    55,   112,   106,    41,   -16,   -14 },
		{  -18,   -11,    50,   111,   108,    46,   -14,   -16 },
	},
	//I=16, D=43, wp= 0.023, ws= 0.026, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -21,    13,    78,   111,    82,    17,   -21,    -3 },
		{  -22,    10,    75,   112,    86,    21,   -20,    -6 },
		{  -22,     6,    72,   113,    90,    25,   -20,    -8 },
		{  -22,     3,    68,   112,    94,    29,   -18,   -10 },
		{  -22,     0,    64,   113,    97,    34,   -17,   -13 },
		{  -21,    -3,    60,   110,   101,    38,   -15,   -14 },
		{  -20,    -6,    56,   109,   104,    43,   -14,   -16 },
		{  -19,    -9,    52,   108,   106,    47,   -11,   -18 },
	},
	//I=16, D=44, wp= 0.023, ws= 0.025, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -21,    16,    78,   110,    81,    19,   -20,    -7 },
		{  -21,    12,    75,   110,    85,    23,   -19,    -9 },
		{  -22,     9,    72,   110,    89,    27,   -18,   -11 },
		{  -22,     5,    68,   111,    93,    31,   -17,   -13 },
		{  -22,     2,    64,   110,    96,    36,   -15,   -15 },
		{  -22,    -1,    61,   109,    99,    40,   -13,   -17 },
		{  -21,    -4,    57,   107,   102,    44,   -11,   -18 },
		{  -20,    -6,    53,   105,   104,    48,    -9,   -19 },
	},
	//I=16, D=45, wp= 0.022, ws= 0.024, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -20,    18,    78,   107,    81,    21,   -19,   -10 },
		{  -21,    14,    75,   109,    84,    25,   -18,   -12 },
		{  -21,    11,    72,   108,    88,    29,   -17,   -14 },
		{  -22,     8,    68,   109,    91,    33,   -15,   -16 },
		{  -22,     5,    65,   107,    94,    37,   -13,   -17 },
		{  -22,     2,    61,   106,    97,    41,   -11,   -18 },
		{  -22,    -1,    57,   106,   100,    45,    -9,   -20 },
		{  -21,    -4,    53,   105,   102,    49,    -7,   -21 },
	},
	//I=16, D=46, wp= 0.022, ws= 0.024, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -19,    20,    77,   107,    80,    23,   -18,   -14 },
		{  -20,    16,    74,   106,    84,    27,   -16,   -15 },
		{  -21,    13,    71,   107,    87,    31,   -15,   -17 },
		{  -21,    10,    68,   105,    90,    35,   -13,   -18 },
		{  -22,     7,    65,   104,    93,    39,   -11,   -19 },
		{  -22,     4,    61,   103,    96,    43,    -9,   -20 },
		{  -22,     1,    58,   103,    98,    46,    -7,   -21 },
		{  -22,    -2,    54,   103,   100,    50,    -5,   -22 },
	},
	//I=16, D=47, wp= 0.021, ws= 0.023, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -18,    22,    77,   103,    80,    25,   -17,   -16 },
		{  -19,    18,    74,   104,    83,    29,   -15,   -18 },
		{  -20,    15,    71,   105,    86,    32,   -14,   -19 },
		{  -21,    12,    68,   104,    89,    36,   -12,   -20 },
		{  -22,     9,    65,   103,    92,    40,   -10,   -21 },
		{  -22,     6,    62,   102,    94,    44,    -8,   -22 },
		{  -22,     3,    58,   101,    96,    47,    -5,   -22 },
		{  -23,     0,    55,   100,    98,    51,    -3,   -22 },
	},
	//I=16, D=48, wp= 0.021, ws= 0.023, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -17,    23,    76,   103,    79,    27,   -16,   -19 },
		{  -18,    20,    74,   102,    82,    30,   -14,   -20 },
		{  -20,    17,    71,   102,    85,    34,   -12,   -21 },
		{  -21,    14,    68,   102,    88,    37,   -10,   -22 },
		{  -21,    11,    65,   100,    90,    41,    -8,   -22 },
		{  -22,     8,    62,   100,    92,    45,    -6,   -23 },
		{  -23,     5,    59,    98,    95,    48,    -3,   -23 },
		{  -23,     2,    55,    98,    96,    52,    -1,   -23 },
	},
	//I=16, D=49, wp= 0.020, ws= 0.022, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -16,    25,    76,   100,    79,    28,   -15,   -21 },
		{  -18,    22,    74,   100,    82,    31,   -13,   -22 },
		{  -19,    18,    71,   101,    84,    35,   -11,   -23 },
		{  -20,    15,    68,   100,    87,    38,    -9,   -23 },
		{  -21,    12,    65,    99,    89,    42,    -7,   -23 },
		{  -22,     9,    62,    99,    91,    45,    -4,   -24 },
		{  -23,     6,    59,    98,    93,    49,    -2,   -24 },
		{  -23,     3,    56,    96,    95,    52,     1,   -24 },
	},
	//I=16, D=50, wp= 0.020, ws= 0.022, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -15,    26,    76,    99,    78,    29,   -14,   -23 },
		{  -17,    23,    73,    99,    81,    33,   -12,   -24 },
		{  -18,    20,    71,    98,    83,    36,   -10,   -24 },
		{  -20,    17,    68,    98,    86,    39,    -8,   -24 },
		{  -21,    14,    65,    97,    88,    43,    -5,   -25 },
		{  -22,    11,    62,    96,    90,    46,    -3,   -24 },
		{  -23,     8,    59,    95,    92,    49,     0,   -24 },
		{  -23,     5,    56,    94,    93,    53,     2,   -24 },
	},
	//I=16, D=51, wp= 0.020, ws= 0.022, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -14,    27,    75,    98,    78,    30,   -13,   -25 },
		{  -16,    24,    73,    97,    80,    34,   -11,   -25 },
		{  -18,    21,    70,    98,    82,    37,    -9,   -25 },
		{  -19,    18,    68,    95,    85,    40,    -6,   -25 },
		{  -20,    15,    65,    95,    87,    43,    -4,   -25 },
		{  -22,    12,    62,    96,    88,    47,    -2,   -25 },
		{  -23,     9,    59,    95,    90,    50,     1,   -25 },
		{  -23,     6,    56,    92,    92,    53,     4,   -24 },
	},
	//I=16, D=52, wp= 0.019, ws= 0.021, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -14,    28,    75,    98,    77,    31,   -12,   -27 },
		{  -15,    25,    72,    97,    79,    35,   -10,   -27 },
		{  -17,    22,    70,    95,    82,    38,    -7,   -27 },
		{  -19,    19,    67,    95,    84,    41,    -5,   -26 },
		{  -20,    16,    65,    94,    86,    44,    -3,   -26 },
		{  -21,    13,    62,    94,    87,    47,     0,   -26 },
		{  -22,    10,    59,    93,    89,    50,     2,   -25 },
		{  -23,     8,    56,    91,    90,    53,     5,   -24 },
	},
	//I=16, D=53, wp= 0.019, ws= 0.021, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -13,    29,    74,    96,    77,    32,   -11,   -28 },
		{  -15,    26,    72,    96,    79,    35,    -9,   -28 },
		{  -16,    23,    70,    94,    81,    38,    -6,   -28 },
		{  -18,    20,    67,    94,    83,    41,    -4,   -27 },
		{  -20,    17,    65,    94,    85,    44,    -2,   -27 },
		{  -21,    14,    62,    93,    86,    47,     1,   -26 },
		{  -22,    12,    59,    91,    88,    50,     3,   -25 },
		{  -23,     9,    56,    90,    89,    53,     6,   -24 },
	},
	//I=16, D=54, wp= 0.019, ws= 0.020, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -12,    30,    74,    94,    76,    33,   -10,   -29 },
		{  -14,    27,    72,    94,    78,    36,    -8,   -29 },
		{  -16,    24,    69,    93,    80,    39,    -5,   -28 },
		{  -17,    21,    67,    92,    82,    42,    -3,   -28 },
		{  -19,    18,    64,    92,    84,    45,    -1,   -27 },
		{  -21,    15,    62,    91,    85,    48,     2,   -26 },
		{  -22,    13,    59,    89,    87,    51,     4,   -25 },
		{  -23,    10,    56,    88,    88,    54,     7,   -24 },
	},
	//I=16, D=55, wp= 0.018, ws= 0.020, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -11,    31,    74,    91,    76,    34,    -9,   -30 },
		{  -13,    28,    71,    92,    78,    37,    -7,   -30 },
		{  -15,    25,    69,    91,    79,    40,    -4,   -29 },
		{  -17,    22,    67,    91,    81,    42,    -2,   -28 },
		{  -19,    19,    64,    91,    83,    45,     0,   -27 },
		{  -20,    16,    62,    90,    84,    48,     3,   -27 },
		{  -22,    14,    59,    89,    85,    51,     5,   -25 },
		{  -23,    11,    56,    87,    87,    54,     8,   -24 },
	},
	//I=16, D=56, wp= 0.018, ws= 0.020, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -10,    32,    73,    91,    75,    34,    -8,   -31 },
		{  -12,    29,    71,    90,    77,    37,    -6,   -30 },
		{  -14,    26,    69,    90,    79,    40,    -4,   -30 },
		{  -16,    23,    66,    90,    80,    43,    -1,   -29 },
		{  -18,    20,    64,    89,    82,    46,     1,   -28 },
		{  -20,    17,    61,    90,    83,    48,     4,   -27 },
		{  -21,    14,    59,    89,    84,    51,     6,   -26 },
		{  -23,    12,    56,    86,    86,    54,     9,   -24 },
	},
	//I=16, D=57, wp= 0.018, ws= 0.019, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{  -10,    32,    73,    90,    75,    35,    -7,   -32 },
		{  -12,    29,    71,    90,    76,    38,    -5,   -31 },
		{  -14,    26,    68,    91,    78,    40,    -3,   -30 },
		{  -16,    24,    66,    89,    79,    43,     0,   -29 },
		{  -18,    21,    64,    88,    81,    46,     2,   -28 },
		{  -19,    18,    61,    87,    82,    49,     5,   -27 },
		{  -21,    15,    59,    87,    83,    51,     7,   -25 },
		{  -23,    13,    56,    85,    85,    54,    10,   -24 },
	},
	//I=16, D=58, wp= 0.017, ws= 0.019, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -9,    33,    72,    89,    74,    36,    -7,   -32 },
		{  -11,    30,    70,    88,    76,    38,    -4,   -31 },
		{  -13,    27,    68,    88,    77,    41,    -2,   -30 },
		{  -15,    24,    66,    88,    79,    43,     0,   -29 },
		{  -17,    21,    63,    88,    80,    46,     3,   -28 },
		{  -19,    19,    61,    87,    81,    49,     5,   -27 },
		{  -21,    16,    59,    85,    83,    51,     8,   -25 },
		{  -22,    13,    56,    84,    84,    54,    11,   -24 },
	},
	//I=16, D=59, wp= 0.017, ws= 0.019, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -8,    33,    72,    88,    74,    36,    -6,   -33 },
		{  -10,    30,    70,    88,    75,    39,    -4,   -32 },
		{  -13,    28,    68,    87,    77,    41,    -1,   -31 },
		{  -15,    25,    65,    87,    78,    44,     1,   -29 },
		{  -17,    22,    63,    87,    79,    46,     4,   -28 },
		{  -18,    19,    61,    85,    81,    49,     6,   -27 },
		{  -20,    17,    58,    84,    82,    51,     9,   -25 },
		{  -22,    14,    56,    84,    83,    54,    11,   -24 },
	},
	//I=16, D=60, wp= 0.017, ws= 0.018, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -8,    34,    71,    88,    73,    36,    -5,   -33 },
		{  -10,    31,    69,    87,    75,    39,    -3,   -32 },
		{  -12,    28,    67,    88,    76,    41,    -1,   -31 },
		{  -14,    25,    65,    86,    77,    44,     2,   -29 },
		{  -16,    23,    63,    85,    79,    46,     4,   -28 },
		{  -18,    20,    61,    84,    80,    49,     7,   -27 },
		{  -20,    17,    58,    85,    81,    51,     9,   -25 },
		{  -22,    15,    56,    82,    82,    54,    12,   -23 },
	},
	//I=16, D=61, wp= 0.016, ws= 0.018, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -7,    34,    71,    87,    73,    37,    -5,   -34 },
		{   -9,    31,    69,    86,    74,    39,    -2,   -32 },
		{  -11,    29,    67,    85,    75,    42,     0,   -31 },
		{  -14,    26,    65,    84,    77,    44,     3,   -29 },
		{  -16,    23,    63,    84,    78,    47,     5,   -28 },
		{  -18,    21,    60,    83,    79,    49,     8,   -26 },
		{  -19,    18,    58,    83,    80,    51,    10,   -25 },
		{  -21,    15,    56,    81,    81,    54,    13,   -23 },
	},
	//I=16, D=62, wp= 0.016, ws= 0.018, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -6,    35,    71,    85,    72,    37,    -4,   -34 },
		{   -9,    32,    69,    84,    74,    40,    -2,   -32 },
		{  -11,    29,    67,    84,    75,    42,     1,   -31 },
		{  -13,    26,    64,    85,    76,    44,     3,   -29 },
		{  -15,    24,    62,    83,    77,    47,     6,   -28 },
		{  -17,    21,    60,    83,    78,    49,     8,   -26 },
		{  -19,    18,    58,    83,    79,    51,    11,   -25 },
		{  -21,    16,    56,    81,    80,    54,    13,   -23 },
	},
	//I=16, D=63, wp= 0.016, ws= 0.017, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -6,    35,    70,    85,    72,    37,    -3,   -34 },
		{   -8,    32,    68,    85,    73,    40,    -1,   -33 },
		{  -10,    30,    66,    84,    74,    42,     1,   -31 },
		{  -12,    27,    64,    83,    75,    44,     4,   -29 },
		{  -15,    24,    62,    84,    76,    47,     6,   -28 },
		{  -17,    22,    60,    81,    78,    49,     9,   -26 },
		{  -19,    19,    58,    82,    78,    51,    11,   -24 },
		{  -21,    16,    56,    81,    79,    53,    14,   -22 },
	},
	//I=16, D=72, wp= 0.014, ws= 0.015, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   -1,    37,    67,    78,    68,    39,     1,   -33 },
		{   -3,    34,    65,    77,    69,    41,     4,   -31 },
		{   -6,    32,    63,    78,    69,    43,     6,   -29 },
		{   -8,    30,    61,    76,    70,    45,     9,   -27 },
		{  -10,    27,    59,    76,    71,    47,    11,   -25 },
		{  -12,    25,    58,    75,    72,    48,    13,   -23 },
		{  -14,    22,    56,    76,    72,    50,    15,   -21 },
		{  -16,    20,    54,    74,    73,    52,    18,   -19 },
	},


	//I=16, D=80, wp= 0.013, ws= 0.014, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{    3,    37,    63,    74,    64,    39,     5,   -29 },
		{    1,    35,    61,    73,    65,    41,     7,   -27 },
		{   -1,    33,    60,    71,    65,    43,    10,   -25 },
		{   -4,    31,    58,    72,    66,    44,    12,   -23 },
		{   -6,    29,    57,    70,    67,    46,    14,   -21 },
		{   -8,    27,    55,    71,    67,    47,    16,   -19 },
		{  -10,    25,    54,    68,    68,    49,    18,   -16 },
		{  -12,    22,    52,    69,    68,    51,    20,   -14 },
	},


	//I=16, D=88, wp= 0.011, ws= 0.013, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{    7,    38,    59,    68,    60,    39,     9,   -24 },
		{    5,    36,    58,    66,    61,    41,    11,   -22 },
		{    3,    34,    57,    66,    61,    42,    13,   -20 },
		{    1,    32,    55,    66,    62,    43,    15,   -18 },
		{   -1,    30,    54,    65,    62,    45,    17,   -16 },
		{   -3,    28,    53,    64,    63,    46,    19,   -14 },
		{   -5,    26,    51,    66,    63,    47,    20,   -12 },
		{   -7,    24,    50,    64,    64,    49,    22,   -10 },
	},


	//I=16, D=96, wp= 0.010, ws= 0.011, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   10,    37,    56,    63,    57,    39,    12,   -18 },
		{    9,    36,    55,    61,    57,    40,    14,   -16 },
		{    7,    34,    53,    62,    57,    41,    16,   -14 },
		{    5,    32,    52,    62,    58,    42,    17,   -12 },
		{    3,    31,    51,    61,    58,    43,    19,   -10 },
		{    1,    29,    50,    60,    59,    44,    21,    -8 },
		{   -1,    27,    49,    61,    59,    45,    22,    -6 },
		{   -3,    26,    48,    59,    59,    47,    24,    -4 },
	},


	//I=16, D=104, wp= 0.010, ws= 0.011, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   14,    37,    52,    58,    53,    38,    15,   -11 },
		{   12,    35,    51,    58,    53,    39,    17,    -9 },
		{   11,    34,    50,    57,    54,    40,    18,    -8 },
		{    9,    32,    49,    57,    54,    41,    20,    -6 },
		{    7,    31,    48,    57,    54,    42,    21,    -4 },
		{    6,    30,    47,    56,    54,    43,    23,    -3 },
		{    4,    28,    46,    56,    55,    44,    24,    -1 },
		{    2,    27,    45,    56,    55,    45,    25,     1 },
	},


	//I=16, D=112, wp= 0.009, ws= 0.010, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   17,    36,    49,    54,    50,    37,    18,    -5 },
		{   15,    35,    48,    54,    50,    38,    19,    -3 },
		{   14,    34,    47,    53,    50,    39,    21,    -2 },
		{   13,    33,    47,    51,    50,    40,    22,     0 },
		{   11,    31,    46,    53,    51,    40,    23,     1 },
		{   10,    30,    45,    52,    51,    41,    24,     3 },
		{    8,    29,    44,    53,    51,    42,    25,     4 },
		{    7,    28,    43,    51,    51,    43,    27,     6 },
	},


	//I=16, D=120, wp= 0.008, ws= 0.009, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   20,    36,    46,    49,    47,    36,    21,     1 },
		{   18,    35,    45,    50,    47,    37,    22,     2 },
		{   17,    34,    45,    48,    47,    38,    23,     4 },
		{   16,    33,    44,    49,    47,    38,    24,     5 },
		{   15,    32,    43,    49,    47,    39,    25,     6 },
		{   13,    31,    43,    48,    48,    40,    26,     7 },
		{   12,    30,    42,    48,    48,    40,    27,     9 },
		{   11,    29,    42,    47,    48,    41,    28,    10 },
	},


	//I=16, D=128, wp= 0.008, ws= 0.009, alpha= 0.100
	//8taps-- Horizontal sampling
	{
		{   22,    35,    44,    46,    44,    36,    23,     6 },
		{   21,    34,    43,    48,    44,    36,    23,     7 },
		{   20,    33,    43,    47,    44,    37,    24,     8 },
		{   19,    33,    42,    46,    45,    37,    25,     9 },
		{   18,    32,    42,    45,    45,    38,    26,    10 },
		{   17,    31,    41,    46,    45,    38,    27,    11 },
		{   16,    30,    40,    46,    45,    39,    28,    12 },
		{   15,    29,    40,    47,    45,    39,    28,    13 },
	},

};

int findRatio8(unsigned long delta_phase, unsigned long *min_diff)
{
	int idx = 0;
	unsigned int i;

	*min_diff = 0x7fffffff;
	if ( delta_phase < 0x4000 ){ /* upscaling */
		*min_diff = 0;
		idx = 0;
		return idx;
	}

	for(i = 1; i < sizeof(VO_ScaleRatio8)/sizeof(unsigned long); i++){
	/*
	* VscaleRatio8 is incrementing, we find the first one that's bigger than or equal to delta
	* instead of min ads diff. This way it will round up to lower pass filter to avoid alias
	*/
		if ( VO_ScaleRatio8[i] >= delta_phase )
			break;
	}
	if(i >= (sizeof(VO_ScaleRatio8) / sizeof(unsigned long)))
		i = sizeof(VO_ScaleRatio8) / sizeof(unsigned long) - 1;
	*min_diff = abs(VO_ScaleRatio8[i] - delta_phase);
	idx = i;
	return idx;
}

//TODO
short VO_coef_4t16p_ratio_[56][8][4];
short VO_coef_8t16p_ratio_[56][8][8];

void generateCoeff(void)
{
	/* re-order scaling coefficients to HW register ordering */
	int taps, idx;

	/* 4-tap and 8-tap */
	for (taps = 4 ; taps <= 8 ; taps+=4)
	//for (swap = 0 ; swap <	2 ; swap++)
	for (idx = 0 ; idx	< 56; idx++)
	{
		short const *p = taps == 4 ? VO_coef_4t16p_ratio [idx][0] : VO_coef_8t16p_ratio [idx][0];
		short	 *coeff = taps == 4 ? VO_coef_4t16p_ratio_[idx][0] : VO_coef_8t16p_ratio_[idx][0];
		int i;

		for (i = 0 ; i < taps << 3 ; i++)
		{
			int x = i &	15;
			int y = i >> 4;

			coeff[i] = (x < 8 ? p[x * taps + taps-1-y] : p[(15-x) * taps + y]) << 4;
			//coeff[(i&1) ? i-swap : i+swap] = (x < 4 ? p[x * taps + taps-1-y] : p[(7-x) * taps + y]) << 4;
		}
	}
}

void SetVideoScalingCoeffs (unsigned short *coeff, int delta_phase,
							int init_phase, int taps, int swap)
{
	int i;


	if ( abs(delta_phase - 0x4000) < 0x20 && init_phase == 0 ){
		//memset (coeff, 0, taps << 4);
		for(i = 1; i <= 8; i++)
			coeff[(taps << 3) - i] = 0x1000;
	}else if ( taps == 2 ){
		for (i = 0; i < 16; i+=2)
		{
			//coeff[(i&1) ? i-swap : i+swap] = VO_coef_2t8p[i];
			unsigned short c = VO_coef_2t8p[i>>1];
			coeff[i  ] = c;
			coeff[i+1] = c;
		}
	}else {

		short const *p ;
		unsigned long min_diff;
		int idx = findRatio8(delta_phase, &min_diff);

		p = (taps == 4 ? VO_coef_4t16p_ratio[idx][0] : VO_coef_8t16p_ratio[idx][0]);
		for(i = 0; i < (taps << 3); i++){
			int x = i &  15;
			int y = i >> 4;

			coeff[i] = (x < 8 ? p[x * taps + taps-1-y] : p[(15-x) * taps + y]) << 4;
			//coeff[(i&1) ? i-swap : i+swap] = (x < 4 ? p[x * taps + taps-1-y] : p[(7-x) * taps + y]) << 4;
		}
	}
}
