#ifndef __BOOT_PARAM_H__
#define __BOOT_PARAM_H__

typedef enum {
	POWER_OFF = 0,
	POWER_ON,
	BACKLIGHT_OFF,
} POWER_MODE_T;

typedef struct {
	unsigned int prev_power_state;
	unsigned int boot_logo_enable;
	unsigned int boot_music_enable;
	unsigned int backlight_value;
	unsigned int custom_video1_leng;
	unsigned int custom_video2_leng;
	unsigned int custom_audio1_leng;
	unsigned int custom_audio2_leng;
	unsigned int local_upgrade_en;
	unsigned int bootup_policy;
	unsigned char install_file_name[64];
	char ethaddr[20];
    	char ir_power_up_key[2][100];
	char ir_default_remoter[2][50];
} bootparam_t;

typedef struct _bootloader_message {
    char command[32];
    char status[32];
    char recovery[768];
    char stage[32];
    char reserved[1184];
} bootloader_message;

void get_bootparam(void);
void get_layout(void);
void set_bootparam_power_state(uint val);
void get_factory_platform_resource(void);
void get_factory_ir_table(void);

extern bootparam_t bootparam;

extern void CusApi_get_bootparam(char *dst_addr, int dst_length); // call customized function
extern void CusApi_decide_power_on_mode(void); // call customized function

#endif /* #define __BOOT_PARAM_H__ */

