#ifndef __FACTORY_LIB_H__
#define __FACTORY_LIB_H__

#include <asm/arch/sys_flash_layout.h>

#if defined(CONFIG_SYS_RTK_EMMC_FLASH)
 #define CONFIG_FACTORY_START		SYS_PARAM_FACTORY_START
 #define CONFIG_FACTORY_SIZE		SYS_PARAM_FACTORY_SIZE
#elif defined(CONFIG_SYS_RTK_NAND_FLASH)
 #define CONFIG_FACTORY_START		SYS_PARAM_FACTORY_START
 #define CONFIG_FACTORY_SIZE		SYS_PARAM_FACTORY_SIZE
#elif defined(CONFIG_SYS_RTK_SPI_NAND) 
 #define CONFIG_FACTORY_START		SYS_PARAM_FACTORY_START
 #define CONFIG_FACTORY_SIZE		SYS_PARAM_FACTORY_SIZE
#elif defined(CONFIG_SYS_RTK_SPI_FLASH)
 #define CONFIG_FACTORY_SIZE		SYS_PARAM_FACTORY_SIZE
#elif defined(CONFIG_SYS_RTK_FLASH_NONE)
 #define CONFIG_FACTORY_SIZE		0x800000
#endif

#define FACTORY_HEADER_FILE_NAME		"tmp/factory/"
#define FACTORY_RO_HEADER_FILE_NAME		"tmp/factory_ro/"
#define TAKEOVER_HEADER_FILE_NAME		"takeover/"

#if defined(CONFIG_CUSTOMER_TV002)
#define TAKEOVER_MAC_XML_BIN 		   TAKEOVER_HEADER_FILE_NAME"macAddress.xml"
#else 
#define FACTORY_MAC_BIN				 FACTORY_HEADER_FILE_NAME"mac.txt" 
#endif

int factory_Get_FACSize(void);
int factory_dump_info(void);
int factory_reset(void);
int factory_delete(char *path);
int factory_read_by_index(int index, char *buffer, int *length, char *name);
int factory_read(char *path, char**buffer, int *length);
int factory_read_link_dest_path(char *ln_path, char *ln_dest_path);
int factory_find_file(char *dir, char *prefix, char *filename);
int factory_write(char *path, char *buffer, int length);
int factory_save(void);
int factory_init(void);

#endif /* __FACTORY_LIB_H__ */

