#include <common.h>
#include <cmd_resume.h>
#include <cmd_snaplog.h>
#include <command.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/ctype.h>
#include <exports.h>
#include <net.h>
#include <usb.h>
#include <xyzModem.h>
#include <environment.h>
#include <mmc.h>
#include <errno.h>
#include <asm/arch/system.h>
#include <asm/arch/fw_info.h>
#include <asm/thread.h>
#include <parse_h.h>
#ifdef SIGN_USE_PARTIAL
#include "x_ldr_env.h"
#endif
#if 0 //should not be used on RTK platform
#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
#include <smp_platform.h>
#include <asm/io.h>
#endif
#endif

#define KCPU_STD_MAGICTAG           0x6b637075  //'kcpu'
#define KCPU_STD_MAGICTAG_ADDR      0x16000000
#define KCPU_STD_RESUME_ADDR        0x16000004

static spin_lock_t decomp_processing_lock = INIT_SPIN_LOCK;
//static u32 decomp_elapsed[NR_CPUS] = {0,};
//static int decomp_do[NR_CPUS] = {0,};
static u32 emmc_elapsed = 0;
//static cond_t g_decomp_cond;
static int wait_cnt = 0;
static u32 g_read_bytes = 0;
static loff_t g_snapshot_offset = 0;
static char g_snasupport =0;
static char g_snpart = 0;
static int decomp_done[NR_CPUS] = {0,};
static int use_single_core = 0;
static int decomp_error_cpumask = 0;
int snapshot_logo_init_done = 0;
layout_part_desc std_part_info;
typedef struct _thread_arg
{
	loff_t offset;
	unsigned long image_size;
}thread_arg_t;

//extern int storage_get_partition(const char* name, storage_partition_t* info);
//extern int rtk_eMMC_read(uint64_t offset, size_t len, void* buf);
//extern int rtk_eMMC_write(uint32_t offset, size_t len, const void* buf);
//extern int storage_erase(unsigned long long offset, unsigned long long len);
extern void enable_console(void);
extern void disable_console(void);
extern unsigned int guipanel_init_done;
extern int rtk_plat_prepare_fw_image_from_eMMC(void);
extern unsigned char GetBootparamSnpArtState(void);
extern void SetBootparamSnpArtState(unsigned char val);
extern void release_non_boot_core(void);
extern int LZ4_uncompress_unknownOutputSize (const char* source, char* dest, int isize, int maxOutputSize);
extern void eMMC_register_callback(int (*emmc_user_callback)(int, int));
extern void SetBootParamSNPSupport(uint val);
extern uint GetBootParamSNPSupport(void);
extern uint GetBootParamSNPART(void);
extern void SetBootParamSNPART(uint val); 
#if 0 //should not be used on RTK platform
#define TIME_CHECK() \
{ unsigned int u32Timer_b, u32Timer_c; \
	u32Timer_c = (*((volatile unsigned int *)0x1f006090)) | ((*((volatile unsigned int *)0x1f006094)) << 16); \
	u32Timer_b = (*((volatile unsigned int *)0x1f206708)) | ((*((volatile unsigned int *)0x1f20670c)) << 16); \
	printf("\033[0;31m[time] mboot takes %d.%dms \033[0m\n", (u32Timer_c - u32Timer_b)/12000, ((u32Timer_c - u32Timer_b)/12)%1000); \
}
#endif

#define MiB(x) (x/(1024 *1024))
static void print_snapshot_header(const struct swsusp_info *si)
{
	struct snapshot_header *header = GET_SNAP_HEADER(si);
	//struct dep_parts *deps = &header->deps;

	printf("/***************************************************************/\n");
	printf("UTS sys name = %s\n", si->uts.sysname);
	printf("UTS node name = %s\n", si->uts.nodename);
	printf("UTS release = %s\n", si->uts.release);
	printf("UTS version = %s\n", si->uts.version);
	printf("UTS machine = %s\n", si->uts.machine);
	printf("UTS domainname = %s\n", si->uts.domainname);

	printf("Kernel %d.%d.%d\n",
			((si->version_code) >> 16) & 0xff,
			((si->version_code) >> 8) & 0xff,
			(si->version_code) & 0xff);

	printf("num_phyuspages = %lu\n", si->num_physpages);
	printf("cpus = %d\n", si->cpus);
	printf("image_pages = %lu\n", si->image_pages);
	printf("pages = %lu\n", si->pages);
	printf("size = %lu\n", si->size);

	if(header->compress_algo)
		printf("compressed(%s) image size = %luMB(%lu)\n", (header->compress_algo == LZO) ?
		"lzo" : ((header->compress_algo == LZ4) ? "lz4" : ((header->compress_algo == LZ4HC) ? "lz4hc" : "unknown")),
		MiB(header->image_size), header->image_size);
	else
		printf("uncompressed image size = %luMB(%lu)\n", MiB(header->image_size), header->image_size);

	if(header->crc != ~0)
		printf("crc = %u\n", header->crc);
	else
		printf("no crc image\n");
	printf("pfn merge info entry count = %u\n", header->pfn_mi_cnt);
	printf("metadata start offset for compressed image = %lu\n", header->metadata_start_offset_for_comp);
	printf("physical address resume func addr %lx\n", header->pa_resume_func);
	printf("snapshot magic number : 0x%lx\n", header->magic);
#if 0
	if (deps->nr_dep_parts) {
		int i;
		struct dep_part_info *dep_info = &deps->dep_part_info[0];

		printf("snapshot dependency %d partitions\n", deps->nr_dep_parts);
		printf(" name\t partnum\t %s\t %s\n", deps->value_name[0], deps->value_name[1]);

		for (i = 0; i < deps->nr_dep_parts; i++) {
			struct partition_info *partition =
				&partinfo.partition[dep_info[i].partnum];
			printf(" %s\t  %4d\t\t 0x%-8x\t  0x%x\n",
			        partition->name,
					dep_info[i].partnum,
					dep_info[i].value[0],
					dep_info[i].value[1]);
		}
	} else {
		printf("snapshot has no dependency partitions\n");
	}
#endif
	printf("/***************************************************************/\n");

	return;
}

static unsigned int get_signed_image_size(struct snapshot_header *header)
{
	unsigned int size;

	size =  ALIGN(header->image_size, 16);

#if defined (CONFIG_SECURITY_BOOT)
	size += SIGNATURE_SIZE * (NUMBER_OF_FRAGMENT+1);
#endif
	return size;
}

static unsigned int SnapDataRead(unsigned long ByteAddr, unsigned int Size,unsigned int *Buffer )
{
    unsigned int BlockOffset = 0;
    BlockOffset = ByteAddr /BLOCK_SIZE;
    return rtk_eMMC_read(BlockOffset, Size, Buffer);
}

unsigned int readMsTicks(void)
{
	return get_boot_time_ms();
}

void snapshot_update_kernel_args(void)
{
    char *commandline;
    char *tmp_cmdline = NULL;
    char snp_str[] ={"snapshot resume"};
    char art_str[]={"snapshot_art"};
    unsigned char part_num = 0;
    unsigned int len;
    part_num = std_part_info.mount_dev[strlen("/dev/block/mmcblk0p")];
    if(g_snpart)
    {
        commandline = getenv("bootargs");
        len =  strlen(commandline) + strlen(art_str);
        tmp_cmdline = (char *)malloc(len);
        if(!tmp_cmdline)
        {
            printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else
        {
            memset(tmp_cmdline, 0, len);
            if(strstr(commandline,art_str)!=NULL)
	         return;
            sprintf(tmp_cmdline, "%s %s",commandline, art_str);
            setenv("bootargs", tmp_cmdline);
            free(tmp_cmdline); 
        }
    }
    if(g_snasupport == 1)
    {
        commandline = getenv("bootargs");
        len =  strlen(commandline) + strlen(snp_str) + 10;
        tmp_cmdline = (char *)malloc(len);
        if(!tmp_cmdline)
        {
            printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else
        {
            memset(tmp_cmdline, 0, len);
            if(strstr(commandline,snp_str)!=NULL)
	         return;
            sprintf(tmp_cmdline, "%s %s=179:%c", commandline, snp_str,part_num);
            setenv("bootargs", tmp_cmdline);
            free(tmp_cmdline);
        }       
    }
}

unsigned char GetSnapShotART(void)
{
    return  GetBootParamSNPART();
}

void SetSnapShotART(unsigned char flag)
{
    SetBootParamSNPART(flag);
}

unsigned char GetSnapShot_Support(void)
{
#if 0
    unsigned char snpsupport = 0;

    char* snp = getenv("snpsupport");
    if(snp == NULL)
    {
        setenv("snpsupport", "off");
        saveenv();
    }
    else
    {
        if(!strcmp("on", snp))
        {
            snpsupport = 1;
        }
    }
    return snpsupport;
#endif
    g_snasupport = GetBootParamSNPSupport();
    return g_snasupport;
}

void SetSnapShot_Support(unsigned char flag)
{
#if 0
    char* snp = getenv("snpsupport");
    int len = 0;
    
    if (flag)
    {
        setenv("snpsupport", "on");
        saveenv();
    }
    else
    {
        setenv("snpsupport", "off");
        saveenv();
    }
#else
    SetBootParamSNPSupport(flag);
#endif
}

int remake_SNSHT(void)
{
    unsigned int block = std_part_info.offset / BLOCK_SIZE;
    unsigned char *erase_buf;
    erase_buf = (unsigned char *)malloc(PAGE_SIZE);
    if(!std_part_info.offset)
    {
        printf("partition not exist\n");
        return -2;
    }
	
    if(!erase_buf)
    {
        printf("allocate %d bytes memroy fail %d\n", PAGE_SIZE, __LINE__);
        return -1;
    }
    printf("remake_SNSHT \n");
    memset(erase_buf, 0, PAGE_SIZE);
    rtk_eMMC_write(block ,PAGE_SIZE,(unsigned int *)erase_buf);
    return 0;
}

struct swsusp_info *info = (struct swsusp_info *)SNAPSHOT_IMAGE_LOAD_ADDR;
void *meta_page_ptr;
void (*kernel_resume_func)(void);
static char *decomp_buf;
static struct pfn_merge_info *pfn_merge_info;
static unsigned int processed_pfn_mi_index;

#ifdef CONFIG_SECURITY_BOOT

int verify_snapshot_image(struct snapshot_header *header)
{
	int index = 0;
	unsigned char *signature_offset = decomp_buf - HEADER_SIZE + header->image_size ;
	unsigned char signature[32];
	unsigned char *sign_area = signature_offset + (NUMBER_OF_FRAGMENT + 1) * SIGNATURE_SIZE;

	if((NUMBER_OF_FRAGMENT * FRAGMENT_UNIT_SIZE) > (header->image_size - HEADER_SIZE))
	{
		printf("boundary check error %s (%d)\n", __FUNCTION__, __LINE__);
		return -1;
	}

	index = (get_timer(0) % NUMBER_OF_FRAGMENT);
	memcpy(sign_area, decomp_buf + (index * FRAGMENT_UNIT_SIZE), FRAGMENT_UNIT_SIZE);
	memcpy(signature, signature_offset + ((index + 1) * SIGNATURE_SIZE), SIGNATURE_SIZE);

	if( !snapshot_image_verify(signature, sign_area, FRAGMENT_UNIT_SIZE))
	{
		printf("snapshot partial verification successed! (index:%d)\n", index);
	}
	else
	{
		printf("snapshot partial verification failed! (index:%d)\n", index);
		return -1;
	}
	return 0;
#if 0 //def SNAPSHOT_DEBUG
    printf("\n");
    for(i=0; i<32; ++i)
        printf("%02x ", 0xFF & ((char*)signature)[i]);
    printf("\n");
#endif
#if 0
	printf("[%d] full verify snapshot image\n", readMsTicks());
	sign_area = decomp_buf;
	signature = signature_offset;
	if(0 == snapshot_image_verify(signature, sign_area, hib_size - HEADER_SIZE))
	if(0 == (ret = snapshot_image_verify(signature, sign_area, hib_size - HEADER_SIZE)))

	{
		printf("snapshot full verification successed!\n");
	}
	else
	{
                char logStr[MAX_LOG_STR_LEN] = {0,};
		enable_console();
		printf("snapshot full verification failed!\n");
                snprintf(logStr, MAX_LOG_STR_LEN, "ret:%d",ret);
                SNPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_VERIFY_ERROR, logStr, 0);
		if((DDI_NVM_GetDebugStatus() == RELEASE_LEVEL) || (DDI_NVM_GetDebugStatus() == EVENT_LEVEL) || (DDI_NVM_GetDebugStatus() == DEBUG_LEVEL))
		{
			char cmd[] = "reset";
			remake_SNSHT();
			run_command(cmd, 0);
		}
		else
		{
			while (1); /* halt */
		}
	}
#endif
}
#endif


#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
extern u64 arch_counter_get_ms(void);

static int emmc_user_callback(int err, int bytes)
{
	g_read_bytes += bytes;
	return 0;
}

void *read_emmc(void *arg)
{
	u32 start_time;
	thread_arg_t *p = (thread_arg_t*)arg;
	thread_arg_t a;
	a.offset = p->offset;
	a.image_size = p->image_size;

	eMMC_register_callback(emmc_user_callback);

	g_read_bytes = 0;
	start_time = (u32)arch_counter_get_ms();
	if (SnapDataRead(a.offset, a.image_size, (void*)(decomp_buf)) < 0)
	{
		printf("Can't read compressed snapshot image image\n");
		return (void*)-1;
	}
	if( g_read_bytes < a.image_size )
		tlog("eMMC error : wrong read size in callback request size=%lu, read=%u\n",a.image_size,g_read_bytes);
	emmc_elapsed = (u32)arch_counter_get_ms() - start_time;
	decomp_done[1] = 1;
	return 0;
}

void storage_dma_read_wait(int len)
{
	while( 1 ) {
		if( len > g_read_bytes  ) {
			udelay(5);
			wait_cnt++;
		} else
			break;
	}
}
#endif

void *decompress_routine(void *print)
{
    unsigned int local_pfn_mi_index, pre_pfn_mi_index = 0;
    unsigned int start_pfn;
    unsigned long compblock_len;
    size_t output_len = 0;
    size_t local_start_offset = 0;
    int i;
    int cpuid = 0;
    struct snapshot_header *header = GET_SNAP_HEADER(info);

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
    //u32 start_time;
    cpuid =  get_cpu_id();
   // thread_t *thread = get_current_thread(cpuid);
    //start_time = (u32)arch_counter_get_ms();
    //decomp_do[cpuid] = 0;
#endif
    while(1)
    {
#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
        spin_lock(&decomp_processing_lock);
        local_pfn_mi_index = processed_pfn_mi_index;
        processed_pfn_mi_index++;
        spin_unlock(&decomp_processing_lock);
        //decomp_do[cpuid]++;
#else
        local_pfn_mi_index = processed_pfn_mi_index;
        processed_pfn_mi_index++;
#endif
        if (local_pfn_mi_index >= header->pfn_mi_cnt)
            break;

        compblock_len = pfn_merge_info[local_pfn_mi_index].info.compblock_len;
        start_pfn = pfn_merge_info[local_pfn_mi_index].start_pfn;

        for (i = pre_pfn_mi_index; i < local_pfn_mi_index; i++)
        {
            local_start_offset += pfn_merge_info[i].info.compblock_len;
        }

        pre_pfn_mi_index = local_pfn_mi_index;

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
		if( !use_single_core )
			storage_dma_read_wait(local_start_offset + compblock_len);
#endif

        if (pfn_merge_info[local_pfn_mi_index].compressed == 1)
        {
            if (header->compress_algo == LZ4HC || header->compress_algo == LZ4)
            {
                output_len = LZ4_uncompress_unknownOutputSize((const void *)(decomp_buf + local_start_offset), \
                (void *)(start_pfn << PAGE_SHIFT), compblock_len, pfn_merge_info[i].info.merged_cnt * PAGE_SIZE);
            }
            else if (header->compress_algo == LZO)
            {
// CK_FIXME
/*
                lzo1x_decompress((const void *)(decomp_buf + local_start_offset), (size_t)compblock_len,\
                (void *)(start_pfn << PAGE_SHIFT), &output_len);
*/
            }
            else
            {
                printf("Unknown decompress type!\n");
            }

           if( print ) tlog("cpu[%d] [%4d] decomp -> in : %p, in_len : 0x%lx, out : 0x%x, out_len : 0x%x\n",cpuid,local_pfn_mi_index, decomp_buf + local_start_offset, compblock_len, start_pfn << PAGE_SHIFT, output_len);


            if (output_len != pfn_merge_info[i].info.merged_cnt * PAGE_SIZE)
            {
                tlog("snapshot image decompress cpu=%d,index : %d fail offset = 0x%x, pfn = 0x%x, outlen=%u,orglen=%lu\n",cpuid, local_pfn_mi_index, local_start_offset, start_pfn,output_len,pfn_merge_info[i].info.merged_cnt * PAGE_SIZE);
				decomp_error_cpumask |= 1 << cpuid;
				decomp_done[cpuid] = 1;
                return (void*)-1;
            }
        }
        else
        {
			if( print ) tlog("cpu[%d] [%4d] memcpy -> in : 0x%x, in_len : 0x%lx, out : 0x%x\n",cpuid, local_pfn_mi_index, SNAPSHOT_IMAGE_LOAD_ADDR + local_start_offset, compblock_len, start_pfn << PAGE_SHIFT);

			memcpy((void *)(start_pfn << PAGE_SHIFT), (void *)(decomp_buf + local_start_offset), compblock_len);
		}
	}
#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
	//decomp_elapsed[cpuid] = (u32)arch_counter_get_ms() - start_time;
	decomp_done[cpuid] = 1;
	//if( !use_single_core ) thread_cond_signal(&g_decomp_cond);
#endif

	return 0;
}

static int uncompressed_snapshot_image_restore(unsigned long nr_meta_pages, unsigned int offset_cur)
{
    uint32_t *pfn_ptr;
    unsigned int read_pages = 0;

    printf("[%4d]Loading snapshot image...\n", readMsTicks());

    pfn_ptr = (uint32_t *)(meta_page_ptr);  
    while (read_pages < info->image_pages)
    {
        if (SnapDataRead(offset_cur, PAGE_SIZE, (void *)((*pfn_ptr) << PAGE_SHIFT)) < 0)
        {
            printf("Can't read snapshot image\n");
            return -1;
        }
        pfn_ptr++;
        read_pages++;
        offset_cur+=PAGE_SIZE;
    }

    printf("[%4d]Completed... [%dKBytes]\n", readMsTicks(), (read_pages << 2));

    return 0;
}

static int compressed_snapshot_image_restore(loff_t offset_cur, int verify, int desc_print, int decomp_print)
{
#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
    /* Multithread support */
    char thread_name[15];
    thread_t *decomp_2 = NULL, *decomp_3 = NULL ,*emmc_thread = NULL;
    thread_arg_t arg;
//    u32 start_time;
    int cnt = 0;
#endif

    // =================================================================
    // 1. get snapshot header
    // =================================================================
    struct snapshot_header *header = GET_SNAP_HEADER(info);

    /* compressed payload size = total size - header size - metadata size */
    unsigned long snapshot_image_payload_size = get_signed_image_size(header) - PAGE_SIZE;
    pfn_merge_info = (struct pfn_merge_info *)meta_page_ptr;
    processed_pfn_mi_index = 0;

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
//    start_time = (u32)arch_counter_get_ms();
   	memset(decomp_done,0,sizeof(decomp_done));
#endif

#ifdef SNAPSHOT_VERIFY
    // =================================================================
    // 2. snapshot verify
    // =================================================================
    // signature offset = current offset(offset + PAGE_SIZE) - PAGE_SIZE(header) + compressed image size
    const loff_t singature_offset = offset_cur - HEADER_SIZE + header->image_size;
    const unsigned long hib_size = header->image_size;
    unsigned char signature[32] = {0,};
    unsigned int index = 0;
    char *sign_area = NULL;

#ifdef SNAPSHOT_PARTIAL_VERIFY
    // partial verification
    if((NUMBER_OF_FRAGMENT * FRAGMENT_UNIT_SIZE) > (hib_size - HEADER_SIZE))
    {
        printf("boundary check error %s (%d)\n", __FUNCTION__, __LINE__);
        return -1;
    }

    sign_area = (char *)(SNAPSHOT_IMAGE_LOAD_ADDR + 0x2000000);//(char *) malloc(FRAGMENT_UNIT_SIZE * sizeof(char));
    if(NULL == sign_area)
    {
        printf("can not allocate memory %s (%d)\n", __FUNCTION__, __LINE__);
        return -1;
    }

    index = (get_timer(0) % NUMBER_OF_FRAGMENT);
    if (-1 == SnapDataRead(offset_cur + (index * FRAGMENT_UNIT_SIZE), FRAGMENT_UNIT_SIZE, sign_area))
    {
        printf("io read error %s (%d)\n", __FUNCTION__, __LINE__);
        //free(sign_area);
	      return -1;
    }

    if(-1 == SnapDataRead(singature_offset + ((index + 1) * sizeof(signature)), sizeof(signature), signature))
    {
        printf("io read error %s (%d)\n", __FUNCTION__, __LINE__);
        //free(sign_area);
        return -1;
    }

    printf("[%d] partial verify snapshot image\n", readMsTicks());
    if(0 == snapshot_image_verify(signature, sign_area, FRAGMENT_UNIT_SIZE))
    {
        printf("snapshot partial verification successed! (index:%d)\n", index);
        goto skip_full_verification;
    }
    else
    {
        printf("snapshot partial verification failed! (index:%d)\n", index);
        //free(sign_area);
        sign_area = NULL;
    }
#endif  // SNAPSHOT_PARTIAL_VERIFY

    // full verification
    sign_area = (char *)(SNAPSHOT_IMAGE_LOAD_ADDR + 0x2000000);//(char *) malloc((hib_size - HEADER_SIZE) * sizeof(char));
    if(NULL == sign_area)
    {
        printf("can not allocate memory %s (%d)\n", __FUNCTION__, __LINE__);
        return -1;
    }
    printf("[%d] snapshot data read, image_leghth = %d\n", readMsTicks(), singature_offset - offset_cur);
    if (-1 == SnapDataRead(offset_cur, (hib_size - HEADER_SIZE), sign_area))
    {
        printf("io read error %s (%d)\n", __FUNCTION__, __LINE__);
        //free(sign_area);
	      return -1;
    }

    if(-1 == SnapDataRead(singature_offset, sizeof(signature), signature))
    {
        printf("io read error %s (%d)\n", __FUNCTION__, __LINE__);
        //free(sign_area);
        return -1;
    }

#if 0 //def SNAPSHOT_DEBUG
    printf("\n");
    for(i=0; i<32; ++i)
        printf("%02x ", 0xFF & ((char*)signature)[i]);
    printf("\n");
#endif

    printf("[%d] full verify snapshot image\n", readMsTicks());
    if(0 == snapshot_image_verify(signature, sign_area, hib_size - HEADER_SIZE))
    {
        printf("snapshot full verification successed!\n");
    }
    else
    {
        printf("snapshot full verification failed!\n");
        {
            char cmd[] = "reset";
            remake_SNSHT();
            run_command(cmd, 0);
        }
    }
skip_full_verification:
	//free(sign_area);
	sign_area = NULL;
	printf("[%d] verify completed\n", readMsTicks());
#endif  //SNAPSHOT_VERIFY

    // =================================================================
    // 3. snapshot decompress
    // =================================================================
    // Reserve 32MB to store meta pages (nr_meta_pages * PAGE_SIZE) + swsusp_info (PAGE_SIZE)
    decomp_buf = (char *)(SNAPSHOT_IMAGE_LOAD_ADDR + 0x2000000);//(SNAPSHOT_IMAGE_LOAD_ADDR + PAGE_SIZE);

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)

    //flush_cache_all();
//    start_time = (u32)arch_counter_get_ms();

    if( use_single_core )
    {
        printf("single core decompress size %ld \n",snapshot_image_payload_size);
        if (SnapDataRead(offset_cur, snapshot_image_payload_size, (void*)(decomp_buf)) < 0)
        {
            printf("Can't read compressed snapshot image image\n");
            return -1;
        }
        decompress_routine((void *)decomp_print);
        //printf("single thread decomp time = %u\n",(u32)arch_counter_get_ms()-start_time);
    }
    else
    {
              console_protect_set(1);
		arg.offset = offset_cur;
		arg.image_size = snapshot_image_payload_size;

		//thread_cond_new(&g_decomp_cond);

		snprintf(thread_name,sizeof(thread_name),"read_emmc");
		emmc_thread = thread_create_ex(thread_name,read_emmc,(void*)&arg,0,1,THREAD_DEFAULT_PRIORITY,0);
                if(emmc_thread == NULL)
                {
                    printf("emmc thread create fail \n");
                    return -1;
                }
		snprintf(thread_name,sizeof(thread_name),"decomp[2]");
		decomp_2 = thread_create_ex(thread_name,decompress_routine,(void *)decomp_print,0,2,THREAD_DEFAULT_PRIORITY,0);
                if(decomp_2 == NULL)
                {
                    printf("decomp_2 thread create fail \n");
                    return -1;
                }
	        	
		snprintf(thread_name,sizeof(thread_name),"decomp[3]");
		decomp_3 = thread_create_ex(thread_name,decompress_routine,(void *)decomp_print,0,3,THREAD_DEFAULT_PRIORITY,0);
	        if(decomp_3 == NULL)
                {
                    printf("decomp_3 thread create fail \n");
                    return -1;
                }
		
		decompress_routine((void *)decomp_print);

		if( !decomp_done[0] || !decomp_done[1] || !decomp_done[2] || !decomp_done[3] )
			while( 1 ) {
				//ret = thread_cond_timedwait(&g_decomp_cond,5);
				mdelay(2);
				cnt++;
				tlog("Waiting for decompression done cnt=%d,CPU0=%d,CPU1=%d,CPU2=%d,CPU3=%d\n",cnt,decomp_done[0],decomp_done[1],decomp_done[2],decomp_done[3]);
				if( decomp_done[0] && decomp_done[1] && decomp_done[2] && decomp_done[3] ) {
					break;
				}
			}
#if 0
		tlog("Decomp time CPU0=%u ms,cnt=%d | CPU2=%u ms,cnt=%d | CPU3=%u ms,cnt=%d | eMMC=%u ms,wait=%d,waiting for eMMC time=%u ms\n",decomp_elapsed[0],decomp_do[0],decomp_elapsed[2],decomp_do[2],decomp_elapsed[3],decomp_do[3],emmc_elapsed,wait_cnt,(5*wait_cnt)/1000);
		tlog("multi thread decomp time = %u\n",(u32)arch_counter_get_ms()-start_time);
#endif
		if( desc_print ) {
			u32 speed;
			if( emmc_elapsed < 1000 ) {
				speed = (snapshot_image_payload_size>>10) / (emmc_elapsed);
				speed *= 1000;
			} else {
				speed = (snapshot_image_payload_size>>10) / (emmc_elapsed/1000);
			}
			tlog("eMMC size=%lu,read speed=%u KB(%u MB) per second\n",snapshot_image_payload_size,speed,speed >> 10);
		}
	}
#else
	printf("[%d] read snapshot image\n", readMsTicks());
	if (SnapDataRead(offset_cur, snapshot_image_payload_size, (void*)(decomp_buf)) < 0)
	{
		printf("Can't read compressed snapshot image\n");
		return -1;
	}
	printf("[%d] decompress snapshot image\n", readMsTicks());
	decompress_routine((void *)0);
#endif

#ifdef CONFIG_SECURITY_BOOT
	if( verify )
		if( verify_snapshot_image(header) < 0 )
			return -1;
#endif

#if 0
	TIME_CHECK();
#else
    display_boottime_log("compressed_snapshot_image_restore");
#endif
       printf("decompress done \n");
	if(decomp_error_cpumask) {
		printf("Snapshot booting failed!! : Decomp error in cpu=0x%x\n",decomp_error_cpumask);
		return -2;
	}

	return 0;
}

static inline int is_valid_snapshot_header(const struct swsusp_info *si)
{
	struct snapshot_header *header = GET_SNAP_HEADER(si);

	if (header->magic == SNAPSHOT_MAGIC_CODE)
		return 1;

	return 0;
}


static int check_snapshot_image(void)
{
    g_snapshot_offset = std_part_info.offset;

    /* Get header */
    if(SnapDataRead(g_snapshot_offset , sizeof(struct swsusp_info), (unsigned int*)info) < 0)
    {
        printf("Can't read snapshot image header\n");
        return -1;
    }
    return is_valid_snapshot_header(info);
}

int check_snapshot_mode(void)
{
    int ret;

    if((GetSnapShot_Support() == 1))
    {
        ret = SNAP_RESUME;
    }
    else if( !check_snapshot_image() )
    {
        ret = SNAP_MAKING_IMAGE;
    }
    else
    {
        ret = SNAP_COLDBOOT;
    }
    snapshot_update_kernel_args();
    return ret;
}

/* 0 if ok, positive value if mismatched partitions found */
static int verify_dep_parts(const struct swsusp_info *si)
{
    int part_mismatch = 0;

    /* check it's valid header */
    if (!is_valid_snapshot_header(si))
    {
	      printf("invalid snapshot header\n");
		    return -1;
    }

	return part_mismatch;
}

static void kernel_proxy(void) __attribute__((naked, noreturn));
static void kernel_proxy(void)
{

	/* enable SMP */
	__asm__ __volatile__ (
#if 0
		"@@ SMP enable  \n\t"
		"mrrc	p15, 1, r0, r1, c15 \n\t"
		"orr	r0, #(1 << 6) \n\t"
		"mcrr	p15, 1, r0, r1, c15 \n\t"
		"isb \n\t"
		"dsb \n\t"
#endif

		"bx  %0 \n\t"
		"isb \n\t"
		:
		:"r"(kernel_resume_func)
		:"r0", "r1");

	//kernel_resume_func();
}

int before_start_linux(void)
{

    eth_halt();

#ifdef CONFIG_USB_PL2303
    pPL2303Dev = NULL;
#endif

#if defined(CONFIG_CMD_USB)
    usb_stop();
#endif

    flush_dcache_all();

    cleanup_before_linux();

    return 0;
}

void cpu_reset(void *jump);
extern int rtk_check_ip_bisr(void);
int snapshot_boot(int verify, int load_only, int header_print, int desc_print, int decomp_print)
{
    loff_t offset, offset_datapage;
    unsigned long nr_meta_pages;
    int part_mismatch = 0;
    struct snapshot_header *header;
    int ret;
    char logStr[MAX_LOG_STR_LEN] = {0,};
#ifdef CONFIG_SECURITY_BOOT
    verify_apps(BOOT_SNAPSHOT);
    if( 0 > (ret = verify_apps(BOOT_SNAPSHOT)))
    {
        snprintf(logStr, MAX_LOG_STR_LEN, "ret:%d");
        SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_VERIFY_APP_ERROR, logStr, 0);
    }
#endif
    offset = g_snapshot_offset;

    //display_boottime_log(__FUNCTION__);

    if( !offset )
    {
        offset = std_part_info.offset;
#if 0
		    /* Get partition which has snapshot boot image(hibernation image) */
        if (storage_get_partition(SNAP_PART_NAME, &partition) < 0)
        {
			      printf("Invalid snapshot image partition\n");
            snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d",__FUNCTION__, __LINE__);
            SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_INVALID_PARTITION_ERROR, logStr, 0);
			      return -1;
		    }
		    offset = partition.offset;
#endif
        /* Get header */
        if (SnapDataRead(offset, sizeof(struct swsusp_info), (unsigned int*)info) < 0)
        {
            printf("Can't read snapshot image header\n");
            snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
            SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_EMMC_READ_ERROR, logStr, 0);
			      return -1;
		    }
    }
    header = GET_SNAP_HEADER(info);

    if(header_print)
		    print_snapshot_header(info);

    part_mismatch = verify_dep_parts(info);
    if(part_mismatch)
    {
        printf("%d dep parts are mismatched!\n", part_mismatch);
        snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
        SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_DEPPART_MISMATCH_ERROR, logStr, 0);
        return -1;
    }
    printf("header->compress_algo %d \n",header->compress_algo);
    /* Restore snapshot image into memory */
    switch(header->compress_algo)
    {
        case UNCOMPRESSED:
            /* Read metadata pages */
            nr_meta_pages = info->pages - info->image_pages - 1;
            meta_page_ptr = (void*)(SNAPSHOT_IMAGE_LOAD_ADDR + PAGE_SIZE);//malloc(nr_meta_pages * PAGE_SIZE);
            if (meta_page_ptr == NULL)
            {
                printf("Can`t alloc buffer for metadata pages\n");
                snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_MEMALLOC_ERROR, logStr, 0);
                return -1;
		        }

            if (SnapDataRead(offset + PAGE_SIZE, nr_meta_pages*PAGE_SIZE, meta_page_ptr) < 0)
            {
                printf("Can't read snapshot image metadata\n");
                //free(meta_page_ptr);
	              snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_EMMC_READ_ERROR, logStr, 0);
                return -1;
            }
	    
            /* add header and metadata pages */
            offset_datapage = offset + ((1 + nr_meta_pages)*PAGE_SIZE);

            if (uncompressed_snapshot_image_restore(nr_meta_pages, offset_datapage) < 0)
            {
                //free(meta_page_ptr);
                snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_UNCOMP_RESTORE_ERROR, logStr, 0);
                return -1;
            }
             break;

        case LZO:
		    // Fall through
        case LZ4HC:
        case LZ4:
            /* Read metadata pages */
            meta_page_ptr = (void*)(SNAPSHOT_IMAGE_LOAD_ADDR + PAGE_SIZE);//malloc(sizeof(struct pfn_merge_info) * header->pfn_mi_cnt);
            if (meta_page_ptr == NULL)
            {
                printf("Can`t alloc buffer for metadata pages\n");
                snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_MEMALLOC_ERROR, logStr, 0);
                return -1;
            }

            {
		  
	        loff_t offset_meta_page = offset + header->metadata_start_offset_for_comp;
		 loff_t aligned_offset = (offset_meta_page>>9)<<9;
		 unsigned long size_meta_page = sizeof(struct pfn_merge_info) * header->pfn_mi_cnt;
		 unsigned long aligned_size = ((size_meta_page+(offset_meta_page-aligned_offset)+512)>>9)<<9;

                printf("page_addr %llx aligned_size %lx\n", aligned_offset, aligned_size);
                if (SnapDataRead(aligned_offset, aligned_size, meta_page_ptr) < 0)
                {
                    printf("Can't read snapshot image metadata\n");
                    snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                    SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_EMMC_READ_ERROR, logStr, 0);
                    return -1;
                }
                printf("offset_meta_page %llx aligned_offset %llx\n",offset_meta_page,aligned_offset);
                if(offset_meta_page)
                    memmove(meta_page_ptr, meta_page_ptr+(offset_meta_page-aligned_offset), size_meta_page);
            }
 
             /* add header */
             offset_datapage = offset + PAGE_SIZE;
             printf("offset_datapage %llx meta_page_ptr %x \n",offset_datapage,(unsigned int)meta_page_ptr);

             if ((ret = compressed_snapshot_image_restore(offset_datapage, verify, desc_print, decomp_print)) < 0)
             {
                 //free(meta_page_ptr);
                 snprintf(logStr, MAX_LOG_STR_LEN, "ret:%d", ret);
                 SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_COMP_RESTORE_ERROR, logStr, 0);
                 return -1;
             }
             break;

             default:
                 printf("Unsupported compress type\n");
                 snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
                 SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_ERROR_UNKNOWN, logStr, 0);
                 return -1;
    }

    /* Cleaning before exit bootloader */
    //free(meta_page_ptr);

    printf("Welcome to snapshot world!\n");

    //wait_oneshot_timer();

    if(load_only)
        return 0;
    display_boottime_log("snapshot_boot");

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
    release_non_boot_core();
#endif
    run_command("go a", 0);
    run_command("go v", 0);
    if(*((volatile int *)KCPU_STD_MAGICTAG_ADDR) == KCPU_STD_MAGICTAG)
    {

#if defined(CONFIG_RTD299S) || defined(COFIG_RTD299O)
		rtd_outl(WDOG_DATA6_reg, *((volatile int *)KCPU_STD_RESUME_ADDR) | MIPS_KSEG0BASE);
#else
		rtd_outl(STB_WDOG_DATA6_reg, *((volatile int *)KCPU_STD_RESUME_ADDR) | MIPS_KSEG0BASE);
#endif
		*((volatile int *)KCPU_STD_MAGICTAG_ADDR) = 0x00000000;
		*((volatile int *)KCPU_STD_RESUME_ADDR) = 0x00000000;
		run_command("go c", 0);
	}

#ifdef CONFIG_RTD289X
        extern void disable_switch_pinmux_to_spi(void);
        disable_switch_pinmux_to_spi();
#endif

        if(rtk_check_ip_bisr() != 0)
        {
                if(!(strncmp(getenv("print"),"off",3))) // log mode is off
                {
                        enable_console();
                }
                printf("\n\033[31m[ERR] BISR CHECK FAIL, PLEASE CHECK ABOVE LOG!!\033[0m\n");
                while(1);
        }

        if(before_start_linux() < 0)
        {
		snprintf(logStr, MAX_LOG_STR_LEN, "%s:%d", __FUNCTION__, __LINE__);
		SNAPSHOT_Log(SNAPSHOT_LOG_ERROR, SNAPSHOT_TZ_LOAD_ERROR, logStr, 0);
                return -1;
        }
        display_boottime_log("kernel resume");
        kernel_resume_func = (void (*))header->pa_resume_func;
#ifdef CONFIG_SECURITY_BOOT
#if 0 // RTK FIXME !!
	wait_tee_ready();
#endif
#endif

        cpu_reset(kernel_proxy);
        //kernel_resume_func();

        return 0;
}

#ifdef CONFIG_USB_PL2303
extern struct usb_device *pPL2303Dev;
#endif

int do_hib(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[])
{
	int rc = -1;
	rc = snapshot_boot(1, 0, 0, 0, 0);

	return rc;
}

U_BOOT_CMD(
	hib,	1,	0,	do_hib,
	"hib\t- resume from snapshot image\n",
	"hib\n"
);

u32 _crc32_le(u32 crc, unsigned char const *p, size_t len)
{
	int i;
	while (len--) {
		crc ^= *p++;
		for (i = 0; i < 8; i++)
			crc = (crc >> 1) ^ ((crc & 1) ? CRCPOLY_LE : 0);
	}
	return crc;
}

static void hib_image_info(void)
{
    struct swsusp_info si;

    /* Get header */
    if (SnapDataRead(std_part_info.offset, sizeof(struct swsusp_info),(unsigned int*)&si) < 0)
    {
        printf("Can't read snapshot image header\n");
    }
    print_snapshot_header(&si);
}

int do_snapshot (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    unsigned char snapshot;
    unsigned char snapshot_old;

    if(argc > 4)
    {
        printf ("Usage:\n%s\n", cmdtp->usage);
        printf ("%s\n", cmdtp->help);
        snapshot = GetSnapShot_Support();
        printf ("current snapshot mode = %s \n", (snapshot == 0x1) ? "on" : "off");
        return 1;
    }

    if( !strcmp(argv[1],"on") || !strcmp(argv[1],"off"))
    {
        snapshot_old = GetSnapShot_Support();
        printf ("snapshot mode is changed to %s from %s \n", argv[1], (snapshot_old == 0xff) ? "on" : "off");

        if(!strcmp(argv[1],"on"))
            SetSnapShot_Support(1);
        else
            SetSnapShot_Support(0);

    }
    else if( !strcmp(argv[1],"info") )
    {
        printf(" !! Display snapshot header info ----------------\n");
        hib_image_info();
    }
    else if( !strcmp(argv[1],"remake") )
    {
        remake_SNSHT();
        printf("snapshot image has been removed\n");
    }
    else if(!strcmp(argv[1],"art"))
    {
         unsigned char art;
         if( argc > 2)
         {
             if(!strcmp(argv[2],"on"))
             {
                 art = GetSnapShotART();
                 if(art == 'N')
                 {
                     remake_SNSHT();
                 }
                 SetSnapShotART('Y');
		   SetBootparamSnpArtState('A');
             }
             else if(!strcmp(argv[2],"makingresume"))
             {
                 SetSnapShotART('Y');
		   SetBootparamSnpArtState('A');
	      }
             else if(!strcmp(argv[2],"resume"))
             {
                  SetBootparamSnpArtState('R');
                   SetSnapShotART('Y');
             }
             else if(!strcmp(argv[2],"making"))
             {
                 SetBootparamSnpArtState('M');
		    SetSnapShotART('Y');
                  remake_SNSHT();
             }
             else
             {
                  art = GetSnapShotART();
                  if(art != 'N')
                      remake_SNSHT();
                  SetSnapShotART('N');
             }
		art = GetBootparamSnpArtState();
		printf("Snapshot ART(Auto Rebooting Test)=%s\n",(art=='A')?"auto":(art=='R')?"resume":(art=='M')?"making":"off");
        }
    }
    else if( !strcmp(argv[1],"load") )
    {
        if( argc > 2 )
        {
            if( !strcmp(argv[2],"nolog") )
                snapshot_boot(1, 1, 0, 1, 0);
            else if( !strcmp(argv[2],"loop") )
            {
                if( argc > 3 )
                {
                    int cnt = simple_strtoul(argv[3], NULL, 0);
                    int loop = cnt;
                    int try = 0;
                    while( 1 )
                    {
                        snapshot_boot(1, 1, 0, 1, 0);
                        if( cnt )
                            if( --loop <= 0 )
								                break;
#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
                        msleep(500);
#endif
                        printf("Decompress test try cnt=%d\n",try++);
                    }
                }
            }
            else
                snapshot_boot(1, 1, 1, 1, 1);
        }
        else
            snapshot_boot(1, 1, 1, 1, 1);
    }
    else if( !strcmp(argv[1],"single") )
    {
        if( argc > 2 )
        {
            if( !strcmp(argv[2],"on") )
            {
                printf("current used %s , changed to single-core\n",use_single_core?"single-core":"multi-core");
                use_single_core = 1;
            }
            else if( !strcmp(argv[2],"off") )
            {
                printf("current used %s , changed to multi-core\n",use_single_core?"single-core":"multi-core");
                use_single_core = 0;
            }
            else
            {
                printf("current used %s , changed to multi-core\n",use_single_core?"single-core":"multi-core");
                use_single_core = 0;
            }
        }
    }
    else
    {
        printf ("Usage:\n%s\n", cmdtp->usage);
        printf ("%s\n", cmdtp->help);
        snapshot = GetSnapShot_Support();
        printf ("current snapshot mode = %s \n", (snapshot == 0x1) ? "on" : "off");
        return 1;
    }
    return 0;
}

U_BOOT_CMD(
	snapshot, 4, 0, do_snapshot,
	"snapshot\t- set snapshot flag on/off at NVM\n",
	"snapshot [on|off]\n"
	"snapshot info -Display snapshot header\n"
	"snapshot load [nolog|loop [cnt]] -load snapshot image without jump to kernel, if cnt is 0 ,loading image infinitely\n"
	"snapshot art [on|off] - auto rebooting test\n"
);

//extern char *typeToStr[SNAPSHOT_LOG_TYPE_END];
extern char *errorReasonToStr[SNAPSHOT_REMAKE_REASON_END];

int do_snap_log_cmd(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    unsigned long size = 0;
    int i;

    if(!strcmp(argv[1], "write"))
    {
        size = simple_strtoul(argv[3], NULL, 16);

        size = size % 16;
        for(i = 0; i < size; i++)
        {
            SNAPSHOT_Log(i%SNAPSHOT_LOG_TYPE_END, i%SNAPSHOT_ERROR_REASON_END,
                        errorReasonToStr[i%SNAPSHOT_ERROR_REASON_END], 0);
        }
    }
    else if(!strcmp(argv[1], "print"))
    {
        SNAPSHOT_PrintLog();
    }
    else if(!strcmp(argv[1], "remove"))
    {
        SNAPSHOT_RemoveLogHeader();
    }
    else
    {
        printf ("Usage:\n%s\n", cmdtp->usage);
        printf ("%s\n", cmdtp->help);
    }
    return 0;
}

U_BOOT_CMD(
    snaplog, 4, 0, do_snap_log_cmd,
    "snapshot log checking\n",
    "snaplog write [offset] [size]\n"
    "snaplog print - print all of snapshot log\n"
    "snaplog remove - remove header info of snapshot log\n"
);


int fast_boot(void)
{
    unsigned char i;
    unsigned char key =0;
    unsigned char art;
    for (i=0; i<20; ++i)
    {
        if (tstc())
        {
             key = getc();	//148010 
             if((key == _ESC) || (key == _TAB) || (key == _SPACE))
             {
                 udelay(100000);
                 break;
             }
        }
    }
#ifdef Config_RTD_STD_TRUE
    SetSnapShot_Support(1);
#endif
    if((key != _ESC) && (key != _TAB) && (key != _SPACE))
    {
#ifdef CONFIG_SYS_SNAPSHOT
        if(check_snapshot_mode() == SNAP_RESUME)
        {
            while(!snapshot_logo_init_done)
            {
                mdelay(1);
            }
        }

        art = GetSnapShotART();
        if(art == 'Y')
        {
             unsigned char ArtState;
             g_snpart = 1;
             ArtState = GetBootparamSnpArtState();
             if(ArtState == 'M')
             {
                  remake_SNSHT();
             }
             else if(ArtState =='A' || ArtState =='a')
             {
                 if(ArtState =='A')
                 {
                        printf("remake state \n");
                       remake_SNSHT();
                       SetBootparamSnpArtState('a');
                 }
                 else
                 {
                        printf("resume state \n");
                       SetBootparamSnpArtState('A');
                 }
                
             }
             else if(ArtState == 'R')
             {
                 printf("resume state \n");
             }
        }
        if(check_snapshot_mode() == SNAP_RESUME)
        {
            while(!guipanel_init_done)
            {
                mdelay(1);
            }

            if(run_command("hib",0) == -1)
            {
                printf("boot state is snapshot, but snapshot image is not valid\n");
                printf("check the snapshot image\n");
                remake_SNSHT();
            }
        }
#if 0
    else if(check_snapshot_mode() == SNAP_MAKING_IMAGE)
    {
        // do clean-up kernel memory (memset(0)
        kernel_mem_cleanup();
    }
#endif
#endif
    }
    return 0;
}

int snapshot_loadlogo(void)
{
    rtk_plat_prepare_fw_image_from_eMMC();
    return 0;
}


