#include <common.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <platform_lib/board/pcb_mgr.h>
#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif
#include <bootparam.h>
#if defined(CONFIG_MISC_MGR_WAKEUP)	
#include <wakeup.h>
#endif
#include "cus_common.h"

void CusApi_boot_prep_linux_for_standby(void)
{
	if(boot_power_on_mode == POWER_OFF)
	{
		printf("STANDY_LED_TYPE---AC--POWER_OFF---=0x%08x\n", cus_bootparam.standy_led_type);
		rtd_outl(SHARE_MEMORY_FOR_LED_STANDBY_TYPE,(cus_bootparam.standy_led_type |0x00110000));
		//rtd_outl(SHARE_MEMORY_FOR_LED_STANDBY_PARAM1,0x1100);	
	}
#if defined(CONFIG_MISC_MGR_WAKEUP)	
	if(boot_power_on_mode == POWER_OFF)
	{
		unsigned long long value=0;
		unsigned int  keyarray[2] = { 0xf2a0d5,
									  0x000000 };
										
		unsigned long long pinarray[3] = {0x00,0x00,0x00};

		if (pcb_mgr_get_enum_info_byname("PIN_POWER_EN", &value) == 0)
		{
			pinarray[0] = value;
		}

		unsigned long long keypad[6]={0x00,0x00,0x00,0x00,0x00,0x00};

		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_MENU", &value) == 0)
		{
			keypad[0] = value;
		}
		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_UP", &value) == 0)
		{
			keypad[1] = value;
		}					   
		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_DOWN", &value) == 0)
		{
			keypad[2] = value;
		}

		powerMgr_setup_power_en(1, &pinarray[0]);
		powerMgr_setup_irda( 8, 1, &keyarray[0]);
		powerMgr_setup_keypad_multi(3, &keypad[0]);
	}
#endif
}

void CusApi_boot_prep_linux_bootargs(void){

}

