#include <common.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <parse_h.h>
#include <exports.h>
#include "cus_common.h"

void CusApi_boot_handler_before_boot_setup(void)
{
	char *dst_addr = NULL;
	char *retAddr = NULL;
	int dst_length;
	uint retVal;
	char *uart_env = getenv("shop_uart");

	//console silent as tcl required if uartEnable is off
	if(factory_read(BOOT_PARAM_FILE_NAME, &dst_addr, &dst_length))
	{
		printf("cannot find %s\n", BOOT_PARAM_FILE_NAME);
	}

	if(parse_h("BOOT_UART_ENABLE", dst_addr, (uint)dst_length, &retVal, &retAddr) == 0)
	{
		cus_bootparam.uartEnable = retVal;
		printf("BOOT_UART_ENABLE=%d\n", retVal);
		if(cus_bootparam.uartEnable == 0)
		{
			if(uart_env != NULL)
			{
				if(strcmp(uart_env, "1") == 0)
				{
					printf("console uart enable off,but boot set it on\n");
				}
				else
				{
					printf("console uart enable off,and boot set it off\n");
					rtd_maskl(0xb8060218, 0x0f0fffff, 0xf0f00000);
				}
			}
			else
			{
				printf("\n console uart enable off\n");
				rtd_maskl(0xb8060218, 0x0f0fffff, 0xf0f00000);
			}
		}
		else
			printf("\n console uart enable on\n");
	}
}

void CusApi_boot_handler_before_boot_go(void)
{
#if 1
//refine by Ravi
//disbale EMCU clk flow  CLKEN=0 > RSTN=0
	rtd_outl(REG_MAGIC_51, 0);
	rtd_outl(REG_EMCU_CLKEN, _BIT9);
	rtd_outl(REG_EMCU_RESET, _BIT9);
#endif
}
