//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
#include <linux/string.h>
//#include <sysdefs.h>
//#include "sysdefs.h"
//#include <Platform_Lib/Board/pcbMgr.h>
#include <platform_lib/board/pcb_mgr.h>
#include <platform_lib/board/pcb.h>
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <linux/compiler.h>
#include <asm/io.h>
#include "AudioAmp.h"
#include <drivers/i2c/rtk_i2c_lib.h>
#include <drivers/i2c/rtk_g2c_lib.h>

static unsigned long long m_I2C_MASTER=0, m_AMP_DEVICE_ADDR=0;//, m_PIN_AMP_MUTE=0; //, m_I2C_SUB_SDA_SRC=0;

#define display_evaluate_time(...)

//#define ENABLE_AMP_USE_HW_I2C

#define ErrCode int
#define R_ERR_RX_ERROR		(0)
#define R_ERR_SUCCESS		(1)

//*************************************************************
// PRIVATE FUNCTIONS
//*************************************************************

//*************************************************************
// PUBLIC FUNCTIONS
//*************************************************************
#if 1
#define END_FLAG 	(0xff)
#define AMP_DEBUG 	(1)

typedef struct
{
    unsigned char bAddr;
    unsigned char bLength;
    unsigned char bArray[2];
}ALC1310_REG;//markchen add for 1310

static char BM28723MUV_InitTbl_1[2][2] = 
{
	//init
	{0x0C,0x00},					 
	{0xE9,0x10},					
};

static char BM28723MUV_InitTbl_2[13][2] = 
{
	//init
	{0x01,0x00},					 
	{0x0D,0x40},
	{0x0E,0x00},					 
	{0x92,0x1D},
	{0x93,0x1B},					 
	{0x94,0x0F},
	{0x95,0x11},					 
	{0x90,0x40},
	{0xF4,0x14},					 
	{0xF3,0x03},
	{0xF2,0x02},					 
	{0xF8,0x01},
	{0x02,0x01}
};

#endif

void AudioAmp_InitAudioOut2I2S_1st(void)
{
	printf("### AudioAmp_InitAudioOut2I2S_1st ###\n");
	//Turn on Audio IP  markchen add for I2S Clk output to AMP
	rtd_outl(0xb80004b0, 0x3);														
	rtd_outl(0xb80004e4, 0x9);														
	rtd_outl(0xb8000104,0x000F8001);
	rtd_outl(0xb800011c,0x000003FF);
	rtd_outl(0xb8000114,0x00038001);
	rtd_outl(0xb8000118,0x00009001);
	//disable pll_64_512 detect circuit 
	//rtd_outl(0xb8006030,0x00320830);//pll_64512_detect_en disable 
	//rtd_outl(0xb8006034,0x00320830);//pll_64512_1_detect_en disable 
	//AUDIO clock 
	rtd_outl(0xb8006038,0x000001f0);
	rtd_outl(0xb8006000,0x00009005); 
	rtd_outl(0xb8006004,0xf0842222);//PLL audio, turn on ADC/DAC SDRAM 
	//rtd_outl(0xb800085c,0x70700000);//GPIO92 I2S OUT D0 / GPIO93 I2S OUT MCLK 
	//rtd_outl(0xb8000858,0xf0707040);//STGPIO0 GPIO90 I2S OUT SCLK / GPIO89 I2S OUT WCLK 
	rtd_outl(0xb8006150,0x01001b00);//MCLK out 512FS = 512*48k = 24.576MHz

#if ENABLE_AMP_USE_HW_I2C
	unsigned char data[2]={0};
    unsigned char size=0;
	unsigned char u8Index=0;

	I2C_Init();

	#ifndef CONFIG_LESS_CONSOLE
    	printf("### HWI2C AMP_BM28723MUV ###\n");
	#endif
	mdelay(30);

	IO_Set(PIN_AMP_RESET, 1);
	mdelay(5);
	size = sizeof(BM28723MUV_InitTbl_1)/sizeof(BM28723MUV_InitTbl_1[0]);
	printf("Alc1310_DefautTbl1:%d\n", size);
	for(u8Index = 0; u8Index<size; u8Index ++)
	{
		data[0] = BM28723MUV_InitTbl_1[u8Index][0]; 
		data[1] = BM28723MUV_InitTbl_1[u8Index][1];
		
		printf("\n %s audio amp write addr=0x%x----data[1]=0x%x,slave addr:%x\n",__func__,data[0],data[1],AMP_DEVICE_ADDR);
		
		if (I2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 2, data) < 0)
		{
			printf("%s audio amp program ACL1310 failed\n",__func__);
			break;
		}

	}
	mdelay(150);
	size = sizeof(BM28723MUV_InitTbl_2)/sizeof(BM28723MUV_InitTbl_2[0]);
	printf("Alc1310_DefautTbl2:%d\n", size);
	for(u8Index = 0; u8Index<size; u8Index ++)
	{
		data[0] = BM28723MUV_InitTbl_2[u8Index][0]; 
		data[1] = BM28723MUV_InitTbl_2[u8Index][1];
		
		printf("\n %s audio amp write addr=0x%x----data[1]=0x%x,slave addr:%x\n",__func__,data[0],data[1],AMP_DEVICE_ADDR);
		
		if (I2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 2, data) < 0)
		{
			printf("%s audio amp program ACL1310 failed\n",__func__);
			break;
		}

	}
	mdelay(20);
	IO_Set(PIN_AMP_MUTE, 1);
#else

	unsigned char data[8];
	unsigned char regaddr[2];
	#if 0
	mdelay(20);

	//Turn on Audio IP  markchen add for I2S Clk output to AMP
	rtd_outl(0xb80004b0, 0x3);														
	rtd_outl(0xb80004e4, 0x9);														
	rtd_outl(0xb8000104,0x000F8001);
	rtd_outl(0xb800011c,0x000003FF);
	rtd_outl(0xb8000114,0x00038001);
	rtd_outl(0xb8000118,0x00009001);
	//disable pll_64_512 detect circuit 
	//rtd_outl(0xb8006030,0x00320830);//pll_64512_detect_en disable 
	//rtd_outl(0xb8006034,0x00320830);//pll_64512_1_detect_en disable 
	//AUDIO clock 
	rtd_outl(0xb8006038,0x000001f0);
	rtd_outl(0xb8006000,0x00009005); 
	rtd_outl(0xb8006004,0xf0842222);//PLL audio, turn on ADC/DAC SDRAM 
	//rtd_outl(0xb800085c,0x70700000);//GPIO92 I2S OUT D0 / GPIO93 I2S OUT MCLK 
	//rtd_outl(0xb8000858,0xf0707040);//STGPIO0 GPIO90 I2S OUT SCLK / GPIO89 I2S OUT WCLK 
	rtd_outl(0xb8006150,0x01001b00);//MCLK out 512FS = 512*48k = 24.576MHz
	#endif
	G2C_Init(AMP_I2C);
	mdelay(30);
//#ifndef CONFIG_LESS_CONSOLE
	printf("#### SW I2C AMP_BM28723MUV ####\n");
//#endif
	IO_Set(PIN_AMP_RESET, 1);
	mdelay(5);

	regaddr[0] = 0x0C; data[0] = 0x00;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("3 failed\n");
	regaddr[0] = 0xE9; data[0] = 0x10;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("4 failed\n");
	mdelay(150);
	regaddr[0] = 0x01; data[0] = 0x00;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("5 failed\n");
	regaddr[0] = 0x0D; data[0] = 0x40;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("6 failed\n");
	regaddr[0] = 0x0E; data[0] = 0x00;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("7 failed\n");
	regaddr[0] = 0x92; data[0] = 0x1D;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("8 failed\n");
	regaddr[0] = 0x93; data[0] = 0x1B;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("9 failed\n");
	regaddr[0] = 0x94; data[0] = 0x0F;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("10 failed\n");
	regaddr[0] = 0x95; data[0] = 0x11;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("11 failed\n");
	regaddr[0] = 0x90; data[0] = 0x40;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("12 failed\n");
	regaddr[0] = 0xF4; data[0] = 0x14;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("13 failed\n");
	regaddr[0] = 0xF3; data[0] = 0x03;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("14 failed\n");
	regaddr[0] = 0xF2; data[0] = 0x02;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("15 failed\n");
	regaddr[0] = 0xF8; data[0] = 0x01;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("16 failed\n");
	regaddr[0] = 0x02; data[0] = 0x01;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("17 failed\n");
	regaddr[0] = 0x16; data[0] = 0xB0;
	if (G2C_Write_EX(AMP_I2C, AMP_DEVICE_ADDR, 1, &regaddr, 1, data) < 0)
			printf("18 failed\n");

	mdelay(20);
	IO_Set(PIN_AMP_MUTE, 1);
#endif

}

void AudioAmp_InitAudioOut2I2S_2nd(void)
{
}

void AudioAmp_SetMute(BOOL isMute)
{

}

