#ifndef EEPROM_H
#define EEPROM_H

#if 1  //def SETUPCLASSSQLITEEEPROM_DEBUG
	#define EEP_PRINT(fmt,args...)	printf(fmt,## args)
#else
	#define EEP_PRINT(fmt,args...)
#endif

#ifndef NULL
#define NULL            0
#endif
#define OK              0
#define NOK             1

#define FALSE		(0)
#define TRUE			(1)

#ifndef false
#define false		(0)
#endif

#ifndef true
#define true			(1)
#endif

#ifndef UINT8
typedef  unsigned char UINT8;
#endif
#ifndef UINT16
typedef  unsigned short UINT16;
#endif
#ifndef UINT32
typedef  unsigned int UINT32;
#endif
#ifndef INT8
typedef  char INT8;
#endif
#ifndef INT16
typedef  short INT16;
#endif
#ifndef INT32
typedef  int INT32;
#endif
#ifndef bool
typedef int bool;
#endif
#ifndef __BOOL
#define __BOOL
typedef int BOOL;
#endif


#define R_ERR_FAILED		(0)
#define R_ERR_RX_ERROR		(0)
#define R_ERR_SUCCESS		(1)

bool Eeprom_SetMacAddressToKernel_Read(void);
bool Eeprom_SetMacAddressToKernel_Apply(void);

int setMacAddress(UINT8 *buff);
int getMacAddress(UINT8 *buff);
int setPanelIndex(UINT32 index);
int getPanelIndex(UINT32 *index);
int setUartMode(UINT8 mode);
int getUartMode(UINT8 *mode);
int setPowerMode(UINT8 mode);
int getPowerMode(UINT8 *mode);
int setPowerState(UINT8 mode);
int getPowerState(UINT8 *mode);
int setCustomIrCode(UINT8 code);
int getCustomIrCode(UINT8 *code);
int getKeypadDisable(UINT8 *tmpflag);
#if defined(Config_Board_TV010_R8)
int setOledSysLock(UINT8 flag);
int getOledSysLock(UINT8 *flag);
#endif
UINT32 ConvertIrCode(UINT8 TmpIrIndex);

#endif

