/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <common.h>
#include <command.h>

#include <platform_lib/board/lsadc.h>

int atoi(char *string){
	
    int ret = -1;
    int val = 0;
    unsigned int digit;
    
    for ( ; ; string += 1) {
		digit = *string - '0';
		if (digit > 9) {
			break;
		}
		val = (10*val) + digit;
		ret = val;
    }
    
    return ret;
}

int do_lsadc_test(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char *buff = NULL;
    int index  = 0;
    int ret = 0;
    
    //parser arguments
	if(argc == 3){
	    strcpy(buff,  &argv[1][0]);
	    if (strncmp(&argv[2][0],"index=", 6) == 0){
	    	index = atoi(&argv[2][6]);
	    	if(index == -1){
	    		printf("[LSADC] need input number\n\tlsadc init index=<index>\n\tlsadc get index=<index>\n");
	    		return 0;
	    	}
	    }
	}else{
		printf("[LSADC] The parameter is incorrect\n\tlsadc init index=<index>\n\tlsadc get index=<index>\n");
		return 0;
	}
	
	//execute command
    if (argc == 3 && strncmp(buff,"init", 4) == 0){
    	ret = lsadc_init(index, 1);
		if(ret != -1){
    	    printf("LSADC Init Index = %d\n", index);
		}
	}else if (argc == 3 && strncmp(buff,"get", 3) == 0){
		ret = lsadc_get(index);
		if(ret != -1){
		    printf("LSADC Get Index(%d) = 0x%x\n", index, ret);
		}
	}else{
		printf("[LSADC] The parameter is incorrect\n\tlsadc init index=<index>\n\tlsadc get index=<index>\n");
	}

	return ret;
}

U_BOOT_CMD(
	lsadc,                               // name
	3,                                   // max arguments
	1,                                   // repeatable
	do_lsadc_test,                       // cmd
	"Test",                              // usage
	"\n\tlsadc init index=<index>\n"     // help
	"\tlsadc get index=<index>\n"
);
