#ifndef __EHCI_PLAT_RTD287O_CONFIG_H__
#define __EHCI_PLAT_RTD287O_CONFIG_H__

#define U2_PHY_SETTING_REVISION     20170420

/////////////////////////////////////////////////////////////////
// U2 Phy Setting
/////////////////////////////////////////////////////////////////

typedef struct {
    unsigned char page;
    unsigned char addr;
} U2_PHY_REG;

typedef struct {
    int port1;
    unsigned char addr;
    unsigned char val;
} U2_PHY_REGISTER;
U2_PHY_REGISTER u2_phy_setting[] =
{
    // 0xF4: select page. 9b=page 0, bb=page 1,db=page 2(include DPLL)
    {1, 0xE0, 0x0f},
    {1, 0XE1, 0x18},
    {1, 0xE2, 0x5f},
    {1, 0xE3, 0xcd},
    {1, 0xE5, 0x63}, // REG_DBS_SEL[1]=1: Double sensitivity 1.5X
    {1, 0xF4, 0xbb},
    {1, 0xE3, 0x13},
    {1, 0xE4, 0x30},
    {1, 0xF4, 0x9b},
    {1, 0xE4, 0x6e},
    {1, 0xE7, 0x61},
    {1, 0xF4, 0xbb},
    {1, 0xE0, 0x23},
    {1, 0xE0, 0x27},
    {1, 0xF4, 0x9b},
    {1, 0xE4, 0x7e},
    {1, 0xE7, 0x61},
    {1, 0xE6, 0x01},
    {1, 0xF0, 0xfc},
    {1, 0xF1, 0x88},
    {1, 0xF2, 0x00},
    {1, 0xF3, 0x11},
    {1, 0xF5, 0x15},
    {1, 0xF6, 0x01},
    {1, 0xF7, 0x8a},
    {1, 0xF4, 0xbb},
    {1, 0xE1, 0x70},
    {1, 0xE2, 0x00},
    {1, 0xE5, 0x0f},
    {1, 0xE6, 0x58},
    {1, 0xE7, 0xe3},
    {1, 0xF4, 0x9b},
};


typedef struct {
    U2_PHY_REGISTER* p_reg_table;
    unsigned int     n_reg;
} U2_PHY_CONFIG;

static U2_PHY_CONFIG u2_phy_config = {
        .p_reg_table = u2_phy_setting,
        .n_reg       = sizeof(u2_phy_setting) / sizeof(U2_PHY_REGISTER),
};


#define U2_PHY_CONFIG_COUNT         1

#endif // __EHCI_PLAT_RTD287O_CONFIG_H__
