#ifndef __RTKMMC_H__
#define __RTKMMC_H__

#include <rbus/sys_reg_reg.h>
/************************************************************************
 * DEBUG CONTROL
*************************************************************************/
#define EMMC_RTD299X
#define AUTO_SEND_STOP
//#define EMMC_DEBUG
//#define EMMC_DEBUG_SHOWCMD
//#define EMMC_SHOW_CSD
//#define EMMC_SHOW_CID
//#define EMMC_SHOW_EXTCSD

/************************************************************************
 * SYSTEM DEFINE ADAPTER
*************************************************************************/


/************************************************************************
 * PRINT MESSAGE CONTROL
*************************************************************************/
//#define THIS_IS_FLASH_WRITE_U_ENV

#define EMMC_DRVNAME "emmc:"
#ifdef THIS_IS_FLASH_WRITE_U_ENV
    #include "sysdefs.h"
    #include "dvrboot_inc/util.h"
    #define UPRINTF(fmt, args...)           \
                if( rtprintf ) {            \
                    rtprintf(fmt,## args);  \
                }
    #define EXT_CSD_CMD_SET_NORMAL      (1 << 0)
    #define EXT_CSD_CMD_SET_SECURE      (1 << 1)
    #define EXT_CSD_CMD_SET_CPSECURE    (1 << 2)
    #define EXT_CSD_CARD_TYPE_26        (1 << 0)
    #define EXT_CSD_CARD_TYPE_52        (1 << 1)
    #define EXT_CSD_BUS_WIDTH_1         0
    #define EXT_CSD_BUS_WIDTH_4         1
    #define EXT_CSD_BUS_WIDTH_8         2
#else
    #include <config.h>
    #include <common.h>
    #include <command.h>
    #include <mmc.h>
    #include <part.h>
    #include <malloc.h>
    #include <mmc.h>
    #include <asm/errno.h>
    #include <asm/io.h>
    #define UPRINTF(fmt, args...)           \
                printf(fmt,## args)
#endif

#ifdef EMMC_DEBUG
    #define mmcinfo(fmt, args...) \
                printf("mmc:%s(%d) " fmt, __func__ ,__LINE__,## args)
#else
    #define mmcinfo(fmt, args...)
#endif

#ifdef EMMC_DEBUG_SHOWCMD
    #define mmcinfo_cmd(fmt, args...) \
    			printf("mmc: " fmt, ## args)

#else
    #define mmcinfo_cmd(fmt, args...)
#endif


#if 1
/* #define MMC_MSG1 */
#ifdef MMC_MSG1
    #define mmcmsg1(fmt, args...) \
           printf( "mmcmsg1:%s(%d):" fmt, __func__ ,__LINE__,## args)
#else
    #define mmcmsg1(fmt, args...)
#endif

/* #define MMC_MSG2 */
#ifdef MMC_MSG2
    #define mmcmsg2(fmt, args...) \
           printf( "mmcmsg2:%s(%d):" fmt, __func__ ,__LINE__,## args)
#else
    #define mmcmsg2(fmt, args...)
#endif

/* #define MMC_MSG3 */
#ifdef MMC_MSG3
    #define mmcmsg3(fmt, args...) \
           printf( "mmcmsg3:%s(%d):" fmt, __func__ ,__LINE__,## args)
#else
    #define mmcmsg3(fmt, args...)
#endif

/* #define MMC_MSG4 */
#ifdef MMC_MSG4
    #define mmcmsg4(fmt, args...) \
           printf( "mmcmsg4:%s(%d):" fmt, __func__ ,__LINE__,## args)
#else
    #define mmcmsg4(fmt, args...)
#endif


#endif

/************************************************************************
 * MMC BIT DATA READING
*************************************************************************/
#define UNSTUFF_BITS(resp,start,size)                                           \
    ({                                                                          \
        const int __size = size;                                                \
        const unsigned int __mask = (__size < 32 ? 1 << __size : 0) - 1;        \
        const int __off = 3 - ((start) / 32);                                   \
        const int __shft = (start) & 31;                                        \
        unsigned int __res;                                                     \
                                                                                \
        __res = resp[__off] >> __shft;                                          \
        if (__size + __shft > 32)                                               \
            __res |= resp[__off-1] << ((32 - __shft) % 32);                     \
        __res & __mask;                                                         \
    })

/************************************************************************
 * REALTEK CONTROL REGISTER ACCESSING METHOD
*************************************************************************/
#define cr_writel(value,addr)       rtd_outl(addr,value)

#define RBUS_READ_FIX
#ifdef RBUS_READ_FIX

#define MMC_ADDR_START      (0xb8010800)
#define MMC_ADDR_END        (0xb8010800+0x3FF)

static __inline__ unsigned int cr_readl(unsigned int __addr){

    volatile unsigned int reg_info;
    unsigned int addr;

    addr = (unsigned int)__addr;
    reg_info = rtd_inl(addr);
    if((addr >= MMC_ADDR_START) && (addr < MMC_ADDR_START) ){
        reg_info = rtd_inl(addr);
        if(reg_info != rtd_inl(addr)){
            printf("rbus hit!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
        }
    }
    return reg_info;
}
#else
    #define cr_readl(addr)              rtd_inl(addr)
#endif


#define cr_readl(addr)              rtd_inl(addr)

/************************************************************************
 *
*************************************************************************/
/*SD voltage supplied *** */
#define SD_VOL_27_36        (0x01UL<<8)
#define SD_CHK_PATTERN      (0xAAUL)
#define SD_CMD8_ARG         (SD_VOL_27_36|SD_CHK_PATTERN)
#define SD_HCS              (0x40000000)
#define SD_CCS              (0x40000000)

#define SD_VER10            (0x00UL)
#define SD_VER20S           (0x01UL)
#define SD_VER20H           (0x11UL)
#define SD_VER_MASK         (0x11UL)
#define SD_eMMC             (0x1UL<<31)
/*SD voltage supplied &&& */

#define EMMC_VDD_30_31              (0x00040000UL)  /* VDD voltage 3.0 ~ 3.1 */
#define EMMC_VDD_31_32              (0x00080000UL)  /* VDD voltage 3.1 ~ 3.2 */
#define EMMC_VDD_32_33              (0x00100000UL)  /* VDD voltage 3.2 ~ 3.3 */
#define EMMC_VDD_33_34              (0x00200000UL)  /* VDD voltage 3.3 ~ 3.4 */
#define EMMC_VDD_34_35              (0x00400000UL)  /* VDD voltage 3.4 ~ 3.5 */
#define EMMC_VDD_35_36              (0x00800000UL)  /* VDD voltage 3.5 ~ 3.6 */
#define MMC_CARD_READY              (0x80000000UL)  /* Card Power up status bit */
#define MMC_SECTOR_ADDR             (0x40000000UL)

#define EMMC_VDD_REQ                (EMMC_VDD_35_36|EMMC_VDD_34_35|EMMC_VDD_33_34|EMMC_VDD_32_33|EMMC_VDD_31_32|EMMC_VDD_30_31)

/* send status event */
#define STATE_IDLE                  0
#define STATE_READY                 1
#define STATE_IDENT                 2
#define STATE_STBY                  3
#define STATE_TRAN                  4
#define STATE_DATA                  5
#define STATE_RCV                   6
#define STATE_PRG                   7
#define STATE_DIS                   8
#define STATE_BTST                  9
#define STATE_SLP                   10

/* RTK IO Driving control flag */
#define DRIVING_COMMON	0
#define DRIVING_HS200	1
#define DRIVING_HS400	2

#define EMMC_MAX_SCRIPT_BLK                15   /* this value is IP limit, can't increase */
#define EMMC_MAX_SCRIPT_LINE               200   /* 15*40 = 600 blocks */
#define EMMC_MAX_XFER_BLK                  (EMMC_MAX_SCRIPT_LINE*EMMC_MAX_SCRIPT_BLK)
#define EMMC_MAX_WXFER_BLK                 150


/* Clock Div setting */
#define CLK_200Khz      200000
#define CLK_400Khz      400000

#define CLK_10Mhz       10000000
#define CLK_15Mhz       15000000
#define CLK_20Mhz       20000000
#define CLK_25Mhz       25000000
#define CLK_30Mhz       30000000
#define CLK_40Mhz       40000000
#define CLK_50Mhz       50000000
#define CLK_60Mhz       60000000
#define CLK_70Mhz       70000000
#define CLK_80Mhz       80000000
#define CLK_90Mhz       90000000

#define CLK_100Mhz      100000000
#define CLK_110Mhz      110000000
#define CLK_120Mhz      120000000
#define CLK_130Mhz      130000000
#define CLK_140Mhz      140000000
#define CLK_150Mhz      150000000
#define CLK_160Mhz      160000000
#define CLK_170Mhz      170000000
#define CLK_180Mhz      180000000
#define CLK_190Mhz      190000000
#define CLK_200Mhz      200000000

#define BUS_WIDTH_1                 (0x00000000UL)
#define BUS_WIDTH_4                 (0x00000001UL)
#define BUS_WIDTH_8                 (0x00000002UL)
#define BUS_DDR_MODE                (0x00000004UL)
#define BUS_WIDTH_DDR4              (BUS_DDR_MODE|BUS_WIDTH_4)
#define BUS_WIDTH_DDR8              (BUS_DDR_MODE|BUS_WIDTH_8)

/*
 * Rbus Register mapping (0x1801_0800~0x1801_0890)
 */

/* EMMC_WRAPPER register (0x1801_0800~0x1801_08FF) */
#define EM_PLUS_BASE                (0xb8010800)

/* Non-security CPU registers: 0x1801_0800 ~ 0x1801_080C (all CPU can access) */
#define EM_SCPU_SEL                 (EM_PLUS_BASE+0x00UL)     //0x18010800
#define EM_INT_STATUS               (EM_PLUS_BASE+0x04UL)     //0x18010804
#define EM_INT_MASK                 (EM_PLUS_BASE+0x08UL)     //0x18010808
#define EM_INT_DUMMY0               (EM_PLUS_BASE+0x0CUL)     //0x1801080C

/* Security CPU (KCPU) registers: 0x1801_0810 ~ 0x1802_082C (only KCPU can access) */
#define EM_KCPU_SEL                 (EM_PLUS_BASE+0x10UL)     //0x18010810
#define EM_START_PROTECT_ADDR       (EM_PLUS_BASE+0x14UL)     //0x18010814
#define EM_END_PROTECT_ADDR         (EM_PLUS_BASE+0x18UL)     //0x18010818
#define EM_INT_STATUS_KCPU          (EM_PLUS_BASE+0x1CUL)     //0x1801081C
#define EM_INT_MASK_KCPU            (EM_PLUS_BASE+0x20UL)     //0x18010820
#define EM_DUMMY0_KCPU              (EM_PLUS_BASE+0x24UL)     //0x18010824
#define EM_DUMMY1_KCPU              (EM_PLUS_BASE+0x28UL)     //0x18010828
#define EM_DUMMY2_KCPU              (EM_PLUS_BASE+0x2CUL)     //0x1801082C

/*
 * Only KCPU can access when kcpu_status = 1 (1801_0830~1801_08FF)
 * All CPUs can access when kcpu_status = 0
*/
#define EM_WARP_CTRL                (EM_PLUS_BASE+0x30UL)     //0x18010830
#define EM_WARP_STATUS0             (EM_PLUS_BASE+0x34UL)     //0x18010834
#define EM_WARP_STATUS1             (EM_PLUS_BASE+0x38UL)     //0x18010838
#define EM_WARP_STATUS2             (EM_PLUS_BASE+0x3CUL)     //0x1801083C

/* MBIST */
#define EM_IP_BIST                  (EM_PLUS_BASE+0x40UL)     //0x18010840
#define EM_WARP_BIST                (EM_PLUS_BASE+0x44UL)     //0x18010844
#define EM_CLK_PHASE_SEL            (EM_PLUS_BASE+0x48UL)     //0x18010848

/* DS tune */
#define EM_DS_TUNE_CTRL             (EM_PLUS_BASE+0x50UL)     //0x18010850
#define EM_DS_TUNE_CAL_DQ0_1        (EM_PLUS_BASE+0x54UL)     //0x18010854
#define EM_DS_TUNE_CAL_DQ2_3        (EM_PLUS_BASE+0x58UL)     //0x18010858
#define EM_DS_TUNE_CAL_DQ4_5        (EM_PLUS_BASE+0x5CUL)     //0x1801085C
#define EM_DS_TUNE_CAL_DQ6_7        (EM_PLUS_BASE+0x60UL)     //0x18010860
#define EM_DS_TUNE_CAL_DQ8          (EM_PLUS_BASE+0x64UL)     //0x18010864
#define EM_DS_TUNE_PH_SEL_0_1       (EM_PLUS_BASE+0x68UL)     //0x18010868
#define EM_DS_TUNE_PH_SEL_2_3       (EM_PLUS_BASE+0x6CUL)     //0x1801086C
#define EM_DS_TUNE_PH_SEL_4_5       (EM_PLUS_BASE+0x70UL)     //0x18010870
#define EM_DS_TUNE_PH_SEL_6_7       (EM_PLUS_BASE+0x74UL)     //0x18010874
#define EM_DS_TUNE_PH_SEL_8         (EM_PLUS_BASE+0x78UL)     //0x18010878
#define EM_DS_TUNE_RCV_1ST          (EM_PLUS_BASE+0x7CUL)     //0x1801087C

/* CP mode */
#define EM_CPMASK_0                 (EM_PLUS_BASE+0x80UL)     //0x18010880
#define EM_CPMASK_1                 (EM_PLUS_BASE+0x84UL)     //0x18010884
#define EM_CPMASK_2                 (EM_PLUS_BASE+0x88UL)     //0x18010888

/* Delay_cal */
#define EM_HALF_CYCLE_CAL_EN        (EM_PLUS_BASE+0x8CUL)     //0x1801088C
#define EM_HALF_CYCLE_CAL_RESULT    (EM_PLUS_BASE+0x90UL)     //0x18010890

/*
 * DWC_Mobile_Storage register address mapping:
 *          0x1801_0900~0x1801_0BFF
 */
#define DWC_IP_BASE                 (0xb8010900)

#define EM_DWC_CTRL                 (DWC_IP_BASE+0x000UL)     //0x18010900
#define EM_DWC_PWREN                (DWC_IP_BASE+0x004UL)     //0x18010904
#define EM_DWC_CLKDIV               (DWC_IP_BASE+0x008UL)     //0x18010908
#define EM_DWC_CLKSRC               (DWC_IP_BASE+0x00CUL)     //0x1801090C
#define EM_DWC_CLKENA               (DWC_IP_BASE+0x010UL)     //0x18010910
#define EM_DWC_TMOUT                (DWC_IP_BASE+0x014UL)     //0x18010914
#define EM_DWC_CTYPE                (DWC_IP_BASE+0x018UL)     //0x18010918
#define EM_DWC_BLKSIZ               (DWC_IP_BASE+0x01CUL)     //0x1801091C
#define EM_DWC_BYTCNT               (DWC_IP_BASE+0x020UL)     //0x18010920
#define EM_DWC_INTMASK              (DWC_IP_BASE+0x024UL)     //0x18010924
#define EM_DWC_CMDARG               (DWC_IP_BASE+0x028UL)     //0x18010928
#define EM_DWC_CMD                  (DWC_IP_BASE+0x02CUL)     //0x1801092C
#define EM_DWC_RESP0                (DWC_IP_BASE+0x030UL)     //0x18010930
#define EM_DWC_RESP1                (DWC_IP_BASE+0x034UL)     //0x18010934
#define EM_DWC_RESP2                (DWC_IP_BASE+0x038UL)     //0x18010938
#define EM_DWC_RESP3                (DWC_IP_BASE+0x03CUL)     //0x1801093C
#define EM_DWC_MINTSTS              (DWC_IP_BASE+0x040UL)     //0x18010940
#define EM_DWC_RINTSTS              (DWC_IP_BASE+0x044UL)     //0x18010944
#define EM_DWC_STATUS               (DWC_IP_BASE+0x048UL)     //0x18010948
#define EM_DWC_FIFOTH               (DWC_IP_BASE+0x04CUL)     //0x1801094C
#define EM_DWC_CDETECT              (DWC_IP_BASE+0x050UL)     //0x18010950
#define EM_DWC_WRTPRT               (DWC_IP_BASE+0x054UL)     //0x18010954
#define EM_DWC_GPIO                 (DWC_IP_BASE+0x058UL)     //0x18010958
#define EM_DWC_TCBCNT               (DWC_IP_BASE+0x05CUL)     //0x1801095C
#define EM_DWC_TBBCNT               (DWC_IP_BASE+0x060UL)     //0x18010960
#define EM_DWC_DEBNCE               (DWC_IP_BASE+0x064UL)     //0x18010964
#define EM_DWC_USRID                (DWC_IP_BASE+0x068UL)     //0x18010968
#define EM_DWC_VERID                (DWC_IP_BASE+0x06CUL)     //0x1801096C
#define EM_DWC_HCON                 (DWC_IP_BASE+0x070UL)     //0x18010970
#define EM_DWC_UHS_REG              (DWC_IP_BASE+0x074UL)     //0x18010974
#define EM_DWC_RST_n                (DWC_IP_BASE+0x078UL)     //0x18010978
#define EM_DWC_BMOD                 (DWC_IP_BASE+0x080UL)     //0x18010980
#define EM_DWC_PLDMND               (DWC_IP_BASE+0x084UL)     //0x18010984
#define EM_DWC_DBADDR               (DWC_IP_BASE+0x088UL)     //0x18010988
#define EM_DWC_DBADDRL64            (DWC_IP_BASE+0x088UL)     //0x18010988
#define EM_DWC_DBADDRU64            (DWC_IP_BASE+0x08CUL)     //0x1801098C
#define EM_DWC_IDSTS                (DWC_IP_BASE+0x08CUL)     //0x1801098C
#define EM_DWC_IDSTS64              (DWC_IP_BASE+0x090UL)     //0x18010990
#define EM_DWC_IDINTEN              (DWC_IP_BASE+0x090UL)     //0x18010990
#define EM_DWC_IDINTEN64            (DWC_IP_BASE+0x094UL)     //0x18010994
#define EM_DWC_DSCADDR              (DWC_IP_BASE+0x094UL)     //0x18010994
#define EM_DWC_DSCADDRL64           (DWC_IP_BASE+0x098UL)     //0x18010998
#define EM_DWC_DSCADDRU64           (DWC_IP_BASE+0x09CUL)     //0x1801099C
#define EM_DWC_BUFADDR              (DWC_IP_BASE+0x098UL)     //0x18010998
#define EM_DWC_BUFADDRL64           (DWC_IP_BASE+0x0A0UL)     //0x180109A0
#define EM_DWC_BUFADDRU64           (DWC_IP_BASE+0x0A4UL)     //0x180109A4
#define EM_DWC_CardThrCtl           (DWC_IP_BASE+0x100UL)     //0x18010a00
#define EM_DWC_Back_END_POWER       (DWC_IP_BASE+0x104UL)     //0x18010a04
#define EM_DWC_UHS_REG_EXT          (DWC_IP_BASE+0x108UL)     //0x18010a08
#define EM_DWC_EMMC_DDR_REG         (DWC_IP_BASE+0x10CUL)     //0x18010a0C
#define EM_DWC_ENABLE_SHIFT         (DWC_IP_BASE+0x110UL)     //0x18010a10
#define EM_DWC_DATA_BASE            (DWC_IP_BASE+0x200UL)     //0x18010b00

/* ====== Register Bit define ====== */
/* Wapper */
//EM_SCPU_SEL               //0x18010800
#define PS_SCPU_STOP                   _BIT2
#define PS_SCPU_STATUS                 _BIT1
#define PS_SCPU_SEL                    _BIT0

//EM_INT_STATUS             //0x18010804
#define PS_DMA_RD_DONE_S               _BIT2
#define PS_DMA_WR_DONE_S               _BIT1
#define PS_STOP_BY_KCPU_FORCE_S        _BIT0

//EM_INT_MASK               //0x18010808
#define PS_DMA_RD_DONE_MASK_S          _BIT2
#define PS_DMA_WD_DONE_MASK_S          _BIT1
#define PS_STOP_BY_KCPU_FORCE_MASK_S   _BIT0

//EM_KCPU_SEL               //0x18010810
#define PS_KCPU_FORCE_EN               _BIT3
#define PS_PROTECT_ADDR_EN             _BIT2
#define PS_KCPU_STATUS                 _BIT1
#define PS_KCPU_SEL                    _BIT0

//EM_INT_STATUS_KCPU        //0x1801081C
#define PS_DMA_RD_DONE_K               _BIT2
#define PS_DMA_WR_DONE_K               _BIT1
#define PS_PROTECT_HIT_K               _BIT0

//EM_INT_MASK_KCPU          //0x18010820
#define PS_DMA_RD_DONE_MASK_K          _BIT2
#define PS_DMA_WR_DONE_MASK_K          _BIT1
#define PS_PROTECT_HIT_MASK_K          _BIT0

//EM_WARP_CTRL              //0x18010830
#define PS_CP_BLK_LEN_SHT              (16)
#define PS_CP_BLK_LEN_MASK             (0x7FFFUL<<CP_BLK_LEN_SHT)
#define PS_CP_MODE_EN                  _BIT15
#define PS_CCLK_IN_SAMPLE_EXT_SEL      _BIT13
#define PS_CCLK_IN_SAMPLE_EXT_EN       _BIT12
#define PS_ECO_OPTION0_DIS             _BIT11
#define PS_M_HBIG_ENDIAN               _BIT10
#define PS_S_HBIG_ENDIAN               _BIT9
#define PS_CCLK_OUT_SRC_SEL            _BIT8
#define PS_WARP_VERSION                _BIT7
#define PS_DEBUG_MUX_SHT               (1)
#define PS_DEBUG_MUX_MASK              (0x3FUL<<DEBUG_MUX_SHT)
#define PS_DEBUG_CTRL                  _BIT0

//EM_WARP_STATUS0           //0x18010834
#define PS_REAL_DUMMY0_SHT             (16)
#define PS_REAL_DUMMY0_MASK            (0xFFFFUL<<REAL_DUMMY0_SHT)
#define PS_RBUS_ERR                    _BIT2
#define PS_DBUS_DMA_BUSY               _BIT1
#define PS_DBUS_WRITE_FLAG             _BIT0

//EM_WARP_STATUS1           //0x18010838
#define PS_ICTRL_STATE_SHT             (16)
#define PS_ICTRL_STATE_MASK            (0x07UL<<ICTRL_STATE_SHT)
#define PS_TOP_SM_SHT                  (0)
#define PS_TOP_SM_MASK                 (0x7FFFUL<<TOP_SM_SHT)

//EM_IP_BIST                //0x18010840
//EM_WARP_BIST              //0x18010844

//EM_CLK_PHASE_SEL          //0x18010848
#define PS_CCLK_OUT_SEL_SHT            (12)
#define PS_CCLK_OUT_SEL_MASK           (0x3FUL<<CCLK_OUT_SEL_SHT)
#define PS_CCLK_IN_SAMPLE_SEL_SHT      (6)
#define PS_CCLK_IN_SAMPLE_SEL_MASK     (0x3FUL<<CCLK_IN_SAMPLE_SEL_SHT)
#define PS_CCLK_IN_DRV_SEL_SHT         (0)
#define PS_CCLK_IN_DRV_SEL_MASK        (0x3FUL<<CCLK_IN_DRV_SEL_SHT)

//EM_DS_TUNE_CTRL           //0x18010850
#define PS_RD_DBG_MOD_SHT              (28)
#define PS_RD_DBG_MOD_MASK             (0xFUL<<RD_DBG_MOD_SHT)
#define PS_RTK_HS400                   _BIT23
#define PS_RTK_HS200_POS               _BIT22
#define PS_RTK_HS200                   _BIT21
#define PS_BYPASS_DS_TUNE              _BIT20
#define PS_BYPASS_DS_PH_SEL_SHT        (15)
#define PS_BYPASS_DS_PH_SEL_MASK       (0x1FUL<<BYPASS_DS_PH_SEL_SHT)
#define PS_RW_CNT_RESET                _BIT14
#define PS_WR_ADR_P_0_TRAN_SEL         _BIT13
#define PS_RW_CNT_REF_ALIGN_EN         _BIT12
#define PS_FW_SET_PLUSE                _BIT9
#define PS_DQSF_DLYN_SHT               (7)
#define PS_DQSF_DLYN_MASK              (0x03UL<<DQSF_DLYN_SHT)
#define PS_POS_TRIG_SEL_SHT            (5)
#define PS_POS_TRIG_SEL_MASK           (0x03UL<<POS_TRIG_SEL_SHT)
#define PS_PRE_TRIG_SEL_SHT            (3)
#define PS_PRE_TRIG_SEL_MASK           (0x03UL<<PRE_TRIG_SEL_SHT)
#define PS_SYNC_CAL_DLYN               _BIT2
#define PS_AUTO_CAL                    _BIT1
#define PS_DQS_DEL_OFFST_EN            _BIT0

//EM_DS_TUNE_CAL_DQ0_1      //0x18010854
#define PS_CAL_DQ1_NEG_DLYN_SHT        (24)
#define PS_CAL_DQ1_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ1_NEG_DLYN_SHT)
#define PS_CAL_DQ1_POS_DLYN_SHT        (16)
#define PS_CAL_DQ1_POS_DLYN_MASK       (0x3FUL<<CAL_DQ1_POS_DLYN_SHT)
#define PS_CAL_DQ0_NEG_DLYN_SHT        (8)
#define PS_CAL_DQ0_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ0_NEG_DLYN_SHT)
#define PS_CAL_DQ0_POS_DLYN_SHT        (0)
#define PS_CAL_DQ0_POS_DLYN_MASK       (0x3FUL<<CAL_DQ0_POS_DLYN_SHT)



//EM_DS_TUNE_CAL_DQ2_3      //0x18010858
#define PS_CAL_DQ3_NEG_DLYN_SHT        (24)
#define PS_CAL_DQ3_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ3_NEG_DLYN_SHT)
#define PS_CAL_DQ3_POS_DLYN_SHT        (16)
#define PS_CAL_DQ3_POS_DLYN_MASK       (0x3FUL<<CAL_DQ3_POS_DLYN_SHT)
#define PS_CAL_DQ2_NEG_DLYN_SHT        (8)
#define PS_CAL_DQ2_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ2_NEG_DLYN_SHT)
#define PS_CAL_DQ2_POS_DLYN_SHT        (0)
#define PS_CAL_DQ2_POS_DLYN_MASK       (0x3FUL<<CAL_DQ2_POS_DLYN_SHT)


//EM_DS_TUNE_CAL_DQ4_5      //0x1801085C
#define PS_CAL_DQ5_NEG_DLYN_SHT        (24)
#define PS_CAL_DQ5_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ5_NEG_DLYN_SHT)
#define PS_CAL_DQ5_POS_DLYN_SHT        (16)
#define PS_CAL_DQ5_POS_DLYN_MASK       (0x3FUL<<CAL_DQ5_POS_DLYN_SHT)
#define PS_CAL_DQ4_NEG_DLYN_SHT        (8)
#define PS_CAL_DQ4_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ4_NEG_DLYN_SHT)
#define PS_CAL_DQ4_POS_DLYN_SHT        (0)
#define PS_CAL_DQ4_POS_DLYN_MASK       (0x3FUL<<CAL_DQ4_POS_DLYN_SHT)


//EM_DS_TUNE_CAL_DQ6_7      //0x18010860
#define PS_CAL_DQ7_NEG_DLYN_SHT        (24)
#define PS_CAL_DQ7_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ7_NEG_DLYN_SHT)
#define PS_CAL_DQ7_POS_DLYN_SHT        (16)
#define PS_CAL_DQ7_POS_DLYN_MASK       (0x3FUL<<CAL_DQ7_POS_DLYN_SHT)
#define PS_CAL_DQ6_NEG_DLYN_SHT        (8)
#define PS_CAL_DQ6_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ6_NEG_DLYN_SHT)
#define PS_CAL_DQ6_POS_DLYN_SHT        (0)
#define PS_CAL_DQ6_POS_DLYN_MASK       (0x3FUL<<CAL_DQ6_POS_DLYN_SHT)


//EM_DS_TUNE_CAL_DQ8        //0x18010864
#define PS_CAL_DQ8_NEG_DLYN_SHT        (8)
#define PS_CAL_DQ8_NEG_DLYN_MASK       (0x3FUL<<CAL_DQ8_NEG_DLYN_SHT)
#define PS_CAL_DQ8_POS_DLYN_SHT        (0)
#define PS_CAL_DQ8_POS_DLYN_MASK       (0x3FUL<<CAL_DQ8_POS_DLYN_SHT)


//EM_DS_TUNE_PH_SEL_0_1     //0x18010868
#define PS_PH_SEL_DQ_NEG_1_SHT         (24)
#define PS_PH_SEL_DQ_NEG_1_MASK        (0x3FUL<<PH_SEL_DQ_NEG_1_SHT)
#define PS_PH_SEL_DQ_POS_1_SHT         (16)
#define PS_PH_SEL_DQ_POS_1_MASK        (0x3FUL<<PH_SEL_DQ_POS_1_SHT)
#define PS_PH_SEL_DQ_NEG_0_SHT         (8)
#define PS_PH_SEL_DQ_NEG_0_MASK        (0x3FUL<<PH_SEL_DQ_NEG_0_SHT)
#define PS_PH_SEL_DQ_POS_0_SHT         (0)
#define PS_PH_SEL_DQ_POS_0_MASK        (0x3FUL<<PH_SEL_DQ_POS_0_SHT)


//EM_DS_TUNE_PH_SEL_2_3     //0x1801086C
#define PS_PH_SEL_DQ_NEG_3_SHT         (24)
#define PS_PH_SEL_DQ_NEG_3_MASK        (0x3FUL<<PH_SEL_DQ_NEG_3_SHT)
#define PS_PH_SEL_DQ_POS_3_SHT         (16)
#define PS_PH_SEL_DQ_POS_3_MASK        (0x3FUL<<PH_SEL_DQ_POS_3_SHT)
#define PS_PH_SEL_DQ_NEG_2_SHT         (8)
#define PS_PH_SEL_DQ_NEG_2_MASK        (0x3FUL<<PH_SEL_DQ_NEG_2_SHT)
#define PS_PH_SEL_DQ_POS_2_SHT         (0)
#define PS_PH_SEL_DQ_POS_2_MASK        (0x3FUL<<PH_SEL_DQ_POS_2_SHT)


//EM_DS_TUNE_PH_SEL_4_5     //0x18010870
#define PS_PH_SEL_DQ_NEG_5_SHT         (24)
#define PS_PH_SEL_DQ_NEG_5_MASK        (0x3FUL<<PH_SEL_DQ_NEG_5_SHT)
#define PS_PH_SEL_DQ_POS_5_SHT         (16)
#define PS_PH_SEL_DQ_POS_5_MASK        (0x3FUL<<PH_SEL_DQ_POS_5_SHT)
#define PS_PH_SEL_DQ_NEG_4_SHT         (8)
#define PS_PH_SEL_DQ_NEG_4_MASK        (0x3FUL<<PH_SEL_DQ_NEG_4_SHT)
#define PS_PH_SEL_DQ_POS_4_SHT         (0)
#define PS_PH_SEL_DQ_POS_4_MASK        (0x3FUL<<PH_SEL_DQ_POS_4_SHT)


//EM_DS_TUNE_PH_SEL_6_7     //0x18011074
#define PS_PH_SEL_DQ_NEG_7_SHT         (24)
#define PS_PH_SEL_DQ_NEG_7_MASK        (0x3FUL<<PH_SEL_DQ_NEG_7_SHT)
#define PS_PH_SEL_DQ_POS_7_SHT         (16)
#define PS_PH_SEL_DQ_POS_7_MASK        (0x3FUL<<PH_SEL_DQ_POS_7_SHT)
#define PS_PH_SEL_DQ_NEG_6_SHT         (8)
#define PS_PH_SEL_DQ_NEG_6_MASK        (0x3FUL<<PH_SEL_DQ_NEG_6_SHT)
#define PS_PH_SEL_DQ_POS_6_SHT         (0)
#define PS_PH_SEL_DQ_POS_6_MASK        (0x3FUL<<PH_SEL_DQ_POS_6_SHT)

//EM_DS_TUNE_PH_SEL_8       //0x18011078
#define PS_RCV_1ST_DQ_PH_SEL_8_SHT     (16)
#define PS_RCV_1ST_DQ_PH_SEL_8_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_8_SHT)
#define PS_PH_SEL_DQ_NEG_8_SHT         (8)
#define PS_PH_SEL_DQ_NEG_8_MASK        (0x3FUL<<PH_SEL_DQ_NEG_8_SHT)
#define PS_PH_SEL_DQ_POS_8_SHT         (0)
#define PS_PH_SEL_DQ_POS_8_MASK        (0x3FUL<<PH_SEL_DQ_POS_8_SHT)

//EM_DS_TUNE_RCV_1ST        //0x1801107C
#define PS_RCV_1ST_DQ_PH_SEL_7_SHT     (28)
#define PS_RCV_1ST_DQ_PH_SEL_7_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_7_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_6_SHT     (24)
#define PS_RCV_1ST_DQ_PH_SEL_6_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_6_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_5_SHT     (20)
#define PS_RCV_1ST_DQ_PH_SEL_5_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_5_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_4_SHT     (16)
#define PS_RCV_1ST_DQ_PH_SEL_4_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_4_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_3_SHT     (12)
#define PS_RCV_1ST_DQ_PH_SEL_3_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_3_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_2_SHT     (8)
#define PS_RCV_1ST_DQ_PH_SEL_2_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_2_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_1_SHT     (4)
#define PS_RCV_1ST_DQ_PH_SEL_1_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_1_SHT)
#define PS_RCV_1ST_DQ_PH_SEL_0_SHT     (0)
#define PS_RCV_1ST_DQ_PH_SEL_0_MASK    (0xfUL<<RCV_1ST_DQ_PH_SEL_0_SHT)

//EM_CPMASK_0               //0x18011080
#define PS_CPMASK_SEL                  _BIT0

//EM_HALF_CYCLE_CAL_EN      //0x1801108C
#define PS_FW_MODE                     _BIT18
#define PS_HALH_CYCLE_CAL_SEL          _BIT17
#define PS_HALH_CYCLE_REF_THR_SHT      (9)
#define PS_HALH_CYCLE_REF_THR_MASK     (0x7FUL<<HALH_CYCLE_REF_THR_SHT)
#define PS_HALH_CYCLE_RES_THR_SHT      (3)
#define PS_HALH_CYCLE_RES_THR_MASK     (0x1FUL<<HALH_CYCLE_RES_THR_SHT)
#define PS_HALH_CYCLE_RES_MOD_SHT      (1)
#define PS_HALH_CYCLE_RES_MOD_MASK     (0x03UL<<HALH_CYCLE_RES_MOD_SHT)
#define PS_HALH_CYCLE_CAL_EN           _BIT0

//EM_HALF_CYCLE_CAL_RESULT  //0x18011090
#define PS_HALH_CYCLE_CAL_RESULT_SHT       (0)
#define PS_HALH_CYCLE_CAL_RESULT_MASK      (0x1FUL<<HALH_CYCLE_CAL_RESULT_SHT)

/* ====== DWC_Mobile_Storage ====== */

//EM_DWC_CTRL               //0x18011100
/* Control register defines  */
#define SDMMC_CTRL_USE_IDMAC		_BIT25
#define SDMMC_CTRL_OD_PULLUP_EN     _BIT24
#define SDMMC_CTRL_CARD_VOLT_B_SHT  (20)
#define SDMMC_CTRL_CARD_VOLT_B_MASK (0xfUL<<SDMMC_CTRL_CARD_VOLT_B_SHT)
#define SDMMC_CTRL_CARD_VOLT_A_SHT  (16)
#define SDMMC_CTRL_CARD_VOLT_A_MASK (0xfUL<<SDMMC_CTRL_CARD_VOLT_A_SHT)
#define SDMMC_CTRL_CEATA_INT_EN		_BIT11
#define SDMMC_CTRL_SEND_AS_CCSD		_BIT10
#define SDMMC_CTRL_SEND_CCSD		_BIT9
#define SDMMC_CTRL_ABRT_READ_DATA	_BIT8
#define SDMMC_CTRL_SEND_IRQ_RESP	_BIT7
#define SDMMC_CTRL_READ_WAIT		_BIT6
#define SDMMC_CTRL_DMA_ENABLE		_BIT5
#define SDMMC_CTRL_INT_ENABLE		_BIT4
#define SDMMC_CTRL_DMA_RESET		_BIT2
#define SDMMC_CTRL_FIFO_RESET		_BIT1
#define SDMMC_CTRL_RESET		    _BIT0


//EM_DWC_CLKDIV             //0x18011108
#define SDMMC_CLKDIV0_SHT           (0)
#define SDMMC_CLKDIV0_MASK          (0xffUL<<SDMMC_CLKDIV0_SHT )
#define SDMMC_CLKDIV0(val)          (((val) & SDMMC_CLKDIV0_MASK)>>SDMMC_CLKDIV0_SHT)
#define CLKDIV_NON                  0
#define CLKDIV_2                    1

//EM_DWC_CLKSRC             //0x1801110C
//EM_DWC_CLKENA             //0x18011110
/* Clock Enable register defines */
#define SDMMC_CLKEN_LOW_PWR_SHT     (16)
#define SDMMC_CLKEN_LOW_PWR_MASK    (0xFFFFUL<<SDMMC_CLKEN_LOW_PWR_SHT)
#define SDMMC_CLKEN_ENABLE_SHT 		(0)
#define SDMMC_CLKEN_ENABLE_MASK		(0xFFFFUL<<SDMMC_CLKEN_ENABLE_SHT)

//EM_DWC_TMOUT              //0x18011114
/* time-out register defines */
#define SDMMC_TMOUT_DATA_SHT        (8)
#define SDMMC_TMOUT_DATA_MASK		(0xFFFFFFUL<<SDMMC_TMOUT_DATA_SHT)
#define SDMMC_TMOUT_RESP_SHT        (0)
#define SDMMC_TMOUT_RESP_MASK		(0xFFUL<<SDMMC_TMOUT_RESP_SHT)

//EM_DWC_CTYPE              //0x18011118
/* card-type register defines */
#define SDMMC_CTYPE_8BIT_SHT		(16)
#define SDMMC_CTYPE_8BIT_MASK		(0xFFFFUL<<SDMMC_CTYPE_8BIT_SHT)
#define SDMMC_CTYPE_4BIT_SHT		(0)
#define SDMMC_CTYPE_4BIT_MASK		(0xFFFFUL<<SDMMC_CTYPE_4BIT_SHT)


//EM_DWC_BLKSIZ             //0x1801111C
//EM_DWC_BYTCNT             //0x18011120
//EM_DWC_INTMASK            //0x18011124
/* Interrupt status & mask register defines */
#define SDMMC_INT_SDIO(n)		(_BIT16+(n))
#define SDMMC_INT_EBE			_BIT15
#define SDMMC_INT_ACD			_BIT14
#define SDMMC_INT_SBE			_BIT13
#define SDMMC_INT_HLE			_BIT12
#define SDMMC_INT_FRUN			_BIT11
#define SDMMC_INT_HTO			_BIT10
#define SDMMC_INT_DTO			_BIT9
#define SDMMC_INT_RTO			_BIT8
#define SDMMC_INT_DCRC			_BIT7
#define SDMMC_INT_RCRC			_BIT6
#define SDMMC_INT_RXDR			_BIT5
#define SDMMC_INT_TXDR			_BIT4
#define SDMMC_INT_DATA_OVER		_BIT3
#define SDMMC_INT_CMD_DONE		_BIT2
#define SDMMC_INT_RESP_ERR		_BIT1
#define SDMMC_INT_CD			_BIT0
#define SDMMC_INT_ERROR			(0xbfc2)

//EM_DWC_CMDARG             //0x18011128
//EM_DWC_CMD                //0x1801112C
/* Command register defines */
#define SDMMC_CMD_START			_BIT31
#define SDMMC_CMD_USE_HREG		_BIT29
#define SDMMC_CMD_CCS_EXP		_BIT23
#define SDMMC_CMD_CEATA_RD		_BIT22
#define SDMMC_CMD_UPD_CLK		_BIT21
#define SDMMC_CMD_CARD_NUM_SHT  (16)
#define SDMMC_CMD_CARD_NUM_MASK (0x1FUL<<SDMMC_CMD_CARD_NUM_SHT)
#define SDMMC_CMD_CARD_NUM(val) (((n) & SDMMC_CMD_INDX_MASK)>>SDMMC_CMD_CARD_NUM_SHT)
#define SDMMC_CMD_INIT			_BIT15
#define SDMMC_CMD_STOP			_BIT14
#define SDMMC_CMD_PRV_DAT_WAIT  _BIT13
#define SDMMC_CMD_SEND_STOP		_BIT12
#define SDMMC_CMD_STRM_MODE		_BIT11
#define SDMMC_CMD_DAT_WR		_BIT10
#define SDMMC_CMD_DAT_EXP		_BIT9
#define SDMMC_CMD_RESP_CRC		_BIT8
#define SDMMC_CMD_RESP_LONG		_BIT7
#define SDMMC_CMD_RESP_EXP		_BIT6
#define SDMMC_CMD_INDX_SHT		(0)
#define SDMMC_CMD_INDX_MASK		(0x3FUL<<SDMMC_CMD_INDX_SHT)
#define SDMMC_CMD_INDX(n)		(((n) & SDMMC_CMD_INDX_MASK)>>SDMMC_CMD_INDX_SHT)

//EM_DWC_RESP0              //0x18011130
//EM_DWC_RESP1              //0x18011134
//EM_DWC_RESP2              //0x18011138
//EM_DWC_RESP3              //0x1801113C
//EM_DWC_MINTSTS            //0x18011140 To reference bits define at REG0x24
//EM_DWC_RINTSTS            //0x18011144
//EM_DWC_STATUS             //0x18011148
/* Status register defines */
#define SDMMC_DAT0_BUSY         _BIT9   //1: card busy; 0: card not busy;
#define SDMMC_GET_FCNT_SHT      (17)
#define SDMMC_GET_FCNT_MASK     (0x1FFFUL<<SDMMC_GET_FCNT_SHT)
#define SDMMC_GET_FCNT(x)		(((x)& SDMMC_GET_FCNT_MASK)>> SDMMC_GET_FCNT_SHT)

//EM_DWC_FIFOTH             //0x1801114C
#define SDMMC_MSIZE_SHT         (28)
#define SDMMC_MSIZE_MASK        (0x07UL<<SDMMC_MSIZE_SHT)
#define SDMMC_MSIZE(x)		    (((x)& SDMMC_MSIZE_MASK)>> SDMMC_MSIZE_SHT)
#define SDMMC_MSIZE_ROW(x)		((x)& SDMMC_MSIZE_MASK)
#define SDMMC_RX_WMARK_SHT      (16)
#define SDMMC_RX_WMARK_MASK     (0x7FFUL<<SDMMC_RX_WMARK_SHT)
#define SDMMC_RX_WMARK(x)	    (((x)& SDMMC_RX_WMARK_MASK)>> SDMMC_RX_WMARK_SHT)
#define SDMMC_RX_WMARK_ROW(x)   ((x)& SDMMC_RX_WMARK_MASK)
#define SDMMC_TX_WMARK_SHT      (0)
#define SDMMC_TX_WMARK_MASK     (0xFFFUL<<SDMMC_TX_WMARK_SHT)
#define SDMMC_TX_WMARK(x)	    (((x)& SDMMC_TX_WMARK_MASK)>> SDMMC_TX_WMARK_SHT)
#define SSDMMC_TX_WMARK_ROW(x)  ((x)& SDMMC_TX_WMARK_MASK)


//EM_DWC_CDETECT            //0x18011150
//EM_DWC_WRTPRT             //0x18011154
//EM_DWC_GPIO               //0x18011158
//EM_DWC_TCBCNT             //0x1801115C
//EM_DWC_TBBCNT             //0x18011160
//EM_DWC_DEBNCE             //0x18011164
//EM_DWC_USRID              //0x18011168
//EM_DWC_VERID              //0x1801116C
//EM_DWC_HCON               //0x18011170
//EM_DWC_UHS_REG            //0x18011174
//EM_DWC_RST_n              //0x18011178
//EM_DWC_BMOD               //0x18011180
#define SDMMC_DE            (_BIT7)
#define SDMMC_FB            (_BIT1)
#define SDMMC_SWR           (_BIT0)

//EM_DWC_PLDMND             //0x18011184
//EM_DWC_DBADDR             //0x18011188
//EM_DWC_DBADDRL64          //0x18011188
//EM_DWC_DBADDRU64          //0x1801118C
//EM_DWC_IDSTS              //0x1801118C
//EM_DWC_IDSTS64            //0x18011190
//EM_DWC_IDINTEN            //0x18011190
//EM_DWC_IDINTEN64          //0x18011194
/* Internal DMAC interrupt defines */
#define SDMMC_IDMAC_INT_AI		_BIT9
#define SDMMC_IDMAC_INT_NI		_BIT8
#define SDMMC_IDMAC_INT_CES		_BIT5
#define SDMMC_IDMAC_INT_DU		_BIT4
#define SDMMC_IDMAC_INT_FBE		_BIT2
#define SDMMC_IDMAC_INT_RI		_BIT1
#define SDMMC_IDMAC_INT_TI		_BIT0

//EM_DWC_DSCADDR            //0x18011194
//EM_DWC_DSCADDRL64         //0x18011198
//EM_DWC_DSCADDRU64         //0x1801119C
//EM_DWC_BUFADDR            //0x18011198
//EM_DWC_BUFADDRL64         //0x180111A0
//EM_DWC_BUFADDRU64         //0x180111A4
//EM_DWC_CardThrCtl         //0x18011200
//EM_DWC_Back_END_POWER     //0x18011204
//EM_DWC_UHS_REG_EXT        //0x18011208
//EM_DWC_EMMC_DDR_REG       //0x1801120C
//EM_DWC_ENABLE_SHIFT       //0x18011210
//EM_DWC_DATA_BASE          //0x18011300

/* Internal DMAC bus mode bits */
#define SDMMC_IDMAC_ENABLE		_BIT7
#define SDMMC_IDMAC_FB			_BIT1
#define SDMMC_IDMAC_SWRESET		_BIT0
/* Version ID register define */
#define SDMMC_GET_VERID(x)		((x) & 0xFFFF)

struct idmac_desc {
	unsigned int		des0;	/* Control Descriptor */
#define IDMAC_DES0_DIC	_BIT1
#define IDMAC_DES0_LD	_BIT2
#define IDMAC_DES0_FD	_BIT3
#define IDMAC_DES0_CH	_BIT4
#define IDMAC_DES0_ER	_BIT5
#define IDMAC_DES0_CES	_BIT30
#define IDMAC_DES0_OWN	_BIT31

	unsigned int		des1;	/* Buffer sizes */
#define IDMAC_SET_BUFFER1_SIZE(d, s) \
	((d)->des1 = ((d)->des1 & 0x03ffe000) | ((s) & 0x1fff))

	unsigned int		des2;	/* buffer 1 physical address */

	unsigned int		des3;	/* buffer 2 physical address */
};


/* Standard MMC commands (4.1)              type    argument            response */
/* class 1 */
#define MMC_GO_IDLE_STATE           0       /* bc                           */
#define MMC_SEND_OP_COND            1       /* bcr  [31:0] OCR          R3  */
#define MMC_ALL_SEND_CID            2       /* bcr                      R2  */
#define MMC_SET_RELATIVE_ADDR       3       /* ac   [31:16] RCA         R1  */
#define MMC_SET_DSR                 4       /* bc   [31:16] RCA             */
#define MMC_SLEEP_AWAKE             5       /* ac   [31:16] RCA 15:flg  R1b */
#define MMC_SWITCH                  6       /* ac   [31:0] See below    R1b */
#define MMC_SELECT_CARD             7       /* ac   [31:16] RCA         R1  */
#define MMC_SEND_EXT_CSD            8       /* adtc                     R1  */
#define MMC_SEND_CSD                9       /* ac   [31:16] RCA         R2  */
#define MMC_SEND_CID                10      /* ac   [31:16] RCA         R2  */
#define MMC_READ_DAT_UNTIL_STOP     11      /* adtc [31:0] dadr         R1  */
#define MMC_STOP_TRANSMISSION       12      /* ac                       R1b */
#define MMC_SEND_STATUS             13      /* ac   [31:16] RCA         R1  */
#define MMC_GO_INACTIVE_STATE       15      /* ac   [31:16] RCA             */
#define MMC_SPI_READ_OCR            58      /* spi                      spi_R3 */
#define MMC_SPI_CRC_ON_OFF          59      /* spi  [0:0] flag          spi_R1 */

  /* class 2 */
#define MMC_SET_BLOCKLEN            16      /* ac   [31:0] block len    R1  */
#define MMC_READ_SINGLE_BLOCK       17      /* adtc [31:0] data addr    R1  */
#define MMC_READ_MULTIPLE_BLOCK     18      /* adtc [31:0] data addr    R1  */

  /* class 3 */
#define MMC_WRITE_DAT_UNTIL_STOP    20      /* adtc [31:0] data addr    R1  */

  /* class 4 */
#define MMC_SET_BLOCK_COUNT         23      /* adtc [31:0] data addr    R1  */
#define MMC_WRITE_BLOCK             24      /* adtc [31:0] data addr    R1  */
#define MMC_WRITE_MULTIPLE_BLOCK    25      /* adtc                     R1  */
#define MMC_PROGRAM_CID             26      /* adtc                     R1  */
#define MMC_PROGRAM_CSD             27      /* adtc                     R1  */

  /* class 6 */
#define MMC_SET_WRITE_PROT          28      /* ac   [31:0] data addr    R1b */
#define MMC_CLR_WRITE_PROT          29      /* ac   [31:0] data addr    R1b */
#define MMC_SEND_WRITE_PROT         30      /* adtc [31:0] wpdata addr  R1  */

  /* class 5 */
#define MMC_ERASE_GROUP_START       35      /* ac   [31:0] data addr    R1  */
#define MMC_ERASE_GROUP_END         36      /* ac   [31:0] data addr    R1  */
#define MMC_ERASE                   38      /* ac                       R1b */

  /* class 9 */
#define MMC_FAST_IO                 39      /* ac   <Complex>           R4  */
#define MMC_GO_IRQ_STATE            40      /* bcr                      R5  */

  /* class 7 */
#define MMC_LOCK_UNLOCK             42      /* adtc                     R1b */

  /* class 8 */
#define MMC_APP_CMD                 55      /* ac   [31:16] RCA         R1  */
#define MMC_GEN_CMD                 56      /* adtc [0] RD/WR           R1  */

#define R1_OUT_OF_RANGE             (0x01UL << 31)   /* er, c */
#define R1_ADDRESS_ERROR            (0x01UL << 30)   /* erx, c */
#define R1_BLOCK_LEN_ERROR          (0x01UL << 29)   /* er, c */
#define R1_ERASE_SEQ_ERROR          (0x01UL << 28)   /* er, c */
#define R1_ERASE_PARAM              (0x01UL << 27)   /* ex, c */
#define R1_WP_VIOLATION             (0x01UL << 26)   /* erx, c */
#define R1_CARD_IS_LOCKED           (0x01UL << 25)   /* sx, a */
#define R1_LOCK_UNLOCK_FAILED       (0x01UL << 24)   /* erx, c */
#define R1_COM_CRC_ERROR            (0x01UL << 23)   /* er, b */
//#define R1_ILLEGAL_COMMAND          (0x01UL << 22)   /* er, b definded at .uboot\include\mmc.h*/
#define R1_CARD_ECC_FAILED          (0x01UL << 21)   /* ex, c */
#define R1_CC_ERROR                 (0x01UL << 20)   /* erx, c */
#define R1_ERROR                    (0x01UL << 19)   /* erx, c */
#define R1_UNDERRUN                 (0x01UL << 18)   /* ex, c */
#define R1_OVERRUN                  (0x01UL << 17)   /* ex, c */
#define R1_CID_CSD_OVERWRITE        (0x01UL << 16)   /* erx, c, CID/CSD overwrite */
#define R1_WP_ERASE_SKIP            (0x01UL << 15)   /* sx, c */
#define R1_CARD_ECC_DISABLED        (0x01UL << 14)   /* sx, a */
#define R1_ERASE_RESET              (0x01UL << 13)   /* sr, c */

#define R1_STATUS(x)                (x & 0xFFFFE000)
#define R1_CURRENT_STATE(x)         ((x & 0x00001E00) >> 9) /* sx, b (4 bits) */
#define R1_READY_FOR_DATA           (0x01UL << 8)    /* sx, a */
#define R1_SWITCH_ERROR             (0x01UL << 7)    /* sx, c */
//#define R1_APP_CMD                (0x01UL << 5)    /* sr, c definded at .\uboot\include\mmc.h*/

#define R1_ERR_CUR_WINDOW           R1_OUT_OF_RANGE         |\
                                    R1_ADDRESS_ERROR        |\
                                    R1_BLOCK_LEN_ERROR      |\
                                    R1_ERASE_SEQ_ERROR      |\
                                    R1_ERASE_PARAM          |\
                                    R1_WP_VIOLATION         |\
                                    R1_LOCK_UNLOCK_FAILED   |\
                                    R1_COM_CRC_ERROR        |\
                                    R1_ILLEGAL_COMMAND      |\
                                    R1_CARD_ECC_FAILED      |\
                                    R1_CC_ERROR             |\
                                    R1_ERROR                |\
                                    R1_UNDERRUN             |\
                                    R1_OVERRUN              |\
                                    R1_CID_CSD_OVERWRITE    |\
                                    R1_WP_ERASE_SKIP        |\
                                    R1_ERASE_RESET


#define R1_ERR_PER_WINDOW           R1_OUT_OF_RANGE         |\
                                    R1_ADDRESS_ERROR        |\
                                    R1_ERASE_PARAM          |\
                                    R1_WP_VIOLATION         |\
                                    R1_LOCK_UNLOCK_FAILED   |\
                                    R1_CARD_ECC_FAILED      |\
                                    R1_ERROR                |\
                                    R1_UNDERRUN             |\
                                    R1_OVERRUN              |\
                                    R1_CID_CSD_OVERWRITE    |\
                                    R1_WP_ERASE_SKIP

/* SD commands                          type  argument     response */
  /* class 0 */
/* This is basically the same command as for MMC with some quirks. */
#define SD_SEND_RELATIVE_ADDR       3   /* bcr                     R6  */
#define SD_SEND_IF_COND             8   /* bcr  [11:0] See below   R7  */
#define SD_SWITCH_VOLTAGE           11  /* ac                      R1  */

  /* class 10 */
#define SD_SWITCH                   6   /* adtc [31:0] See below   R1  */

  /* class 5 */
#define SD_ERASE_WR_BLK_START       32  /* ac   [31:0] data addr   R1  */
#define SD_ERASE_WR_BLK_END         33  /* ac   [31:0] data addr   R1  */

  /* Application commands */
#define SD_APP_SET_BUS_WIDTH        6   /* ac   [1:0] bus width    R1  */
#define SD_APP_SD_STATUS            13  /* adtc                    R1  */
#define SD_APP_SEND_NUM_WR_BLKS     22  /* adtc                    R1  */
#define SD_APP_OP_COND              41  /* bcr  [31:0] OCR         R3  */
#define SD_APP_SEND_SCR             51  /* adtc                    R1  */

/* OCR bit definitions */
#define SD_OCR_S18R                 (1 << 24)    /* 1.8V switching request */
#define SD_ROCR_S18A                SD_OCR_S18R  /* 1.8V switching accepted by card */
#define SD_OCR_XPC                  (1 << 28)    /* SDXC power control */
#define SD_OCR_CCS                  (1 << 30)    /* Card Capacity Status */

/*
 * EXT_CSD fields
 */
#define EXT_CSD_BUS_WIDTH           183     /* R/W */
#define EXT_CSD_HS_TIMING           185     /* R/W */
#define EXT_CSD_CARD_TYPE           196     /* RO */
#define EXT_CONT_CSD_VER            194     /* RO */
#define EXT_CSD_REV                 192     /* RO */
#define EXT_CSD_SEC_CNT             212     /* RO, 4 bytes */
#define EXT_CSD_S_A_TIMEOUT         217
//#define EXT_CSD_SEC_FEATURE_SUPPORT   231 /* RO */

/*
 * MMC_SWITCH access modes
 */
#define MMC_SWITCH_MODE_CMD_SET     0x00    /* Change the command set */
#define MMC_SWITCH_MODE_SET_BITS    0x01    /* Set bits which are 1 in value */
#define MMC_SWITCH_MODE_CLEAR_BITS  0x02    /* Clear bits which are 1 in value */
#define MMC_SWITCH_MODE_WRITE_BYTE  0x03    /* Set target to value */

/* *** Realtek CRT register *** */

#define RTK_EM_DW_SRST          SYS_REG_SYS_SRST2_reg
#define RTK_EM_DW_CLKEN         SYS_REG_SYS_CLKEN2_reg

#define RSTN_EM_SHT		(23)
#define CLKEN_EM_SHT		(23)

#define RSTN_EM_DW              (0x01UL<<RSTN_EM_SHT)
#define CLKEN_EM_DW             (0x01UL<<CLKEN_EM_SHT)

/* 299s PLL and Phase relation */
#define EMMC_PLL_SET            0xb8000700
#define EMMC_PLL_CTRL           0xb8000704
#define EMMC_PLLPHASE_CTRL      0xb8000708
#define EMMC_PLL_PHASE_INTERPOLATION    0xb800070C
#define EMMC_PLL_SSC0           0xb8000710
#define EMMC_PLL_SSC1           0xb8000714
#define EMMC_PLL_SSC2           0xb8000718
#define EMMC_PLL_SSC3           0xb800071C
#define EMMC_PLL_SSC4           0xb8000720
#define EMMC_PLL_SSC5           0xb8000724
#define EMMC_PLL_SSC6           0xb8000728

#define MAX_TUNING_STEP        (28)
#define MAX_DS_TUNE			   (32)
#define PHASE_W_SHT             0
#define PHASE_W_MASK            0x03fUL
#define PHASE_R_SHT             10
#define PHASE_R_MASK            0x03fUL

#define DIS_HS400 0x01
#define DIS_HS200 0x02
#define SET_SPEED_MODE(val)	\
		cr_writel((cr_readl(EM_WARP_STATUS0) & ~0xffff0000)|(val<<16), EM_WARP_STATUS0)
#define GET_SPEED_MODE()	\
		((cr_readl(EM_WARP_STATUS0) & 0xffff0000) >> 16)

/************************************************************************
 *  Structure
 ************************************************************************/
struct rtk_mmc_command {
    unsigned int opcode;
    unsigned int arg;
    unsigned int resp[4];
};


struct rtk_cmd_info {
    struct rtk_mmc_command *        cmd;
    unsigned int  *                 rsp;
    unsigned char *                 data_buffer;
    unsigned int                    byte_count;
    unsigned int                    block_count;
    unsigned int                    xfer_flag;

#define RTK_MMC_DATA_READ		_BIT0
#define RTK_MMC_DATA_WRITE		_BIT1
#define RTK_MMC_IS_REL_WRITE		_BIT31

    unsigned int                    cmd_flag;
    unsigned int                    rsp_para;
    unsigned int                    rsp_len;
    unsigned int					timeout;
};

/*
 * emmc profile
 */
struct rtk_mmc_cid {
    unsigned int                    manfid;
    char                            prod_name[8];
    unsigned int                    serial;
    unsigned int                    oemid;
    unsigned int                    year;
    unsigned char                   hwrev;
    unsigned char                   fwrev;
    unsigned char                   month;
};

struct rtk_mmc_csd {
    unsigned char                   csd_ver;
    unsigned char                   csd_ver2;// from EXT_CSD
    unsigned char                   mmca_vsn;
    unsigned short                  cmdclass;
    unsigned short                  tacc_clks;
    unsigned int                    tacc_ns;
    unsigned int                    r2w_factor;
    unsigned int                    max_dtr;
    unsigned int                    read_blkbits;
    unsigned int                    write_blkbits;
    unsigned int                    capacity;
    unsigned int                    read_partial:1,
                                    read_misalign:1,
                                    write_partial:1,
                                    write_misalign:1;
};

struct rtk_mmc_ext_csd {
    unsigned int                    rev;
    unsigned char		sec_support;
    unsigned int                    sa_timeout;
    unsigned int                    hs_max_dtr;
    unsigned int                    sectors;
};

struct sd_scr {
    unsigned char       sda_vsn;
    unsigned char       bus_widths;
#define SD_SCR_BUS_WIDTH_1  (1<<0)
#define SD_SCR_BUS_WIDTH_4  (1<<2)
};

struct sd_switch_caps {
    unsigned int        hs_max_dtr;
};

#define MMC_EN_SSCG _BIT0

typedef struct  {
	u32                 ctl;
	u8                  ncode_t;
	u8                  sdiv2;
	u8                  r_phase;
	u8                  w_phase;
	u8                  icp;
	u8                  pi_isel;
	u16                 ncode_ssc;
	u16                 fcode_ssc;
	u32                 range_ssc;
}mmc_param_t;

typedef struct {
	unsigned int		sector_addressing;
	unsigned int		rca;	/* relative card address of device */
	unsigned int		state;	/* (our) card state */
#define MMC_STATE_PRESENT   (1<<0)	/* present in sysfs */
#define MMC_STATE_READONLY  (1<<1)	/* card is read-only */
#define MMC_STATE_HIGHSPEED (1<<2)	/* card is in high speed mode */
#define MMC_STATE_BLOCKADDR (1<<3)	/* card uses block-addressing */

#define MMC_STATE_ONE_BLK   (1<<4)	/* writting use one block mode */
#define MMC_STATE_IDENT_RDY (1<<5)	/* for check identify state, */
#define MMC_STATE_CMD24_ERR (1<<6)	/* for cmd24 error handling */
#define MMC_STATE_SD_EMMC   (1<<7)	/* SD base eMMC */

	unsigned int		raw_cid[4];     /* raw card CID */
	unsigned int		raw_csd[4];     /* raw card CSD */
	unsigned int		raw_scr[2];     /* raw card SCR */
	unsigned char		raw_ecsd[512];     /* raw card CSD, add for cowork kboot */

	unsigned int cur_clock;
	unsigned int cur_width;
	unsigned int cur_PLL;
	unsigned int cur_div;
	unsigned int cur_w_phase;
	unsigned int cur_w_ph400;
	unsigned int cur_r_phase;
	unsigned int cur_c_phase;
	unsigned int cur_ds_tune;
	unsigned int tud_r_phase;
	unsigned int tud_r_clock;

	//unsigned int pre_r_phase;	//have no resume case
	//unsigned int pre_ds_tune; //have no resume case

	unsigned int mid;
	unsigned int dev_status;
	unsigned int pre_status;	//only for auto_stop_cmd resp

	unsigned int rtflags;        /* Driver states */
	/* rtflags */
	#define RTKCR_FCARD_DETECTED    (1<<0)      /* Card is detected */
	#define RTKCR_FOPEN_LOG         (1<<1)      /* open command log */
	#define RTKCR_USER_PARTITION    (1<<2)      /* card is working on normal partition */
	#define RTKCR_IDENT_STATE       (1<<3)      /* card is identification mode */
	#define RTKCR_FCARD_POWER       (1<<4)      /* Card is power on */
	#define RTKCR_FHOST_POWER       (1<<5)      /* Host is power on */
	#define RTKCR_TUNING_STATE      (1<<6)      /* Host is processing phase tuning */
	#define RTKCR_CMD23_ALERT	(1<<7)      /* cmd23 alert, disable auto cmd12 */

	struct rtk_mmc_cid              cid;            /* card identification */
	struct rtk_mmc_csd              csd;            /* card specific */
	struct rtk_mmc_ext_csd          ext_csd;        /* mmc v4 extended card specific */
	struct sd_scr           scr;                    /* extra SD information */
	struct sd_switch_caps   sw_caps;                /* switch (CMD6) caps */
	mmc_param_t *mmc_boot_param;	/* for bootcode pre setting parameter *** */
	int (*call_back_byte_cnt)(int err,int bytes);
	struct mmc * mmc;
} e_device_type;

#ifdef __RTKMMC_C__
    #define EXTERN_CALL
#else
    #define EXTERN_CALL extern
#endif

/* export function */
extern void dw_em_set_clk(unsigned int em_clock);
extern unsigned int dw_em_set_bits(unsigned int bus_width);
EXTERN_CALL e_device_type emmc_card;
EXTERN_CALL void mmccr_set_bits_width( unsigned int set_bit );
EXTERN_CALL int rtk_eMMC_init( void );
EXTERN_CALL unsigned int rtk_eMMC_write( unsigned int blk_addr, unsigned int data_size, unsigned int * buffer );
EXTERN_CALL unsigned int rtk_eMMC_read( unsigned int blk_addr, unsigned int data_size, unsigned int * buffer );
EXTERN_CALL int export_rtk_emmc_chk_max_xfer_blk(struct mmc * mmc, bool show_msg);

#endif /* end of file */
