#ifndef __PWM_MENU_H__
#define __PWM_MENU_H__

#include <drivers/pwm/pwm.h>
#include <drivers/pwm/roku_drvPWM.h>

#define MENU_LEVEL_MAX (10) //at most 10 level menus
#define MENU_NAME_LEN (16) //max length for menu name show in path

#define FRED_START "\033[1;31;40m"
#define FGREEN_START "\033[1;32;40m"
#define FYELLOW_START "\033[1;33;40m"
#define FBLUE_START "\033[1;34;40m"
#define FCOLOR_END "\033[0m"

#define DBG_DFT(format, ...) do{ printf(format, ##__VA_ARGS__); }while(0)
#define DBG_RED(format, ...) do{ printf(FRED_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_GREEN(format, ...) do{ printf(FGREEN_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_YELLOW(format, ...) do{ printf(FYELLOW_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_BLUE(format, ...) do{ printf(FBLUE_START format FCOLOR_END, ##__VA_ARGS__); }while(0)

typedef struct pwm_setmenu
{
    char * name;//name
    char * desc;//description
    int (*func)(void);//name
    struct pwm_setmenu * father;//father menu
} pwm_setmenu;

typedef struct pwm_menu_state
{
    pwm_setmenu * menu;
    int level;
    char path[MENU_LEVEL_MAX][MENU_NAME_LEN];
} pwm_menu_state;

void pwm_prepare_go_ahead(void);
void pwm_prepare_go_back(void);
int go_pwm_up_menu(void);
int go_test_top(void);
int go_pwm_list(void);
int go_duty_top(void);
int go_frequency_top(void);
int go_output_top(void);
int go_polarity_top(void);
int go_vsync_top(void);
int go_gpio_mode_top(void);
int go_show_pwm_pcb_info_top(void);
int go_show_all_info_top(void);
void show_pwm_menu(pwm_setmenu * p);
void show_pwm_now_path(void);
int get_pwm_menu_len(pwm_setmenu * p);
int pwm_menu_wait(pwm_setmenu * p);
int go_pwm_main_menu(void);
#ifdef CONFIG_REALTEK_PWM_ROKU
int roku_test(void);
#endif

extern int pwm_list(void);

extern int gets(char *s);
extern void *malloc(size_t size);
extern void free(void *ptr);
extern char *getenv(const char *name);
extern int setenv(const char *varname, const char *varvalue);
#endif