#ifndef __PWM_H__
#define __PWM_H__
#ifdef __cplusplus
extern "C" {
#endif

#define  SYS_CLKDIV                  (0xb8000214)

#define  ISO_PWM_DB_CTRL_VADDR       (0xb8061280)
#define  ISO_PWM0_CTRL_VADDR         (ISO_PWM_DB_CTRL_VADDR + 0x4)
#define  ISO_PWM0_TIMING_CTRL_VADDR  (ISO_PWM_DB_CTRL_VADDR + 0x8)
#define  ISO_PWM0_DUTY_SET_VADDR     (ISO_PWM_DB_CTRL_VADDR + 0xC)
#define  ISO_PWM0_ALIGN_VADDR        (ISO_PWM_DB_CTRL_VADDR + 0x10)
#define  ISO_PWM0_TRACKVALUE_VADDR   (ISO_PWM_DB_CTRL_VADDR + 0x14)
#define  ISO_PWM1_CTRL_VADDR         (ISO_PWM_DB_CTRL_VADDR + 0x18)
#define  ISO_PWM1_TIMING_CTRL_VADDR  (ISO_PWM_DB_CTRL_VADDR + 0x1C)
#define  ISO_PWM1_DUTY_SET_VADDR     (ISO_PWM_DB_CTRL_VADDR + 0x20)
#define  ISO_PWM1_ALIGN_VADDR        (ISO_PWM_DB_CTRL_VADDR + 0x24)
#define  ISO_PWM1_TRACKVALUE_VADDR   (ISO_PWM_DB_CTRL_VADDR + 0x28)
#define  ISO_PWM_OD_MODE_VADDR       (ISO_PWM_DB_CTRL_VADDR + 0x34)
#define  ISO_PWM_NONE                (0xbFFFFFFF)


#define  MIS_PWM_DB0_CTRL_VADDR    (0xb801b900)
#define  MIS_PWM_DB1_CTRL_VADDR                    (MIS_PWM_DB0_CTRL_VADDR + 0x4)
#define  MIS_PWM0_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0x8)
#define  MIS_PWM0_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xC)
#define  MIS_PWM0_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0x10)
#define  MIS_PWM0_DVS_PERIOD_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x14)
#define  MIS_PWM0_DVS_MONITOR_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0x18)
#define  MIS_PWM0_MONITOR_VADDR                    (MIS_PWM_DB0_CTRL_VADDR + 0x1C)
#define  MIS_PWM0_ERR_STATUS_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x20)
#define  MIS_PWM0_TRACK_SET_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x24)
#define  MIS_PWM0_TRACK_FSM_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x28)
#define  MIS_PWM0_TRACK_PTI_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x2C)
#define  MIS_PWM0_FREQ0_VADDR                      (MIS_PWM_DB0_CTRL_VADDR + 0x30)
#define  MIS_PWM0_FREQ1_VADDR                      (MIS_PWM_DB0_CTRL_VADDR + 0x34)
#define  MIS_PWM0_PHASE0_VADDR                     (MIS_PWM_DB0_CTRL_VADDR + 0x38)
#define  MIS_PWM0_PHASE1_VADDR                     (MIS_PWM_DB0_CTRL_VADDR + 0x3C)
#define  MIS_PWM0_HW_PREDICT_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x40)
#define  MIS_PWM0_SW_PREDICT_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x44)
#define  MIS_PWM0_PREDICT_RATIO_VADDR              (MIS_PWM_DB0_CTRL_VADDR + 0x48)
#define  MIS_PWM1_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0x4C)
#define  MIS_PWM1_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0x50)
#define  MIS_PWM1_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0x54)
#define  MIS_PWM1_DVS_PERIOD_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x58)
#define  MIS_PWM1_DVS_MONITOR_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0x5C)
#define  MIS_PWM1_MONITOR_VADDR                    (MIS_PWM_DB0_CTRL_VADDR + 0x60)
#define  MIS_PWM1_ERR_STATUS_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x64)
#define  MIS_PWM1_TRACK_SET_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x68)
#define  MIS_PWM1_TRACK_FSM_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x6C)
#define  MIS_PWM1_TRACK_PTI_VADDR                  (MIS_PWM_DB0_CTRL_VADDR + 0x70)
#define  MIS_PWM1_FREQ0_VADDR                      (MIS_PWM_DB0_CTRL_VADDR + 0x74)
#define  MIS_PWM1_FREQ1_VADDR                      (MIS_PWM_DB0_CTRL_VADDR + 0x78)
#define  MIS_PWM1_PHASE0_VADDR                     (MIS_PWM_DB0_CTRL_VADDR + 0x7C)
#define  MIS_PWM1_PHASE1_VADDR                     (MIS_PWM_DB0_CTRL_VADDR + 0x80)
#define  MIS_PWM1_HW_PREDICT_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x84)
#define  MIS_PWM1_SW_PREDICT_VADDR                 (MIS_PWM_DB0_CTRL_VADDR + 0x88)
#define  MIS_PWM1_PREDICT_RATIO_VADDR              (MIS_PWM_DB0_CTRL_VADDR + 0x8C)
#define  MIS_PWM2_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0x90)
#define  MIS_PWM2_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0x94)
#define  MIS_PWM2_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0x98)
#define  MIS_PWM3_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0x9C)
#define  MIS_PWM3_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xA0)
#define  MIS_PWM3_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0xA4)
#define  MIS_PWM4_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0xA8)
#define  MIS_PWM4_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xAC)
#define  MIS_PWM4_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0xB0)
#define  MIS_PWM5_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0xB4)
#define  MIS_PWM5_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xB8)
#define  MIS_PWM5_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0xBC)
#define  MIS_PWM6_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0xC0)
#define  MIS_PWM6_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xC4)
#define  MIS_PWM6_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0xC8)
#define  MIS_PWM7_CTRL_VADDR                       (MIS_PWM_DB0_CTRL_VADDR + 0xCC)
#define  MIS_PWM7_TIMING_CTRL_VADDR                (MIS_PWM_DB0_CTRL_VADDR + 0xD0)
#define  MIS_PWM7_DUTY_SET_VADDR                   (MIS_PWM_DB0_CTRL_VADDR + 0xD4)
#define  MIS_PWM_HW_PREDICT_FROM_D_DOMAIN_VADDR    (MIS_PWM_DB0_CTRL_VADDR + 0xD8)
#define  MIS_PWM_OD_MODE_VADDR                     (MIS_PWM_DB0_CTRL_VADDR + 0xDC)
#define  MIS_DUMMY_VADDR                           (MIS_PWM_DB0_CTRL_VADDR + 0xE0)
#define  MIS_PWM_NONE                              (0xbFFFFFFF)

/*
#define N_MAX		(4096)
#define M_MAX		(3)

#define ISO_PWM_MAX	2
#define MISC_PWM_MAX	8

#define MIN_PWM_FREQ		(4)
#define MAX_PWM_FREQ		(105600)
#define CONFIG_CPU_XTAL_FREQ	(27000000)
#define CONFIG_CPU_XTAL_NS		(37)*/


#ifndef LITTLE_ENDIAN		/*apply BIG_ENDIAN */

/*======MISC_PWM register structure define==========*/
//MISC DB Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    global_vsync_en:1;
        unsigned int    pwm7_w_db0_mode:1;
        unsigned int    pwm7_db0_rd_sel:1;
        unsigned int    pwm7_w_db0_en:1;
        unsigned int    reserved_0:1;
        unsigned int    pwm6_w_db0_mode:1;
        unsigned int    pwm6_db0_rd_sel:1;
        unsigned int    pwm6_w_db0_en:1;
        unsigned int    reserved_1:1;
        unsigned int    pwm5_w_db0_mode:1;
        unsigned int    pwm5_db0_rd_sel:1;
        unsigned int    pwm5_w_db0_en:1;
        unsigned int    reserved_2:1;
        unsigned int    pwm4_w_db0_mode:1;
        unsigned int    pwm4_db0_rd_sel:1;
        unsigned int    pwm4_w_db0_en:1;
        unsigned int    reserved_3:1;
        unsigned int    pwm3_w_db0_mode:1;
        unsigned int    pwm3_db0_rd_sel:1;
        unsigned int    pwm3_w_db0_en:1;
        unsigned int    reserved_4:1;
        unsigned int    pwm2_w_db0_mode:1;
        unsigned int    pwm2_db0_rd_sel:1;
        unsigned int    pwm2_w_db0_en:1;
        unsigned int    reserved_5:1;
        unsigned int    pwm1_w_db0_mode:1;
        unsigned int    pwm1_db0_rd_sel:1;
        unsigned int    pwm1_w_db0_en:1;
        unsigned int    reserved_6:1;
        unsigned int    pwm0_w_db0_mode:1;
        unsigned int    pwm0_db0_rd_sel:1;
        unsigned int    pwm0_w_db0_en:1;
    };
    struct{
        unsigned int    i_global_delay_en:1;
        unsigned int    i_pwm_w_db_mode:1;
        unsigned int    i_db_rd_sel:1;
        unsigned int    i_pwm_w_db_en:1;
        unsigned int    i_reserved_1:28;
    };
}pwm_db0_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:16;
        unsigned int    pwm7_db1_rd_sel:1;
        unsigned int    pwm7_w_db1_en:1;
        unsigned int    pwm6_db1_rd_sel:1;
        unsigned int    pwm6_w_db1_en:1;
        unsigned int    pwm5_db1_rd_sel:1;
        unsigned int    pwm5_w_db1_en:1;
        unsigned int    pwm4_db1_rd_sel:1;
        unsigned int    pwm4_w_db1_en:1;
        unsigned int    pwm3_db1_rd_sel:1;
        unsigned int    pwm3_w_db1_en:1;
        unsigned int    pwm2_db1_rd_sel:1;
        unsigned int    pwm2_w_db1_en:1;
        unsigned int    pwm1_db1_rd_sel:1;
        unsigned int    pwm1_w_db1_en:1;
        unsigned int    pwm0_db1_rd_sel:1;
        unsigned int    pwm0_w_db1_en:1;
    };
}pwm_mis_db1_ctrl_RBUS;

//MISC Basic Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0l:1;
        unsigned int    m_reserved_0:1;
        unsigned int    m_pwm0_en:1;
        unsigned int    m_pwm0_vs_rst_en:1;
        unsigned int    m_pwm0_mode:2;
        unsigned int    m_pwm0_mplus_dim_duty_en:1;
        unsigned int    m_pwm0_vs_delay_thr:21;
        unsigned int    m_pwm0_mplus_dim_duty_round_en:1;
        unsigned int    m_pwm0_dvs_mux:1;
        unsigned int    m_pwm0_w_db1_wr:1;
        unsigned int    m_pwm0_w_db0_wr:1;
    };
    struct
    {
        unsigned int    i_pwm0l:1;
        unsigned int    i_reserved_0:1;
        unsigned int    i_pwm0_en:1;
        unsigned int    i_pwm0_vs_rst_en:1;
        unsigned int    i_reserved_1:3;
        unsigned int    i_pwm0_vs_delay_thr:21;
        unsigned int    i_reserved_2:3;
        unsigned int    i_pwm0_w_db_wr:1;
    };
}pwm_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0_duty_ratio:10;
        unsigned int    m_pwm0_vsync_interval_num:8;
        unsigned int    m_pwm0_m:2;
        unsigned int    m_pwm0_n:12;
    };
    struct
    {
        unsigned int    i_reserved_0:1;
        unsigned int    i_reserved_1:1;
        unsigned int    i_pwm0_clk_sel:1;
        unsigned int    i_reserved_2:7;
        unsigned int    i_pwm0_vsync_interval_num:8;
        unsigned int    i_pwm0_m:2;
        unsigned int    i_pwm0_n:12;
    };
}pwm_timing_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0_num:4;
        unsigned int    m_pwm0_dut:12;
        unsigned int    m_pwm0_cycle_max:4;
        unsigned int    m_pwm0_totalcnt:12;
    };
    struct
    {
        unsigned int    i_reserved_0:4;
        unsigned int    i_pwm0_dut:12;
        unsigned int    i_pwm0_cycle_max:4;
        unsigned int    i_pwm0_totalcnt:12;
    };
}pwm_duty_set_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_vs_max_period:16;
        unsigned int    pwm0_vs_min_period:16;
    };
}pwm_mis_dvs_period_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_vs_period:16;
        unsigned int    pwm0_vs_real_time:16;
    };
}pwm_mis_dvs_monitor_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_int:1;
        unsigned int    reserved_0:2;
        unsigned int    pwm0_real_totalcnt:13;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_real_duty:13;
    };
}pwm_mis_monitor_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_predict_max_vs_thr:16;
        unsigned int    pwm0_err2int_en:3;
        unsigned int    reserved_0:7;
        unsigned int    pwm0_predict_err:2;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_vs_unstable:1;
    };
}pwm_mis_err_status_RBUS;

//MISC Tracking Mode Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_track_index:4;
        unsigned int    reserved_0:19;
        unsigned int    pwm0_track_int_en:1;
        unsigned int    reserved_1:2;
        unsigned int    pwm0_track_mode:2;
        unsigned int    pwm0_track_start:1;
        unsigned int    pwm0_track_stop:1;
        unsigned int    reserved_2:1;
        unsigned int    pwm0_track_en:1;
    };
}pwm_mis_track_set_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_phase_finish_to_int_en:1;
        unsigned int    pwm0_freq_finish_to_int_en:1;
        unsigned int    reserved_0:26;
        unsigned int    pwm0_track_phase_finish:1;
        unsigned int    pwm0_track_freq_finish:1;
        unsigned int    pwm0_track_fsm:2;
    };
}pwm_mis_track_fsm_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_pti_phase:16;
        unsigned int    pwm0_pti_period:16;
    };
}pwm_mis_track_pti_RBUS;

//MISC Tracking Mode Register(Frequency)
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:12;
        unsigned int    pwm0_freq_debounce:4;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_freq_max_step:12;
    };
}pwm_mis_freq_0_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:16;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_freq_min_thr:12;
    };
}pwm_mis_freq_1_RBUS;

//MISC Tracking Mode Register(Phase)
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:12;
        unsigned int    pwm0_phase_debounce:4;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_phase_max_step:12;
    };
}pwm_mis_phase_0_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:4;
        unsigned int    pwm0_phase_max_thr:12;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_phase_min_thr:12;
    };
}pwm_mis_phase_1_RBUS;

//MISC Predict Mode Register

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    reserved_0:24;
        unsigned int    pwm0_predict_index:4;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_predict_en:1;
    };
}pwm_mis_hw_predict_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    dummy:16;
        unsigned int    pwm0_sw_nxt_vw_period:16;
    };
}pwm_mis_sw_predict_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_d2p_ratio:32;
    };
}pwm_mis_predict_ratio_RBUS;


//DTG Predict Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int     hw_nxt_vs_period:16;
        unsigned int     reserved_0:14;
        unsigned int     hw_nxt_vs_update:2;
    };
}pwm_hw_predict_from_d_domain_RBUS;

//ISO DB Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int     reserved_0:6;
        unsigned int     pwm0_dut_ratio:10;
        unsigned int     pwm0_offset_value:12;
        unsigned int     pwm0_int:1
        unsigned int     pwm0_ie:1
        unsigned int     pwm0_align_mode:2;
    };
}pwm_iso_align_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int     reserved_0:4;
        unsigned int     pwm0_max_step:12;
        unsigned int     reserved_1:4;
        unsigned int     pwm0_max_thr:12;
    };
}pwm_iso_trackvalue_RBUS;

//CRT:SYS_CLKDIV
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm7_clksel:1;
        unsigned int    pwm6_clksel:1;
        unsigned int    pwm5_clksel:1;
        unsigned int    pwm4_clksel:1;
        unsigned int    pwm3_clksel:1;
        unsigned int    pwm2_clksel:1;
        unsigned int    pwm1_clksel:1;
        unsigned int    pwm0_clksel:1;
        unsigned int    reserved_0:7;
        unsigned int    i2c4_clksel:1;
        unsigned int    i2c3_clksel:1;
        unsigned int    dtv_demod_sel:1;
        unsigned int    i2c2_clksel:1;
        unsigned int    i2c1_clksel:1;
        unsigned int    dtv_demod_hdic_en:1;
        unsigned int    NF_CLKSEL:3;
        unsigned int    pwm_pll_clksel:1;
        unsigned int    AUD_DTV2_FREQ_SEL:3;
        unsigned int    Dummy:1;
        unsigned int    AUD_DTV_FREQ_SEL:3;
    };
}pwm_sys_clkdiv_RBUS;

#else    // apply LITTLE_ENDIAN
//MISC DB Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_w_db0_en:1;
        unsigned int    pwm0_db0_rd_sel:1;
        unsigned int    pwm0_w_db0_mode:1;
        unsigned int    reserved_6:1;
        unsigned int    pwm1_w_db0_en:1;
        unsigned int    pwm1_db0_rd_sel:1;
        unsigned int    pwm1_w_db0_mode:1;
        unsigned int    reserved_5:1;
        unsigned int    pwm2_w_db0_en:1;
        unsigned int    pwm2_db0_rd_sel:1;
        unsigned int    pwm2_w_db0_mode:1;
        unsigned int    reserved_4:1;
        unsigned int    pwm3_w_db0_en:1;
        unsigned int    pwm3_db0_rd_sel:1;
        unsigned int    pwm3_w_db0_mode:1;
        unsigned int    reserved_3:1;
        unsigned int    pwm4_w_db0_en:1;
        unsigned int    pwm4_db0_rd_sel:1;
        unsigned int    pwm4_w_db0_mode:1;
        unsigned int    reserved_2:1;
        unsigned int    pwm5_w_db0_en:1;
        unsigned int    pwm5_db0_rd_sel:1;
        unsigned int    pwm5_w_db0_mode:1;
        unsigned int    reserved_1:1;
        unsigned int    pwm6_w_db0_en:1;
        unsigned int    pwm6_db0_rd_sel:1;
        unsigned int    pwm6_w_db0_mode:1;
        unsigned int    reserved_0:1;
        unsigned int    pwm7_w_db0_en:1;
        unsigned int    pwm7_db0_rd_sel:1;
        unsigned int    pwm7_w_db0_mode:1;
        unsigned int    global_vsync_en:1;
    };
    struct{
        unsigned int    i_reserved_1:28;
        unsigned int    i_pwm_w_db_en:1;
        unsigned int    i_db_rd_sel:1;
        unsigned int    i_pwm_w_db_mode:1;
        unsigned int    i_global_delay_en:1;
    };
}pwm_db0_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_w_db1_en:1;
        unsigned int    pwm0_db1_rd_sel:1;
        unsigned int    pwm1_w_db1_en:1;
        unsigned int    pwm1_db1_rd_sel:1;
        unsigned int    pwm2_w_db1_en:1;
        unsigned int    pwm2_db1_rd_sel:1;
        unsigned int    pwm3_w_db1_en:1;
        unsigned int    pwm3_db1_rd_sel:1;
        unsigned int    pwm4_w_db1_en:1;
        unsigned int    pwm4_db1_rd_sel:1;
        unsigned int    pwm5_w_db1_en:1;
        unsigned int    pwm5_db1_rd_sel:1;
        unsigned int    pwm6_w_db1_en:1;
        unsigned int    pwm6_db1_rd_sel:1;
        unsigned int    pwm7_w_db1_en:1;
        unsigned int    pwm7_db1_rd_sel:1;
        unsigned int    reserved_0:16;
    };
}pwm_mis_db1_ctrl_RBUS;

//MISC Basic Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0_w_db0_wr:1;
        unsigned int    m_pwm0_w_db1_wr:1;
        unsigned int    m_pwm0_dvs_mux:1;
        unsigned int    m_pwm0_mplus_dim_duty_round_en:1;
        unsigned int    m_pwm0_vs_delay_thr:21;
        unsigned int    m_pwm0_mplus_dim_duty_en:1;
        unsigned int    m_pwm0_mode:2;
        unsigned int    m_pwm0_vs_rst_en:1;
        unsigned int    m_pwm0_en:1;
        unsigned int    m_reserved_0:1;
        unsigned int    m_pwm0l:1;
    };
    struct
    {
        unsigned int    i_pwm0_w_db_wr:1;
        unsigned int    i_reserved_0:3;
        unsigned int    i_pwm0_vs_delay_thr:21;
        unsigned int    i_reserved_1:3;
        unsigned int    i_pwm0_vs_rst_en:1;
        unsigned int    i_pwm0_en:1;
        unsigned int    i_reserved_2:1;
        unsigned int    i_pwm0l:1;
    };
}pwm_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0_n:12;
        unsigned int    m_pwm0_m:2;
        unsigned int    m_pwm0_vsync_interval_num:8;
        unsigned int    m_pwm0_duty_ratio:10;
    };
    struct
    {
        unsigned int    i_pwm0_n:12;
        unsigned int    i_pwm0_m:2;
        unsigned int    i_pwm0_vsync_interval_num:8;
        unsigned int    i_reserved_0:7;
        unsigned int    i_pwm0_clk_sel:1;
        unsigned int    i_reserved_1:1;
        unsigned int    i_reserved_2:1;
    };
}pwm_timing_ctrl_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    m_pwm0_totalcnt:12;
        unsigned int    m_pwm0_cycle_max:4;
        unsigned int    m_pwm0_dut:12;
        unsigned int    m_pwm0_num:4;
    };
    struct
    {
        unsigned int    i_pwm0_totalcnt:12;
        unsigned int    i_pwm0_cycle_max:4;
        unsigned int    i_pwm0_dut:12;
        unsigned int    i_reserved_0:4;
    };
}pwm_duty_set_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_vs_min_period:16;
        unsigned int    pwm0_vs_max_period:16;
    };
}pwm_mis_dvs_period_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_vs_real_time:16;
        unsigned int    pwm0_vs_period:16;
    };
}pwm_mis_dvs_monitor_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_real_duty:13;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_real_totalcnt:13;
        unsigned int    reserved_0:2;
        unsigned int    pwm0_int:1;
    };
}pwm_mis_monitor_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_vs_unstable:1;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_predict_err:2;
        unsigned int    reserved_0:7;
        unsigned int    pwm0_err2int_en:3;
        unsigned int    pwm0_predict_max_vs_thr:16;
    };
}pwm_mis_err_status_RBUS;

//MISC Tracking Mode Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_track_en:1;
        unsigned int    reserved_2:1;
        unsigned int    pwm0_track_stop:1;
        unsigned int    pwm0_track_start:1;
        unsigned int    pwm0_track_mode:2;
        unsigned int    reserved_1:2;
        unsigned int    pwm0_track_int_en:1;
        unsigned int    reserved_0:19;
        unsigned int    pwm0_track_index:4;
    };
}pwm_mis_track_set_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_track_fsm:2;
        unsigned int    pwm0_track_freq_finish:1;
        unsigned int    pwm0_track_phase_finish:1;
        unsigned int    reserved_0:26;
        unsigned int    pwm0_freq_finish_to_int_en:1;
        unsigned int    pwm0_phase_finish_to_int_en:1;
    };
}pwm_mis_track_fsm_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_pti_period:16;
        unsigned int    pwm0_pti_phase:16;
    };
}pwm_mis_track_pti_RBUS;

//MISC Tracking Mode Register(Frequency)
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_freq_max_step:12;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_freq_debounce:4;
        unsigned int    reserved_0:12;
    };
}pwm_mis_freq_0_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_freq_min_thr:12;
        unsigned int    reserved_1:4;
        unsigned int    reserved_0:16;
    };
}pwm_mis_freq_1_RBUS;

//MISC Tracking Mode Register(Phase)
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_phase_max_step:12;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_phase_debounce:4;
        unsigned int    reserved_0:12;
    };
}pwm_mis_phase_0_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_phase_min_thr:12;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_phase_max_thr:12;
        unsigned int    reserved_0:4;
    };
}pwm_mis_phase_1_RBUS;

//MISC Predict Mode Register

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_predict_en:1;
        unsigned int    reserved_1:3;
        unsigned int    pwm0_predict_index:4;
        unsigned int    reserved_0:24;
    };
}pwm_mis_hw_predict_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_sw_nxt_vw_period:16;
        unsigned int    dummy:16;
    };
}pwm_mis_sw_predict_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_d2p_ratio:32;
    };
}pwm_mis_predict_ratio_RBUS;

//DTG Predict Register
typedef union
{
	unsigned int    regValue;
	struct
	{
	  unsigned int     hw_nxt_vs_update:2;
	  unsigned int     reserved_0:14;
	  unsigned int     hw_nxt_vs_period:16;
	};
}pwm_hw_predict_from_d_domain_RBUS;

//ISO DB Function Register
typedef union
{
    unsigned int    regValue;
    struct{
        unsigned int  reserved_2:26;
        unsigned int  reserved_1:1;
        unsigned int  global_delay_en:1;
        unsigned int  pwm_w_db_mode:1;
        unsigned int  reserved_0:1;
        unsigned int  db_rd_sel:1;
        unsigned int  pwm_w_db_en:1;
    };
}pwm_iso_db_ctrl_RBUS;

//MISC Basic Function Register
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_align_mode:2;
        unsigned int    pwm0_ie:1;
        unsigned int    pwm0_int:1;
        unsigned int    pwm0_offset_value:12;  
        unsigned int    pwm0_dut_ratio:10;
        unsigned int    reserved_0:6;
    };
}pwm_iso_align_RBUS;

typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    pwm0_max_thr:12;
        unsigned int    reserved_1:4;
        unsigned int    pwm0_max_step:12;
        unsigned int    reserved_0:4;
    };
}pwm_iso_trackvalue_RBUS;

//CRT:SYS_CLKDIV
typedef union
{
    unsigned int    regValue;
    struct
    {
        unsigned int    AUD_DTV_FREQ_SEL:3;
        unsigned int    Dummy:1;
        unsigned int    AUD_DTV2_FREQ_SEL:3;
        unsigned int    pwm_pll_clksel:1;
        unsigned int    NF_CLKSEL:3;
        unsigned int    dtv_demod_hdic_en:1;
        unsigned int    i2c1_clksel:1;
        unsigned int    i2c2_clksel:1;
        unsigned int    dtv_demod_sel:1;
        unsigned int    i2c3_clksel:1;
        unsigned int    i2c4_clksel:1;
        unsigned int    reserved_0:7;
        unsigned int    pwm0_clksel:1;
        unsigned int    pwm1_clksel:1;
        unsigned int    pwm2_clksel:1;
        unsigned int    pwm3_clksel:1;
        unsigned int    pwm4_clksel:1;
        unsigned int    pwm5_clksel:1;
        unsigned int    pwm6_clksel:1;
        unsigned int    pwm7_clksel:1;
    };
}pwm_sys_clkdiv_RBUS;
#endif

#ifdef __cplusplus
}
#endif
#endif
