/**
* @file Merlin4-DesignSpec-WOV
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_WOV_REG_H_
#define _RBUS_WOV_REG_H_

#include "rbus_types.h"



//  WOV Register Address
#define  WOV_stby_tcon_1                                                        0x18060600
#define  WOV_stby_tcon_1_reg_addr                                                "0xB8060600"
#define  WOV_stby_tcon_1_reg                                                     0xB8060600
#define  WOV_stby_tcon_1_inst_addr                                               "0x0000"
#define  set_WOV_stby_tcon_1_reg(data)                                           (*((volatile unsigned int*)WOV_stby_tcon_1_reg)=data)
#define  get_WOV_stby_tcon_1_reg                                                 (*((volatile unsigned int*)WOV_stby_tcon_1_reg))
#define  WOV_stby_tcon_1_adc_0_en_shift                                          (31)
#define  WOV_stby_tcon_1_adc_1_en_shift                                          (30)
#define  WOV_stby_tcon_1_adc_0_sample_rate_shift                                 (26)
#define  WOV_stby_tcon_1_adc_1_sample_rate_shift                                 (22)
#define  WOV_stby_tcon_1_dmic_0_clk_sel_shift                                    (18)
#define  WOV_stby_tcon_1_dmic_0_en_shift                                         (17)
#define  WOV_stby_tcon_1_gen_src_16k128_en_shift                                 (16)
#define  WOV_stby_tcon_1_gen_src_32k128_en_shift                                 (15)
#define  WOV_stby_tcon_1_gen_src_48k128_en_shift                                 (14)
#define  WOV_stby_tcon_1_vad_en_shift                                            (13)
#define  WOV_stby_tcon_1_adc_0_en_mask                                           (0x80000000)
#define  WOV_stby_tcon_1_adc_1_en_mask                                           (0x40000000)
#define  WOV_stby_tcon_1_adc_0_sample_rate_mask                                  (0x3C000000)
#define  WOV_stby_tcon_1_adc_1_sample_rate_mask                                  (0x03C00000)
#define  WOV_stby_tcon_1_dmic_0_clk_sel_mask                                     (0x003C0000)
#define  WOV_stby_tcon_1_dmic_0_en_mask                                          (0x00020000)
#define  WOV_stby_tcon_1_gen_src_16k128_en_mask                                  (0x00010000)
#define  WOV_stby_tcon_1_gen_src_32k128_en_mask                                  (0x00008000)
#define  WOV_stby_tcon_1_gen_src_48k128_en_mask                                  (0x00004000)
#define  WOV_stby_tcon_1_vad_en_mask                                             (0x00002000)
#define  WOV_stby_tcon_1_adc_0_en(data)                                          (0x80000000&((data)<<31))
#define  WOV_stby_tcon_1_adc_1_en(data)                                          (0x40000000&((data)<<30))
#define  WOV_stby_tcon_1_adc_0_sample_rate(data)                                 (0x3C000000&((data)<<26))
#define  WOV_stby_tcon_1_adc_1_sample_rate(data)                                 (0x03C00000&((data)<<22))
#define  WOV_stby_tcon_1_dmic_0_clk_sel(data)                                    (0x003C0000&((data)<<18))
#define  WOV_stby_tcon_1_dmic_0_en(data)                                         (0x00020000&((data)<<17))
#define  WOV_stby_tcon_1_gen_src_16k128_en(data)                                 (0x00010000&((data)<<16))
#define  WOV_stby_tcon_1_gen_src_32k128_en(data)                                 (0x00008000&((data)<<15))
#define  WOV_stby_tcon_1_gen_src_48k128_en(data)                                 (0x00004000&((data)<<14))
#define  WOV_stby_tcon_1_vad_en(data)                                            (0x00002000&((data)<<13))
#define  WOV_stby_tcon_1_get_adc_0_en(data)                                      ((0x80000000&(data))>>31)
#define  WOV_stby_tcon_1_get_adc_1_en(data)                                      ((0x40000000&(data))>>30)
#define  WOV_stby_tcon_1_get_adc_0_sample_rate(data)                             ((0x3C000000&(data))>>26)
#define  WOV_stby_tcon_1_get_adc_1_sample_rate(data)                             ((0x03C00000&(data))>>22)
#define  WOV_stby_tcon_1_get_dmic_0_clk_sel(data)                                ((0x003C0000&(data))>>18)
#define  WOV_stby_tcon_1_get_dmic_0_en(data)                                     ((0x00020000&(data))>>17)
#define  WOV_stby_tcon_1_get_gen_src_16k128_en(data)                             ((0x00010000&(data))>>16)
#define  WOV_stby_tcon_1_get_gen_src_32k128_en(data)                             ((0x00008000&(data))>>15)
#define  WOV_stby_tcon_1_get_gen_src_48k128_en(data)                             ((0x00004000&(data))>>14)
#define  WOV_stby_tcon_1_get_vad_en(data)                                        ((0x00002000&(data))>>13)

#define  WOV_stby_ad0_1                                                         0x18060604
#define  WOV_stby_ad0_1_reg_addr                                                 "0xB8060604"
#define  WOV_stby_ad0_1_reg                                                      0xB8060604
#define  WOV_stby_ad0_1_inst_addr                                                "0x0001"
#define  set_WOV_stby_ad0_1_reg(data)                                            (*((volatile unsigned int*)WOV_stby_ad0_1_reg)=data)
#define  get_WOV_stby_ad0_1_reg                                                  (*((volatile unsigned int*)WOV_stby_ad0_1_reg))
#define  WOV_stby_ad0_1_adc0_ad_gain_l_shift                                     (8)
#define  WOV_stby_ad0_1_adc0_ad_gain_r_shift                                     (0)
#define  WOV_stby_ad0_1_adc0_ad_gain_l_mask                                      (0x00007F00)
#define  WOV_stby_ad0_1_adc0_ad_gain_r_mask                                      (0x0000007F)
#define  WOV_stby_ad0_1_adc0_ad_gain_l(data)                                     (0x00007F00&((data)<<8))
#define  WOV_stby_ad0_1_adc0_ad_gain_r(data)                                     (0x0000007F&(data))
#define  WOV_stby_ad0_1_get_adc0_ad_gain_l(data)                                 ((0x00007F00&(data))>>8)
#define  WOV_stby_ad0_1_get_adc0_ad_gain_r(data)                                 (0x0000007F&(data))

#define  WOV_stby_ad0_2                                                         0x18060608
#define  WOV_stby_ad0_2_reg_addr                                                 "0xB8060608"
#define  WOV_stby_ad0_2_reg                                                      0xB8060608
#define  WOV_stby_ad0_2_inst_addr                                                "0x0002"
#define  set_WOV_stby_ad0_2_reg(data)                                            (*((volatile unsigned int*)WOV_stby_ad0_2_reg)=data)
#define  get_WOV_stby_ad0_2_reg                                                  (*((volatile unsigned int*)WOV_stby_ad0_2_reg))
#define  WOV_stby_ad0_2_adc0_dmicl_ri_fa_sel_shift                               (31)
#define  WOV_stby_ad0_2_adc0_dmicr_ri_fa_sel_shift                               (30)
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_fc_sel_shift                            (28)
#define  WOV_stby_ad0_2_adc0_dmic_lpf2nd_fc_sel_shift                            (27)
#define  WOV_stby_ad0_2_adc0_ad_hpf_en_shift                                     (26)
#define  WOV_stby_ad0_2_adc0_ad_comp_gain_shift                                  (24)
#define  WOV_stby_ad0_2_adc0_ad_mute_l_shift                                     (23)
#define  WOV_stby_ad0_2_adc0_ad_mute_r_shift                                     (22)
#define  WOV_stby_ad0_2_adc0_ad_zdet_tout_shift                                  (20)
#define  WOV_stby_ad0_2_adc0_ad_zdet_func_shift                                  (18)
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_l_shift                             (16)
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_r_shift                             (14)
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_en_shift                                (13)
#define  WOV_stby_ad0_2_adc0_dmicl_ri_fa_sel_mask                                (0x80000000)
#define  WOV_stby_ad0_2_adc0_dmicr_ri_fa_sel_mask                                (0x40000000)
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_fc_sel_mask                             (0x30000000)
#define  WOV_stby_ad0_2_adc0_dmic_lpf2nd_fc_sel_mask                             (0x08000000)
#define  WOV_stby_ad0_2_adc0_ad_hpf_en_mask                                      (0x04000000)
#define  WOV_stby_ad0_2_adc0_ad_comp_gain_mask                                   (0x03000000)
#define  WOV_stby_ad0_2_adc0_ad_mute_l_mask                                      (0x00800000)
#define  WOV_stby_ad0_2_adc0_ad_mute_r_mask                                      (0x00400000)
#define  WOV_stby_ad0_2_adc0_ad_zdet_tout_mask                                   (0x00300000)
#define  WOV_stby_ad0_2_adc0_ad_zdet_func_mask                                   (0x000C0000)
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_l_mask                              (0x00030000)
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_r_mask                              (0x0000C000)
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_en_mask                                 (0x00002000)
#define  WOV_stby_ad0_2_adc0_dmicl_ri_fa_sel(data)                               (0x80000000&((data)<<31))
#define  WOV_stby_ad0_2_adc0_dmicr_ri_fa_sel(data)                               (0x40000000&((data)<<30))
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_fc_sel(data)                            (0x30000000&((data)<<28))
#define  WOV_stby_ad0_2_adc0_dmic_lpf2nd_fc_sel(data)                            (0x08000000&((data)<<27))
#define  WOV_stby_ad0_2_adc0_ad_hpf_en(data)                                     (0x04000000&((data)<<26))
#define  WOV_stby_ad0_2_adc0_ad_comp_gain(data)                                  (0x03000000&((data)<<24))
#define  WOV_stby_ad0_2_adc0_ad_mute_l(data)                                     (0x00800000&((data)<<23))
#define  WOV_stby_ad0_2_adc0_ad_mute_r(data)                                     (0x00400000&((data)<<22))
#define  WOV_stby_ad0_2_adc0_ad_zdet_tout(data)                                  (0x00300000&((data)<<20))
#define  WOV_stby_ad0_2_adc0_ad_zdet_func(data)                                  (0x000C0000&((data)<<18))
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_l(data)                             (0x00030000&((data)<<16))
#define  WOV_stby_ad0_2_adc0_dmic_boost_gain_r(data)                             (0x0000C000&((data)<<14))
#define  WOV_stby_ad0_2_adc0_dmic_lpf1st_en(data)                                (0x00002000&((data)<<13))
#define  WOV_stby_ad0_2_get_adc0_dmicl_ri_fa_sel(data)                           ((0x80000000&(data))>>31)
#define  WOV_stby_ad0_2_get_adc0_dmicr_ri_fa_sel(data)                           ((0x40000000&(data))>>30)
#define  WOV_stby_ad0_2_get_adc0_dmic_lpf1st_fc_sel(data)                        ((0x30000000&(data))>>28)
#define  WOV_stby_ad0_2_get_adc0_dmic_lpf2nd_fc_sel(data)                        ((0x08000000&(data))>>27)
#define  WOV_stby_ad0_2_get_adc0_ad_hpf_en(data)                                 ((0x04000000&(data))>>26)
#define  WOV_stby_ad0_2_get_adc0_ad_comp_gain(data)                              ((0x03000000&(data))>>24)
#define  WOV_stby_ad0_2_get_adc0_ad_mute_l(data)                                 ((0x00800000&(data))>>23)
#define  WOV_stby_ad0_2_get_adc0_ad_mute_r(data)                                 ((0x00400000&(data))>>22)
#define  WOV_stby_ad0_2_get_adc0_ad_zdet_tout(data)                              ((0x00300000&(data))>>20)
#define  WOV_stby_ad0_2_get_adc0_ad_zdet_func(data)                              ((0x000C0000&(data))>>18)
#define  WOV_stby_ad0_2_get_adc0_dmic_boost_gain_l(data)                         ((0x00030000&(data))>>16)
#define  WOV_stby_ad0_2_get_adc0_dmic_boost_gain_r(data)                         ((0x0000C000&(data))>>14)
#define  WOV_stby_ad0_2_get_adc0_dmic_lpf1st_en(data)                            ((0x00002000&(data))>>13)

#define  WOV_stby_ad1_1                                                         0x1806060C
#define  WOV_stby_ad1_1_reg_addr                                                 "0xB806060C"
#define  WOV_stby_ad1_1_reg                                                      0xB806060C
#define  WOV_stby_ad1_1_inst_addr                                                "0x0003"
#define  set_WOV_stby_ad1_1_reg(data)                                            (*((volatile unsigned int*)WOV_stby_ad1_1_reg)=data)
#define  get_WOV_stby_ad1_1_reg                                                  (*((volatile unsigned int*)WOV_stby_ad1_1_reg))
#define  WOV_stby_ad1_1_adc1_ad_gain_l_shift                                     (8)
#define  WOV_stby_ad1_1_adc1_ad_gain_r_shift                                     (0)
#define  WOV_stby_ad1_1_adc1_ad_gain_l_mask                                      (0x00007F00)
#define  WOV_stby_ad1_1_adc1_ad_gain_r_mask                                      (0x0000007F)
#define  WOV_stby_ad1_1_adc1_ad_gain_l(data)                                     (0x00007F00&((data)<<8))
#define  WOV_stby_ad1_1_adc1_ad_gain_r(data)                                     (0x0000007F&(data))
#define  WOV_stby_ad1_1_get_adc1_ad_gain_l(data)                                 ((0x00007F00&(data))>>8)
#define  WOV_stby_ad1_1_get_adc1_ad_gain_r(data)                                 (0x0000007F&(data))

#define  WOV_stby_ad1_2                                                         0x18060610
#define  WOV_stby_ad1_2_reg_addr                                                 "0xB8060610"
#define  WOV_stby_ad1_2_reg                                                      0xB8060610
#define  WOV_stby_ad1_2_inst_addr                                                "0x0004"
#define  set_WOV_stby_ad1_2_reg(data)                                            (*((volatile unsigned int*)WOV_stby_ad1_2_reg)=data)
#define  get_WOV_stby_ad1_2_reg                                                  (*((volatile unsigned int*)WOV_stby_ad1_2_reg))
#define  WOV_stby_ad1_2_adc1_dmicl_ri_fa_sel_shift                               (31)
#define  WOV_stby_ad1_2_adc1_dmicr_ri_fa_sel_shift                               (30)
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_fc_sel_shift                            (28)
#define  WOV_stby_ad1_2_adc1_dmic_lpf2nd_fc_sel_shift                            (27)
#define  WOV_stby_ad1_2_adc1_ad_hpf_en_shift                                     (26)
#define  WOV_stby_ad1_2_adc1_ad_comp_gain_shift                                  (24)
#define  WOV_stby_ad1_2_adc1_ad_mute_l_shift                                     (23)
#define  WOV_stby_ad1_2_adc1_ad_mute_r_shift                                     (22)
#define  WOV_stby_ad1_2_adc1_ad_zdet_tout_shift                                  (20)
#define  WOV_stby_ad1_2_adc1_ad_zdet_func_shift                                  (18)
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_l_shift                             (16)
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_r_shift                             (14)
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_en_shift                                (13)
#define  WOV_stby_ad1_2_adc1_dmicl_ri_fa_sel_mask                                (0x80000000)
#define  WOV_stby_ad1_2_adc1_dmicr_ri_fa_sel_mask                                (0x40000000)
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_fc_sel_mask                             (0x30000000)
#define  WOV_stby_ad1_2_adc1_dmic_lpf2nd_fc_sel_mask                             (0x08000000)
#define  WOV_stby_ad1_2_adc1_ad_hpf_en_mask                                      (0x04000000)
#define  WOV_stby_ad1_2_adc1_ad_comp_gain_mask                                   (0x03000000)
#define  WOV_stby_ad1_2_adc1_ad_mute_l_mask                                      (0x00800000)
#define  WOV_stby_ad1_2_adc1_ad_mute_r_mask                                      (0x00400000)
#define  WOV_stby_ad1_2_adc1_ad_zdet_tout_mask                                   (0x00300000)
#define  WOV_stby_ad1_2_adc1_ad_zdet_func_mask                                   (0x000C0000)
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_l_mask                              (0x00030000)
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_r_mask                              (0x0000C000)
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_en_mask                                 (0x00002000)
#define  WOV_stby_ad1_2_adc1_dmicl_ri_fa_sel(data)                               (0x80000000&((data)<<31))
#define  WOV_stby_ad1_2_adc1_dmicr_ri_fa_sel(data)                               (0x40000000&((data)<<30))
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_fc_sel(data)                            (0x30000000&((data)<<28))
#define  WOV_stby_ad1_2_adc1_dmic_lpf2nd_fc_sel(data)                            (0x08000000&((data)<<27))
#define  WOV_stby_ad1_2_adc1_ad_hpf_en(data)                                     (0x04000000&((data)<<26))
#define  WOV_stby_ad1_2_adc1_ad_comp_gain(data)                                  (0x03000000&((data)<<24))
#define  WOV_stby_ad1_2_adc1_ad_mute_l(data)                                     (0x00800000&((data)<<23))
#define  WOV_stby_ad1_2_adc1_ad_mute_r(data)                                     (0x00400000&((data)<<22))
#define  WOV_stby_ad1_2_adc1_ad_zdet_tout(data)                                  (0x00300000&((data)<<20))
#define  WOV_stby_ad1_2_adc1_ad_zdet_func(data)                                  (0x000C0000&((data)<<18))
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_l(data)                             (0x00030000&((data)<<16))
#define  WOV_stby_ad1_2_adc1_dmic_boost_gain_r(data)                             (0x0000C000&((data)<<14))
#define  WOV_stby_ad1_2_adc1_dmic_lpf1st_en(data)                                (0x00002000&((data)<<13))
#define  WOV_stby_ad1_2_get_adc1_dmicl_ri_fa_sel(data)                           ((0x80000000&(data))>>31)
#define  WOV_stby_ad1_2_get_adc1_dmicr_ri_fa_sel(data)                           ((0x40000000&(data))>>30)
#define  WOV_stby_ad1_2_get_adc1_dmic_lpf1st_fc_sel(data)                        ((0x30000000&(data))>>28)
#define  WOV_stby_ad1_2_get_adc1_dmic_lpf2nd_fc_sel(data)                        ((0x08000000&(data))>>27)
#define  WOV_stby_ad1_2_get_adc1_ad_hpf_en(data)                                 ((0x04000000&(data))>>26)
#define  WOV_stby_ad1_2_get_adc1_ad_comp_gain(data)                              ((0x03000000&(data))>>24)
#define  WOV_stby_ad1_2_get_adc1_ad_mute_l(data)                                 ((0x00800000&(data))>>23)
#define  WOV_stby_ad1_2_get_adc1_ad_mute_r(data)                                 ((0x00400000&(data))>>22)
#define  WOV_stby_ad1_2_get_adc1_ad_zdet_tout(data)                              ((0x00300000&(data))>>20)
#define  WOV_stby_ad1_2_get_adc1_ad_zdet_func(data)                              ((0x000C0000&(data))>>18)
#define  WOV_stby_ad1_2_get_adc1_dmic_boost_gain_l(data)                         ((0x00030000&(data))>>16)
#define  WOV_stby_ad1_2_get_adc1_dmic_boost_gain_r(data)                         ((0x0000C000&(data))>>14)
#define  WOV_stby_ad1_2_get_adc1_dmic_lpf1st_en(data)                            ((0x00002000&(data))>>13)

#define  WOV_stby_vad_1                                                         0x18060614
#define  WOV_stby_vad_1_reg_addr                                                 "0xB8060614"
#define  WOV_stby_vad_1_reg                                                      0xB8060614
#define  WOV_stby_vad_1_inst_addr                                                "0x0005"
#define  set_WOV_stby_vad_1_reg(data)                                            (*((volatile unsigned int*)WOV_stby_vad_1_reg)=data)
#define  get_WOV_stby_vad_1_reg                                                  (*((volatile unsigned int*)WOV_stby_vad_1_reg))
#define  WOV_stby_vad_1_vad_bypass_square_shift                                  (31)
#define  WOV_stby_vad_1_vad_en_lt_fine_coef_shift                                (30)
#define  WOV_stby_vad_1_vad_en_st_fine_coef_shift                                (29)
#define  WOV_stby_vad_1_vad_initial_thr_shift                                    (23)
#define  WOV_stby_vad_1_vad_lt_coef_fast_shift                                   (20)
#define  WOV_stby_vad_1_vad_lt_coef_slow_shift                                   (17)
#define  WOV_stby_vad_1_vad_st_chk_start_thr_shift                               (11)
#define  WOV_stby_vad_1_vad_st_coef_shift                                        (8)
#define  WOV_stby_vad_1_vad_st_high_keep_chk_thr_shift                           (0)
#define  WOV_stby_vad_1_vad_bypass_square_mask                                   (0x80000000)
#define  WOV_stby_vad_1_vad_en_lt_fine_coef_mask                                 (0x40000000)
#define  WOV_stby_vad_1_vad_en_st_fine_coef_mask                                 (0x20000000)
#define  WOV_stby_vad_1_vad_initial_thr_mask                                     (0x1F800000)
#define  WOV_stby_vad_1_vad_lt_coef_fast_mask                                    (0x00700000)
#define  WOV_stby_vad_1_vad_lt_coef_slow_mask                                    (0x000E0000)
#define  WOV_stby_vad_1_vad_st_chk_start_thr_mask                                (0x0001F800)
#define  WOV_stby_vad_1_vad_st_coef_mask                                         (0x00000700)
#define  WOV_stby_vad_1_vad_st_high_keep_chk_thr_mask                            (0x000000FF)
#define  WOV_stby_vad_1_vad_bypass_square(data)                                  (0x80000000&((data)<<31))
#define  WOV_stby_vad_1_vad_en_lt_fine_coef(data)                                (0x40000000&((data)<<30))
#define  WOV_stby_vad_1_vad_en_st_fine_coef(data)                                (0x20000000&((data)<<29))
#define  WOV_stby_vad_1_vad_initial_thr(data)                                    (0x1F800000&((data)<<23))
#define  WOV_stby_vad_1_vad_lt_coef_fast(data)                                   (0x00700000&((data)<<20))
#define  WOV_stby_vad_1_vad_lt_coef_slow(data)                                   (0x000E0000&((data)<<17))
#define  WOV_stby_vad_1_vad_st_chk_start_thr(data)                               (0x0001F800&((data)<<11))
#define  WOV_stby_vad_1_vad_st_coef(data)                                        (0x00000700&((data)<<8))
#define  WOV_stby_vad_1_vad_st_high_keep_chk_thr(data)                           (0x000000FF&(data))
#define  WOV_stby_vad_1_get_vad_bypass_square(data)                              ((0x80000000&(data))>>31)
#define  WOV_stby_vad_1_get_vad_en_lt_fine_coef(data)                            ((0x40000000&(data))>>30)
#define  WOV_stby_vad_1_get_vad_en_st_fine_coef(data)                            ((0x20000000&(data))>>29)
#define  WOV_stby_vad_1_get_vad_initial_thr(data)                                ((0x1F800000&(data))>>23)
#define  WOV_stby_vad_1_get_vad_lt_coef_fast(data)                               ((0x00700000&(data))>>20)
#define  WOV_stby_vad_1_get_vad_lt_coef_slow(data)                               ((0x000E0000&(data))>>17)
#define  WOV_stby_vad_1_get_vad_st_chk_start_thr(data)                           ((0x0001F800&(data))>>11)
#define  WOV_stby_vad_1_get_vad_st_coef(data)                                    ((0x00000700&(data))>>8)
#define  WOV_stby_vad_1_get_vad_st_high_keep_chk_thr(data)                       (0x000000FF&(data))

#define  WOV_stby_vad_2                                                         0x18060618
#define  WOV_stby_vad_2_reg_addr                                                 "0xB8060618"
#define  WOV_stby_vad_2_reg                                                      0xB8060618
#define  WOV_stby_vad_2_inst_addr                                                "0x0006"
#define  set_WOV_stby_vad_2_reg(data)                                            (*((volatile unsigned int*)WOV_stby_vad_2_reg)=data)
#define  get_WOV_stby_vad_2_reg                                                  (*((volatile unsigned int*)WOV_stby_vad_2_reg))
#define  WOV_stby_vad_2_vad_st_energy_low_chk_thr_shift                          (26)
#define  WOV_stby_vad_2_vad_st_energy_thr_shift                                  (20)
#define  WOV_stby_vad_2_vad_st_fall_thr_shift                                    (14)
#define  WOV_stby_vad_2_vad_time_debounce_thr_shift                              (4)
#define  WOV_stby_vad_2_vad_syllable_thr_shift                                   (0)
#define  WOV_stby_vad_2_vad_st_energy_low_chk_thr_mask                           (0xFC000000)
#define  WOV_stby_vad_2_vad_st_energy_thr_mask                                   (0x03F00000)
#define  WOV_stby_vad_2_vad_st_fall_thr_mask                                     (0x000FC000)
#define  WOV_stby_vad_2_vad_time_debounce_thr_mask                               (0x00003FF0)
#define  WOV_stby_vad_2_vad_syllable_thr_mask                                    (0x0000000F)
#define  WOV_stby_vad_2_vad_st_energy_low_chk_thr(data)                          (0xFC000000&((data)<<26))
#define  WOV_stby_vad_2_vad_st_energy_thr(data)                                  (0x03F00000&((data)<<20))
#define  WOV_stby_vad_2_vad_st_fall_thr(data)                                    (0x000FC000&((data)<<14))
#define  WOV_stby_vad_2_vad_time_debounce_thr(data)                              (0x00003FF0&((data)<<4))
#define  WOV_stby_vad_2_vad_syllable_thr(data)                                   (0x0000000F&(data))
#define  WOV_stby_vad_2_get_vad_st_energy_low_chk_thr(data)                      ((0xFC000000&(data))>>26)
#define  WOV_stby_vad_2_get_vad_st_energy_thr(data)                              ((0x03F00000&(data))>>20)
#define  WOV_stby_vad_2_get_vad_st_fall_thr(data)                                ((0x000FC000&(data))>>14)
#define  WOV_stby_vad_2_get_vad_time_debounce_thr(data)                          ((0x00003FF0&(data))>>4)
#define  WOV_stby_vad_2_get_vad_syllable_thr(data)                               (0x0000000F&(data))

#define  WOV_stby_vad_3                                                         0x1806061C
#define  WOV_stby_vad_3_reg_addr                                                 "0xB806061C"
#define  WOV_stby_vad_3_reg                                                      0xB806061C
#define  WOV_stby_vad_3_inst_addr                                                "0x0007"
#define  set_WOV_stby_vad_3_reg(data)                                            (*((volatile unsigned int*)WOV_stby_vad_3_reg)=data)
#define  get_WOV_stby_vad_3_reg                                                  (*((volatile unsigned int*)WOV_stby_vad_3_reg))
#define  WOV_stby_vad_3_vad_st_stable_thr_shift                                  (24)
#define  WOV_stby_vad_3_vad_st_valid_thr_shift                                   (8)
#define  WOV_stby_vad_3_vad_syllable_wait_thr_shift                              (0)
#define  WOV_stby_vad_3_vad_st_stable_thr_mask                                   (0xFF000000)
#define  WOV_stby_vad_3_vad_st_valid_thr_mask                                    (0x00FFFF00)
#define  WOV_stby_vad_3_vad_syllable_wait_thr_mask                               (0x000000FF)
#define  WOV_stby_vad_3_vad_st_stable_thr(data)                                  (0xFF000000&((data)<<24))
#define  WOV_stby_vad_3_vad_st_valid_thr(data)                                   (0x00FFFF00&((data)<<8))
#define  WOV_stby_vad_3_vad_syllable_wait_thr(data)                              (0x000000FF&(data))
#define  WOV_stby_vad_3_get_vad_st_stable_thr(data)                              ((0xFF000000&(data))>>24)
#define  WOV_stby_vad_3_get_vad_st_valid_thr(data)                               ((0x00FFFF00&(data))>>8)
#define  WOV_stby_vad_3_get_vad_syllable_wait_thr(data)                          (0x000000FF&(data))

#define  WOV_stby_vad_4                                                         0x18060620
#define  WOV_stby_vad_4_reg_addr                                                 "0xB8060620"
#define  WOV_stby_vad_4_reg                                                      0xB8060620
#define  WOV_stby_vad_4_inst_addr                                                "0x0008"
#define  set_WOV_stby_vad_4_reg(data)                                            (*((volatile unsigned int*)WOV_stby_vad_4_reg)=data)
#define  get_WOV_stby_vad_4_reg                                                  (*((volatile unsigned int*)WOV_stby_vad_4_reg))
#define  WOV_stby_vad_4_vad_flag_sel_out_shift                                   (21)
#define  WOV_stby_vad_4_vad_initial_flag_shift                                   (19)
#define  WOV_stby_vad_4_vad_st_start_ref_thr_shift                               (11)
#define  WOV_stby_vad_4_vad_noise_pulse_thr_shift                                (7)
#define  WOV_stby_vad_4_vad_flag_clr_shift                                       (6)
#define  WOV_stby_vad_4_vad_flag_sel_shift                                       (5)
#define  WOV_stby_vad_4_vad_in_sel_shift                                         (2)
#define  WOV_stby_vad_4_vad_flag_shift                                           (1)
#define  WOV_stby_vad_4_vad_flag_hold_shift                                      (0)
#define  WOV_stby_vad_4_vad_flag_sel_out_mask                                    (0x00200000)
#define  WOV_stby_vad_4_vad_initial_flag_mask                                    (0x00080000)
#define  WOV_stby_vad_4_vad_st_start_ref_thr_mask                                (0x0003F800)
#define  WOV_stby_vad_4_vad_noise_pulse_thr_mask                                 (0x00000780)
#define  WOV_stby_vad_4_vad_flag_clr_mask                                        (0x00000040)
#define  WOV_stby_vad_4_vad_flag_sel_mask                                        (0x00000020)
#define  WOV_stby_vad_4_vad_in_sel_mask                                          (0x0000001C)
#define  WOV_stby_vad_4_vad_flag_mask                                            (0x00000002)
#define  WOV_stby_vad_4_vad_flag_hold_mask                                       (0x00000001)
#define  WOV_stby_vad_4_vad_flag_sel_out(data)                                   (0x00200000&((data)<<21))
#define  WOV_stby_vad_4_vad_initial_flag(data)                                   (0x00080000&((data)<<19))
#define  WOV_stby_vad_4_vad_st_start_ref_thr(data)                               (0x0003F800&((data)<<11))
#define  WOV_stby_vad_4_vad_noise_pulse_thr(data)                                (0x00000780&((data)<<7))
#define  WOV_stby_vad_4_vad_flag_clr(data)                                       (0x00000040&((data)<<6))
#define  WOV_stby_vad_4_vad_flag_sel(data)                                       (0x00000020&((data)<<5))
#define  WOV_stby_vad_4_vad_in_sel(data)                                         (0x0000001C&((data)<<2))
#define  WOV_stby_vad_4_vad_flag(data)                                           (0x00000002&((data)<<1))
#define  WOV_stby_vad_4_vad_flag_hold(data)                                      (0x00000001&(data))
#define  WOV_stby_vad_4_get_vad_flag_sel_out(data)                               ((0x00200000&(data))>>21)
#define  WOV_stby_vad_4_get_vad_initial_flag(data)                               ((0x00080000&(data))>>19)
#define  WOV_stby_vad_4_get_vad_st_start_ref_thr(data)                           ((0x0003F800&(data))>>11)
#define  WOV_stby_vad_4_get_vad_noise_pulse_thr(data)                            ((0x00000780&(data))>>7)
#define  WOV_stby_vad_4_get_vad_flag_clr(data)                                   ((0x00000040&(data))>>6)
#define  WOV_stby_vad_4_get_vad_flag_sel(data)                                   ((0x00000020&(data))>>5)
#define  WOV_stby_vad_4_get_vad_in_sel(data)                                     ((0x0000001C&(data))>>2)
#define  WOV_stby_vad_4_get_vad_flag(data)                                       ((0x00000002&(data))>>1)
#define  WOV_stby_vad_4_get_vad_flag_hold(data)                                  (0x00000001&(data))

#define  WOV_stby_vad_5                                                         0x18060624
#define  WOV_stby_vad_5_reg_addr                                                 "0xB8060624"
#define  WOV_stby_vad_5_reg                                                      0xB8060624
#define  WOV_stby_vad_5_inst_addr                                                "0x0009"
#define  set_WOV_stby_vad_5_reg(data)                                            (*((volatile unsigned int*)WOV_stby_vad_5_reg)=data)
#define  get_WOV_stby_vad_5_reg                                                  (*((volatile unsigned int*)WOV_stby_vad_5_reg))
#define  WOV_stby_vad_5_vad_bq_para_update_shift                                 (31)
#define  WOV_stby_vad_5_vad_biquad_0_wclr_shift                                  (30)
#define  WOV_stby_vad_5_vad_biquad_1_wclr_shift                                  (29)
#define  WOV_stby_vad_5_vad_biquad_0_h0_shift                                    (0)
#define  WOV_stby_vad_5_vad_bq_para_update_mask                                  (0x80000000)
#define  WOV_stby_vad_5_vad_biquad_0_wclr_mask                                   (0x40000000)
#define  WOV_stby_vad_5_vad_biquad_1_wclr_mask                                   (0x20000000)
#define  WOV_stby_vad_5_vad_biquad_0_h0_mask                                     (0x1FFFFFFF)
#define  WOV_stby_vad_5_vad_bq_para_update(data)                                 (0x80000000&((data)<<31))
#define  WOV_stby_vad_5_vad_biquad_0_wclr(data)                                  (0x40000000&((data)<<30))
#define  WOV_stby_vad_5_vad_biquad_1_wclr(data)                                  (0x20000000&((data)<<29))
#define  WOV_stby_vad_5_vad_biquad_0_h0(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_vad_5_get_vad_bq_para_update(data)                             ((0x80000000&(data))>>31)
#define  WOV_stby_vad_5_get_vad_biquad_0_wclr(data)                              ((0x40000000&(data))>>30)
#define  WOV_stby_vad_5_get_vad_biquad_1_wclr(data)                              ((0x20000000&(data))>>29)
#define  WOV_stby_vad_5_get_vad_biquad_0_h0(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_1                                                         0x18060628
#define  WOV_stby_biq_1_reg_addr                                                 "0xB8060628"
#define  WOV_stby_biq_1_reg                                                      0xB8060628
#define  WOV_stby_biq_1_inst_addr                                                "0x000A"
#define  set_WOV_stby_biq_1_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_1_reg)=data)
#define  get_WOV_stby_biq_1_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_1_reg))
#define  WOV_stby_biq_1_vad_bq_cd_en_shift                                       (31)
#define  WOV_stby_biq_1_vad_biquad_0_en_shift                                    (30)
#define  WOV_stby_biq_1_vad_biquad_1_en_shift                                    (29)
#define  WOV_stby_biq_1_vad_biquad_0_b1_shift                                    (0)
#define  WOV_stby_biq_1_vad_bq_cd_en_mask                                        (0x80000000)
#define  WOV_stby_biq_1_vad_biquad_0_en_mask                                     (0x40000000)
#define  WOV_stby_biq_1_vad_biquad_1_en_mask                                     (0x20000000)
#define  WOV_stby_biq_1_vad_biquad_0_b1_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_1_vad_bq_cd_en(data)                                       (0x80000000&((data)<<31))
#define  WOV_stby_biq_1_vad_biquad_0_en(data)                                    (0x40000000&((data)<<30))
#define  WOV_stby_biq_1_vad_biquad_1_en(data)                                    (0x20000000&((data)<<29))
#define  WOV_stby_biq_1_vad_biquad_0_b1(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_1_get_vad_bq_cd_en(data)                                   ((0x80000000&(data))>>31)
#define  WOV_stby_biq_1_get_vad_biquad_0_en(data)                                ((0x40000000&(data))>>30)
#define  WOV_stby_biq_1_get_vad_biquad_1_en(data)                                ((0x20000000&(data))>>29)
#define  WOV_stby_biq_1_get_vad_biquad_0_b1(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_2                                                         0x1806062C
#define  WOV_stby_biq_2_reg_addr                                                 "0xB806062C"
#define  WOV_stby_biq_2_reg                                                      0xB806062C
#define  WOV_stby_biq_2_inst_addr                                                "0x000B"
#define  set_WOV_stby_biq_2_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_2_reg)=data)
#define  get_WOV_stby_biq_2_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_2_reg))
#define  WOV_stby_biq_2_vad_bq_cd_flag_shift                                     (31)
#define  WOV_stby_biq_2_vad_bq_dither_sel_shift                                  (29)
#define  WOV_stby_biq_2_vad_biquad_0_b2_shift                                    (0)
#define  WOV_stby_biq_2_vad_bq_cd_flag_mask                                      (0x80000000)
#define  WOV_stby_biq_2_vad_bq_dither_sel_mask                                   (0x60000000)
#define  WOV_stby_biq_2_vad_biquad_0_b2_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_2_vad_bq_cd_flag(data)                                     (0x80000000&((data)<<31))
#define  WOV_stby_biq_2_vad_bq_dither_sel(data)                                  (0x60000000&((data)<<29))
#define  WOV_stby_biq_2_vad_biquad_0_b2(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_2_get_vad_bq_cd_flag(data)                                 ((0x80000000&(data))>>31)
#define  WOV_stby_biq_2_get_vad_bq_dither_sel(data)                              ((0x60000000&(data))>>29)
#define  WOV_stby_biq_2_get_vad_biquad_0_b2(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_3                                                         0x18060630
#define  WOV_stby_biq_3_reg_addr                                                 "0xB8060630"
#define  WOV_stby_biq_3_reg                                                      0xB8060630
#define  WOV_stby_biq_3_inst_addr                                                "0x000C"
#define  set_WOV_stby_biq_3_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_3_reg)=data)
#define  get_WOV_stby_biq_3_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_3_reg))
#define  WOV_stby_biq_3_vad_biquad_0_status_shift                                (31)
#define  WOV_stby_biq_3_vad_biquad_1_status_shift                                (30)
#define  WOV_stby_biq_3_vad_bq_status_shift                                      (29)
#define  WOV_stby_biq_3_vad_biquad_0_a1_shift                                    (0)
#define  WOV_stby_biq_3_vad_biquad_0_status_mask                                 (0x80000000)
#define  WOV_stby_biq_3_vad_biquad_1_status_mask                                 (0x40000000)
#define  WOV_stby_biq_3_vad_bq_status_mask                                       (0x20000000)
#define  WOV_stby_biq_3_vad_biquad_0_a1_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_3_vad_biquad_0_status(data)                                (0x80000000&((data)<<31))
#define  WOV_stby_biq_3_vad_biquad_1_status(data)                                (0x40000000&((data)<<30))
#define  WOV_stby_biq_3_vad_bq_status(data)                                      (0x20000000&((data)<<29))
#define  WOV_stby_biq_3_vad_biquad_0_a1(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_3_get_vad_biquad_0_status(data)                            ((0x80000000&(data))>>31)
#define  WOV_stby_biq_3_get_vad_biquad_1_status(data)                            ((0x40000000&(data))>>30)
#define  WOV_stby_biq_3_get_vad_bq_status(data)                                  ((0x20000000&(data))>>29)
#define  WOV_stby_biq_3_get_vad_biquad_0_a1(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_4                                                         0x18060634
#define  WOV_stby_biq_4_reg_addr                                                 "0xB8060634"
#define  WOV_stby_biq_4_reg                                                      0xB8060634
#define  WOV_stby_biq_4_inst_addr                                                "0x000D"
#define  set_WOV_stby_biq_4_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_4_reg)=data)
#define  get_WOV_stby_biq_4_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_4_reg))
#define  WOV_stby_biq_4_vad_biquad_0_a2_shift                                    (0)
#define  WOV_stby_biq_4_vad_biquad_0_a2_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_4_vad_biquad_0_a2(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_4_get_vad_biquad_0_a2(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_5                                                         0x18060638
#define  WOV_stby_biq_5_reg_addr                                                 "0xB8060638"
#define  WOV_stby_biq_5_reg                                                      0xB8060638
#define  WOV_stby_biq_5_inst_addr                                                "0x000E"
#define  set_WOV_stby_biq_5_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_5_reg)=data)
#define  get_WOV_stby_biq_5_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_5_reg))
#define  WOV_stby_biq_5_vad_biquad_1_h0_shift                                    (0)
#define  WOV_stby_biq_5_vad_biquad_1_h0_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_5_vad_biquad_1_h0(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_5_get_vad_biquad_1_h0(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_6                                                         0x1806063C
#define  WOV_stby_biq_6_reg_addr                                                 "0xB806063C"
#define  WOV_stby_biq_6_reg                                                      0xB806063C
#define  WOV_stby_biq_6_inst_addr                                                "0x000F"
#define  set_WOV_stby_biq_6_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_6_reg)=data)
#define  get_WOV_stby_biq_6_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_6_reg))
#define  WOV_stby_biq_6_vad_biquad_1_b1_shift                                    (0)
#define  WOV_stby_biq_6_vad_biquad_1_b1_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_6_vad_biquad_1_b1(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_6_get_vad_biquad_1_b1(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_7                                                         0x18060640
#define  WOV_stby_biq_7_reg_addr                                                 "0xB8060640"
#define  WOV_stby_biq_7_reg                                                      0xB8060640
#define  WOV_stby_biq_7_inst_addr                                                "0x0010"
#define  set_WOV_stby_biq_7_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_7_reg)=data)
#define  get_WOV_stby_biq_7_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_7_reg))
#define  WOV_stby_biq_7_vad_biquad_1_b2_shift                                    (0)
#define  WOV_stby_biq_7_vad_biquad_1_b2_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_7_vad_biquad_1_b2(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_7_get_vad_biquad_1_b2(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_8                                                         0x18060644
#define  WOV_stby_biq_8_reg_addr                                                 "0xB8060644"
#define  WOV_stby_biq_8_reg                                                      0xB8060644
#define  WOV_stby_biq_8_inst_addr                                                "0x0011"
#define  set_WOV_stby_biq_8_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_8_reg)=data)
#define  get_WOV_stby_biq_8_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_8_reg))
#define  WOV_stby_biq_8_vad_biquad_1_a1_shift                                    (0)
#define  WOV_stby_biq_8_vad_biquad_1_a1_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_8_vad_biquad_1_a1(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_8_get_vad_biquad_1_a1(data)                                (0x1FFFFFFF&(data))

#define  WOV_stby_biq_9                                                         0x18060648
#define  WOV_stby_biq_9_reg_addr                                                 "0xB8060648"
#define  WOV_stby_biq_9_reg                                                      0xB8060648
#define  WOV_stby_biq_9_inst_addr                                                "0x0012"
#define  set_WOV_stby_biq_9_reg(data)                                            (*((volatile unsigned int*)WOV_stby_biq_9_reg)=data)
#define  get_WOV_stby_biq_9_reg                                                  (*((volatile unsigned int*)WOV_stby_biq_9_reg))
#define  WOV_stby_biq_9_vad_biquad_1_a2_shift                                    (0)
#define  WOV_stby_biq_9_vad_biquad_1_a2_mask                                     (0x1FFFFFFF)
#define  WOV_stby_biq_9_vad_biquad_1_a2(data)                                    (0x1FFFFFFF&(data))
#define  WOV_stby_biq_9_get_vad_biquad_1_a2(data)                                (0x1FFFFFFF&(data))

#define  WOV_wov_ctrl_1                                                         0x1806064C
#define  WOV_wov_ctrl_1_reg_addr                                                 "0xB806064C"
#define  WOV_wov_ctrl_1_reg                                                      0xB806064C
#define  WOV_wov_ctrl_1_inst_addr                                                "0x0013"
#define  set_WOV_wov_ctrl_1_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_1_reg)=data)
#define  get_WOV_wov_ctrl_1_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_1_reg))
#define  WOV_wov_ctrl_1_reg_dmic_clk_src_shift                                   (31)
#define  WOV_wov_ctrl_1_reg_force_ls_en_shift                                    (22)
#define  WOV_wov_ctrl_1_reg_force_ls_val_shift                                   (21)
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_ptr_shift                                (8)
#define  WOV_wov_ctrl_1_reg_wov_1ch_sel_shift                                    (4)
#define  WOV_wov_ctrl_1_reg_wov_1ch_mode_shift                                   (3)
#define  WOV_wov_ctrl_1_reg_wov_sram_wr_en_shift                                 (2)
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_en_shift                                 (1)
#define  WOV_wov_ctrl_1_reg_wov_func_en_shift                                    (0)
#define  WOV_wov_ctrl_1_reg_dmic_clk_src_mask                                    (0x80000000)
#define  WOV_wov_ctrl_1_reg_force_ls_en_mask                                     (0x00400000)
#define  WOV_wov_ctrl_1_reg_force_ls_val_mask                                    (0x00200000)
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_ptr_mask                                 (0x001FFF00)
#define  WOV_wov_ctrl_1_reg_wov_1ch_sel_mask                                     (0x00000030)
#define  WOV_wov_ctrl_1_reg_wov_1ch_mode_mask                                    (0x00000008)
#define  WOV_wov_ctrl_1_reg_wov_sram_wr_en_mask                                  (0x00000004)
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_en_mask                                  (0x00000002)
#define  WOV_wov_ctrl_1_reg_wov_func_en_mask                                     (0x00000001)
#define  WOV_wov_ctrl_1_reg_dmic_clk_src(data)                                   (0x80000000&((data)<<31))
#define  WOV_wov_ctrl_1_reg_force_ls_en(data)                                    (0x00400000&((data)<<22))
#define  WOV_wov_ctrl_1_reg_force_ls_val(data)                                   (0x00200000&((data)<<21))
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_ptr(data)                                (0x001FFF00&((data)<<8))
#define  WOV_wov_ctrl_1_reg_wov_1ch_sel(data)                                    (0x00000030&((data)<<4))
#define  WOV_wov_ctrl_1_reg_wov_1ch_mode(data)                                   (0x00000008&((data)<<3))
#define  WOV_wov_ctrl_1_reg_wov_sram_wr_en(data)                                 (0x00000004&((data)<<2))
#define  WOV_wov_ctrl_1_reg_wov_sram_rd_en(data)                                 (0x00000002&((data)<<1))
#define  WOV_wov_ctrl_1_reg_wov_func_en(data)                                    (0x00000001&(data))
#define  WOV_wov_ctrl_1_get_reg_dmic_clk_src(data)                               ((0x80000000&(data))>>31)
#define  WOV_wov_ctrl_1_get_reg_force_ls_en(data)                                ((0x00400000&(data))>>22)
#define  WOV_wov_ctrl_1_get_reg_force_ls_val(data)                               ((0x00200000&(data))>>21)
#define  WOV_wov_ctrl_1_get_reg_wov_sram_rd_ptr(data)                            ((0x001FFF00&(data))>>8)
#define  WOV_wov_ctrl_1_get_reg_wov_1ch_sel(data)                                ((0x00000030&(data))>>4)
#define  WOV_wov_ctrl_1_get_reg_wov_1ch_mode(data)                               ((0x00000008&(data))>>3)
#define  WOV_wov_ctrl_1_get_reg_wov_sram_wr_en(data)                             ((0x00000004&(data))>>2)
#define  WOV_wov_ctrl_1_get_reg_wov_sram_rd_en(data)                             ((0x00000002&(data))>>1)
#define  WOV_wov_ctrl_1_get_reg_wov_func_en(data)                                (0x00000001&(data))

#define  WOV_wov_ctrl_2                                                         0x18060650
#define  WOV_wov_ctrl_2_reg_addr                                                 "0xB8060650"
#define  WOV_wov_ctrl_2_reg                                                      0xB8060650
#define  WOV_wov_ctrl_2_inst_addr                                                "0x0014"
#define  set_WOV_wov_ctrl_2_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_2_reg)=data)
#define  get_WOV_wov_ctrl_2_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_2_reg))
#define  WOV_wov_ctrl_2_wov_sram_irq_wr_ptr_shift                                (16)
#define  WOV_wov_ctrl_2_wov_sram_wr_ptr_shift                                    (0)
#define  WOV_wov_ctrl_2_wov_sram_irq_wr_ptr_mask                                 (0x1FFF0000)
#define  WOV_wov_ctrl_2_wov_sram_wr_ptr_mask                                     (0x00001FFF)
#define  WOV_wov_ctrl_2_wov_sram_irq_wr_ptr(data)                                (0x1FFF0000&((data)<<16))
#define  WOV_wov_ctrl_2_wov_sram_wr_ptr(data)                                    (0x00001FFF&(data))
#define  WOV_wov_ctrl_2_get_wov_sram_irq_wr_ptr(data)                            ((0x1FFF0000&(data))>>16)
#define  WOV_wov_ctrl_2_get_wov_sram_wr_ptr(data)                                (0x00001FFF&(data))

#define  WOV_wov_ctrl_3                                                         0x18060654
#define  WOV_wov_ctrl_3_reg_addr                                                 "0xB8060654"
#define  WOV_wov_ctrl_3_reg                                                      0xB8060654
#define  WOV_wov_ctrl_3_inst_addr                                                "0x0015"
#define  set_WOV_wov_ctrl_3_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_3_reg)=data)
#define  get_WOV_wov_ctrl_3_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_3_reg))
#define  WOV_wov_ctrl_3_wov_sram_rd_ptr_shift                                    (0)
#define  WOV_wov_ctrl_3_wov_sram_rd_ptr_mask                                     (0x00001FFF)
#define  WOV_wov_ctrl_3_wov_sram_rd_ptr(data)                                    (0x00001FFF&(data))
#define  WOV_wov_ctrl_3_get_wov_sram_rd_ptr(data)                                (0x00001FFF&(data))

#define  WOV_wov_ctrl_4                                                         0x18060658
#define  WOV_wov_ctrl_4_reg_addr                                                 "0xB8060658"
#define  WOV_wov_ctrl_4_reg                                                      0xB8060658
#define  WOV_wov_ctrl_4_inst_addr                                                "0x0016"
#define  set_WOV_wov_ctrl_4_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_4_reg)=data)
#define  get_WOV_wov_ctrl_4_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_4_reg))
#define  WOV_wov_ctrl_4_reg_wov_ddr_start_addr_shift                             (0)
#define  WOV_wov_ctrl_4_reg_wov_ddr_start_addr_mask                              (0xFFFFFFFF)
#define  WOV_wov_ctrl_4_reg_wov_ddr_start_addr(data)                             (0xFFFFFFFF&(data))
#define  WOV_wov_ctrl_4_get_reg_wov_ddr_start_addr(data)                         (0xFFFFFFFF&(data))

#define  WOV_wov_ctrl_5                                                         0x1806065C
#define  WOV_wov_ctrl_5_reg_addr                                                 "0xB806065C"
#define  WOV_wov_ctrl_5_reg                                                      0xB806065C
#define  WOV_wov_ctrl_5_inst_addr                                                "0x0017"
#define  set_WOV_wov_ctrl_5_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_5_reg)=data)
#define  get_WOV_wov_ctrl_5_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_5_reg))
#define  WOV_wov_ctrl_5_reg_wov_ddr_ring_shift                                   (31)
#define  WOV_wov_ctrl_5_wov_ddr_ov_shift                                         (30)
#define  WOV_wov_ctrl_5_reg_wov_ddr_lenth_limt_shift                             (5)
#define  WOV_wov_ctrl_5_reg_wov_ddr_ring_mask                                    (0x80000000)
#define  WOV_wov_ctrl_5_wov_ddr_ov_mask                                          (0x40000000)
#define  WOV_wov_ctrl_5_reg_wov_ddr_lenth_limt_mask                              (0x3FFFFFE0)
#define  WOV_wov_ctrl_5_reg_wov_ddr_ring(data)                                   (0x80000000&((data)<<31))
#define  WOV_wov_ctrl_5_wov_ddr_ov(data)                                         (0x40000000&((data)<<30))
#define  WOV_wov_ctrl_5_reg_wov_ddr_lenth_limt(data)                             (0x3FFFFFE0&((data)<<5))
#define  WOV_wov_ctrl_5_get_reg_wov_ddr_ring(data)                               ((0x80000000&(data))>>31)
#define  WOV_wov_ctrl_5_get_wov_ddr_ov(data)                                     ((0x40000000&(data))>>30)
#define  WOV_wov_ctrl_5_get_reg_wov_ddr_lenth_limt(data)                         ((0x3FFFFFE0&(data))>>5)

#define  WOV_wov_ctrl_6                                                         0x18060660
#define  WOV_wov_ctrl_6_reg_addr                                                 "0xB8060660"
#define  WOV_wov_ctrl_6_reg                                                      0xB8060660
#define  WOV_wov_ctrl_6_inst_addr                                                "0x0018"
#define  set_WOV_wov_ctrl_6_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_6_reg)=data)
#define  get_WOV_wov_ctrl_6_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_6_reg))
#define  WOV_wov_ctrl_6_wov_ddr_wr_ptr_shift                                     (5)
#define  WOV_wov_ctrl_6_wov_ddr_wr_ptr_mask                                      (0xFFFFFFE0)
#define  WOV_wov_ctrl_6_wov_ddr_wr_ptr(data)                                     (0xFFFFFFE0&((data)<<5))
#define  WOV_wov_ctrl_6_get_wov_ddr_wr_ptr(data)                                 ((0xFFFFFFE0&(data))>>5)

#define  WOV_wov_ctrl_7                                                         0x18060664
#define  WOV_wov_ctrl_7_reg_addr                                                 "0xB8060664"
#define  WOV_wov_ctrl_7_reg                                                      0xB8060664
#define  WOV_wov_ctrl_7_inst_addr                                                "0x0019"
#define  set_WOV_wov_ctrl_7_reg(data)                                            (*((volatile unsigned int*)WOV_wov_ctrl_7_reg)=data)
#define  get_WOV_wov_ctrl_7_reg                                                  (*((volatile unsigned int*)WOV_wov_ctrl_7_reg))
#define  WOV_wov_ctrl_7_wov_bist_done_shift                                      (31)
#define  WOV_wov_ctrl_7_wov_bist_fail_0_shift                                    (30)
#define  WOV_wov_ctrl_7_wov_bist_fail_1_shift                                    (29)
#define  WOV_wov_ctrl_7_wov_drf_bist_done_shift                                  (28)
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_0_shift                                (27)
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_1_shift                                (26)
#define  WOV_wov_ctrl_7_wov_drf_start_pause_shift                                (25)
#define  WOV_wov_ctrl_7_reg_wov_rm_1_shift                                       (9)
#define  WOV_wov_ctrl_7_reg_wov_rme_1_shift                                      (8)
#define  WOV_wov_ctrl_7_reg_wov_rm_0_shift                                       (4)
#define  WOV_wov_ctrl_7_reg_wov_rme_0_shift                                      (3)
#define  WOV_wov_ctrl_7_reg_wov_drf_test_resume_shift                            (2)
#define  WOV_wov_ctrl_7_reg_wov_drf_bist_mode_shift                              (1)
#define  WOV_wov_ctrl_7_reg_wov_bist_mode_shift                                  (0)
#define  WOV_wov_ctrl_7_wov_bist_done_mask                                       (0x80000000)
#define  WOV_wov_ctrl_7_wov_bist_fail_0_mask                                     (0x40000000)
#define  WOV_wov_ctrl_7_wov_bist_fail_1_mask                                     (0x20000000)
#define  WOV_wov_ctrl_7_wov_drf_bist_done_mask                                   (0x10000000)
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_0_mask                                 (0x08000000)
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_1_mask                                 (0x04000000)
#define  WOV_wov_ctrl_7_wov_drf_start_pause_mask                                 (0x02000000)
#define  WOV_wov_ctrl_7_reg_wov_rm_1_mask                                        (0x00001E00)
#define  WOV_wov_ctrl_7_reg_wov_rme_1_mask                                       (0x00000100)
#define  WOV_wov_ctrl_7_reg_wov_rm_0_mask                                        (0x000000F0)
#define  WOV_wov_ctrl_7_reg_wov_rme_0_mask                                       (0x00000008)
#define  WOV_wov_ctrl_7_reg_wov_drf_test_resume_mask                             (0x00000004)
#define  WOV_wov_ctrl_7_reg_wov_drf_bist_mode_mask                               (0x00000002)
#define  WOV_wov_ctrl_7_reg_wov_bist_mode_mask                                   (0x00000001)
#define  WOV_wov_ctrl_7_wov_bist_done(data)                                      (0x80000000&((data)<<31))
#define  WOV_wov_ctrl_7_wov_bist_fail_0(data)                                    (0x40000000&((data)<<30))
#define  WOV_wov_ctrl_7_wov_bist_fail_1(data)                                    (0x20000000&((data)<<29))
#define  WOV_wov_ctrl_7_wov_drf_bist_done(data)                                  (0x10000000&((data)<<28))
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_0(data)                                (0x08000000&((data)<<27))
#define  WOV_wov_ctrl_7_wov_drf_bist_fail_1(data)                                (0x04000000&((data)<<26))
#define  WOV_wov_ctrl_7_wov_drf_start_pause(data)                                (0x02000000&((data)<<25))
#define  WOV_wov_ctrl_7_reg_wov_rm_1(data)                                       (0x00001E00&((data)<<9))
#define  WOV_wov_ctrl_7_reg_wov_rme_1(data)                                      (0x00000100&((data)<<8))
#define  WOV_wov_ctrl_7_reg_wov_rm_0(data)                                       (0x000000F0&((data)<<4))
#define  WOV_wov_ctrl_7_reg_wov_rme_0(data)                                      (0x00000008&((data)<<3))
#define  WOV_wov_ctrl_7_reg_wov_drf_test_resume(data)                            (0x00000004&((data)<<2))
#define  WOV_wov_ctrl_7_reg_wov_drf_bist_mode(data)                              (0x00000002&((data)<<1))
#define  WOV_wov_ctrl_7_reg_wov_bist_mode(data)                                  (0x00000001&(data))
#define  WOV_wov_ctrl_7_get_wov_bist_done(data)                                  ((0x80000000&(data))>>31)
#define  WOV_wov_ctrl_7_get_wov_bist_fail_0(data)                                ((0x40000000&(data))>>30)
#define  WOV_wov_ctrl_7_get_wov_bist_fail_1(data)                                ((0x20000000&(data))>>29)
#define  WOV_wov_ctrl_7_get_wov_drf_bist_done(data)                              ((0x10000000&(data))>>28)
#define  WOV_wov_ctrl_7_get_wov_drf_bist_fail_0(data)                            ((0x08000000&(data))>>27)
#define  WOV_wov_ctrl_7_get_wov_drf_bist_fail_1(data)                            ((0x04000000&(data))>>26)
#define  WOV_wov_ctrl_7_get_wov_drf_start_pause(data)                            ((0x02000000&(data))>>25)
#define  WOV_wov_ctrl_7_get_reg_wov_rm_1(data)                                   ((0x00001E00&(data))>>9)
#define  WOV_wov_ctrl_7_get_reg_wov_rme_1(data)                                  ((0x00000100&(data))>>8)
#define  WOV_wov_ctrl_7_get_reg_wov_rm_0(data)                                   ((0x000000F0&(data))>>4)
#define  WOV_wov_ctrl_7_get_reg_wov_rme_0(data)                                  ((0x00000008&(data))>>3)
#define  WOV_wov_ctrl_7_get_reg_wov_drf_test_resume(data)                        ((0x00000004&(data))>>2)
#define  WOV_wov_ctrl_7_get_reg_wov_drf_bist_mode(data)                          ((0x00000002&(data))>>1)
#define  WOV_wov_ctrl_7_get_reg_wov_bist_mode(data)                              (0x00000001&(data))

#define  WOV_wov_vad_1                                                          0x18060668
#define  WOV_wov_vad_1_reg_addr                                                  "0xB8060668"
#define  WOV_wov_vad_1_reg                                                       0xB8060668
#define  WOV_wov_vad_1_inst_addr                                                 "0x001A"
#define  set_WOV_wov_vad_1_reg(data)                                             (*((volatile unsigned int*)WOV_wov_vad_1_reg)=data)
#define  get_WOV_wov_vad_1_reg                                                   (*((volatile unsigned int*)WOV_wov_vad_1_reg))
#define  WOV_wov_vad_1_clk_vad_test_shift                                        (31)
#define  WOV_wov_vad_1_test_wreq_shift                                           (30)
#define  WOV_wov_vad_1_vad_debug_en_shift                                        (16)
#define  WOV_wov_vad_1_test_data_in_shift                                        (0)
#define  WOV_wov_vad_1_clk_vad_test_mask                                         (0x80000000)
#define  WOV_wov_vad_1_test_wreq_mask                                            (0x40000000)
#define  WOV_wov_vad_1_vad_debug_en_mask                                         (0x00010000)
#define  WOV_wov_vad_1_test_data_in_mask                                         (0x0000FFFF)
#define  WOV_wov_vad_1_clk_vad_test(data)                                        (0x80000000&((data)<<31))
#define  WOV_wov_vad_1_test_wreq(data)                                           (0x40000000&((data)<<30))
#define  WOV_wov_vad_1_vad_debug_en(data)                                        (0x00010000&((data)<<16))
#define  WOV_wov_vad_1_test_data_in(data)                                        (0x0000FFFF&(data))
#define  WOV_wov_vad_1_get_clk_vad_test(data)                                    ((0x80000000&(data))>>31)
#define  WOV_wov_vad_1_get_test_wreq(data)                                       ((0x40000000&(data))>>30)
#define  WOV_wov_vad_1_get_vad_debug_en(data)                                    ((0x00010000&(data))>>16)
#define  WOV_wov_vad_1_get_test_data_in(data)                                    (0x0000FFFF&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======WOV register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_0_en:1;
        RBus_UInt32  adc_1_en:1;
        RBus_UInt32  adc_0_sample_rate:4;
        RBus_UInt32  adc_1_sample_rate:4;
        RBus_UInt32  dmic_0_clk_sel:4;
        RBus_UInt32  dmic_0_en:1;
        RBus_UInt32  gen_src_16k128_en:1;
        RBus_UInt32  gen_src_32k128_en:1;
        RBus_UInt32  gen_src_48k128_en:1;
        RBus_UInt32  vad_en:1;
        RBus_UInt32  res1:13;
    };
}wov_stby_tcon_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  adc0_ad_gain_l:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  adc0_ad_gain_r:7;
    };
}wov_stby_ad0_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc0_dmicl_ri_fa_sel:1;
        RBus_UInt32  adc0_dmicr_ri_fa_sel:1;
        RBus_UInt32  adc0_dmic_lpf1st_fc_sel:2;
        RBus_UInt32  adc0_dmic_lpf2nd_fc_sel:1;
        RBus_UInt32  adc0_ad_hpf_en:1;
        RBus_UInt32  adc0_ad_comp_gain:2;
        RBus_UInt32  adc0_ad_mute_l:1;
        RBus_UInt32  adc0_ad_mute_r:1;
        RBus_UInt32  adc0_ad_zdet_tout:2;
        RBus_UInt32  adc0_ad_zdet_func:2;
        RBus_UInt32  adc0_dmic_boost_gain_l:2;
        RBus_UInt32  adc0_dmic_boost_gain_r:2;
        RBus_UInt32  adc0_dmic_lpf1st_en:1;
        RBus_UInt32  res1:13;
    };
}wov_stby_ad0_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  adc1_ad_gain_l:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  adc1_ad_gain_r:7;
    };
}wov_stby_ad1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc1_dmicl_ri_fa_sel:1;
        RBus_UInt32  adc1_dmicr_ri_fa_sel:1;
        RBus_UInt32  adc1_dmic_lpf1st_fc_sel:2;
        RBus_UInt32  adc1_dmic_lpf2nd_fc_sel:1;
        RBus_UInt32  adc1_ad_hpf_en:1;
        RBus_UInt32  adc1_ad_comp_gain:2;
        RBus_UInt32  adc1_ad_mute_l:1;
        RBus_UInt32  adc1_ad_mute_r:1;
        RBus_UInt32  adc1_ad_zdet_tout:2;
        RBus_UInt32  adc1_ad_zdet_func:2;
        RBus_UInt32  adc1_dmic_boost_gain_l:2;
        RBus_UInt32  adc1_dmic_boost_gain_r:2;
        RBus_UInt32  adc1_dmic_lpf1st_en:1;
        RBus_UInt32  res1:13;
    };
}wov_stby_ad1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_bypass_square:1;
        RBus_UInt32  vad_en_lt_fine_coef:1;
        RBus_UInt32  vad_en_st_fine_coef:1;
        RBus_UInt32  vad_initial_thr:6;
        RBus_UInt32  vad_lt_coef_fast:3;
        RBus_UInt32  vad_lt_coef_slow:3;
        RBus_UInt32  vad_st_chk_start_thr:6;
        RBus_UInt32  vad_st_coef:3;
        RBus_UInt32  vad_st_high_keep_chk_thr:8;
    };
}wov_stby_vad_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_st_energy_low_chk_thr:6;
        RBus_UInt32  vad_st_energy_thr:6;
        RBus_UInt32  vad_st_fall_thr:6;
        RBus_UInt32  vad_time_debounce_thr:10;
        RBus_UInt32  vad_syllable_thr:4;
    };
}wov_stby_vad_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_st_stable_thr:8;
        RBus_UInt32  vad_st_valid_thr:16;
        RBus_UInt32  vad_syllable_wait_thr:8;
    };
}wov_stby_vad_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  vad_flag_sel_out:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  vad_initial_flag:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  vad_st_start_ref_thr:7;
        RBus_UInt32  vad_noise_pulse_thr:4;
        RBus_UInt32  vad_flag_clr:1;
        RBus_UInt32  vad_flag_sel:1;
        RBus_UInt32  vad_in_sel:3;
        RBus_UInt32  vad_flag:1;
        RBus_UInt32  vad_flag_hold:1;
    };
}wov_stby_vad_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_bq_para_update:1;
        RBus_UInt32  vad_biquad_0_wclr:1;
        RBus_UInt32  vad_biquad_1_wclr:1;
        RBus_UInt32  vad_biquad_0_h0:29;
    };
}wov_stby_vad_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_bq_cd_en:1;
        RBus_UInt32  vad_biquad_0_en:1;
        RBus_UInt32  vad_biquad_1_en:1;
        RBus_UInt32  vad_biquad_0_b1:29;
    };
}wov_stby_biq_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_bq_cd_flag:1;
        RBus_UInt32  vad_bq_dither_sel:2;
        RBus_UInt32  vad_biquad_0_b2:29;
    };
}wov_stby_biq_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_status:1;
        RBus_UInt32  vad_biquad_1_status:1;
        RBus_UInt32  vad_bq_status:1;
        RBus_UInt32  vad_biquad_0_a1:29;
    };
}wov_stby_biq_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_0_a2:29;
    };
}wov_stby_biq_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_1_h0:29;
    };
}wov_stby_biq_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_1_b1:29;
    };
}wov_stby_biq_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_1_b2:29;
    };
}wov_stby_biq_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_1_a1:29;
    };
}wov_stby_biq_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  vad_biquad_1_a2:29;
    };
}wov_stby_biq_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_dmic_clk_src:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  reg_force_ls_en:1;
        RBus_UInt32  reg_force_ls_val:1;
        RBus_UInt32  reg_wov_sram_rd_ptr:13;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_wov_1ch_sel:2;
        RBus_UInt32  reg_wov_1ch_mode:1;
        RBus_UInt32  reg_wov_sram_wr_en:1;
        RBus_UInt32  reg_wov_sram_rd_en:1;
        RBus_UInt32  reg_wov_func_en:1;
    };
}wov_wov_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  wov_sram_irq_wr_ptr:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  wov_sram_wr_ptr:13;
    };
}wov_wov_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  wov_sram_rd_ptr:13;
    };
}wov_wov_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_wov_ddr_start_addr:32;
    };
}wov_wov_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_wov_ddr_ring:1;
        RBus_UInt32  wov_ddr_ov:1;
        RBus_UInt32  reg_wov_ddr_lenth_limt:25;
        RBus_UInt32  res1:5;
    };
}wov_wov_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wov_ddr_wr_ptr:27;
        RBus_UInt32  res1:5;
    };
}wov_wov_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wov_bist_done:1;
        RBus_UInt32  wov_bist_fail_0:1;
        RBus_UInt32  wov_bist_fail_1:1;
        RBus_UInt32  wov_drf_bist_done:1;
        RBus_UInt32  wov_drf_bist_fail_0:1;
        RBus_UInt32  wov_drf_bist_fail_1:1;
        RBus_UInt32  wov_drf_start_pause:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  reg_wov_rm_1:4;
        RBus_UInt32  reg_wov_rme_1:1;
        RBus_UInt32  reg_wov_rm_0:4;
        RBus_UInt32  reg_wov_rme_0:1;
        RBus_UInt32  reg_wov_drf_test_resume:1;
        RBus_UInt32  reg_wov_drf_bist_mode:1;
        RBus_UInt32  reg_wov_bist_mode:1;
    };
}wov_wov_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clk_vad_test:1;
        RBus_UInt32  test_wreq:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  vad_debug_en:1;
        RBus_UInt32  test_data_in:16;
    };
}wov_wov_vad_1_RBUS;

#else //apply LITTLE_ENDIAN

//======WOV register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  vad_en:1;
        RBus_UInt32  gen_src_48k128_en:1;
        RBus_UInt32  gen_src_32k128_en:1;
        RBus_UInt32  gen_src_16k128_en:1;
        RBus_UInt32  dmic_0_en:1;
        RBus_UInt32  dmic_0_clk_sel:4;
        RBus_UInt32  adc_1_sample_rate:4;
        RBus_UInt32  adc_0_sample_rate:4;
        RBus_UInt32  adc_1_en:1;
        RBus_UInt32  adc_0_en:1;
    };
}wov_stby_tcon_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc0_ad_gain_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  adc0_ad_gain_l:7;
        RBus_UInt32  res2:17;
    };
}wov_stby_ad0_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  adc0_dmic_lpf1st_en:1;
        RBus_UInt32  adc0_dmic_boost_gain_r:2;
        RBus_UInt32  adc0_dmic_boost_gain_l:2;
        RBus_UInt32  adc0_ad_zdet_func:2;
        RBus_UInt32  adc0_ad_zdet_tout:2;
        RBus_UInt32  adc0_ad_mute_r:1;
        RBus_UInt32  adc0_ad_mute_l:1;
        RBus_UInt32  adc0_ad_comp_gain:2;
        RBus_UInt32  adc0_ad_hpf_en:1;
        RBus_UInt32  adc0_dmic_lpf2nd_fc_sel:1;
        RBus_UInt32  adc0_dmic_lpf1st_fc_sel:2;
        RBus_UInt32  adc0_dmicr_ri_fa_sel:1;
        RBus_UInt32  adc0_dmicl_ri_fa_sel:1;
    };
}wov_stby_ad0_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc1_ad_gain_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  adc1_ad_gain_l:7;
        RBus_UInt32  res2:17;
    };
}wov_stby_ad1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  adc1_dmic_lpf1st_en:1;
        RBus_UInt32  adc1_dmic_boost_gain_r:2;
        RBus_UInt32  adc1_dmic_boost_gain_l:2;
        RBus_UInt32  adc1_ad_zdet_func:2;
        RBus_UInt32  adc1_ad_zdet_tout:2;
        RBus_UInt32  adc1_ad_mute_r:1;
        RBus_UInt32  adc1_ad_mute_l:1;
        RBus_UInt32  adc1_ad_comp_gain:2;
        RBus_UInt32  adc1_ad_hpf_en:1;
        RBus_UInt32  adc1_dmic_lpf2nd_fc_sel:1;
        RBus_UInt32  adc1_dmic_lpf1st_fc_sel:2;
        RBus_UInt32  adc1_dmicr_ri_fa_sel:1;
        RBus_UInt32  adc1_dmicl_ri_fa_sel:1;
    };
}wov_stby_ad1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_st_high_keep_chk_thr:8;
        RBus_UInt32  vad_st_coef:3;
        RBus_UInt32  vad_st_chk_start_thr:6;
        RBus_UInt32  vad_lt_coef_slow:3;
        RBus_UInt32  vad_lt_coef_fast:3;
        RBus_UInt32  vad_initial_thr:6;
        RBus_UInt32  vad_en_st_fine_coef:1;
        RBus_UInt32  vad_en_lt_fine_coef:1;
        RBus_UInt32  vad_bypass_square:1;
    };
}wov_stby_vad_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_syllable_thr:4;
        RBus_UInt32  vad_time_debounce_thr:10;
        RBus_UInt32  vad_st_fall_thr:6;
        RBus_UInt32  vad_st_energy_thr:6;
        RBus_UInt32  vad_st_energy_low_chk_thr:6;
    };
}wov_stby_vad_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_syllable_wait_thr:8;
        RBus_UInt32  vad_st_valid_thr:16;
        RBus_UInt32  vad_st_stable_thr:8;
    };
}wov_stby_vad_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_flag_hold:1;
        RBus_UInt32  vad_flag:1;
        RBus_UInt32  vad_in_sel:3;
        RBus_UInt32  vad_flag_sel:1;
        RBus_UInt32  vad_flag_clr:1;
        RBus_UInt32  vad_noise_pulse_thr:4;
        RBus_UInt32  vad_st_start_ref_thr:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  vad_initial_flag:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  vad_flag_sel_out:1;
        RBus_UInt32  res3:10;
    };
}wov_stby_vad_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_h0:29;
        RBus_UInt32  vad_biquad_1_wclr:1;
        RBus_UInt32  vad_biquad_0_wclr:1;
        RBus_UInt32  vad_bq_para_update:1;
    };
}wov_stby_vad_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_b1:29;
        RBus_UInt32  vad_biquad_1_en:1;
        RBus_UInt32  vad_biquad_0_en:1;
        RBus_UInt32  vad_bq_cd_en:1;
    };
}wov_stby_biq_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_b2:29;
        RBus_UInt32  vad_bq_dither_sel:2;
        RBus_UInt32  vad_bq_cd_flag:1;
    };
}wov_stby_biq_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_a1:29;
        RBus_UInt32  vad_bq_status:1;
        RBus_UInt32  vad_biquad_1_status:1;
        RBus_UInt32  vad_biquad_0_status:1;
    };
}wov_stby_biq_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_0_a2:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_1_h0:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_1_b1:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_1_b2:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_1_a1:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vad_biquad_1_a2:29;
        RBus_UInt32  res1:3;
    };
}wov_stby_biq_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_wov_func_en:1;
        RBus_UInt32  reg_wov_sram_rd_en:1;
        RBus_UInt32  reg_wov_sram_wr_en:1;
        RBus_UInt32  reg_wov_1ch_mode:1;
        RBus_UInt32  reg_wov_1ch_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_wov_sram_rd_ptr:13;
        RBus_UInt32  reg_force_ls_val:1;
        RBus_UInt32  reg_force_ls_en:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  reg_dmic_clk_src:1;
    };
}wov_wov_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wov_sram_wr_ptr:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  wov_sram_irq_wr_ptr:13;
        RBus_UInt32  res2:3;
    };
}wov_wov_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wov_sram_rd_ptr:13;
        RBus_UInt32  res1:19;
    };
}wov_wov_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_wov_ddr_start_addr:32;
    };
}wov_wov_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  reg_wov_ddr_lenth_limt:25;
        RBus_UInt32  wov_ddr_ov:1;
        RBus_UInt32  reg_wov_ddr_ring:1;
    };
}wov_wov_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  wov_ddr_wr_ptr:27;
    };
}wov_wov_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_wov_bist_mode:1;
        RBus_UInt32  reg_wov_drf_bist_mode:1;
        RBus_UInt32  reg_wov_drf_test_resume:1;
        RBus_UInt32  reg_wov_rme_0:1;
        RBus_UInt32  reg_wov_rm_0:4;
        RBus_UInt32  reg_wov_rme_1:1;
        RBus_UInt32  reg_wov_rm_1:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  wov_drf_start_pause:1;
        RBus_UInt32  wov_drf_bist_fail_1:1;
        RBus_UInt32  wov_drf_bist_fail_0:1;
        RBus_UInt32  wov_drf_bist_done:1;
        RBus_UInt32  wov_bist_fail_1:1;
        RBus_UInt32  wov_bist_fail_0:1;
        RBus_UInt32  wov_bist_done:1;
    };
}wov_wov_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  test_data_in:16;
        RBus_UInt32  vad_debug_en:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  test_wreq:1;
        RBus_UInt32  clk_vad_test:1;
    };
}wov_wov_vad_1_RBUS;




#endif 


#endif 
