

/************************************************************************
 *  Include files
 ************************************************************************/

#include <common.h>
#include <malloc.h>
#include <linux/ctype.h>
#include <panel.h>

#include <asm/arch/panel_config_parameter.h>

#include <asm/io.h>
#include <platform_lib/board/pcb_mgr.h>
#include <platform_lib/board/pcb.h>
#include <asm/arch/factorylib.h>
#include <asm/arch/factorylib_ro.h>
#include "cus_bootparam.h"
#include <wakeup.h>

//#include <asm/arch/panel/panel_setting.h>
extern int CusApi_env_readDynamicEnvFile(const char *pItemName, char *pParameter);


/************************************************************************
 *  Definitions
 ************************************************************************/
//#define PANEL_ADJUST_PRINT	printf
#define PANEL_ADJUST_PRINT
#ifdef CONFIG_CUSTOM_PQ_SELECT
#define MODEL_ENV_FILE_NAME		"tmp/factory/Model_Env.xml"
#endif

/************************************************************************
 *  Public variables
 ************************************************************************/
//struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;
//UINT8 LVDS_4_PORTS_INDEX;
/************************************************************************
 *  Static variables
 ************************************************************************/

/* Default settings of env. variables */



/************************************************************************
 *  Static function prototypes
 ************************************************************************/

/************************************************************************
 *  Implementation : Static functions
 ************************************************************************/
#ifdef CONFIG_CUSTOM_SN_PANEL
extern void env_panel_set_default(void);
extern uint env_panel_change_panel_bin_in_factory(char *panel_bin_path);
#ifdef CONFIG_CUSTOM_PQ_SELECT
extern bool CusApi_env_selectModelEnvFile(void);
extern bool CusApi_env_writeEnvFile(int textFile, char *pItemName, char *pParameter);
extern bool CusApi_env_get_PQ_file_name(char * pParameter);
extern bool CusApi_env_syncFactorySave(void);
extern bool CusApi_env_setFactorySave(void);
extern int CusApi_env_readXmlFile(const char* pFileName, const char *pItemName, char *pParameter, size_t parameterLen);
#ifdef Config_EXT4_Load_TvConfigs_TRUE
extern bool syncTvConfigWithModelEnv(void);
#endif
#endif

//extern bool CusApi_env_writePnCommonFile(char *pItemName, char *pParameter);

extern uint getSnStr(char *target_str, uint target_str_length,char *src_addr, uint length, char* pRetVal, char **pRetAddr);
extern int IsID_Match(void);
extern void setID_Match(int en);
extern int check_PQ_file_current_status(const char *cur_panelname);
#ifdef CONFIG_CUSTOM_PQ_SELECT
extern int check_PQ_extend_file_current_status(const char *cur_panelname);
#endif


extern uchar boot_ac_on;

#define PANEL_NUM 48

extern PANEL_CONFIG_PARAMETER_SN panel_setting[PANEL_NUM];
extern int rtk_plat_run_rescue_from_eMMC(unsigned int blk_no);
extern bool fsw_emmc_bootup;

void env_struct_arrange(UINT8 select,char *raw_ptr);


typedef enum {
	SOR_UNDEF,	// 0
	SOR_KEYPAD,	// 1
	SOR_WUT,		// 2
	SOR_IRDA,		// 3
	SOR_CEC,		// 4
	SOR_PPS,		// 5
	SOR_WOW,		// 6
	SOR_MHL,		// 7
	SOR_RTC,		// 8
    	SOR_WOV, 		// 9
    	SOR_MAX, //10
} wake_soruce; //from EMCU define


int PanelID_Out_list=0;

#define PANEL_LESS_STRING "paneless_index"
#define shutdown_disable "shutdown_disable"
#define CHASSIS_STRING    "chassis"
#define I2S_STRING	"pin_i2s_sclk"
#define SPDIF_STRING	"pin_spdif"
#define OEM_KEY1 "oem_key1"

bool EnPnUpdate=0;
int shutdown_disable_value = 0;

int env_getI2S(void){

	bool ret = false;
	int i2s_idx =0;
	char retStr[6]={0};

	if(fsw_emmc_bootup)
		return i2s_idx;
#ifdef CONFIG_CUSTOM_PQ_SELECT
	if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME, I2S_STRING,retStr, sizeof(retStr)))
		ret = true;
#endif
	if(ret==true)
		i2s_idx = simple_strtoul(retStr, NULL, 10);

	return i2s_idx;
}

int env_getSPDIF(void){

	bool ret = false;
	int spdif_idx =0;
	char retStr[6]={0};

	if(fsw_emmc_bootup)
		return spdif_idx;
#ifdef CONFIG_CUSTOM_PQ_SELECT
	if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,SPDIF_STRING,retStr,sizeof(retStr)))
		ret =true;
#endif
	if(ret==true)
		spdif_idx = simple_strtoul(retStr, NULL, 10);

	return spdif_idx;
}

int env_getPanelessIndex(void){

	bool ret = false;
	int panel_less_idx =0;
	char retStr[6]={0};

	if(fsw_emmc_bootup)
		return panel_less_idx;
#ifdef CONFIG_CUSTOM_PQ_SELECT
	if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,PANEL_LESS_STRING,retStr,sizeof(retStr)))
		ret =true;
#endif
	if(ret==true)
		panel_less_idx = simple_strtoul(retStr, NULL, 10);
	//printf("panel_less_idx =%d\n",panel_less_idx);
	return panel_less_idx;
}

void env_setRO_OemKey(void){
	char retStr[13]={0};
	char* oemKeyStr;

	if(fsw_emmc_bootup)
		return;
	if(0 == CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME, OEM_KEY1, retStr,sizeof(retStr)))
	{
		printf("oem_key1=%s\n", retStr);
	}
	else
	{
		printf("Failed to get %s!\n",OEM_KEY1);
	}

	if (((oemKeyStr = getenv("OEM_KEY1")) != NULL) && (strcmp(oemKeyStr, retStr) == 0))
		printf("the oemkey1 is the same as before\n");
	else
	{
		setenv("OEM_KEY1", retStr);
	}
}

bool env_getShutdownDisable(void){

	bool ret = false;
	char retStr[6]={0};

	if(fsw_emmc_bootup)
		return ret;
#ifdef CONFIG_CUSTOM_PQ_SELECT
	if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,shutdown_disable,retStr,sizeof(retStr)))
		ret = true;
#endif
	if(ret==true)
		shutdown_disable_value = simple_strtoul(retStr, NULL, 10);

	return ret;
}

int env_getChassis(void){

	bool ret = false;
	int chassis =0;
	char retStr[6]={0};

	if(fsw_emmc_bootup)
		return chassis;
#ifdef CONFIG_CUSTOM_PQ_SELECT
	if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,CHASSIS_STRING,retStr,sizeof(retStr)))
		ret = true;
#endif
	if(ret==true)
		chassis = simple_strtoul(retStr, NULL, 10);

	//printf("chassis =%d\n",chassis);
	return chassis;
#if 0
	int dst_length;
	char *dst_addr = NULL;
	char *retAddr = NULL;
	char retStr[30]={0};
	int i=0;

	if (factory_read(MODEL_ENV_FILE, &dst_addr, &dst_length)) {
			printf("can't find %s\n", MODEL_ENV_FILE);
	}
	else{
		printf("%s len=%d found\n", MODEL_ENV_FILE,dst_length);

		if (getSnStr("Chassis", strlen("Chassis"), dst_addr, (uint)dst_length, retStr, &retAddr) == 0) {
			printf("Chassis=%s\n", retStr);

			if(strcmp(retStr,"ChassisType0")==0){
				printf("ChassisType0= 0\n");
				return	0;
			}
			else{
				//printf("ChassisVariation\n");
				//printf("strlen =%d\n",strlen(retVal));

				int retLen =strlen(retStr);
				int minusLen =strlen("ChassisVariation");
				int diffLen=retLen-minusLen;
				char value[3]={0};
				for(i=0;i<diffLen;i++){
					//printf("%d %x\n",i,*(retVal+i));
					value[i]=*(retStr+minusLen+i);
				}

				int retVal =(int)strtoul(value, (char **)NULL, 10);
				return retVal;

			}
			//tuner_id = retVal;
		}
	}
	return 0;
#endif
}

void env_panel_set_parameter(int select)
{
	memset(&default_panel_parameter, 0, sizeof(PANEL_CONFIG_PARAMETER));

	if( select >= PANEL_NUM ) {
		printf("%s: Error. Invalid panel select: %d\n", __FUNCTION__, select);
		 select = PANEL_NUM - 1;
	}

	default_panel_parameter.iCONFIG_DISPLAY_PORT	=panel_setting[select].iCONFIG_DISPLAY_PORT ;
	default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS	=panel_setting[select].iCONFIG_DISPLAY_COLOR_BITS	;
	default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT	=panel_setting[select].iCONFIG_DISPLAY_EVEN_RSV1_BIT ;
	default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT	=panel_setting[select].iCONFIG_DISPLAY_ODD_RSV1_BIT ;
	default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE	=panel_setting[select].iCONFIG_DISPLAY_BITMAPPING_TABLE ;
	default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP 	=panel_setting[select].iCONFIG_DISPLAY_PORTAB_SWAP	;
	default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP	=panel_setting[select].iCONFIG_DISPLAY_RED_BLUE_SWAP ;
	default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP	=panel_setting[select].iCONFIG_DISPLAY_MSB_LSB_SWAP ;
	default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT	=panel_setting[select].iCONFIG_DISPLAY_SKEW_DATA_OUTPUT ;
	default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE	=panel_setting[select].iCONFIG_DISPLAY_OUTPUT_INVERSE	;
	default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL	=panel_setting[select].iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL ;
	default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL	=panel_setting[select].iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL	;
	default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3	=panel_setting[select].iCONFIG_DISPLAY_RATIO_4X3 ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX	=panel_setting[select].iCONFIG_DISPLAY_CLOCK_MAX ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN	=panel_setting[select].iCONFIG_DISPLAY_CLOCK_MIN ;
	default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE	=panel_setting[select].iCONFIG_DISPLAY_REFRESH_RATE ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL	=panel_setting[select].iCONFIG_DISPLAY_CLOCK_TYPICAL ;
	default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL	=panel_setting[select].iCONFIG_DISP_HORIZONTAL_TOTAL ;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL 	=panel_setting[select].iCONFIG_DISP_VERTICAL_TOTAL	;
	default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH	=panel_setting[select].iCONFIG_DISP_HSYNC_WIDTH ;
	default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH	=panel_setting[select].iCONFIG_DISP_VSYNC_LENGTH ;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS	=panel_setting[select].iCONFIG_DISP_DEN_STA_HPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS	=panel_setting[select].iCONFIG_DISP_DEN_END_HPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS	=panel_setting[select].iCONFIG_DISP_DEN_STA_VPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS	=panel_setting[select].iCONFIG_DISP_DEN_END_VPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS	=panel_setting[select].iCONFIG_DISP_ACT_STA_HPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS	=panel_setting[select].iCONFIG_DISP_ACT_END_HPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS	=panel_setting[select].iCONFIG_DISP_ACT_STA_VPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS	=panel_setting[select].iCONFIG_DISP_ACT_END_VPOS ;
	default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE 	=panel_setting[select].iCONFIG_DISP_HSYNC_LASTLINE	;
	default_panel_parameter.iCONFIG_DISP_DCLK_DELAY 	=panel_setting[select].iCONFIG_DISP_DCLK_DELAY	;
	default_panel_parameter._iCONFIG_DISP_ACT_STA_BIOS	=panel_setting[select]._iCONFIG_DISP_ACT_STA_BIOS	;
	default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER	=panel_setting[select].iCONFIG_DEFAULT_DPLL_M_DIVIDER	;
	default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER	=panel_setting[select].iCONFIG_DEFAULT_DPLL_N_DIVIDER	;
	default_panel_parameter.iPANEL_TO_LVDS_ON_ms	=panel_setting[select].iPANEL_TO_LVDS_ON_ms ;
	default_panel_parameter.iLVDS_TO_LIGHT_ON_ms	=panel_setting[select].iLVDS_TO_LIGHT_ON_ms ;
	default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms	=panel_setting[select].iLIGHT_TO_LDVS_OFF_ms ;
	default_panel_parameter.iLVDS_TO_PANEL_OFF_ms	=panel_setting[select].iLVDS_TO_PANEL_OFF_ms ;
	default_panel_parameter.iPANEL_OFF_TO_ON_ms 	=panel_setting[select].iPANEL_OFF_TO_ON_ms	;
	default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ	=panel_setting[select].iCONFIG_BACKLIGHT_PWM_FREQ	;
	default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY	=panel_setting[select].iCONFIG_BACKLIGHT_PWM_DUTY	;
	default_panel_parameter.iFIX_LAST_LINE_ENABLE	=panel_setting[select].iFIX_LAST_LINE_ENABLE ;
	default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE	=panel_setting[select].iFIX_LAST_LINE_4X_ENABLE ;
	default_panel_parameter.iVFLIP	=panel_setting[select].iVFLIP	;
	default_panel_parameter.iPICASSO_CONTROL_ON 	=panel_setting[select].iPICASSO_CONTROL_ON	;
	default_panel_parameter.i3D_DISPLAY_SUPPORT 	=panel_setting[select].i3D_DISPLAY_SUPPORT	;
	default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT	=panel_setting[select].i3D_LINE_ALTERNATIVE_SUPPORT ;
	default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP	=panel_setting[select].i3D_PR_OUTPUT_LR_SWAP ;
	default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON	=panel_setting[select].i3D_SG_OUTPUT_120HZ_ON	;
	default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON	=panel_setting[select].i3D_SG_24HZ_OUTPUT_FHD_ON ;
	default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE	=panel_setting[select].iSCALER_2D_3D_CVT_HWSHIFT_ENABLE ;
	default_panel_parameter.iCONFIG_SFG_SEG_NUM 	=panel_setting[select].iCONFIG_SFG_SEG_NUM	;
	default_panel_parameter.iCONFIG_SFG_PORT_NUM	=panel_setting[select].iCONFIG_SFG_PORT_NUM ;
	default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1	=panel_setting[select].iCONFIG_DISPLAY_PORT_CONFIG1 ;
	default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2	=panel_setting[select].iCONFIG_DISPLAY_PORT_CONFIG2 ;


	default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX	=panel_setting[select].iCONFIG_LVDS_4_PORTS_INDEX	;

	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN	=panel_setting[select].iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN ;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX	=panel_setting[select].iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX ;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN	=panel_setting[select].iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN ;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX	=panel_setting[select].iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX ;
	default_panel_parameter.iCONFIG_LVDS_PN_SWAP	=panel_setting[select].iCONFIG_LVDS_PN_SWAP ;
	default_panel_parameter.iCONFIG_LVDS_MIRROR 	=panel_setting[select].iCONFIG_LVDS_MIRROR	;
	default_panel_parameter.iCONFIG_PANEL_TYPE	=panel_setting[select].iCONFIG_PANEL_TYPE	;
	default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX	=panel_setting[select].iCONFIG_PANEL_CUSTOM_INDEX	;
	default_panel_parameter.iCONFIG_SR_MODE 	=panel_setting[select].iCONFIG_SR_MODE	;
	default_panel_parameter.iCONFIG_SR_PIXEL_MODE	=panel_setting[select].iCONFIG_SR_PIXEL_MODE ;
	default_panel_parameter.i3D_DISPLAY_TIMING	=panel_setting[select].i3D_DISPLAY_TIMING	;
	default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID	=panel_setting[select].iCONFIG_CUSTOMER_PANEL_ID ;

	default_panel_parameter.iPANEL_WIDTH_MM	=panel_setting[select].iPANEL_WIDTH_MM ;
	default_panel_parameter.iPANEL_HEIGHT_MM	=panel_setting[select].iPANEL_HEIGHT_MM ;
	default_panel_parameter.iBACKLIGHT_PWM_48HZ_FREQ	=panel_setting[select].iBACKLIGHT_PWM_48HZ_FREQ ;
	default_panel_parameter.iBACKLIGHT_PWM_50HZ_FREQ	=panel_setting[select].iBACKLIGHT_PWM_50HZ_FREQ ;
	default_panel_parameter.iBACKLIGHT_PWM_60HZ_FREQ	=panel_setting[select].iBACKLIGHT_PWM_60HZ_FREQ ;

	default_panel_parameter.iPixelClk60Hz	=panel_setting[select].iPixelClk60Hz ;
	default_panel_parameter.iHTotal60Hz		=panel_setting[select].iHTotal60Hz ;
	default_panel_parameter.iVTotal60Hz		=panel_setting[select].iVTotal60Hz ;
	default_panel_parameter.iHSyncWidth_60Hz	=panel_setting[select].iHSyncWidth_60Hz ;
	default_panel_parameter.iVSyncWidth_60Hz	=panel_setting[select].iVSyncWidth_60Hz ;
	default_panel_parameter.iHFrontPorch_60Hz	=panel_setting[select].iHFrontPorch_60Hz ;
	default_panel_parameter.iHbackPorch_60Hz	=panel_setting[select].iHbackPorch_60Hz ;
	default_panel_parameter.iVFrontPorch_60Hz	=panel_setting[select].iVFrontPorch_60Hz ;
	default_panel_parameter.iVbackPorch_60Hz	=panel_setting[select].iVbackPorch_60Hz ;

	default_panel_parameter.iPixelClk50Hz	=panel_setting[select].iPixelClk50Hz ;
	default_panel_parameter.iHTotal50Hz		=panel_setting[select].iHTotal50Hz ;
	default_panel_parameter.iVTotal50Hz		=panel_setting[select].iVTotal50Hz ;
	default_panel_parameter.iHSyncWidth_50Hz	=panel_setting[select].iHSyncWidth_50Hz ;
	default_panel_parameter.iVSyncWidth_50Hz	=panel_setting[select].iVSyncWidth_50Hz ;
	default_panel_parameter.iHFrontPorch_50Hz	=panel_setting[select].iHFrontPorch_50Hz ;
	default_panel_parameter.iHbackPorch_50Hz	=panel_setting[select].iHbackPorch_50Hz ;
	default_panel_parameter.iVFrontPorch_50Hz	=panel_setting[select].iVFrontPorch_50Hz ;
	default_panel_parameter.iVbackPorch_50Hz	=panel_setting[select].iVbackPorch_50Hz ;

	default_panel_parameter.iPixelClk48Hz	=panel_setting[select].iPixelClk48Hz ;
	default_panel_parameter.iHTotal48Hz		=panel_setting[select].iHTotal48Hz ;
	default_panel_parameter.iVTotal48Hz		=panel_setting[select].iVTotal48Hz ;
	default_panel_parameter.iHSyncWidth_48Hz	=panel_setting[select].iHSyncWidth_48Hz ;
	default_panel_parameter.iVSyncWidth_48Hz	=panel_setting[select].iVSyncWidth_48Hz ;
	default_panel_parameter.iHFrontPorch_48Hz	=panel_setting[select].iHFrontPorch_48Hz ;
	default_panel_parameter.iHbackPorch_48Hz	=panel_setting[select].iHbackPorch_48Hz ;
	default_panel_parameter.iVFrontPorch_48Hz	=panel_setting[select].iVFrontPorch_48Hz ;
	default_panel_parameter.iVbackPorch_48Hz	=panel_setting[select].iVbackPorch_48Hz ;

	strcpy(default_panel_parameter.sPanelName, panel_setting[select].sPanelName);


}


uchar env_setup_sn_panel(uchar *panel_filename)
{
	char *raw_ptr = NULL;
	unsigned int rc = 1;	/* 0:fail 1:success */
	uint parameter_len = 0;
	int file_len = 0;
	int select = 0;
	#define PN_BLOCK 611

	#define HEADER_SIZE 0x20
	//char Panel_Sn[PN_BLOCK]={0};
	//SN_PANEL_TEST_INFO tmp;

	//memcpy(tmp, 0, sizeof(SN_PANEL_TEST_INFO));
	//if(tmp==NULL)
	//	;

	parameter_len = sizeof(default_panel_parameter);


	//printf("--parameter_len =%d:%d--\n",parameter_len,parameter_len_test);
	//printf("--panel_filename =%s--\n",panel_filename);

	if(parameter_len<0)
		;
	if (panel_filename == NULL) // set default value
	{
		printf("\n\033[1;41<<<<<<<<<<panel_filename NULL>>>>>>>>>>\033[m");
		env_panel_set_default();
        printf("Panel: %s\n", default_panel_parameter.sPanelName);
		rc=0;
	}
	else
	{
		//if ((factory_read((char *)panel_filename, &raw_ptr, &file_len) == 0) && file_len == parameter_len) {
		if ((factory_ro_read((char *)panel_filename, &raw_ptr, &file_len) == 0)) {

			printf("--file_len=%d:0x%x--\n",file_len,file_len);

			//cp
			const char *panelselect = getenv("panel_select");
			if( panelselect != NULL)
			{
				select = simple_strtoul(panelselect, NULL, 10);
			}

			printf("--panel_select =%d--\n",select);
			raw_ptr=raw_ptr+HEADER_SIZE+select*PN_BLOCK;
			//memcpy(Panel_Sn, raw_ptr, sizeof(Panel_Sn));
			//printf("--Panel_Sn len =%d:%d--\n",sizeof(Panel_Sn),sizeof(char)*611);

			//printf("--SN_PANEL_TEST_INFO len =%d:%d--\n",sizeof(SN_PANEL_TEST_INFO),sizeof(tmp));
			//snInfo

			//memcpy(panel_setting[select].snInfo, raw_ptr, sizeof(SN_PANEL_INFO));

			env_panel_set_parameter(select);
			env_struct_arrange(select,raw_ptr);
		}
		else{
			rc=0;
			printf("-- %s is not exist--\n", panel_filename);
		}
	}
	return rc;
}






#include <common.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <asm/arch/bootparam.h>

extern int boot_power_on_mode;



typedef struct
{
	char string[14];
	int value;
}Pn_String;

Pn_String PnCommon[]=
{
	{"CURRENT_MAX", 0 },
	{"CURRENT_MIN", 0 },
	{"BL_PWM_MAX", 0 },
	{"BL_PWM_MIN", 0 },
	{"BL_CUR_FREQ", 0 },
	{"BL_PWM_FREQ", 0 },
	{"BL_WAIT_LOGO", 0 },
	{"BL_PSL_DIFF", 0 },

};
#define SIZEOF_PN_COMMON (sizeof(PnCommon)/sizeof(PnCommon[0]))

Pn_String PiQ_Sect_1[]=
{
	{"X1_31", 0 },
	{"X1_23", 0 },
	{"X1_15", 0 },
	{"X1_7", 0 },
	{"X2_31", 0 },
	{"X2_23", 0 },
	{"X2_15", 0 },
	{"X2_7", 0 },
	{"X3_31", 0 },
	{"X3_23", 0 },
	{"X3_15", 0 },
	{"X3_7", 0 },
	{"X4_31", 0 },
	{"X4_23", 0 },
	{"X4_15", 0 },
	{"X4_7", 0 },
	{"X5_31", 0 },
	{"X5_23", 0 },
	{"X5_15", 0 },
	{"X5_7", 0 },
	{"X6_31", 0 },
	{"X6_23", 0 },
	{"X6_15", 0 },
	{"X6_7", 0 },
	{"X7_31", 0 },
	{"X7_23", 0 },
	{"X7_15", 0 },
	{"X7_7", 0 },
	{"X8_31", 0 },
	{"X8_23", 0 },
	{"X8_15", 0 },
	{"X8_7", 0 },
	{"X9_31", 0 },
	{"X9_23", 0 },
	{"X9_15", 0 },
	{"X9_7", 0 },
	{"X10_31", 0 },
	{"X10_23", 0 },
	{"X10_15", 0 },
	{"X10_7", 0 },
	{"X11_31", 0 },
	{"X11_23", 0 },
	{"X11_15", 0 },
	{"X11_7", 0 },
	{"X12_31", 0 },
	{"X12_23", 0 },
	{"X12_15", 0 },
	{"X12_7", 0 },
	{"X13_31", 0 },
	{"X13_23", 0 },
	{"X13_15", 0 },
	{"X13_7", 0 },
	{"X14_31", 0 },
	{"X14_23", 0 },
	{"X14_15", 0 },
	{"X14_7", 0 },
	{"X15_31", 0 },
	{"X15_23", 0 },
	{"X15_15", 0 },
	{"X15_7", 0 },
	{"X16_31", 0 },
	{"X16_23", 0 },
	{"X16_15", 0 },
	{"X16_7", 0 },
	{"X17_31", 0 },
	{"X17_23", 0 },
	{"X17_15", 0 },
	{"X17_7", 0 },

};
#define SIZEOF_PIQ_SECT_1 (sizeof(PiQ_Sect_1)/sizeof(PiQ_Sect_1[0]))

Pn_String PiQ_Sect_2[]=
{
	{"X29_31", 0 },
	{"X29_23", 0 },
	{"X29_15", 0 },
	{"X29_7", 0 },
	{"X30_31", 0 },
	{"X30_23", 0 },
	{"X30_15", 0 },
	{"X30_7", 0 },
	{"X31_31", 0 },
	{"X31_23", 0 },
	{"X31_15", 0 },
	{"X31_7", 0 },
	{"X32_31", 0 },
	{"X32_23", 0 },
	{"X32_15", 0 },
	{"X32_7", 0 },
	{"X33_31", 0 },
	{"X33_23", 0 },
	{"X33_15", 0 },
	{"X33_7", 0 },
	{"X34_31", 0 },
	{"X34_23", 0 },
	{"X34_15", 0 },
	{"X34_7", 0 },
	{"X35_31", 0 },
	{"X35_23", 0 },
	{"X35_15", 0 },
	{"X35_7", 0 },
	{"X36_31", 0 },
	{"X36_23", 0 },
	{"X36_15", 0 },
	{"X36_7", 0 },
	{"X37_31", 0 },
	{"X37_23", 0 },
	{"X37_15", 0 },
	{"X37_7", 0 },
	{"X38_31", 0 },
	{"X38_23", 0 },
	{"X38_15", 0 },
	{"X38_7", 0 },
	{"X39_31", 0 },
	{"X39_23", 0 },
	{"X39_15", 0 },
	{"X39_7", 0 },
	{"X40_31", 0 },
	{"X40_23", 0 },
	{"X40_15", 0 },
	{"X40_7", 0 },
	{"X41_31", 0 },
	{"X41_23", 0 },
	{"X41_15", 0 },
	{"X41_7", 0 },
	{"X42_31", 0 },
	{"X42_23", 0 },
	{"X42_15", 0 },
	{"X42_7", 0 },
	{"X43_31", 0 },
	{"X43_23", 0 },
	{"X43_15", 0 },
	{"X43_7", 0 },
	{"X44_31", 0 },
	{"X44_23", 0 },
	{"X44_15", 0 },
	{"X44_7", 0 },
	{"X45_31", 0 },
	{"X45_23", 0 },
	{"X45_15", 0 },
	{"X45_7", 0 },
	{"X46_31", 0 },
	{"X46_23", 0 },
	{"X46_15", 0 },
	{"X46_7", 0 },
};
#define SIZEOF_PiQ_SECT_2 (sizeof(PiQ_Sect_2)/sizeof(PiQ_Sect_2[0]))

Pn_String OutputTiming[]=
{
	{"PXL_CLK_60", 0 },
	{"HTOTAL_60", 0 },
	{"VTOTAL_60", 0 },
	{"HSYNC_W_60", 0 },
	{"VSYNC_W_60", 0 },
	{"HFP_60", 0 },
	{"HBP_60", 0 },
	{"VFP_60", 0 },
	{"VBP_60", 0 },
	{"PXL_CLK_50", 0 },
	{"HTOTAL_50", 0 },
	{"VTOTAL_50", 0 },
	{"HSYNC_W_50", 0 },
	{"VSYNC_W_50", 0 },
	{"HFP_50", 0 },
	{"HBP_50", 0 },
	{"VFP_50", 0 },
	{"VBP_50", 0 },
	{"PXL_CLK_48", 0 },
	{"HTOTAL_48", 0 },
	{"VTOTAL_48", 0 },
	{"HSYNC_W_48", 0 },
	{"VSYNC_W_48", 0 },
	{"HFP_48", 0 },
	{"HBP_48", 0 },
	{"VFP_48", 0 },
	{"VBP_48", 0 },

};

#define SIZEOF_OUTPUT_TIMING (sizeof(OutputTiming)/sizeof(OutputTiming[0]))


void updatePnCommon(void)
{
	if(EnPnUpdate==1){
		EnPnUpdate=0;
	}else {
		return;
	}

	printf("updatePnCommon start\n");
	//printf(" %s =%d\n",PnCommon[0].string,PnCommon[0].value);

	PnCommon[0].value	=	default_panel_parameter.snInfo[0].CURRENT_MAX;
	PnCommon[1].value	=	default_panel_parameter.snInfo[0].CURRENT_MIN;
	PnCommon[2].value	=	default_panel_parameter.snInfo[0].BL_PWM_MAX;
	PnCommon[3].value	=	default_panel_parameter.snInfo[0].BL_PWM_MIN;
	PnCommon[4].value	=	default_panel_parameter.snInfo[0].BL_CUR_FREQ;
	PnCommon[5].value	=	default_panel_parameter.snInfo[0].BL_PWM_FREQ;
	PnCommon[6].value	=	default_panel_parameter.snInfo[0].BL_WAIT_LOGO;
	PnCommon[7].value	=	default_panel_parameter.snInfo[0].BL_PSL_DIFF;

	PiQ_Sect_1[0].value=default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24;
	PiQ_Sect_1[1].value=default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16;
	PiQ_Sect_1[2].value=default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8;
	PiQ_Sect_1[3].value=default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0;
	PiQ_Sect_1[4].value=default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24;
	PiQ_Sect_1[5].value=default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16;
	PiQ_Sect_1[6].value=default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8;
	PiQ_Sect_1[7].value=default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0;
	PiQ_Sect_1[8].value=default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24;
	PiQ_Sect_1[9].value=default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16;
	PiQ_Sect_1[10].value=default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8;
	PiQ_Sect_1[11].value=default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0;
	PiQ_Sect_1[12].value=default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24;
	PiQ_Sect_1[13].value=default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16;
	PiQ_Sect_1[14].value=default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8;
	PiQ_Sect_1[15].value=default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0;
	PiQ_Sect_1[16].value=default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24;
	PiQ_Sect_1[17].value=default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16;
	PiQ_Sect_1[18].value=default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8;
	PiQ_Sect_1[19].value=default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0;
	PiQ_Sect_1[20].value=default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24;
	PiQ_Sect_1[21].value=default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16;
	PiQ_Sect_1[22].value=default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8;
	PiQ_Sect_1[23].value=default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0;
	PiQ_Sect_1[24].value=default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24;
	PiQ_Sect_1[25].value=default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16;
	PiQ_Sect_1[26].value=default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8;
	PiQ_Sect_1[27].value=default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0;
	PiQ_Sect_1[28].value=default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24;
	PiQ_Sect_1[29].value=default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16;
	PiQ_Sect_1[30].value=default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8;
	PiQ_Sect_1[31].value=default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0;
	PiQ_Sect_1[32].value=default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24;
	PiQ_Sect_1[33].value=default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16;
	PiQ_Sect_1[34].value=default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8;
	PiQ_Sect_1[35].value=default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0;
	PiQ_Sect_1[36].value=default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24;
	PiQ_Sect_1[37].value=default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16;
	PiQ_Sect_1[38].value=default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8;
	PiQ_Sect_1[39].value=default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0;
	PiQ_Sect_1[40].value=default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24;
	PiQ_Sect_1[41].value=default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16;
	PiQ_Sect_1[42].value=default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8;
	PiQ_Sect_1[43].value=default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0;
	PiQ_Sect_1[44].value=default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24;
	PiQ_Sect_1[45].value=default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16;
	PiQ_Sect_1[46].value=default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8;
	PiQ_Sect_1[47].value=default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0;
	PiQ_Sect_1[48].value=default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24;
	PiQ_Sect_1[49].value=default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16;
	PiQ_Sect_1[50].value=default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8;
	PiQ_Sect_1[51].value=default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0;
	PiQ_Sect_1[52].value=default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24;
	PiQ_Sect_1[53].value=default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16;
	PiQ_Sect_1[54].value=default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8;
	PiQ_Sect_1[55].value=default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0;
	PiQ_Sect_1[56].value=default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24;
	PiQ_Sect_1[57].value=default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16;
	PiQ_Sect_1[58].value=default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8;
	PiQ_Sect_1[59].value=default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0;
	PiQ_Sect_1[60].value=default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24;
	PiQ_Sect_1[61].value=default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16;
	PiQ_Sect_1[62].value=default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8;
	PiQ_Sect_1[63].value=default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0;
	PiQ_Sect_1[64].value=default_panel_parameter.snInfo[0].External_device_control_1_X17_31_24;
	PiQ_Sect_1[65].value=default_panel_parameter.snInfo[0].External_device_control_1_X17_23_16;
	PiQ_Sect_1[66].value=default_panel_parameter.snInfo[0].External_device_control_1_X17_15_8;
	PiQ_Sect_1[67].value=default_panel_parameter.snInfo[0].External_device_control_1_X17_7_0;


	PiQ_Sect_2[0].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[0];
	PiQ_Sect_2[1].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[1];
	PiQ_Sect_2[2].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[2];
	PiQ_Sect_2[3].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[3];
	PiQ_Sect_2[4].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[4];
	PiQ_Sect_2[5].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[5];
	PiQ_Sect_2[6].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[6];
	PiQ_Sect_2[7].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[7];
	PiQ_Sect_2[8].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[8];
	PiQ_Sect_2[9].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[9];
	PiQ_Sect_2[10].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[10];
	PiQ_Sect_2[11].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[11];
	PiQ_Sect_2[12].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[12];
	PiQ_Sect_2[13].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[13];
	PiQ_Sect_2[14].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[14];
	PiQ_Sect_2[15].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[15];
	PiQ_Sect_2[16].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[16];
	PiQ_Sect_2[17].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[17];
	PiQ_Sect_2[18].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[18];
	PiQ_Sect_2[19].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[19];
	PiQ_Sect_2[20].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[20];
	PiQ_Sect_2[21].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[21];
	PiQ_Sect_2[22].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[22];
	PiQ_Sect_2[23].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[23];
	PiQ_Sect_2[24].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[24];
	PiQ_Sect_2[25].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[25];
	PiQ_Sect_2[26].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[26];
	PiQ_Sect_2[27].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[27];
	PiQ_Sect_2[28].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[28];
	PiQ_Sect_2[29].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[29];
	PiQ_Sect_2[30].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[30];
	PiQ_Sect_2[31].value=default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[31];
	PiQ_Sect_2[32].value=default_panel_parameter.snInfo[0].Common_control[0];
	PiQ_Sect_2[33].value=default_panel_parameter.snInfo[0].Common_control[1];
	PiQ_Sect_2[34].value=default_panel_parameter.snInfo[0].Common_control[2];
	PiQ_Sect_2[35].value=default_panel_parameter.snInfo[0].Common_control[3];
	PiQ_Sect_2[36].value=default_panel_parameter.snInfo[0].Common_control[4];
	PiQ_Sect_2[37].value=default_panel_parameter.snInfo[0].Common_control[5];
	PiQ_Sect_2[38].value=default_panel_parameter.snInfo[0].Common_control[6];
	PiQ_Sect_2[39].value=default_panel_parameter.snInfo[0].Common_control[7];
	PiQ_Sect_2[40].value=default_panel_parameter.snInfo[0].Common_control[8];
	PiQ_Sect_2[41].value=default_panel_parameter.snInfo[0].Common_control[9];
	PiQ_Sect_2[42].value=default_panel_parameter.snInfo[0].Common_control[10];
	PiQ_Sect_2[43].value=default_panel_parameter.snInfo[0].Common_control[11];
	PiQ_Sect_2[44].value=default_panel_parameter.snInfo[0].Common_control[12];
	PiQ_Sect_2[45].value=default_panel_parameter.snInfo[0].Common_control[13];
	PiQ_Sect_2[46].value=default_panel_parameter.snInfo[0].Common_control[14];
	PiQ_Sect_2[47].value=default_panel_parameter.snInfo[0].Common_control[15];
	PiQ_Sect_2[48].value=default_panel_parameter.snInfo[0].Common_control[16];
	PiQ_Sect_2[49].value=default_panel_parameter.snInfo[0].Common_control[17];
	PiQ_Sect_2[50].value=default_panel_parameter.snInfo[0].Common_control[18];
	PiQ_Sect_2[51].value=default_panel_parameter.snInfo[0].Common_control[19];
	PiQ_Sect_2[52].value=default_panel_parameter.snInfo[0].Common_control[20];
	PiQ_Sect_2[53].value=default_panel_parameter.snInfo[0].Common_control[21];
	PiQ_Sect_2[54].value=default_panel_parameter.snInfo[0].Common_control[22];
	PiQ_Sect_2[55].value=default_panel_parameter.snInfo[0].Common_control[23];
	PiQ_Sect_2[56].value=default_panel_parameter.snInfo[0].Common_control[24];
	PiQ_Sect_2[57].value=default_panel_parameter.snInfo[0].Common_control[25];
	PiQ_Sect_2[58].value=default_panel_parameter.snInfo[0].Common_control[26];
	PiQ_Sect_2[59].value=default_panel_parameter.snInfo[0].Common_control[27];
	PiQ_Sect_2[60].value=default_panel_parameter.snInfo[0].Common_control[28];
	PiQ_Sect_2[61].value=default_panel_parameter.snInfo[0].Common_control[29];
	PiQ_Sect_2[62].value=default_panel_parameter.snInfo[0].Common_control[30];
	PiQ_Sect_2[63].value=default_panel_parameter.snInfo[0].Common_control[31];
	PiQ_Sect_2[64].value=default_panel_parameter.snInfo[0].Common_control[32];
	PiQ_Sect_2[65].value=default_panel_parameter.snInfo[0].Common_control[33];
	PiQ_Sect_2[66].value=default_panel_parameter.snInfo[0].Common_control[34];
	PiQ_Sect_2[67].value=default_panel_parameter.snInfo[0].Common_control[35];
	PiQ_Sect_2[68].value=default_panel_parameter.snInfo[0].Common_control[36];
	PiQ_Sect_2[69].value=default_panel_parameter.snInfo[0].Common_control[37];
	PiQ_Sect_2[70].value=default_panel_parameter.snInfo[0].Common_control[38];
	PiQ_Sect_2[71].value=default_panel_parameter.snInfo[0].Common_control[39];


	OutputTiming[0].value =	default_panel_parameter.snInfo[0].PixelClk60Hz;
	OutputTiming[1].value =	default_panel_parameter.snInfo[0].HTotal60Hz;
	OutputTiming[2].value =	default_panel_parameter.snInfo[0].VTotal60Hz;
	OutputTiming[3].value =	default_panel_parameter.snInfo[0].HSyncWidth_60Hz;
	OutputTiming[4].value =	default_panel_parameter.snInfo[0].VSyncWidth_60Hz;
	OutputTiming[5].value =	default_panel_parameter.snInfo[0].HFrontPorch_60Hz;
	OutputTiming[6].value =	default_panel_parameter.snInfo[0].HbackPorch_60Hz;
	OutputTiming[7].value =	default_panel_parameter.snInfo[0].VFrontPorch_60Hz;
	OutputTiming[8].value =	default_panel_parameter.snInfo[0].VbackPorch_60Hz;
	OutputTiming[9].value =	default_panel_parameter.snInfo[0].PixelClk50Hz;
	OutputTiming[10].value =	default_panel_parameter.snInfo[0].HTotal50Hz;
	OutputTiming[11].value =	default_panel_parameter.snInfo[0].VTotal50Hz;
	OutputTiming[12].value =	default_panel_parameter.snInfo[0].HSyncWidth_50Hz;
	OutputTiming[13].value =	default_panel_parameter.snInfo[0].VSyncWidth_50Hz;
	OutputTiming[14].value =	default_panel_parameter.snInfo[0].HFrontPorch_50Hz;
	OutputTiming[15].value =	default_panel_parameter.snInfo[0].HbackPorch_50Hz;
	OutputTiming[16].value =	default_panel_parameter.snInfo[0].VFrontPorch_50Hz;
	OutputTiming[17].value =	default_panel_parameter.snInfo[0].VbackPorch_50Hz;
	OutputTiming[18].value =	default_panel_parameter.snInfo[0].PixelClk48Hz;
	OutputTiming[19].value =	default_panel_parameter.snInfo[0].HTotal48Hz;
	OutputTiming[20].value =	default_panel_parameter.snInfo[0].VTotal48Hz;
	OutputTiming[21].value =	default_panel_parameter.snInfo[0].HSyncWidth_48Hz;
	OutputTiming[22].value =	default_panel_parameter.snInfo[0].VSyncWidth_48Hz;
	OutputTiming[23].value =	default_panel_parameter.snInfo[0].HFrontPorch_48Hz;
	OutputTiming[24].value =	default_panel_parameter.snInfo[0].HbackPorch_48Hz;
	OutputTiming[25].value =	default_panel_parameter.snInfo[0].VFrontPorch_48Hz;
	OutputTiming[26].value =	default_panel_parameter.snInfo[0].VbackPorch_48Hz;

	int i=0;
	char value2_s[9]={0};
	UINT32 val;
	for(i=0;i<SIZEOF_PN_COMMON;i++){

		val = PnCommon[i].value;
		sprintf(value2_s, "%d",val);
		CusApi_env_writeEnvFile(2,PnCommon[i].string,value2_s);
		mdelay(3);
	}

	for(i=0;i<SIZEOF_PIQ_SECT_1;i++){

		val = PiQ_Sect_1[i].value;
		sprintf(value2_s, "%d",val);
		CusApi_env_writeEnvFile(3,PiQ_Sect_1[i].string,value2_s);
		mdelay(3);
	}

	for(i=0;i<SIZEOF_PiQ_SECT_2;i++){

		val = PiQ_Sect_2[i].value;
		sprintf(value2_s, "%d",val);
		CusApi_env_writeEnvFile(4,PiQ_Sect_2[i].string,value2_s);
		mdelay(3);
	}

	for(i=0;i<SIZEOF_OUTPUT_TIMING;i++){

		val = OutputTiming[i].value;
		sprintf(value2_s, "%d",val);
		CusApi_env_writeEnvFile(5,OutputTiming[i].string,value2_s);
		mdelay(3);
	}

	factory_save();

	#if 0//verify
	char value2_s[5]={0};
	UINT16 val = default_panel_parameter.snInfo[0].CURRENT_MAX;
	sprintf(value2_s, "%d",val);
	// 0: Model_Env.txt
    // 1: Dynamic_Env.txt
    // 2: PnCommon.txt
	CusApi_env_writeEnvFile(2,"CURRENT_MAX",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].CURRENT_MIN);
	CusApi_env_writeEnvFile(2,"CURRENT_MIN",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PWM_MAX);
	CusApi_env_writeEnvFile(2,"BL_PWM_MAX",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PWM_MIN);
	CusApi_env_writeEnvFile(2,"BL_PWM_MIN",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_CUR_FREQ);
	CusApi_env_writeEnvFile(2,"BL_CUR_FREQ",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PWM_FREQ);
	CusApi_env_writeEnvFile(2,"BL_PWM_FREQ",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_WAIT_LOGO);
	CusApi_env_writeEnvFile(2,"BL_WAIT_LOGO",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PSO_TH3);
	//CusApi_env_writeEnvFile(2,"BL_PSO_TH3",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PSL_DIFF);
	CusApi_env_writeEnvFile(2,"BL_PSL_DIFF",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_PSH_GAIN);
	//CusApi_env_writeEnvFile(2,"BL_PSH_GAIN",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_IP_FREQ);
	//CusApi_env_writeEnvFile(2,"BL_IP_FREQ",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_DIMM_PWM_FREQ);
	//CusApi_env_writeEnvFile(2,"BL_DIMM_PWM_FREQ",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_CUR_MIN);
	//CusApi_env_writeEnvFile(2,"BL_CUR_MIN",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_CUR_MAX);
	//CusApi_env_writeEnvFile(2,"BL_CUR_MAX",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_DIMM_PWM_MIN);
	//CusApi_env_writeEnvFile(2,"BL_DIMM_PWM_MIN",value2_s);
	//sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].BL_DIMM_PWM_MAX);
	//CusApi_env_writeEnvFile(2,"BL_DIMM_PWM_MAX",value2_s);

	mdelay(100);
	//BE IC
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24);
	CusApi_env_writeEnvFile(2,"X1_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16);
	CusApi_env_writeEnvFile(2,"X1_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8);
	CusApi_env_writeEnvFile(2,"X1_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0);
	CusApi_env_writeEnvFile(2,"X1_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24);
	CusApi_env_writeEnvFile(2,"X2_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16);
	CusApi_env_writeEnvFile(2,"X2_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8);
	CusApi_env_writeEnvFile(2,"X2_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0);
	CusApi_env_writeEnvFile(2,"X2_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24);
	CusApi_env_writeEnvFile(2,"X3_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16);
	CusApi_env_writeEnvFile(2,"X3_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8);
	CusApi_env_writeEnvFile(2,"X3_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0);
	CusApi_env_writeEnvFile(2,"X3_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24);
	CusApi_env_writeEnvFile(2,"X4_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16);
	CusApi_env_writeEnvFile(2,"X4_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8);
	CusApi_env_writeEnvFile(2,"X4_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0);
	CusApi_env_writeEnvFile(2,"X4_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24);
	CusApi_env_writeEnvFile(2,"X5_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16);
	CusApi_env_writeEnvFile(2,"X5_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8);
	CusApi_env_writeEnvFile(2,"X5_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0);
	CusApi_env_writeEnvFile(2,"X5_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24);
	CusApi_env_writeEnvFile(2,"X6_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16);
	CusApi_env_writeEnvFile(2,"X6_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8);
	CusApi_env_writeEnvFile(2,"X6_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0);
	CusApi_env_writeEnvFile(2,"X6_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24);
	CusApi_env_writeEnvFile(2,"X7_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16);
	CusApi_env_writeEnvFile(2,"X7_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8);
	CusApi_env_writeEnvFile(2,"X7_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0);
	CusApi_env_writeEnvFile(2,"X7_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24);
	CusApi_env_writeEnvFile(2,"X8_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16);
	CusApi_env_writeEnvFile(2,"X8_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8);
	CusApi_env_writeEnvFile(2,"X8_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0);
	CusApi_env_writeEnvFile(2,"X8_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24);
	CusApi_env_writeEnvFile(2,"X9_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16);
	CusApi_env_writeEnvFile(2,"X9_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8);
	CusApi_env_writeEnvFile(2,"X9_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0);
	CusApi_env_writeEnvFile(2,"X9_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24);
	CusApi_env_writeEnvFile(2,"X10_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16);
	CusApi_env_writeEnvFile(2,"X10_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8);
	CusApi_env_writeEnvFile(2,"X10_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0);
	CusApi_env_writeEnvFile(2,"X10_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24);
	CusApi_env_writeEnvFile(2,"X11_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16);
	CusApi_env_writeEnvFile(2,"X11_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8);
	CusApi_env_writeEnvFile(2,"X11_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0);
	CusApi_env_writeEnvFile(2,"X11_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24);
	CusApi_env_writeEnvFile(2,"X12_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16);
	CusApi_env_writeEnvFile(2,"X12_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8);
	CusApi_env_writeEnvFile(2,"X12_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0);
	CusApi_env_writeEnvFile(2,"X12_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24);
	CusApi_env_writeEnvFile(2,"X13_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16);
	CusApi_env_writeEnvFile(2,"X13_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8);
	CusApi_env_writeEnvFile(2,"X13_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0);
	CusApi_env_writeEnvFile(2,"X13_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24);
	CusApi_env_writeEnvFile(2,"X14_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16);
	CusApi_env_writeEnvFile(2,"X14_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8);
	CusApi_env_writeEnvFile(2,"X14_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0);
	CusApi_env_writeEnvFile(2,"X14_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24);
	CusApi_env_writeEnvFile(2,"X15_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16);
	CusApi_env_writeEnvFile(2,"X15_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8);
	CusApi_env_writeEnvFile(2,"X15_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0);
	CusApi_env_writeEnvFile(2,"X15_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24);
	CusApi_env_writeEnvFile(2,"X16_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16);
	CusApi_env_writeEnvFile(2,"X16_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8);
	CusApi_env_writeEnvFile(2,"X16_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0);
	CusApi_env_writeEnvFile(2,"X16_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X17_31_24);
	CusApi_env_writeEnvFile(2,"X17_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X17_23_16);
	CusApi_env_writeEnvFile(2,"X17_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X17_15_8);
	CusApi_env_writeEnvFile(2,"X17_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].External_device_control_1_X17_7_0);
	CusApi_env_writeEnvFile(2,"X17_7",value2_s);
	mdelay(100);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[0]);
	CusApi_env_writeEnvFile(2,"X29_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[1]);
	CusApi_env_writeEnvFile(2,"X29_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[2]);
	CusApi_env_writeEnvFile(2,"X29_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[3]);
	CusApi_env_writeEnvFile(2,"X29_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[4]);
	CusApi_env_writeEnvFile(2,"X30_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[5]);
	CusApi_env_writeEnvFile(2,"X30_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[6]);
	CusApi_env_writeEnvFile(2,"X30_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[7]);
	CusApi_env_writeEnvFile(2,"X30_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[8]);
	CusApi_env_writeEnvFile(2,"X31_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[9]);
	CusApi_env_writeEnvFile(2,"X31_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[10]);
	CusApi_env_writeEnvFile(2,"X31_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[11]);
	CusApi_env_writeEnvFile(2,"X31_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[12]);
	CusApi_env_writeEnvFile(2,"X32_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[13]);
	CusApi_env_writeEnvFile(2,"X32_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[14]);
	CusApi_env_writeEnvFile(2,"X32_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[15]);
	CusApi_env_writeEnvFile(2,"X32_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[16]);
	CusApi_env_writeEnvFile(2,"X33_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[17]);
	CusApi_env_writeEnvFile(2,"X33_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[18]);
	CusApi_env_writeEnvFile(2,"X33_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[19]);
	CusApi_env_writeEnvFile(2,"X33_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[20]);
	CusApi_env_writeEnvFile(2,"X34_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[21]);
	CusApi_env_writeEnvFile(2,"X34_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[22]);
	CusApi_env_writeEnvFile(2,"X34_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[23]);
	CusApi_env_writeEnvFile(2,"X34_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[24]);
	CusApi_env_writeEnvFile(2,"X35_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[25]);
	CusApi_env_writeEnvFile(2,"X35_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[26]);
	CusApi_env_writeEnvFile(2,"X35_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[27]);
	CusApi_env_writeEnvFile(2,"X35_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[28]);
	CusApi_env_writeEnvFile(2,"X36_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[29]);
	CusApi_env_writeEnvFile(2,"X36_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[30]);
	CusApi_env_writeEnvFile(2,"X36_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTOD_De_emphasis_set[31]);
	CusApi_env_writeEnvFile(2,"X36_7",value2_s);
	mdelay(100);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[0]);
	CusApi_env_writeEnvFile(2,"X37_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[1]);
	CusApi_env_writeEnvFile(2,"X37_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[2]);
	CusApi_env_writeEnvFile(2,"X37_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[3]);
	CusApi_env_writeEnvFile(2,"X37_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[4]);
	CusApi_env_writeEnvFile(2,"X38_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[5]);
	CusApi_env_writeEnvFile(2,"X38_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[6]);
	CusApi_env_writeEnvFile(2,"X38_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[7]);
	CusApi_env_writeEnvFile(2,"X38_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[8]);
	CusApi_env_writeEnvFile(2,"X39_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[9]);
	CusApi_env_writeEnvFile(2,"X39_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[10]);
	CusApi_env_writeEnvFile(2,"X39_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[11]);
	CusApi_env_writeEnvFile(2,"X39_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[12]);
	CusApi_env_writeEnvFile(2,"X40_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[13]);
	CusApi_env_writeEnvFile(2,"X40_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[14]);
	CusApi_env_writeEnvFile(2,"X40_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[15]);
	CusApi_env_writeEnvFile(2,"X40_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[16]);
	CusApi_env_writeEnvFile(2,"X41_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[17]);
	CusApi_env_writeEnvFile(2,"X41_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[18]);
	CusApi_env_writeEnvFile(2,"X41_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[19]);
	CusApi_env_writeEnvFile(2,"X41_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[20]);
	CusApi_env_writeEnvFile(2,"X42_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[21]);
	CusApi_env_writeEnvFile(2,"X42_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[22]);
	CusApi_env_writeEnvFile(2,"X42_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[23]);
	CusApi_env_writeEnvFile(2,"X42_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[24]);
	CusApi_env_writeEnvFile(2,"X43_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[25]);
	CusApi_env_writeEnvFile(2,"X43_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[26]);
	CusApi_env_writeEnvFile(2,"X43_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[27]);
	CusApi_env_writeEnvFile(2,"X43_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[28]);
	CusApi_env_writeEnvFile(2,"X44_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[29]);
	CusApi_env_writeEnvFile(2,"X44_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[30]);
	CusApi_env_writeEnvFile(2,"X44_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[31]);
	CusApi_env_writeEnvFile(2,"X44_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[32]);
	CusApi_env_writeEnvFile(2,"X45_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[33]);
	CusApi_env_writeEnvFile(2,"X45_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[34]);
	CusApi_env_writeEnvFile(2,"X45_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[35]);
	CusApi_env_writeEnvFile(2,"X45_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[36]);
	CusApi_env_writeEnvFile(2,"X46_31",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[37]);
	CusApi_env_writeEnvFile(2,"X46_23",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[38]);
	CusApi_env_writeEnvFile(2,"X46_15",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].Common_control[39]);
	CusApi_env_writeEnvFile(2,"X46_7",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].PixelClk60Hz);
	CusApi_env_writeEnvFile(2,"PXL_CLK_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HTotal60Hz);
	CusApi_env_writeEnvFile(2,"HTOATL_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTotal60Hz);
	CusApi_env_writeEnvFile(2,"VTOATL_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	CusApi_env_writeEnvFile(2,"HSYNC_W_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VSyncWidth_60Hz);
	CusApi_env_writeEnvFile(2,"VSYNC_W_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HFrontPorch_60Hz);
	CusApi_env_writeEnvFile(2,"HFP_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HbackPorch_60Hz);
	CusApi_env_writeEnvFile(2,"HBP_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VFrontPorch_60Hz);
	CusApi_env_writeEnvFile(2,"VFP_60",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	CusApi_env_writeEnvFile(2,"VBP_60",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].PixelClk50Hz);
	CusApi_env_writeEnvFile(2,"PXL_CLK_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HTotal50Hz);
	CusApi_env_writeEnvFile(2,"HTOATL_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTotal50Hz);
	CusApi_env_writeEnvFile(2,"VTOATL_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HSyncWidth_50Hz);
	CusApi_env_writeEnvFile(2,"HSYNC_W_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VSyncWidth_50Hz);
	CusApi_env_writeEnvFile(2,"VSYNC_W_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HFrontPorch_50Hz);
	CusApi_env_writeEnvFile(2,"HFP_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HbackPorch_50Hz);
	CusApi_env_writeEnvFile(2,"HBP_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VFrontPorch_50Hz);
	CusApi_env_writeEnvFile(2,"VFP_50",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VbackPorch_50Hz);
	CusApi_env_writeEnvFile(2,"VBP_50",value2_s);

	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].PixelClk48Hz);
	CusApi_env_writeEnvFile(2,"PXL_CLK_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HTotal48Hz);
	CusApi_env_writeEnvFile(2,"HTOATL_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VTotal48Hz);
	CusApi_env_writeEnvFile(2,"VTOATL_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HSyncWidth_48Hz);
	CusApi_env_writeEnvFile(2,"HSYNC_W_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VSyncWidth_48Hz);
	CusApi_env_writeEnvFile(2,"VSYNC_W_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HFrontPorch_48Hz);
	CusApi_env_writeEnvFile(2,"HFP_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].HbackPorch_48Hz);
	CusApi_env_writeEnvFile(2,"HBP_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VFrontPorch_48Hz);
	CusApi_env_writeEnvFile(2,"VFP_48",value2_s);
	sprintf(value2_s, "%d",default_panel_parameter.snInfo[0].VbackPorch_48Hz);
	CusApi_env_writeEnvFile(2,"VBP_48",value2_s);
	factory_save();
	#endif
	printf("updatePnCommon end\n");

}

void updatePanelType(UINT8 format)
{
	int pin_panel_less =IO_Get(PIN_PANEL_LESS);

	printf("updatePanelType =%d:%d\n",default_panel_parameter.iCONFIG_PANEL_TYPE,format);
	switch(format){
		case 0:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_VBY1_4K2K;
			break;
		case 1:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_EPI_TYPE;
			break;
		case 3:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_CEDS;
			break;
		case 4:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_CHPI;
			break;
		case 5:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_CHPI;// ?CSOT
			break;
		case 6:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_ISP;
			break;
		case 7:
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_LVDS_4K_2K_BOOTCODE_2K;
			break;
	}

	if(pin_panel_less==1){
		default_panel_parameter.iCONFIG_PANEL_TYPE = P_VBY1_TO_HDMI;
	}
}

void env_panel_sync(void){

	printf("env_panel_sync start\n");
	#if 0
	if(default_panel_parameter.snInfo[0].VClkMax!=0)
		default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX = default_panel_parameter.snInfo[0].VClkMax;

	if(default_panel_parameter.snInfo[0].VClkMin!=0)
		default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN = default_panel_parameter.snInfo[0].VClkMin;

	if(default_panel_parameter.snInfo[0].PixelClk60Hz!=0)
		default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL = default_panel_parameter.snInfo[0].PixelClk60Hz;

 	if(default_panel_parameter.snInfo[0].BL_PWM_FREQ!=0)
		default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ=default_panel_parameter.snInfo[0].BL_PWM_FREQ;

	if(default_panel_parameter.snInfo[0].Panel_Width!=0)
		default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS =default_panel_parameter.snInfo[0].Panel_Width;

	if(default_panel_parameter.snInfo[0].Panel_Height!=0)
		default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS =default_panel_parameter.snInfo[0].Panel_Height;

	if(default_panel_parameter.snInfo[0].HTotal60Hz!=0)
		default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL =default_panel_parameter.snInfo[0].HTotal60Hz;

	if(default_panel_parameter.snInfo[0].VTotal60Hz!=0)
		default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL   =default_panel_parameter.snInfo[0].VTotal60Hz;
	#endif
	#if 1
	//return;
	//Use Sn param
	if(default_panel_parameter.snInfo[0].Panel_Number==0)
		return;

	//printf("Panel_Number =%d\n",default_panel_parameter.snInfo[0].Panel_Number);
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX = default_panel_parameter.snInfo[0].VClkMax;

	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN = default_panel_parameter.snInfo[0].VClkMin;

	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL = default_panel_parameter.snInfo[0].PixelClk60Hz;

	default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ=default_panel_parameter.snInfo[0].BL_PWM_FREQ;

	default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL =default_panel_parameter.snInfo[0].HTotal60Hz;

	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL   =default_panel_parameter.snInfo[0].VTotal60Hz;

	//printf("default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH =%d:%d \n",default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH,default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	//printf("default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH =%d:%d \n",default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH,default_panel_parameter.snInfo[0].VSyncWidth_60Hz );
	#if 1//roll-back
	default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH =default_panel_parameter.snInfo[0].HSyncWidth_60Hz-1;
	#else
	default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH =default_panel_parameter.snInfo[0].HSyncWidth_60Hz;
	#endif
	default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH =default_panel_parameter.snInfo[0].VSyncWidth_60Hz-1;//setting =realvaue -1

	//printf("default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS =%d:%d\n",default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS,default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS);
	//printf("default_panel_parameter.snInfo[0].HFrontPorch_60Hz =%d:%d\n",default_panel_parameter.snInfo[0].HFrontPorch_60Hz,default_panel_parameter.snInfo[0].HbackPorch_60Hz);

	//printf("default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS =%d:%d\n",default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS,default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS);
	//printf("default_panel_parameter.snInfo[0].VFrontPorch_60Hz =%d:%d\n",default_panel_parameter.snInfo[0].VFrontPorch_60Hz,default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	printf("Panel bin:\n");
	printf("Htotal =0x%x(%d)\n",default_panel_parameter.snInfo[0].HTotal60Hz,default_panel_parameter.snInfo[0].HTotal60Hz);
	printf("Hactive =0x%x(%d)\n",default_panel_parameter.snInfo[0].Panel_Width,default_panel_parameter.snInfo[0].Panel_Width);
	printf("HBackPorch =0x%x(%d)\n",default_panel_parameter.snInfo[0].HbackPorch_60Hz,default_panel_parameter.snInfo[0].HbackPorch_60Hz);
	printf("HFrontProch =0x%x(%d)\n",default_panel_parameter.snInfo[0].HFrontPorch_60Hz,default_panel_parameter.snInfo[0].HFrontPorch_60Hz);
	printf("Hpulse =0x%x(%d)\n",default_panel_parameter.snInfo[0].HSyncWidth_60Hz,default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	printf("Vtotal =0x%x(%d)\n",default_panel_parameter.snInfo[0].VTotal60Hz,default_panel_parameter.snInfo[0].VTotal60Hz);
	printf("Vactive =0x%x(%d)\n",default_panel_parameter.snInfo[0].Panel_Height,default_panel_parameter.snInfo[0].Panel_Height);
	printf("VBackPorch =0x%x(%d)\n",default_panel_parameter.snInfo[0].VbackPorch_60Hz,default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	printf("VFrontProch =0x%x(%d)\n",default_panel_parameter.snInfo[0].VFrontPorch_60Hz,default_panel_parameter.snInfo[0].VFrontPorch_60Hz);
	printf("Vpulse =0x%x(%d)\n",default_panel_parameter.snInfo[0].VSyncWidth_60Hz,default_panel_parameter.snInfo[0].VSyncWidth_60Hz);

	printf("HSyncWidth_60Hz =%d ,VSyncWidth_60Hz =%d\n",default_panel_parameter.snInfo[0].HSyncWidth_60Hz,default_panel_parameter.snInfo[0].VSyncWidth_60Hz);
	printf("%d %d %d %d\n",default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS
		                    );

	#if 1//roll-back
	default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS = default_panel_parameter.snInfo[0].HbackPorch_60Hz+default_panel_parameter.snInfo[0].HSyncWidth_60Hz;
	default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS = default_panel_parameter.snInfo[0].HbackPorch_60Hz+default_panel_parameter.snInfo[0].HSyncWidth_60Hz+default_panel_parameter.snInfo[0].Panel_Width;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS = default_panel_parameter.snInfo[0].VbackPorch_60Hz+default_panel_parameter.snInfo[0].VSyncWidth_60Hz;
	default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS = default_panel_parameter.snInfo[0].VbackPorch_60Hz+default_panel_parameter.snInfo[0].VSyncWidth_60Hz+default_panel_parameter.snInfo[0].Panel_Height;
	#endif

	printf("%d %d %d %d\n",default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS,
		                    default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS
		                    );

	default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS =0;
	default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS =default_panel_parameter.snInfo[0].Panel_Width;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS =0;
	default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS =default_panel_parameter.snInfo[0].Panel_Height;

	//printf("default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX =%d:%d\n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX,default_panel_parameter.snInfo[0].VTotalMax);
	//printf("default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN =%d:%d\n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN,default_panel_parameter.snInfo[0].VTotalMin);

	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX = default_panel_parameter.snInfo[0].VTotalMax;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN = default_panel_parameter.snInfo[0].VTotalMin;

	default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL = default_panel_parameter.snInfo[0].VSyncPolarity;
	default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL = default_panel_parameter.snInfo[0].HSyncPolarity;

	default_panel_parameter.iPixelClk60Hz   =default_panel_parameter.snInfo[0].PixelClk60Hz;
	default_panel_parameter.iHTotal60Hz   =default_panel_parameter.snInfo[0].HTotal60Hz;
	default_panel_parameter.iVTotal60Hz   =default_panel_parameter.snInfo[0].VTotal60Hz;
	default_panel_parameter.iHSyncWidth_60Hz   =default_panel_parameter.snInfo[0].HSyncWidth_60Hz;
	default_panel_parameter.iVSyncWidth_60Hz   =default_panel_parameter.snInfo[0].VSyncWidth_60Hz;
	default_panel_parameter.iHFrontPorch_60Hz   =default_panel_parameter.snInfo[0].HFrontPorch_60Hz;
	default_panel_parameter.iHbackPorch_60Hz   =default_panel_parameter.snInfo[0].HbackPorch_60Hz;
	default_panel_parameter.iVFrontPorch_60Hz   =default_panel_parameter.snInfo[0].VFrontPorch_60Hz;
	default_panel_parameter.iVbackPorch_60Hz   =default_panel_parameter.snInfo[0].VbackPorch_60Hz;

	default_panel_parameter.iPixelClk50Hz   =default_panel_parameter.snInfo[0].PixelClk50Hz;
	default_panel_parameter.iHTotal50Hz   =default_panel_parameter.snInfo[0].HTotal50Hz;
	default_panel_parameter.iVTotal50Hz   =default_panel_parameter.snInfo[0].VTotal50Hz;
	default_panel_parameter.iHSyncWidth_50Hz   =default_panel_parameter.snInfo[0].HSyncWidth_50Hz;
	default_panel_parameter.iVSyncWidth_50Hz   =default_panel_parameter.snInfo[0].VSyncWidth_50Hz;
	default_panel_parameter.iHFrontPorch_50Hz   =default_panel_parameter.snInfo[0].HFrontPorch_50Hz;
	default_panel_parameter.iHbackPorch_50Hz   =default_panel_parameter.snInfo[0].HbackPorch_50Hz;
	default_panel_parameter.iVFrontPorch_50Hz   =default_panel_parameter.snInfo[0].VFrontPorch_50Hz;
	default_panel_parameter.iVbackPorch_50Hz   =default_panel_parameter.snInfo[0].VbackPorch_50Hz;

	default_panel_parameter.iPixelClk48Hz   =default_panel_parameter.snInfo[0].PixelClk48Hz;
	default_panel_parameter.iHTotal48Hz   =default_panel_parameter.snInfo[0].HTotal48Hz;
	default_panel_parameter.iVTotal48Hz   =default_panel_parameter.snInfo[0].VTotal48Hz;
	default_panel_parameter.iHSyncWidth_48Hz   =default_panel_parameter.snInfo[0].HSyncWidth_48Hz;
	default_panel_parameter.iVSyncWidth_48Hz   =default_panel_parameter.snInfo[0].VSyncWidth_48Hz;
	default_panel_parameter.iHFrontPorch_48Hz   =default_panel_parameter.snInfo[0].HFrontPorch_48Hz;
	default_panel_parameter.iHbackPorch_48Hz   =default_panel_parameter.snInfo[0].HbackPorch_48Hz;
	default_panel_parameter.iVFrontPorch_48Hz   =default_panel_parameter.snInfo[0].VFrontPorch_48Hz;
	default_panel_parameter.iVbackPorch_48Hz   =default_panel_parameter.snInfo[0].VbackPorch_48Hz;

	//Misc
	default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID =default_panel_parameter.snInfo[0].PanelIndex;
	updatePanelType(default_panel_parameter.snInfo[0].Video_I_F_format);

	updatePnCommon();

	#endif
	printf("env_panel_sync end\n");
}

void env_print_default_setting(void){
#if 0
	printf("--env_print_default_setting start--\n");
	printf("Version_String %s\n",default_panel_parameter.snInfo[0].Version_String);
	printf("Panel_Number =%d 0x%x\n",default_panel_parameter.snInfo[0].Panel_Number,default_panel_parameter.snInfo[0].Panel_Number);
	printf("Reserved_00 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_00,default_panel_parameter.snInfo[0].Reserved_00);
	printf("Reserved_01 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_01,default_panel_parameter.snInfo[0].Reserved_01);
	printf("Reserved_02 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_02,default_panel_parameter.snInfo[0].Reserved_02);
	printf("Reserved_03 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_03,default_panel_parameter.snInfo[0].Reserved_03);
	printf("Reserved_04 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_04,default_panel_parameter.snInfo[0].Reserved_04);
	printf("Reserved_05 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_05,default_panel_parameter.snInfo[0].Reserved_05);
	printf("Reserved_06 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_06,default_panel_parameter.snInfo[0].Reserved_06);
	printf("Reserved_07 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_07,default_panel_parameter.snInfo[0].Reserved_07);
	printf("Reserved_08 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_08,default_panel_parameter.snInfo[0].Reserved_08);
	printf("Reserved_09 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_09,default_panel_parameter.snInfo[0].Reserved_09);
	printf("Reserved_10 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_10,default_panel_parameter.snInfo[0].Reserved_10);
	printf("Reserved_11 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_11,default_panel_parameter.snInfo[0].Reserved_11);
	printf("PanelIndex =%d 0x%x\n",default_panel_parameter.snInfo[0].PanelIndex,default_panel_parameter.snInfo[0].PanelIndex);
	printf("PanelIDString %s\n",default_panel_parameter.snInfo[0].PanelIDString);


	printf("InchSize =%d 0x%x\n",default_panel_parameter.snInfo[0].InchSize,default_panel_parameter.snInfo[0].InchSize);
	printf("Chassis_Index =%d 0x%x\n",default_panel_parameter.snInfo[0].Chassis_Index,default_panel_parameter.snInfo[0].Chassis_Index);
	printf("Panel_Width =%d 0x%x\n",default_panel_parameter.snInfo[0].Panel_Width,default_panel_parameter.snInfo[0].Panel_Width);
	printf("Panel_Height =%d 0x%x\n",default_panel_parameter.snInfo[0].Panel_Height,default_panel_parameter.snInfo[0].Panel_Height);
	printf("Reserved_12 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_12,default_panel_parameter.snInfo[0].Reserved_12);
	printf("Reserved_13 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_13,default_panel_parameter.snInfo[0].Reserved_13);
	printf("Reserved_14 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_14,default_panel_parameter.snInfo[0].Reserved_14);
	printf("Reserved_15 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_15,default_panel_parameter.snInfo[0].Reserved_15);
	printf("PixelClk60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].PixelClk60Hz,default_panel_parameter.snInfo[0].PixelClk60Hz);
	printf("Reserved_16 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_16,default_panel_parameter.snInfo[0].Reserved_16);
	printf("Reserved_17 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_17,default_panel_parameter.snInfo[0].Reserved_17);
	printf("Reserved_18 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_18,default_panel_parameter.snInfo[0].Reserved_18);
	printf("Reserved_19 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_19,default_panel_parameter.snInfo[0].Reserved_19);
	printf("HTotalMax =%d 0x%x\n",default_panel_parameter.snInfo[0].HTotalMax,default_panel_parameter.snInfo[0].HTotalMax);
	printf("HTotal60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].HTotal60Hz,default_panel_parameter.snInfo[0].HTotal60Hz);
	printf("HTotalMin =%d 0x%x\n",default_panel_parameter.snInfo[0].HTotalMin,default_panel_parameter.snInfo[0].HTotalMin);
	printf("VTotalMax =%d 0x%x\n",default_panel_parameter.snInfo[0].VTotalMax,default_panel_parameter.snInfo[0].VTotalMax);
	printf("VTotal60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].VTotal60Hz,default_panel_parameter.snInfo[0].VTotal60Hz);
	printf("VTotalMin =%d 0x%x\n",default_panel_parameter.snInfo[0].VTotalMin,default_panel_parameter.snInfo[0].VTotalMin);
	printf("VClkMax =%d 0x%x\n",default_panel_parameter.snInfo[0].VClkMax,default_panel_parameter.snInfo[0].VClkMax);
	printf("VClkMin =%d 0x%x\n",default_panel_parameter.snInfo[0].VClkMin,default_panel_parameter.snInfo[0].VClkMin);
	printf("HSyncWidth_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].HSyncWidth_60Hz,default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	printf("VSyncWidth_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].VSyncWidth_60Hz,default_panel_parameter.snInfo[0].VSyncWidth_60Hz);
	printf("HFrontPorch_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].HFrontPorch_60Hz,default_panel_parameter.snInfo[0].HFrontPorch_60Hz);
	printf("HbackPorch_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].HbackPorch_60Hz,default_panel_parameter.snInfo[0].HbackPorch_60Hz);
	printf("VFrontPorch_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].VFrontPorch_60Hz,default_panel_parameter.snInfo[0].VFrontPorch_60Hz);
	printf("VbackPorch_60Hz =%d 0x%x\n",default_panel_parameter.snInfo[0].VbackPorch_60Hz,default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	printf("HSyncPolarity =%d 0x%x\n",default_panel_parameter.snInfo[0].HSyncPolarity,default_panel_parameter.snInfo[0].HSyncPolarity);
	printf("VSyncPolarity =%d 0x%x\n",default_panel_parameter.snInfo[0].VSyncPolarity,default_panel_parameter.snInfo[0].VSyncPolarity);
	printf("Reserved_20 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_20,default_panel_parameter.snInfo[0].Reserved_20);
	printf("Reserved_21 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_21,default_panel_parameter.snInfo[0].Reserved_21);
	printf("Reserved_22 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_22,default_panel_parameter.snInfo[0].Reserved_22);
	printf("Reserved_23 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_23,default_panel_parameter.snInfo[0].Reserved_23);
	printf("Reserved_24 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_24,default_panel_parameter.snInfo[0].Reserved_24);
	printf("Reserved_25 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_25,default_panel_parameter.snInfo[0].Reserved_25);
	printf("Reserved_26 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_26,default_panel_parameter.snInfo[0].Reserved_26);
	printf("VCOM_Type =%d 0x%x\n",default_panel_parameter.snInfo[0].VCOM_Type,default_panel_parameter.snInfo[0].VCOM_Type);
	printf("Drive_strength =%d 0x%x\n",default_panel_parameter.snInfo[0].Drive_strength,default_panel_parameter.snInfo[0].Drive_strength);
	printf("Pre_emphasis_On_Off =%d 0x%x\n",default_panel_parameter.snInfo[0].Pre_emphasis_On_Off,default_panel_parameter.snInfo[0].Pre_emphasis_On_Off);
	printf("Pre_emphasis_level =%d 0x%x\n",default_panel_parameter.snInfo[0].Pre_emphasis_level,default_panel_parameter.snInfo[0].Pre_emphasis_level);
	printf("Spread_spectrum_On_Off =%d 0x%x\n",default_panel_parameter.snInfo[0].Spread_spectrum_On_Off,default_panel_parameter.snInfo[0].Spread_spectrum_On_Off);
	printf("SpreadPermillage =%d 0x%x\n",default_panel_parameter.snInfo[0].SpreadPermillage,default_panel_parameter.snInfo[0].SpreadPermillage);
	printf("SpreadFreq =%d 0x%x\n",default_panel_parameter.snInfo[0].SpreadFreq,default_panel_parameter.snInfo[0].SpreadFreq);
	printf("Video_I_F_format =%d 0x%x\n",default_panel_parameter.snInfo[0].Video_I_F_format,default_panel_parameter.snInfo[0].Video_I_F_format);
	printf("Reserved_27 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_27,default_panel_parameter.snInfo[0].Reserved_27);
	printf("Reserved_28 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_28,default_panel_parameter.snInfo[0].Reserved_28);
	printf("Reserved_29 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_29,default_panel_parameter.snInfo[0].Reserved_29);
	printf("Reserved_30 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_30,default_panel_parameter.snInfo[0].Reserved_30);
	printf("Reserved_31 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_31,default_panel_parameter.snInfo[0].Reserved_31);
	printf("Reserved_32 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_32,default_panel_parameter.snInfo[0].Reserved_32);
	printf("Reserved_33 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_33,default_panel_parameter.snInfo[0].Reserved_33);
	printf("Reserved_34 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_34,default_panel_parameter.snInfo[0].Reserved_34);
	printf("Reserved_35 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_35,default_panel_parameter.snInfo[0].Reserved_35);
	printf("Reserved_36 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_36,default_panel_parameter.snInfo[0].Reserved_36);
	printf("Reserved_37 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_37,default_panel_parameter.snInfo[0].Reserved_37);
	printf("Reserved_38 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_38,default_panel_parameter.snInfo[0].Reserved_38);
	printf("Reserved_39 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_39,default_panel_parameter.snInfo[0].Reserved_39);
	printf("Reserved_40 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_40,default_panel_parameter.snInfo[0].Reserved_40);
	printf("CURRENT_MAX =%d 0x%x\n",default_panel_parameter.snInfo[0].CURRENT_MAX,default_panel_parameter.snInfo[0].CURRENT_MAX);
	printf("CURRENT_MIN =%d 0x%x\n",default_panel_parameter.snInfo[0].CURRENT_MIN,default_panel_parameter.snInfo[0].CURRENT_MIN);
	printf("BL_PWM_MAX =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PWM_MAX,default_panel_parameter.snInfo[0].BL_PWM_MAX);
	printf("BL_PWM_MIN =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PWM_MIN,default_panel_parameter.snInfo[0].BL_PWM_MIN);
	printf("BL_CUR_FREQ =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_CUR_FREQ,default_panel_parameter.snInfo[0].BL_CUR_FREQ);
	printf("BL_PWM_FREQ =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PWM_FREQ,default_panel_parameter.snInfo[0].BL_PWM_FREQ);
	printf("BL_PSO_TH3 =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PSO_TH3,default_panel_parameter.snInfo[0].BL_PSO_TH3);
	printf("BL_PSL_DIFF =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PSL_DIFF,default_panel_parameter.snInfo[0].BL_PSL_DIFF);
	printf("BL_PSH_GAIN =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_PSH_GAIN,default_panel_parameter.snInfo[0].BL_PSH_GAIN);
	printf("BL_IP_FREQ =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_IP_FREQ,default_panel_parameter.snInfo[0].BL_IP_FREQ);
	printf("BL_DIMM_PWM_FREQ =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_DIMM_PWM_FREQ,default_panel_parameter.snInfo[0].BL_DIMM_PWM_FREQ);
	printf("BL_CUR_MIN =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_CUR_MIN,default_panel_parameter.snInfo[0].BL_CUR_MIN);
	printf("BL_CUR_MAX =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_CUR_MAX,default_panel_parameter.snInfo[0].BL_CUR_MAX);
	printf("BL_DIMM_PWM_MIN =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_DIMM_PWM_MIN,default_panel_parameter.snInfo[0].BL_DIMM_PWM_MIN);
	printf("BL_DIMM_PWM_MAX =%d 0x%x\n",default_panel_parameter.snInfo[0].BL_DIMM_PWM_MAX,default_panel_parameter.snInfo[0].BL_DIMM_PWM_MAX);
	printf("Reserved_41 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_41,default_panel_parameter.snInfo[0].Reserved_41);
	printf("Reserved_42 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_42,default_panel_parameter.snInfo[0].Reserved_42);
	printf("Reserved_43 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_43,default_panel_parameter.snInfo[0].Reserved_43);
	printf("Reserved_44 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_44,default_panel_parameter.snInfo[0].Reserved_44);
	printf("Reserved_45 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_45,default_panel_parameter.snInfo[0].Reserved_45);
	printf("Reserved_46 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_46,default_panel_parameter.snInfo[0].Reserved_46);
	printf("Reserved_47 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_47,default_panel_parameter.snInfo[0].Reserved_47);
	printf("Reserved_48 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_48,default_panel_parameter.snInfo[0].Reserved_48);
	printf("Reserved_49 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_49,default_panel_parameter.snInfo[0].Reserved_49);
	printf("Reserved_50 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_50,default_panel_parameter.snInfo[0].Reserved_50);
	printf("Reserved_51 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_51,default_panel_parameter.snInfo[0].Reserved_51);
	printf("Reserved_52 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_52,default_panel_parameter.snInfo[0].Reserved_52);
	printf("Reserved_53 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_53,default_panel_parameter.snInfo[0].Reserved_53);
	printf("Reserved_54 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_54,default_panel_parameter.snInfo[0].Reserved_54);
	printf("Reserved_55 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_55,default_panel_parameter.snInfo[0].Reserved_55);
	printf("Reserved_56 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_56,default_panel_parameter.snInfo[0].Reserved_56);
	printf("Reserved_57 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_57,default_panel_parameter.snInfo[0].Reserved_57);
	printf("Reserved_58 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_58,default_panel_parameter.snInfo[0].Reserved_58);
	printf("Reserved_59 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_59,default_panel_parameter.snInfo[0].Reserved_59);
	printf("Reserved_60 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_60,default_panel_parameter.snInfo[0].Reserved_60);
	printf("Reserved_61 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_61,default_panel_parameter.snInfo[0].Reserved_61);
	printf("Reserved_62 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_62,default_panel_parameter.snInfo[0].Reserved_62);
	printf("Reserved_63 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_63,default_panel_parameter.snInfo[0].Reserved_63);
	printf("Reserved_64 =%d 0x%x\n",default_panel_parameter.snInfo[0].Reserved_64,default_panel_parameter.snInfo[0].Reserved_64);


	//printf("	External_device_control_1[112] =%s\n",default_panel_parameter.snInfo[0].External_device_control_1);
	printf("External_device_control_1_X1_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24);
	printf("External_device_control_1_X1_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16);
	printf("External_device_control_1_X1_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8);
	printf("External_device_control_1_X1_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0);
	printf("External_device_control_1_X2_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24);
	printf("External_device_control_1_X2_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16);
	printf("External_device_control_1_X2_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8);
	printf("External_device_control_1_X2_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0);
	printf("External_device_control_1_X3_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24);
	printf("External_device_control_1_X3_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16);
	printf("External_device_control_1_X3_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8);
	printf("External_device_control_1_X3_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0);
	printf("External_device_control_1_X4_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24);
	printf("External_device_control_1_X4_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16);
	printf("External_device_control_1_X4_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8);
	printf("External_device_control_1_X4_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0);
	printf("External_device_control_1_X5_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24);
	printf("External_device_control_1_X5_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16);
	printf("External_device_control_1_X5_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8);
	printf("External_device_control_1_X5_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0);
	printf("External_device_control_1_X6_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24);
	printf("External_device_control_1_X6_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16);
	printf("External_device_control_1_X6_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8);
	printf("External_device_control_1_X6_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0);
	printf("External_device_control_1_X7_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24);
	printf("External_device_control_1_X7_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16);
	printf("External_device_control_1_X7_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8);
	printf("External_device_control_1_X7_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0);
	printf("External_device_control_1_X8_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24);
	printf("External_device_control_1_X8_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16);
	printf("External_device_control_1_X8_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8);
	printf("External_device_control_1_X8_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0);
	printf("External_device_control_1_X9_31_24	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24);
	printf("External_device_control_1_X9_23_16	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16);
	printf("External_device_control_1_X9_15_8  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8);
	printf("External_device_control_1_X9_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0);
	printf("External_device_control_1_X10_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24);
	printf("External_device_control_1_X10_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16);
	printf("External_device_control_1_X10_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8);
	printf("External_device_control_1_X10_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0);
	printf("External_device_control_1_X11_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24);
	printf("External_device_control_1_X11_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16);
	printf("External_device_control_1_X11_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8);
	printf("External_device_control_1_X11_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0);
	printf("External_device_control_1_X12_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24);
	printf("External_device_control_1_X12_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16);
	printf("External_device_control_1_X12_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8);
	printf("External_device_control_1_X12_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0);
	printf("External_device_control_1_X13_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24);
	printf("External_device_control_1_X13_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16);
	printf("External_device_control_1_X13_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8);
	printf("External_device_control_1_X13_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0);
	printf("External_device_control_1_X14_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24);
	printf("External_device_control_1_X14_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16);
	printf("External_device_control_1_X14_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8);
	printf("External_device_control_1_X14_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0);
	printf("External_device_control_1_X15_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24);
	printf("External_device_control_1_X15_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16);
	printf("External_device_control_1_X15_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8);
	printf("External_device_control_1_X15_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0);
	printf("External_device_control_1_X16_31_24  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24);
	printf("External_device_control_1_X16_23_16  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16);
	printf("External_device_control_1_X16_15_8	0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8);
	printf("External_device_control_1_X16_7_0  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0);
	printf("External_device_control_1_X17_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_Reserved_00);
	printf("External_device_control_1_X17_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_Reserved_01);
	printf("External_device_control_1_X18_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_00);
	printf("External_device_control_1_X18_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_01);
	printf("External_device_control_1_X19_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_00);
	printf("External_device_control_1_X19_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_01);
	printf("External_device_control_1_X20_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_00);
	printf("External_device_control_1_X20_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_01);
	printf("External_device_control_1_X21_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_00);
	printf("External_device_control_1_X21_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_01);
	printf("External_device_control_1_X22_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_00);
	printf("External_device_control_1_X22_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_01);
	printf("External_device_control_1_X23_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_00);
	printf("External_device_control_1_X23_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_01);
	printf("External_device_control_1_X24_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_00);
	printf("External_device_control_1_X24_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_01);
	printf("External_device_control_1_X25_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_00);
	printf("External_device_control_1_X25_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_01);
	printf("External_device_control_1_X26_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_00);
	printf("External_device_control_1_X26_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_01);
	printf("External_device_control_1_X27_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_00);
	printf("External_device_control_1_X27_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_01);
	printf("External_device_control_1_X28_Reserved_00  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_00);
	printf("External_device_control_1_X28_Reserved_01  0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_01);
	printf("--env_print_default_setting end--\n");
#endif
}

void env_print_sn_panel_setting(UINT8 select)
{
#if 0
	printf("Version_String	%s %s	\n",default_panel_parameter.snInfo[0].Version_String,default_panel_parameter.snInfo[0].Version_String);
	printf("Panel_Number	%d 0x%x \n",default_panel_parameter.snInfo[0].Panel_Number	,default_panel_parameter.snInfo[0].Panel_Number );
	printf("Reserved_00 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_00	,default_panel_parameter.snInfo[0].Reserved_00);
	printf("Reserved_01 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_01	,default_panel_parameter.snInfo[0].Reserved_01);
	printf("Reserved_02 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_02	,default_panel_parameter.snInfo[0].Reserved_02);
	printf("Reserved_03 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_03	,default_panel_parameter.snInfo[0].Reserved_03);
	printf("Reserved_04 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_04	,default_panel_parameter.snInfo[0].Reserved_04);
	printf("Reserved_05 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_05	,default_panel_parameter.snInfo[0].Reserved_05);
	printf("Reserved_06 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_06	,default_panel_parameter.snInfo[0].Reserved_06);
	printf("Reserved_07 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_07	,default_panel_parameter.snInfo[0].Reserved_07);
	printf("Reserved_08 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_08	,default_panel_parameter.snInfo[0].Reserved_08);
	printf("Reserved_09 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_09	,default_panel_parameter.snInfo[0].Reserved_09);
	printf("Reserved_10 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_10	,default_panel_parameter.snInfo[0].Reserved_10);
	printf("Reserved_11 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_11	,default_panel_parameter.snInfo[0].Reserved_11);
	printf("PanelIndex	%d 0x%x \n",default_panel_parameter.snInfo[0].PanelIndex	,default_panel_parameter.snInfo[0].PanelIndex);
	printf("PanelIDString	%s %s	\n",default_panel_parameter.snInfo[0].PanelIDString ,default_panel_parameter.snInfo[0].PanelIDString);
	printf("InchSize	%d 0x%x \n",default_panel_parameter.snInfo[0].InchSize	,default_panel_parameter.snInfo[0].InchSize );
	printf("Chassis Index	%d 0x%x \n",default_panel_parameter.snInfo[0].Chassis_Index ,default_panel_parameter.snInfo[0].Chassis_Index);
	printf("Panel Width %d 0x%x \n",default_panel_parameter.snInfo[0].Panel_Width	,default_panel_parameter.snInfo[0].Panel_Width);
	printf("Panel Height	%d 0x%x \n",default_panel_parameter.snInfo[0].Panel_Height	,default_panel_parameter.snInfo[0].Panel_Height );
	printf("Reserved_12 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_12	,default_panel_parameter.snInfo[0].Reserved_12);
	printf("PixelClk60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk60Hz	,default_panel_parameter.snInfo[0].PixelClk60Hz );
	printf("Reserved_13 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_13	,default_panel_parameter.snInfo[0].Reserved_13);
	printf("HTotalMax	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotalMax ,default_panel_parameter.snInfo[0].HTotalMax);
	printf("HTotal60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal60Hz	,default_panel_parameter.snInfo[0].HTotal60Hz);
	printf("HTotalMin	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotalMin ,default_panel_parameter.snInfo[0].HTotalMin);
	printf("VTotalMax	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotalMax ,default_panel_parameter.snInfo[0].VTotalMax);
	printf("VTotal60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal60Hz	,default_panel_parameter.snInfo[0].VTotal60Hz);
	printf("VTotalMin	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotalMin ,default_panel_parameter.snInfo[0].VTotalMin);
	printf("VClkMax %d 0x%x \n",default_panel_parameter.snInfo[0].VClkMax	,default_panel_parameter.snInfo[0].VClkMax);
	printf("VClkMin %d 0x%x \n",default_panel_parameter.snInfo[0].VClkMin	,default_panel_parameter.snInfo[0].VClkMin);
	printf("HSyncWidth_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_60Hz	,default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	printf("VSyncWidth_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_60Hz	,default_panel_parameter.snInfo[0].VSyncWidth_60Hz);
	printf("HFrontPorch_60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_60Hz	,default_panel_parameter.snInfo[0].HFrontPorch_60Hz );
	printf("HbackPorch_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_60Hz	,default_panel_parameter.snInfo[0].HbackPorch_60Hz);
	printf("VFrontPorch_60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_60Hz	,default_panel_parameter.snInfo[0].VFrontPorch_60Hz );
	printf("VbackPorch_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_60Hz	,default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	printf("HSyncPolarity	%d 0x%x \n",default_panel_parameter.snInfo[0].HSyncPolarity ,default_panel_parameter.snInfo[0].HSyncPolarity);
	printf("VSyncPolarity	%d 0x%x \n",default_panel_parameter.snInfo[0].VSyncPolarity ,default_panel_parameter.snInfo[0].VSyncPolarity);
	printf("PixelClk50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk50Hz	,default_panel_parameter.snInfo[0].PixelClk50Hz );
	printf("HTotal50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal50Hz	,default_panel_parameter.snInfo[0].HTotal50Hz);
	printf("VCOM_Pattern	%d 0x%x \n",default_panel_parameter.snInfo[0].VCOM_Pattern	,default_panel_parameter.snInfo[0].VCOM_Pattern );
	printf("VCOM_Type	%d 0x%x \n",default_panel_parameter.snInfo[0].VCOM_Type ,default_panel_parameter.snInfo[0].VCOM_Type);
	printf("Drive strength	%d 0x%x \n",default_panel_parameter.snInfo[0].Drive_strength	,default_panel_parameter.snInfo[0].Drive_strength);
	printf("Pre emphasis On/Off %d 0x%x \n",default_panel_parameter.snInfo[0].Pre_emphasis_On_Off	,default_panel_parameter.snInfo[0].Pre_emphasis_On_Off);
	printf("Pre emphasis level	%d 0x%x \n",default_panel_parameter.snInfo[0].Pre_emphasis_level	,default_panel_parameter.snInfo[0].Pre_emphasis_level);
	printf("Spread spectrum On/Off	%d 0x%x \n",default_panel_parameter.snInfo[0].Spread_spectrum_On_Off	,default_panel_parameter.snInfo[0].Spread_spectrum_On_Off);
	printf("SpreadPermillage	%d 0x%x \n",default_panel_parameter.snInfo[0].SpreadPermillage	,default_panel_parameter.snInfo[0].SpreadPermillage );
	printf("SpreadFreq	%d 0x%x \n",default_panel_parameter.snInfo[0].SpreadFreq	,default_panel_parameter.snInfo[0].SpreadFreq);
	printf("Video I/F format	%d 0x%x \n",default_panel_parameter.snInfo[0].Video_I_F_format	,default_panel_parameter.snInfo[0].Video_I_F_format );
	printf("VTotal50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal50Hz	,default_panel_parameter.snInfo[0].VTotal50Hz);
	printf("HSyncWidth_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_50Hz	,default_panel_parameter.snInfo[0].HSyncWidth_50Hz);
	printf("VSyncWidth_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_50Hz	,default_panel_parameter.snInfo[0].VSyncWidth_50Hz);
	printf("HFrontPorch_50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_50Hz	,default_panel_parameter.snInfo[0].HFrontPorch_50Hz );
	printf("HbackPorch_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_50Hz	,default_panel_parameter.snInfo[0].HbackPorch_50Hz);
	printf("VFrontPorch_50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_50Hz	,default_panel_parameter.snInfo[0].VFrontPorch_50Hz );
	printf("VbackPorch_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_50Hz	,default_panel_parameter.snInfo[0].VbackPorch_50Hz);
	printf("Reserved_14 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_14	,default_panel_parameter.snInfo[0].Reserved_14);
	printf("Reserved_15 %d 0x%x \n",default_panel_parameter.snInfo[0].Reserved_15	,default_panel_parameter.snInfo[0].Reserved_15);
	printf("CURRENT_MAX %d 0x%x \n",default_panel_parameter.snInfo[0].CURRENT_MAX	,default_panel_parameter.snInfo[0].CURRENT_MAX);
	printf("CURRENT_MIN %d 0x%x \n",default_panel_parameter.snInfo[0].CURRENT_MIN	,default_panel_parameter.snInfo[0].CURRENT_MIN);
	printf("BL_PWM_MAX	%d 0x%x \n",default_panel_parameter.snInfo[0].BL_PWM_MAX	,default_panel_parameter.snInfo[0].BL_PWM_MAX);
	printf("BL_PWM_MIN	%d 0x%x \n",default_panel_parameter.snInfo[0].BL_PWM_MIN	,default_panel_parameter.snInfo[0].BL_PWM_MIN);
	printf("BL_CUR_FREQ %d 0x%x \n",default_panel_parameter.snInfo[0].BL_CUR_FREQ	,default_panel_parameter.snInfo[0].BL_CUR_FREQ);
	printf("BL_PWM_FREQ %d 0x%x \n",default_panel_parameter.snInfo[0].BL_PWM_FREQ	,default_panel_parameter.snInfo[0].BL_PWM_FREQ);
	printf("BL_WAIT_LOGO	%d 0x%x \n",default_panel_parameter.snInfo[0].BL_WAIT_LOGO	,default_panel_parameter.snInfo[0].BL_WAIT_LOGO );
	printf("BL_PSL_DIFF %d 0x%x \n",default_panel_parameter.snInfo[0].BL_PSL_DIFF	,default_panel_parameter.snInfo[0].BL_PSL_DIFF);
	printf("PixelClk48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk48Hz	,default_panel_parameter.snInfo[0].PixelClk48Hz );
	printf("HTotal48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal48Hz	,default_panel_parameter.snInfo[0].HTotal48Hz);
	printf("VTotal48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal48Hz	,default_panel_parameter.snInfo[0].VTotal48Hz);
	printf("HSyncWidth_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_48Hz	,default_panel_parameter.snInfo[0].HSyncWidth_48Hz);
	printf("VSyncWidth_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_48Hz	,default_panel_parameter.snInfo[0].VSyncWidth_48Hz);
	printf("HFrontPorch_48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_48Hz	,default_panel_parameter.snInfo[0].HFrontPorch_48Hz );
	printf("HbackPorch_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_48Hz	,default_panel_parameter.snInfo[0].HbackPorch_48Hz);
	printf("VFrontPorch_48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_48Hz	,default_panel_parameter.snInfo[0].VFrontPorch_48Hz );
	printf("VbackPorch_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_48Hz	,default_panel_parameter.snInfo[0].VbackPorch_48Hz);
	#endif
	#if 0
	printf("External_device_control_1_X1_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24);
	printf("External_device_control_1_X1_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16);
	printf("External_device_control_1_X1_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8);
	printf("External_device_control_1_X1_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0);
	printf("External_device_control_1_X2_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24);
	printf("External_device_control_1_X2_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16);
	printf("External_device_control_1_X2_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8);
	printf("External_device_control_1_X2_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0);
	printf("External_device_control_1_X3_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24);
	printf("External_device_control_1_X3_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16);
	printf("External_device_control_1_X3_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8);
	printf("External_device_control_1_X3_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0);
	printf("External_device_control_1_X4_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24);
	printf("External_device_control_1_X4_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16);
	printf("External_device_control_1_X4_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8);
	printf("External_device_control_1_X4_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0);
	printf("External_device_control_1_X5_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24);
	printf("External_device_control_1_X5_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16);
	printf("External_device_control_1_X5_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8);
	printf("External_device_control_1_X5_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0);
	printf("External_device_control_1_X6_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24);
	printf("External_device_control_1_X6_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16);
	printf("External_device_control_1_X6_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8);
	printf("External_device_control_1_X6_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0);
	printf("External_device_control_1_X7_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24);
	printf("External_device_control_1_X7_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16);
	printf("External_device_control_1_X7_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8);
	printf("External_device_control_1_X7_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0);
	printf("External_device_control_1_X8_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24);
	printf("External_device_control_1_X8_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16);
	printf("External_device_control_1_X8_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8);
	printf("External_device_control_1_X8_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0);
	printf("External_device_control_1_X9_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24);
	printf("External_device_control_1_X9_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16);
	printf("External_device_control_1_X9_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8);
	printf("External_device_control_1_X9_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0);
	#endif
	#if 0
	printf("External_device_control_1_X10_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24);
	printf("External_device_control_1_X10_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16);
	printf("External_device_control_1_X10_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8);
	printf("External_device_control_1_X10_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0);
	printf("External_device_control_1_X11_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24);
	printf("External_device_control_1_X11_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16);
	printf("External_device_control_1_X11_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8);
	printf("External_device_control_1_X11_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0);
	printf("External_device_control_1_X12_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24);
	printf("External_device_control_1_X12_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16);
	printf("External_device_control_1_X12_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8);
	printf("External_device_control_1_X12_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0);
	printf("External_device_control_1_X13_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24);
	printf("External_device_control_1_X13_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16);
	printf("External_device_control_1_X13_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8);
	printf("External_device_control_1_X13_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0);
	printf("External_device_control_1_X14_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24);
	printf("External_device_control_1_X14_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16);
	printf("External_device_control_1_X14_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8);
	printf("External_device_control_1_X14_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0);
	printf("External_device_control_1_X15_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24);
	printf("External_device_control_1_X15_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16);
	printf("External_device_control_1_X15_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8);
	printf("External_device_control_1_X15_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0);
	printf("External_device_control_1_X16_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24);
	printf("External_device_control_1_X16_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16);
	printf("External_device_control_1_X16_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8);
	printf("External_device_control_1_X16_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0);
	printf("External_device_control_1_X17_31_24%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_31_24,default_panel_parameter.snInfo[0].External_device_control_1_X17_31_24);
	printf("External_device_control_1_X17_23_16%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_23_16,default_panel_parameter.snInfo[0].External_device_control_1_X17_23_16);
	printf("External_device_control_1_X17_15_8%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_15_8,default_panel_parameter.snInfo[0].External_device_control_1_X17_15_8);
	printf("External_device_control_1_X17_7_0%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X17_7_0,default_panel_parameter.snInfo[0].External_device_control_1_X17_7_0);

	#endif
	#if 0
	printf("External_device_control_1_X18_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_00);

	printf("External_device_control_1_X18_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_01);

	printf("External_device_control_1_X19_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_00);

	printf("External_device_control_1_X19_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_01);

	printf("External_device_control_1_X20_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_00);

	printf("External_device_control_1_X20_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_01);

	printf("External_device_control_1_X21_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_00);

	printf("External_device_control_1_X21_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_01);

	printf("External_device_control_1_X22_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_00);

	printf("External_device_control_1_X22_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_01);

	printf("External_device_control_1_X23_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_00);

	printf("External_device_control_1_X23_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_01);

	printf("External_device_control_1_X24_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_00);

	printf("External_device_control_1_X24_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_01);

	printf("External_device_control_1_X25_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_00);

	printf("External_device_control_1_X25_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_01);

	printf("External_device_control_1_X26_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_00);

	printf("External_device_control_1_X26_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_01);

	printf("External_device_control_1_X27_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_00);

	printf("External_device_control_1_X27_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_01);

	printf("External_device_control_1_X28_Reserved_00%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_00,default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_00);

	printf("External_device_control_1_X28_Reserved_01%d 0x%x\n",default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_01,default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_01);

	#endif

	#if 0//48/50/60 debug
	printf("PixelClk60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk60Hz	,default_panel_parameter.snInfo[0].PixelClk60Hz );
	printf("HTotal60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal60Hz	,default_panel_parameter.snInfo[0].HTotal60Hz);
	printf("VTotal60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal60Hz	,default_panel_parameter.snInfo[0].VTotal60Hz);
	printf("HSyncWidth_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_60Hz	,default_panel_parameter.snInfo[0].HSyncWidth_60Hz);
	printf("VSyncWidth_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_60Hz	,default_panel_parameter.snInfo[0].VSyncWidth_60Hz);
	printf("HFrontPorch_60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_60Hz	,default_panel_parameter.snInfo[0].HFrontPorch_60Hz );
	printf("HbackPorch_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_60Hz	,default_panel_parameter.snInfo[0].HbackPorch_60Hz);
	printf("VFrontPorch_60Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_60Hz	,default_panel_parameter.snInfo[0].VFrontPorch_60Hz );
	printf("VbackPorch_60Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_60Hz	,default_panel_parameter.snInfo[0].VbackPorch_60Hz);
	printf("-----------------------------------------\n");
	printf("PixelClk50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk50Hz	,default_panel_parameter.snInfo[0].PixelClk50Hz );
	printf("HTotal50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal50Hz	,default_panel_parameter.snInfo[0].HTotal50Hz);
	printf("VTotal50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal50Hz	,default_panel_parameter.snInfo[0].VTotal50Hz);
	printf("HSyncWidth_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_50Hz	,default_panel_parameter.snInfo[0].HSyncWidth_50Hz);
	printf("VSyncWidth_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_50Hz	,default_panel_parameter.snInfo[0].VSyncWidth_50Hz);
	printf("HFrontPorch_50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_50Hz	,default_panel_parameter.snInfo[0].HFrontPorch_50Hz );
	printf("HbackPorch_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_50Hz	,default_panel_parameter.snInfo[0].HbackPorch_50Hz);
	printf("VFrontPorch_50Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_50Hz	,default_panel_parameter.snInfo[0].VFrontPorch_50Hz );
	printf("VbackPorch_50Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_50Hz	,default_panel_parameter.snInfo[0].VbackPorch_50Hz);

	printf("-----------------------------------------\n");
	printf("PixelClk48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].PixelClk48Hz	,default_panel_parameter.snInfo[0].PixelClk48Hz );
	printf("HTotal48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HTotal48Hz	,default_panel_parameter.snInfo[0].HTotal48Hz);
	printf("VTotal48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VTotal48Hz	,default_panel_parameter.snInfo[0].VTotal48Hz);
	printf("HSyncWidth_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HSyncWidth_48Hz	,default_panel_parameter.snInfo[0].HSyncWidth_48Hz);
	printf("VSyncWidth_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VSyncWidth_48Hz	,default_panel_parameter.snInfo[0].VSyncWidth_48Hz);
	printf("HFrontPorch_48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].HFrontPorch_48Hz	,default_panel_parameter.snInfo[0].HFrontPorch_48Hz );
	printf("HbackPorch_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].HbackPorch_48Hz	,default_panel_parameter.snInfo[0].HbackPorch_48Hz);
	printf("VFrontPorch_48Hz	%d 0x%x \n",default_panel_parameter.snInfo[0].VFrontPorch_48Hz	,default_panel_parameter.snInfo[0].VFrontPorch_48Hz );
	printf("VbackPorch_48Hz %d 0x%x \n",default_panel_parameter.snInfo[0].VbackPorch_48Hz	,default_panel_parameter.snInfo[0].VbackPorch_48Hz);
	#endif

	printf("--env_print_sn_panel_setting end--\n");

}


void env_struct_arrange(UINT8 select,char *raw_ptr)
{
	//cp to panel_setting and arrange.
	printf("--env_struct_arrange start--\n");
	memcpy(default_panel_parameter.snInfo[0].Version_String,raw_ptr, sizeof(char)*16);
	memcpy(&default_panel_parameter.snInfo[0].Panel_Number	,raw_ptr+16 , sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_00	,raw_ptr+20 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_01	,raw_ptr+21 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_02	,raw_ptr+22 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_03	,raw_ptr+23 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_04	,raw_ptr+24 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_05	,raw_ptr+25 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_06	,raw_ptr+26 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_07	,raw_ptr+27 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_08	,raw_ptr+28 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_09	,raw_ptr+29 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_10	,raw_ptr+30 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_11	,raw_ptr+31 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].PanelIndex	,raw_ptr+32 , sizeof(UINT8));
	memcpy(default_panel_parameter.snInfo[0].PanelIDString	,raw_ptr+33 ,sizeof(char)*16);
	memcpy(&default_panel_parameter.snInfo[0].InchSize	,raw_ptr+49 , sizeof(UINT8));

	#if 0//debug
	printf("InchSize %c \n",*(raw_ptr+49));

	char test=*(raw_ptr+49);
	UINT8 test1 =(UINT8)test;

	printf("InchSize %d\n",test1);

	test=*(raw_ptr+50);
	test1 =(UINT8)test;
	printf("Chassis_Index %d\n",test1);


	test=*(raw_ptr+51);
	test1 =(UINT8)test;
	printf("Panel_Width %d\n",test1);

	test=*(raw_ptr+52);
	test1 =(UINT8)test;
	printf("Panel_Width %d\n",test1);
	#endif

	memcpy(&default_panel_parameter.snInfo[0].Chassis_Index ,raw_ptr+50 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Panel_Width	 ,raw_ptr+51	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].Panel_Height	 ,raw_ptr+53	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_12	,raw_ptr+55 , sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].PixelClk60Hz	,raw_ptr+59 , sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_13	,raw_ptr+63 , sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].HTotalMax ,raw_ptr+67 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HTotal60Hz	,raw_ptr+69 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HTotalMin ,raw_ptr+71 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VTotalMax ,raw_ptr+73 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VTotal60Hz	,raw_ptr+75 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VTotalMin ,raw_ptr+77 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VClkMax	,raw_ptr+79 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VClkMin	,raw_ptr+80 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].HSyncWidth_60Hz	,raw_ptr+81 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VSyncWidth_60Hz	,raw_ptr+82 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].HFrontPorch_60Hz	,raw_ptr+83 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HbackPorch_60Hz	,raw_ptr+85 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VFrontPorch_60Hz	,raw_ptr+87 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VbackPorch_60Hz	,raw_ptr+89 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HSyncPolarity ,raw_ptr+91 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VSyncPolarity ,raw_ptr+92 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].PixelClk50Hz	,raw_ptr+93 , sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].HTotal50Hz	,raw_ptr+97 , sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VCOM_Pattern	,raw_ptr+99 , sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VCOM_Type ,raw_ptr+100	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Drive_strength	,raw_ptr+101	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Pre_emphasis_On_Off	,raw_ptr+102	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Pre_emphasis_level	,raw_ptr+103	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Spread_spectrum_On_Off	,raw_ptr+104	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].SpreadPermillage	,raw_ptr+105	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].SpreadFreq	,raw_ptr+106	, sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].Video_I_F_format	,raw_ptr+110	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VTotal50Hz	,raw_ptr+111	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HSyncWidth_50Hz	,raw_ptr+113	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VSyncWidth_50Hz	,raw_ptr+114	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].HFrontPorch_50Hz	,raw_ptr+115	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HbackPorch_50Hz	,raw_ptr+117	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VFrontPorch_50Hz	,raw_ptr+119	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VbackPorch_50Hz	,raw_ptr+121	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].Mura_CUC_ID	,raw_ptr+123	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_15	,raw_ptr+124	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].CURRENT_MAX	,raw_ptr+125	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].CURRENT_MIN	,raw_ptr+127	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_PWM_MAX	,raw_ptr+129	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_PWM_MIN	,raw_ptr+131	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_CUR_FREQ	,raw_ptr+133	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_PWM_FREQ	,raw_ptr+135	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_WAIT_LOGO	,raw_ptr+137	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].BL_PSL_DIFF	,raw_ptr+139	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].PixelClk48Hz	,raw_ptr+141	, sizeof(UINT32));
	memcpy(&default_panel_parameter.snInfo[0].HTotal48Hz	,raw_ptr+145	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VTotal48Hz	,raw_ptr+147	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HSyncWidth_48Hz	,raw_ptr+149	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].VSyncWidth_48Hz	,raw_ptr+150	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].HFrontPorch_48Hz	,raw_ptr+151	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].HbackPorch_48Hz	,raw_ptr+153	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VFrontPorch_48Hz	,raw_ptr+155	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].VbackPorch_48Hz	,raw_ptr+157	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_16	,raw_ptr+159	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_17	,raw_ptr+160	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_18	,raw_ptr+161	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_19	,raw_ptr+162	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_20	,raw_ptr+163	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_21	,raw_ptr+164	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_22	,raw_ptr+165	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_23	,raw_ptr+166	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_24	,raw_ptr+167	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_25	,raw_ptr+168	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_26	,raw_ptr+169	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_27	,raw_ptr+170	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_28	,raw_ptr+171	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_29	,raw_ptr+172	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_30	,raw_ptr+173	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_31	,raw_ptr+174	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_32	,raw_ptr+175	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_33	,raw_ptr+176	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_34	,raw_ptr+177	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].Reserved_35	,raw_ptr+178	, sizeof(UINT8));

	//External device
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X1_31_24	,raw_ptr+179	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X1_23_16	,raw_ptr+180	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X1_15_8 ,raw_ptr+181	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X1_7_0	,raw_ptr+182	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X2_31_24	,raw_ptr+183	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X2_23_16	,raw_ptr+184	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X2_15_8 ,raw_ptr+185	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X2_7_0	,raw_ptr+186	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X3_31_24	,raw_ptr+187	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X3_23_16	,raw_ptr+188	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X3_15_8 ,raw_ptr+189	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X3_7_0	,raw_ptr+190	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X4_31_24	,raw_ptr+191	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X4_23_16	,raw_ptr+192	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X4_15_8 ,raw_ptr+193	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X4_7_0	,raw_ptr+194	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X5_31_24	,raw_ptr+195	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X5_23_16	,raw_ptr+196	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X5_15_8 ,raw_ptr+197	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X5_7_0	,raw_ptr+198	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X6_31_24	,raw_ptr+199	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X6_23_16	,raw_ptr+200	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X6_15_8 ,raw_ptr+201	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X6_7_0	,raw_ptr+202	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X7_31_24	,raw_ptr+203	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X7_23_16	,raw_ptr+204	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X7_15_8 ,raw_ptr+205	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X7_7_0	,raw_ptr+206	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X8_31_24	,raw_ptr+207	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X8_23_16	,raw_ptr+208	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X8_15_8 ,raw_ptr+209	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X8_7_0	,raw_ptr+210	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X9_31_24	,raw_ptr+211	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X9_23_16	,raw_ptr+212	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X9_15_8 ,raw_ptr+213	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X9_7_0	,raw_ptr+214	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X10_31_24	,raw_ptr+215	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X10_23_16	,raw_ptr+216	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X10_15_8	,raw_ptr+217	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X10_7_0 ,raw_ptr+218	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X11_31_24	,raw_ptr+219	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X11_23_16	,raw_ptr+220	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X11_15_8	,raw_ptr+221	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X11_7_0 ,raw_ptr+222	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X12_31_24	,raw_ptr+223	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X12_23_16	,raw_ptr+224	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X12_15_8	,raw_ptr+225	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X12_7_0 ,raw_ptr+226	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X13_31_24	,raw_ptr+227	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X13_23_16	,raw_ptr+228	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X13_15_8	,raw_ptr+229	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X13_7_0 ,raw_ptr+230	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X14_31_24	,raw_ptr+231	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X14_23_16	,raw_ptr+232	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X14_15_8	,raw_ptr+233	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X14_7_0 ,raw_ptr+234	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X15_31_24	,raw_ptr+235	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X15_23_16	,raw_ptr+236	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X15_15_8	,raw_ptr+237	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X15_7_0 ,raw_ptr+238	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X16_31_24	,raw_ptr+239	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X16_23_16	,raw_ptr+240	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X16_15_8	,raw_ptr+241	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X16_7_0 ,raw_ptr+242	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X17_31_24	,raw_ptr+243	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X17_23_16	,raw_ptr+244	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X17_15_8	,raw_ptr+245	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X17_7_0 ,raw_ptr+246	, sizeof(UINT8));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_00 ,raw_ptr+247	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X18_Reserved_01 ,raw_ptr+249	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_00 ,raw_ptr+251	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X19_Reserved_01 ,raw_ptr+253	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_00 ,raw_ptr+255	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X20_Reserved_01 ,raw_ptr+257	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_00 ,raw_ptr+259	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X21_Reserved_01 ,raw_ptr+261	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_00 ,raw_ptr+263	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X22_Reserved_01 ,raw_ptr+265	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_00 ,raw_ptr+267	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X23_Reserved_01 ,raw_ptr+269	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_00 ,raw_ptr+271	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X24_Reserved_01 ,raw_ptr+273	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_00 ,raw_ptr+275	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X25_Reserved_01 ,raw_ptr+277	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_00 ,raw_ptr+279	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X26_Reserved_01 ,raw_ptr+281	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_00 ,raw_ptr+283	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X27_Reserved_01 ,raw_ptr+285	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_00 ,raw_ptr+287	, sizeof(UINT16));
	memcpy(&default_panel_parameter.snInfo[0].External_device_control_1_X28_Reserved_01 ,raw_ptr+289	, sizeof(UINT16));

	memcpy(&default_panel_parameter.snInfo[0].VTOD_De_emphasis_set	,raw_ptr+291	, sizeof(UINT8)*32	);
	memcpy(&default_panel_parameter.snInfo[0].Common_control	,raw_ptr+323	, sizeof(UINT8)*40	);
	memcpy(&default_panel_parameter.snInfo[0].Reserved	,raw_ptr+363	, sizeof(UINT8)*248 );

	env_print_sn_panel_setting(select);

		printf("--env_struct_arrange end--\n");
}


#define PANEL_BIN_FILENAME_IN_FACTORY	FACTORY_HEADER_FILE_NAME"bin_panel/panel.bin"
#define ReadCnt 3
#define NVM_ADDR (0xAA>>1)

typedef struct PANEL_ID_INFO{
    UINT8 searchIdx;
	char PanelIDString[16];
	UINT8 Chassis_Index;
	UINT8 PanelIndex;
}PANEL_ID_INFO;

#define DEBUG_MODE 0
#define NORMAL_MODE 1
#define PANEL_INDEX "PanelIndex"

void env_chk_dyna_panel_id(void)
{
	//if the same ,need check Panel_ID again.
	char sPanelIndex[32] = {0};
	int PanelIndex = 0;

	char value2_s[9]={0};
	UINT32 val=0;
	if(CusApi_env_readDynamicEnvFile(PANEL_INDEX, sPanelIndex) != 0){
		//printf("Can't read panel_id from Dyna");
		return ;//false;
	}

	//printf("--pannelID =%s--\n",pannelID);
	//printf("--default_panel_parameter pannelID =%s--\n",default_panel_parameter.snInfo[0].PanelIDString);

	PanelIndex = simple_strtoul(sPanelIndex, NULL, 10);

	if(PanelIndex !=default_panel_parameter.snInfo[0].PanelIndex){
		printf("--update %d to %d --\n",PanelIndex,default_panel_parameter.snInfo[0].PanelIndex);


		val = default_panel_parameter.snInfo[0].PanelIndex;
		sprintf(value2_s, "%d",val);
		CusApi_env_writeEnvFile(1, PANEL_INDEX,value2_s );
	}

}

uchar env_setup_env_panel_sn(uchar *panel_filename)
{
	char *raw_ptr = NULL;
	uint parameter_len = 0;
       unsigned long long value = 0;
	bool mForceEnterSuspend = false;
	unsigned char mWakeSource =SOR_UNDEF;
	unsigned char mPowerMode = 0;
	unsigned char mShutDown = 0;


#if (defined(Config_Emmc_Bootcode_To_SPI_TRUE) && defined(Config_Boot_Flash_Type_is_SPI))
	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	fsw_emmc_bootup = 0;
	CusApi_env_selectModelEnvFile();
#else
	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	if(rtk_plat_run_rescue_from_eMMC(SYS_PARAM_FACTORY_EEPROM_START>>9) == 0)
		fsw_emmc_bootup = 1;
	else
		fsw_emmc_bootup = 0;
	printf("[trace code] fsw_emmc_bootup = %d\n", fsw_emmc_bootup);
	if (fsw_emmc_bootup == 0)
		CusApi_env_selectModelEnvFile();
#endif

#ifdef Config_EXT4_Load_TvConfigs_TRUE
    syncTvConfigWithModelEnv();
#endif
	PanelID_Out_list=0;
	setID_Match(1);
	mPowerMode = CusApi_get_bootparam_PowerMode();

	if((boot_ac_on == 0) && (mPowerMode == 0)){
		mShutDown = CusApi_get_bootparam_SHUTDOWN();
		if(mShutDown == 0){
			mWakeSource = powerMgr_get_wakeup_source()&0xff;
			if(!((mWakeSource > SOR_UNDEF) && (mWakeSource < SOR_MAX)))
				mForceEnterSuspend = true;
		}
	}

	printf("\nboot_ac_on=%d, mPowerMode=%d,mShutDown=%d,mForceEnterSuspend=%d\n",boot_ac_on,mPowerMode,mShutDown,mForceEnterSuspend);

	if((boot_ac_on) && (mPowerMode == 0)){
	    boot_power_on_mode = POWER_OFF;
	}else if((boot_ac_on == 0) && (mPowerMode == 0) && (mForceEnterSuspend == true)){
		boot_power_on_mode = POWER_OFF;
	}else{
	    if (pcb_mgr_get_enum_info_byname("PIN_LEDS_0", &value) == 0)
	    {
	        printf("--SetWLED_High--\n");
	        IO_Set(value, 1);
	    }
	}

	int panelmode = NORMAL_MODE;
	const char *panelmodeStr = getenv("PANEL_DEBUG");
	// 0:debug 1:normal mode
	panelmode = simple_strtoul(panelmodeStr, NULL, 10);
	if(panelmode==0)
		printf("\n\033[1;33m<<<<<<Attention Debug mode>>>>>>>>\033[m\n");

	printf("--panelmode=%d--\n",panelmode);

	int rtk_pn = 0;
	const char *rtk_pnStr = getenv("rtk_pn");
	rtk_pn = simple_strtoul(rtk_pnStr, NULL, 10);
	//int ret;
	unsigned int rc = 1;	/* 0:fail 1:success */
	//printf("--env_setup_env_panel_sn_01--\n");
	//printf("--panel_filename =%s--\n",panel_filename);

	//check PANEL_LESS
	int pin_panel_less =IO_Get(PIN_PANEL_LESS);

	printf("pin_panel_less =%d\n",pin_panel_less);

	unsigned char data[32] = {0};
	char t_con_id[32] = {0};
	unsigned char regAddr[2] = {0,0xE0};
	int len,ii;
	int ret;
	len =16;

	int TConErrCnt=0;
	int TconReadFail=0;

    bool PanelID_Enable=true;
    if(boot_power_on_mode != POWER_OFF){
            if(env_getShutdownDisable() == true){
                printf("shutdown_disable_value =%d\n",shutdown_disable_value);
                if(shutdown_disable_value == 0xFF){ //turnoff self-diagnosis
                        pin_panel_less = 1;
                        TconReadFail = 1;
                        PanelID_Enable = false;
                 }else{
                    if(pin_panel_less == 1){  //turnoff panel id handler
                         PanelID_Enable = false;
                         TconReadFail = 0;
                    }else{
                        if(shutdown_disable_value & 0x08){ //turnoff panel id handler
                            PanelID_Enable = false;
                            TconReadFail = 1;
                        }
                    }
                 }
            }
        }else{
            pin_panel_less = 1;
            TconReadFail = 1;
        }

	//I2C_Init();
	if((panelmode==NORMAL_MODE)&&(pin_panel_less==0)){

		//T-con power on
		if (boot_power_on_mode != POWER_OFF){
			IO_Set(PIN_LVDS_ON_OFF, 1);
			mdelay(30);	//spec-20ms ,but wait i2c rise a little time,so set 30ms.
		}

		//read NVM
		I2C_SetSpeed( TCON_I2C , 400 );

		for(ii=0;ii<ReadCnt;ii++){
			ret=I2C_Read_EX(TCON_I2C, NVM_ADDR , 2, regAddr, len, data);
			if(ret !=S_OK){
				//printf("--I2C_Read_EX_test error --\n");
				TConErrCnt++;
				if(TConErrCnt>=ReadCnt){
                                printf("--TCon read error, BL&PWD pull low --\n");
                                setID_Match(0);
                                TconReadFail=1;
                                IO_Set(PIN_LVDS_ON_OFF, 0);
                                IO_Set(PIN_BL_ON_OFF, 0);
                            }
			}
		}

		//for(ii = 0; ii < len; ii++){
					//printf("%02X ",data[ii]);
		//		if((ii%16)==15)
		//			printf("\n");
		//	}

		//printf("Panel ID :%s--\n",data);
		sprintf(t_con_id, "%s", data);
		printf("Panel ID :%s\n",t_con_id);
	}


#if defined(PANEL_CONFIG_FROM_FACTORY_PANEL_BIN) || defined(CONFIG_CUSTOM_SN_PANEL)

	int file_len = 0;
#endif

	int i = 0;
	#if 1

	#endif
	//printf(" \n");
	char tmp_str[3] = {0};
	char *raw1 = NULL;
	char *raw2 = NULL;
	char *raw3 = NULL;
	char *raw4 = NULL;
	char *raw5 = NULL;
#if 0
	char *raw6 = NULL;
	char *raw7 = NULL;
	char *raw8 = NULL;
	char *raw9 = NULL;

	char *raw10 = NULL;
	char *raw11 = NULL;
	char *raw12 = NULL;
	char *raw13 = NULL;
	char *raw14 = NULL;
	char *raw15 = NULL;
	//char *raw16 = NULL;
#endif

#ifdef CONFIG_REALTEK_EERPOM_TV010_A
	__attribute__ ((unused)) char  Eep_panelID = 0,EepPanelName[sizeof(default_panel_parameter.sPanelName)],curPanelName[sizeof(default_panel_parameter.sPanelName)];
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
	unsigned long eepnamecrc=0,namecrc=0;
#endif
#endif
#if 0 // debug
	unsigned char* p;
#endif

	parameter_len = sizeof(default_panel_parameter);
	//printf("--parameter_len=%d--\n",parameter_len);
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
	int EpiTestPinStatus =	IO_Get(PIN_EPI_TEST_DETECT);
#endif

	if (panel_filename == NULL) // set default value
	{
		//printf("\n\033[1;41<<<<<<<<<<panel_filename NULL>>>>>>>>>>\033[m");
		env_panel_set_default();
		printf("Panel: %s\n", default_panel_parameter.sPanelName);
	}
	else
	{
#ifdef CONFIG_PANEL_SHARP_60_MEMC
		//reset to default panel
		env_panel_set_default();
#else //#ifdef CONFIG_PANEL_SHARP_60_MEMC

//#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
#if defined(PANEL_CONFIG_FROM_FACTORY_PANEL_BIN) || defined(CONFIG_CUSTOM_SN_PANEL)

		/* read panel parameter from factory */

		if ((factory_read((char *)panel_filename, &raw_ptr, &file_len) == 0) && file_len == parameter_len) {
			memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));


		//printf("PanelIDString %x\n",default_panel_parameter.snInfo[0].PanelIDString[0]);
		//printf("PanelIDString %x\n",default_panel_parameter.snInfo[0].PanelIDString[1]);

		int panel_less_idx = env_getPanelessIndex();
		printf("panel_less_idx =%d\n",panel_less_idx);

		//int Chassis = env_getChassis();
		//printf("Chassis =%d\n",Chassis);

		if((panelmode==NORMAL_MODE)	&&(TconReadFail==0)){
			if(0){//if(strncmp(default_panel_parameter.snInfo[0].PanelIDString, t_con_id,16) == 0){
				//printf("the same ID =%s\n",t_con_id);
			}
			else{
					#define SN_PANEL_BIN_FILE			FACTORY_RO_HEADER_FILE_NAME"bin_panel/panel/sn_panel.bin"
					#define PN_BLOCK 611
					UINT32 tmpPanelCnt=0;

					PANEL_CONFIG_PARAMETER Tmp_panel_setting;

					#define HEADER_SIZE 0x20
					char *raw_ptr_s = NULL;
					char *raw_ptr_p = NULL;
					UINT8 select =0;
					PANEL_ID_INFO matchInfo[16];
					int matchCnt=0;
					int SettingStep=0;
					int j=0;

					memset(&matchInfo, 0, sizeof(PANEL_ID_INFO));
					int panelIdxCheck=0xFF;

					int getChassis=0;
					getChassis=env_getChassis();

					char value2_s[9]={0};
					UINT32 val=0;
					//printf("--getChassis=%d--\n",getChassis);

					if ((factory_ro_read((char *)SN_PANEL_BIN_FILE, &raw_ptr_s, &file_len) == 0)) {

						//printf("sn_panel.bin size =%d byte.--\n",file_len);

						//shift header+PN_BLOCK size

						raw_ptr_p=raw_ptr_s+HEADER_SIZE;
						memcpy(&Tmp_panel_setting.snInfo[0].Panel_Number,raw_ptr_p+16, sizeof(UINT32));

						tmpPanelCnt =Tmp_panel_setting.snInfo[0].Panel_Number;
						//printf("Panel Number =%d\n",tmpPanelCnt);

						if(pin_panel_less==1){// panel less flow.

								panel_less_idx = env_getPanelessIndex();
								select =panel_less_idx;
								printf("panel_less_idx =%d\n",panel_less_idx);
								raw_ptr_p = raw_ptr_s+HEADER_SIZE+select*PN_BLOCK;

								//check id
								if(default_panel_parameter.snInfo[0].PanelIndex!=select){
									char buf[4]={0};

									sprintf(buf,"%d",select);
									setenv("PANEL_SELECT", strim(buf));
									//select= Tmp_panel_setting.snInfo[0].PanelIndex;
									//struct arrange
									env_panel_set_parameter(select);
									env_struct_arrange(select,raw_ptr_p);
#ifdef CONFIG_CUSTOM_PQ_SELECT
	                                printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	                                // 0: Model_Env.txt
	                                // 1: Dynamic_Env.txt
	                                // 2: PnCommon.txt
									val = default_panel_parameter.snInfo[0].PanelIndex;
									sprintf(value2_s, "%d",val);
									CusApi_env_writeEnvFile(1, PANEL_INDEX,value2_s);
#endif
									//cp to default
									//memcpy(&default_panel_parameter, &panel_setting[select], sizeof(default_panel_parameter));

									//save to rtk panel bin
									env_panel_change_panel_bin_in_factory(PANEL_BIN_FILENAME_IN_FACTORY);
									EnPnUpdate=1;
								}

						}
						else{//Normal mode flow
							for(i=0;i<tmpPanelCnt;i++){
								raw_ptr_p=raw_ptr_s+HEADER_SIZE+i*PN_BLOCK;
								memcpy(&Tmp_panel_setting.snInfo[0].Panel_Number,raw_ptr_p+16, sizeof(UINT32));
								memcpy(&Tmp_panel_setting.snInfo[0].PanelIndex,raw_ptr_p+32, sizeof(UINT8));
								memcpy(Tmp_panel_setting.snInfo[0].PanelIDString,raw_ptr_p+33, sizeof(char)*16);
								memcpy(&Tmp_panel_setting.snInfo[0].Chassis_Index,raw_ptr_p+50, sizeof(UINT8));

								//printf("i=%d  %s  %d  %d\n",i,Tmp_panel_setting.snInfo[0].PanelIDString
								//									 ,Tmp_panel_setting.snInfo[0].PanelIndex
								//									 ,Tmp_panel_setting.snInfo[0].Chassis_Index);

								//check Panel ID Cnt
								if(strcmp(Tmp_panel_setting.snInfo[0].PanelIDString, t_con_id) == 0)
								{
									strcpy(matchInfo[matchCnt].PanelIDString,t_con_id);
									matchInfo[matchCnt].searchIdx =i;
									matchInfo[matchCnt].Chassis_Index = Tmp_panel_setting.snInfo[0].Chassis_Index;
									matchInfo[matchCnt].PanelIndex = Tmp_panel_setting.snInfo[0].PanelIndex;
									printf("--save %d :%s Sd=%d  Cd=%d Pd=%d--\n",matchCnt,t_con_id,
																				  matchInfo[matchCnt].searchIdx,
																				  matchInfo[matchCnt].Chassis_Index,
																				  matchInfo[matchCnt].PanelIndex);
									matchCnt++;
								}


								if(i==(tmpPanelCnt-1)){
									//printf("--finish check panel list--\n");

									if(matchCnt)
										SettingStep=1;
									else{
										printf("Attention Panel ID out of panel list\n");
										PanelID_Out_list=1;
										boot_power_on_mode = POWER_OFF;
										setID_Match(0);
									}
								}
								if(SettingStep==1){
									//check Chassis & ID priority 1
									for(j=0;j<matchCnt;j++){
										if(matchInfo[j].Chassis_Index==getChassis){
											select =matchInfo[j].PanelIndex;
											printf("Chassis & ID match select=%d\n",select);
											SettingStep=2;
											break;
										}
									}

									//compare PanelIndex
									if(SettingStep==1){
										for(j=0;j<matchCnt;j++){
											if(matchInfo[j].PanelIndex < panelIdxCheck){
												panelIdxCheck =matchInfo[j].PanelIndex;
											}
											if(j==(matchCnt-1)){
												select=panelIdxCheck;
												SettingStep=2;
											}
										}
									}
								}

								if(SettingStep==2)
								{
									raw_ptr_p=raw_ptr_s+HEADER_SIZE+select*PN_BLOCK;
									//printf("--Got it --\n");
									memcpy(&Tmp_panel_setting.snInfo[0].Panel_Number,raw_ptr_p+16, sizeof(UINT32));
									memcpy(&Tmp_panel_setting.snInfo[0].PanelIndex,raw_ptr_p+32, sizeof(UINT8));
									memcpy(Tmp_panel_setting.snInfo[0].PanelIDString,raw_ptr_p+33, sizeof(char)*16);
									memcpy(&Tmp_panel_setting.snInfo[0].Chassis_Index,raw_ptr_p+50, sizeof(UINT8));

									printf("select=%d  %s  %d  %d\n",select,Tmp_panel_setting.snInfo[0].PanelIDString
																	 ,Tmp_panel_setting.snInfo[0].PanelIndex
																	 ,Tmp_panel_setting.snInfo[0].Chassis_Index);

									memcpy(Tmp_panel_setting.snInfo[0].Version_String,raw_ptr_p, sizeof(char)*16);

									//printf(" default Version_String =%s\n",default_panel_parameter.snInfo[0].Version_String);
									//printf("  Version_String =%s\n",Tmp_panel_setting.snInfo[0].Version_String);

									if(((strncmp(default_panel_parameter.snInfo[0].PanelIDString, t_con_id,16) != 0)
										&&(default_panel_parameter.snInfo[0].PanelIndex!=select))
										||(strncmp(default_panel_parameter.snInfo[0].Version_String, Tmp_panel_setting.snInfo[0].Version_String,16))){

										if(strncmp(default_panel_parameter.snInfo[0].Version_String, Tmp_panel_setting.snInfo[0].Version_String,16))
											printf("Rev %s to %s\n",default_panel_parameter.snInfo[0].Version_String,Tmp_panel_setting.snInfo[0].Version_String);
										char buf[4]={0};
										sprintf(buf,"%d",select);
										setenv("PANEL_SELECT", strim(buf));
										//select= Tmp_panel_setting.snInfo[0].PanelIndex;
										//struct arrange
										env_panel_set_parameter(select);
										env_struct_arrange(select,raw_ptr_p);
#ifdef CONFIG_CUSTOM_PQ_SELECT
                                        printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
                                        // 0: Model_Env.txt
                                        // 1: Dynamic_Env.txt
                                        // 2: PnCommon.txt

										val = default_panel_parameter.snInfo[0].PanelIndex;
										sprintf(value2_s, "%d",val);
										CusApi_env_writeEnvFile(1, PANEL_INDEX,value2_s);
#endif
										//cp to default
										//memcpy(&default_panel_parameter, &panel_setting[select], sizeof(default_panel_parameter));

										//save to rtk panel bin
										env_panel_change_panel_bin_in_factory(PANEL_BIN_FILENAME_IN_FACTORY);
										EnPnUpdate=1;
									}
									else{//the same ID & panel idx
										env_chk_dyna_panel_id();
										printf("--the same ID and Panel Idx--\n");
									}


									SettingStep=0;
								}
							}
						//printf("-----------------------------------------------\n");
						}//pin_panel_less
				}//factory_read
				else{

				}
			}//panelmode

		}
		else{
			if(TconReadFail){
            	if(PanelID_Enable == false)
                	printf("turn off panel id function\n");
                else
                    printf("T-CON read x3 fail\n");
			 }
			else{
				env_chk_dyna_panel_id();
				printf("Debug mode bypass T-CON read\n");
			}
		}

#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
		strcpy(curPanelName,default_panel_parameter.sPanelName);
		vby1_aphy16_23_output = 0;
		if(EpiTestPinStatus == 0 && default_panel_parameter.iCONFIG_PANEL_TYPE == 4 )
		{
			if ((factory_read("tmp/factory/bin_panel/panel/Skyworth_Default_4K2K_VBY1_panel.bin", &raw_ptr, &file_len) == 0) && file_len == parameter_len)
			{
				memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));
				strcpy(default_panel_parameter.sPanelName,curPanelName);
				vby1_aphy16_23_output = 1;
				//printf("\n\033[1;32m@@@@@Read Skyworth_Default_4K2K_VBY1 Ok\033[m");
			}
		}
#endif
		}
		else {
			if (file_len != 0) {
				printf("Panel: Use default config (panel.bin size is not matched)\n");
				//printf("[WARN] size of panel.bin is 0x%x\n", file_len);
				//printf("[WARN] size of default_panel_parameter is 0x%x\n", parameter_len);
			}
			else{
				printf("Panel: Use default config (%s is not found)\n", panel_filename);
			}
			//reset to default panel
			env_panel_set_default();
		}
#else
		env_panel_set_default();
#endif

#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

		printf("\n\033[1;33m<<<<<<Panel: %s>>>>>>>>\033[m\n", default_panel_parameter.sPanelName);
		//printf("\n\033[1;33m<<<<<<parameter_len: %d >>>>>>>>\033[m\n", parameter_len);
	}
	if(rtk_pn){
		printf("\033[1;33m Enable RTK panel setting bypass sync sn_panel.bin\033[m\n");
	}
	else
		env_panel_sync();
#ifdef CONFIG_CUSTOM_PQ_SELECT
#if 0
	char parameter[64] = {0};
//	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	ret = CusApi_env_get_PQ_file_name(parameter);
//	printf("[trace code] PQ_file_name = %s\n", parameter);
	if(ret)
	{
//		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		ret = check_PQ_file_current_status(parameter);
		ret = check_PQ_extend_file_current_status(parameter);
	}
	else
	{
//		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		ret = check_PQ_file_current_status(default_panel_parameter.sPanelName);
		ret = check_PQ_extend_file_current_status(default_panel_parameter.sPanelName);
	}
#else
	ret = true;
#endif
#if (defined(Config_Emmc_Bootcode_To_SPI_TRUE) && defined(Config_Boot_Flash_Type_is_SPI))
#if 0	// CVT
	rtd_maskl(0xb8060220,0xFFFFFF0F, 0x000000F0);	// I2S 0xB8060220[7:4] = 0xF
	rtd_maskl(0xb8060228,0xFF0FFFFF, 0x00F00000);	// 0xB8060228[23:20] = 0xF
#else	// CVT2
	rtd_maskl(0xb800081C,0xFFFFFF0F, 0x000000F0);	// I2S 0xB800081C[7:4] = 0xF
	rtd_maskl(0xb8000818,0xFF0FFFFF, 0x00F00000);	// 0xB8000818[23:20] = 0xF
#endif
#else

#if 1
#if 0
	char *dst_addr;
	int dst_length;
	if(factory_ro_read("tmp/factory_ro/avb.bin", &dst_addr, &dst_length))
	{
		// for emmc fsw bootup
		// CVT2
		rtd_maskl(0xb800081C,0xFFFFFF0F, 0x000000F0);	// I2S 0xB800081C[7:4] = 0xF
		rtd_maskl(0xb8000818,0xFF0FFFFF, 0x00F00000);	// 0xB8000818[23:20] = 0xF
	}
#endif
	/*run factory kernel for tv002*/
	if(fsw_emmc_bootup){ // RTK_PLAT_ERR_OK=0
		// CVT2
		rtd_maskl(0xb800081C,0xFFFFFF0F, 0x000000F0);	// I2S 0xB800081C[7:4] = 0xF
		rtd_maskl(0xb8000818,0xFF0FFFFF, 0x00F00000);	// 0xB8000818[23:20] = 0xF
	}
#endif
	////////////////////////////////////
	int audio_pin = env_getI2S();
//	printf("aaaaaI2S=%d\n",audio_pin);
	//audio_pin = 2;
	if(audio_pin == 1)
    	{	//CVT
		rtd_maskl(0xb8060220,0xFFFFFF0F, 0x000000F0);	// I2S 0xB8060220[7:4] = 0xF
//		printf("CVT I2S\n");
	}else if(audio_pin == 2)
	{	//CVT2
	    	rtd_maskl(0xb800081C,0xFFFFFF0F, 0x000000F0);	// I2S 0xB800081C[7:4] = 0xF
//		printf("CVT2 I2S\n");
	}
	audio_pin = 0;
	audio_pin = env_getSPDIF();
//	printf("aaaaaSPDIF=%d\n",audio_pin);
	//audio_pin = 2;
	if(audio_pin == 1)
    	{	//CVT
		rtd_maskl(0xb8060228,0xFF0FFFFF, 0x00F00000);	// 0xB8060228[23:20] = 0xF
//		printf("CVT SPDIF\n");
	}
	else if(audio_pin == 2)
	{	//CVT2
	    	rtd_maskl(0xb8000818,0xFF0FFFFF, 0x00F00000);	// 0xB8000818[23:20] = 0xF
//		printf("CVT2 SPDIF\n");
	}
	///////////////////////////////////////
	env_setRO_OemKey();
#endif
        printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	CusApi_env_syncFactorySave();
#else
	ret = check_PQ_file_current_status(default_panel_parameter.sPanelName);
#endif
	if(ret < 0)
		printf("No match pq file at factory!\r\n");

	raw1 = malloc(150);
	raw2 = malloc(150);
	raw3 = malloc(150);
	raw4 = malloc(150);
	raw5 = malloc(150);
#if 0//if need with driver
	raw6 = malloc(150);
	raw7 = malloc(150);
	raw8 = malloc(150);
	raw9 = malloc(150);

	raw10 = malloc(128);
	raw11 = malloc(128);
	raw12 = malloc(128);
	raw13 = malloc(128);
	raw14 = malloc(128);
	raw15 = malloc(128);
#endif

	if ((raw1 == NULL) || (raw2 == NULL) || (raw3 == NULL) || (raw4 == NULL)||
		(raw5 == NULL)/* || (raw6 == NULL) || (raw7 == NULL) || (raw8 == NULL)||(raw9 == NULL)
		|| (raw10 == NULL) || (raw11 == NULL) || (raw12 == NULL)||
		(raw13 == NULL) || (raw14 == NULL) || (raw15 == NULL)*/)
	{
		printf("[ERR] %s:%d: malloc for raw data failed\n", __FUNCTION__, __LINE__);
		return 0;
	}

	/***********************************************
	 * FIXME: use magic number here is a bad decision !!!!!!!!!!
	 ***********************************************/
	/* set panel_file_name */
	//printf("--sPanelName=%s--\n",default_panel_parameter.sPanelName);
	raw_ptr = default_panel_parameter.sPanelName;
	printf("sPanelName=%s\n",raw_ptr);
	if (setenv("panel_file_name", raw_ptr))
	{
		rc = 0;
	}

	/* generate panel env */
	for (i = 0 ; i < 50 ; i++)
		sprintf( raw1+2*i, "%.2x", *((UINT8 *)&default_panel_parameter+i));

	if (parameter_len < 100)
	{
		for (i = 50 ; i < parameter_len ; i++)
			sprintf( raw2+2*(i-50), "%.2x", *((UINT8 *)&default_panel_parameter+i));
	}
	else
	{
		for (i = 50 ; i < 100 ; i++)
			sprintf( raw2+2*(i-50), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		for (i = 100 ; i < 150 ; i++)
			sprintf( raw3+2*(i-100), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 150 ; i < 200 ; i++)
			sprintf( raw4+2*(i-150), "%.2x", *((UINT8 *)&default_panel_parameter+i));


		for (i = 200 ; i < 250 ; i++)
			sprintf( raw5+2*(i-200), "%.2x", *((UINT8 *)&default_panel_parameter+i));
#if 0//if need with driver
		for (i = 250 ; i < 300 ; i++)
			sprintf( raw6+2*(i-250), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 300 ; i < 350 ; i++)
			sprintf( raw7+2*(i-300), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 350 ; i < 400 ; i++)
			sprintf( raw8+2*(i-350), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		for (i = 400 ; i < 450 ; i++)
			sprintf( raw9+2*(i-400), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 450 ; i < 500 ; i++)
			sprintf( raw10+2*(i-450), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		for (i = 500 ; i < 550 ; i++)
			sprintf( raw11+2*(i-500), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 550 ; i < 600 ; i++)
			sprintf( raw12+2*(i-550), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		for (i = 600 ; i < 650 ; i++)
			sprintf( raw13+2*(i-600), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		for (i = 650 ; i < 700 ; i++)
			sprintf( raw14+2*(i-650), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 700 ; i < parameter_len ; i++)
			sprintf( raw15+2*(i-700), "%.2x", *((UINT8 *)&default_panel_parameter+i));
		//for (i = 750 ; i < parameter_len ; i++)
		//	sprintf( raw16+2*(i-750), "%.2x", *((UINT8 *)&default_panel_parameter+i));
#endif


	}

//	printf("sizeof(default_panel_parameter)=%d \n", parameter_len);//hcy test

#if 0 // debug
	printf("bootcode inside panel parameter\n" ) ;
	p = (unsigned char*)&default_panel_parameter  ;

	for (i=0; i < sizeof(default_panel_parameter); i++) {
		if (i%16 == 0)
			printf("\n %02x",*p++ ) ;
		else
			printf(" %02x",*p++ ) ;
	}
	printf("\n" ) ;
#endif

	/* set panel_parameter1 */
	raw_ptr = raw1; /* Create new */
	if (setenv("panel_parameter_1", raw_ptr))
	{
		rc = 0;
	}

	for (i = 0 ; i < 50 ; i++)
	{
		strncpy(tmp_str, raw_ptr+2*i, 2);
		tmp_str[2] = '\0';
		*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
	}

	if (parameter_len < 100) // paramter size is less than 100, only need use two raws
	{
		/* set panel_parameter2 */
		raw_ptr = raw2;  /* Create new */

		if (setenv("panel_parameter_2", raw_ptr))
		{
			rc = 0;
		}

		for (i = 50 ; i < parameter_len ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-50), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}
	}
	else
	{
		/* set panel_parameter2 */
		raw_ptr = raw2;  /* Create new */
		if (setenv("panel_parameter_2", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter3 */
		raw_ptr = raw3;  /* Create new */
		if (setenv("panel_parameter_3", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter4 */
		raw_ptr = raw4;  /* Create new */
		if (setenv("panel_parameter_4", raw_ptr))
		{
			rc = 0;
		}


		/* set panel_parameter5 */
		raw_ptr = raw5;  /* Create new */
		if (setenv("panel_parameter_5", raw_ptr))
		{
			rc = 0;
		}
#if 0//if need with driver

		/* set panel_parameter6 */
		raw_ptr = raw6;  /* Create new */
		if (setenv("panel_parameter_6", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter7 */
		raw_ptr = raw7;  /* Create new */
		if (setenv("panel_parameter_7", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter8 */
		raw_ptr = raw8;  /* Create new */
		if (setenv("panel_parameter_8", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter9 */
		raw_ptr = raw9;  /* Create new */
		if (setenv("panel_parameter_9", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter10 */
		raw_ptr = raw10;  /* Create new */
		if (setenv("panel_parameter_10", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter11 */
		raw_ptr = raw11;  /* Create new */
		if (setenv("panel_parameter_11", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter12 */
		raw_ptr = raw12;  /* Create new */
		if (setenv("panel_parameter_12", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter13 */
		raw_ptr = raw13;  /* Create new */
		if (setenv("panel_parameter_13", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter14 */
		raw_ptr = raw14;  /* Create new */
		if (setenv("panel_parameter_14", raw_ptr))
		{
			rc = 0;
		}

		/* set panel_parameter15 */
		raw_ptr = raw15;  /* Create new */
		if (setenv("panel_parameter_15", raw_ptr))
		{
			rc = 0;
		}
#endif
		#if 0
		if(panelmode==1){
			if (boot_power_on_mode != POWER_OFF)
				IO_Set(PIN_LVDS_ON_OFF, 0);
			mdelay(500);
		}
		#endif
#if 0
		/* set panel_parameter2 */
		raw_ptr = raw2;  /* Create new */
		if (setenv("panel_parameter_2", raw_ptr))
		{
			rc = 0;
		}

		for (i = 100 ; i < 150	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-100), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter3 */
		raw_ptr = raw3;  /* Create new */
		if (setenv("panel_parameter_3", raw_ptr))
		{
			rc = 0;
		}

		for (i = 150 ; i < 200	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-150), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter4 */
		raw_ptr = raw4;  /* Create new */
		if (setenv("panel_parameter_4", raw_ptr))
		{
			rc = 0;
		}

		for (i = 200 ; i < 250	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-200), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter5 */
		raw_ptr = raw5;  /* Create new */
		if (setenv("panel_parameter_5", raw_ptr))
		{
			rc = 0;
		}

		for (i = 250 ; i < 300	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-250), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter6 */
		raw_ptr = raw6;  /* Create new */
		if (setenv("panel_parameter_6", raw_ptr))
		{
			rc = 0;
		}

		for (i = 300 ; i < 350	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-300), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter7 */
		raw_ptr = raw7;  /* Create new */
		if (setenv("panel_parameter_7", raw_ptr))
		{
			rc = 0;
		}

		for (i = 350 ; i < 400	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-350), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter8 */
		raw_ptr = raw8;  /* Create new */
		if (setenv("panel_parameter_8", raw_ptr))
		{
			rc = 0;
		}

		for (i = 400 ; i < 450	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-400), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter9 */
		raw_ptr = raw9;  /* Create new */
		if (setenv("panel_parameter_9", raw_ptr))
		{
			rc = 0;
		}

		for (i = 450 ; i < 500	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-450), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter10 */
		raw_ptr = raw10;  /* Create new */
		if (setenv("panel_parameter_10", raw_ptr))
		{
			rc = 0;
		}

		for (i = 500 ; i < 550	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-500), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter11 */
		raw_ptr = raw11;  /* Create new */
		if (setenv("panel_parameter_11", raw_ptr))
		{
			rc = 0;
		}

		for (i = 550 ; i < 600	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-550), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter12 */
		raw_ptr = raw12;  /* Create new */
		if (setenv("panel_parameter_12", raw_ptr))
		{
			rc = 0;
		}

		for (i = 600 ; i < 650	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-600), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter13 */
		raw_ptr = raw14;  /* Create new */
		if (setenv("panel_parameter_13", raw_ptr))
		{
			rc = 0;
		}

		for (i = 650 ; i < 700	; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-650), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter14 */
		raw_ptr = raw14;  /* Create new */
		if (setenv("panel_parameter_14", raw_ptr))
		{
			rc = 0;
		}

		for (i = 700 ; i < parameter_len  ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-700), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter15 */
		raw_ptr = raw15;  /* Create new */
		if (setenv("panel_parameter_15", raw_ptr))
		{
			rc = 0;
		}
#endif
#if 0
		for (i = 750 ; i < parameter_len  ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-750), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter16 */
		raw_ptr = raw16;  /* Create new */
		if (setenv("panel_parameter_16", raw_ptr))
		{
			rc = 0;
		}
#endif
	}
//	LVDS_4_PORTS_INDEX = default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX;

#if 0 // debug
    unsigned char* p;
	printf("\n\nenv's final panel parameter\n" ) ;
	p = (unsigned char*)&default_panel_parameter  ;

	for (i=0; i< sizeof(default_panel_parameter); i++) {
		if (i%16 == 0)
			printf("\n %02x",*p++ ) ;
		else
			printf(" %02x",*p++ ) ;
	}
	printf("\n" ) ;
#endif

	free((void *)raw1);
	free((void *)raw2);
	free((void *)raw3);
	free((void *)raw4);
	free((void *)raw5);
#if 0//if need with driver
	free((void *)raw6);
	free((void *)raw7);
	free((void *)raw8);
	free((void *)raw9);
	free((void *)raw10);
	free((void *)raw11);
	free((void *)raw12);
	free((void *)raw13);
	free((void *)raw14);
	free((void *)raw15);
#endif
	return rc;
}
#endif


